/*++
completeDP.mu

Author: Marcus Hausdorf, Uni Karlsruhe
        (hausdorf@ira.uka.de)
Created: 	Tue Jan 11 11:36:32 2000
Last update: 	Tue Feb 29 18:04:20 2000
++*/

alias (DAT(x)=detools::data[x],
       CDAT(x)=contains(detools::data, x),
       SDAT(x,y)=sysassign(detools::data[x],y),
       S2DAT(x,y,z)= sysassign((detools::data[x][y]), z)):

detools::prol := proc(eq:DOM_TABLE, v:DOM_INT):DOM_TABLE
    begin
	eq["class"] := min(eq["class"], v);
	eq["order"] := eq["order"] + 1;
	eq["ops"] := (DAT("DF"))::totalDiff(eq["ops"], v);
	eq["leader"] := subsop(eq["leader"], v = eq["leader"][v] + 1);
	eq;
    end_proc;
    
detools::r2E := proc(r):DOM_TABLE
    local t:DOM_TABLE, tmp;
    begin
	t := table();
	t["ident"] := genident("_lc_eq_");
	tmp := (DAT("DF"))::leader(r);
	if (DAT("DF"))::iszero(r) then
	    t["leader"] := [0 $ DAT("nIvars")];
	    t["pos"] := 0;
	    t["class"] := DAT("nIvars");
	    t["order"] := 0;
	    t["ops"] := (DAT("DF"))::zero;
	    t["co"] := 0;
	else
	    t["leader"] := (DAT("DF"))::Variables::multiIndex(tmp);
	    t["pos"] := (DAT("DF"))::Variables::index(tmp);
	    t["class"] := (DAT("DF"))::Variables::class(tmp);
	    t["order"] := (DAT("DF"))::Variables::order(tmp);
	    t["co"] := 1;
	    t["ops"] := r;
	end_if;
	t["lvl"] := 0;
	t["g_lvl"] := 0;
	t;
    end_proc;
    
detools::addEqs := proc(eq1:DOM_TABLE, eq2:DOM_TABLE):DOM_TABLE
    local tmp, tmp2, tmp3, rr:DOM_INT, ss:DOM_INT, DP:DOM_DOMAIN, l1, l2;
    begin
	rr := DAT("R");
	ss := DAT("S");
	DP := DAT("DF");
	l1 := DP::solve(eq1["ops"], DP::leader(eq1["ops"]), "Coeff");
	l2 := DP::solve(eq2["ops"], DP::leader(eq2["ops"]), "Coeff");
	if (l1 <> FAIL and l2 <> FAIL) then
	    tmp := DP::_subtract(DP::multcoeffs(l1[1], l2[2]), 
		DP::multcoeffs(l2[1], l1[2]));
	    tmp2 := _union((DAT("CR"))::indets(l1[2]), (DAT("CR"))::indets(l2[2]));
	    if tmp2 <> {} then
		tmp3 := DAT("Pivots");
		if contains(tmp3, [rr, ss]) then
		    tmp3[rr, ss] := _union(tmp3[rr, ss], tmp2);
		else
		    tmp2[rr, ss] := tmp2;
		end_if;  
		SDAT("Pivots", tmp3);
	    end_if;
	    return(detools::r2E(tmp));
	else	    
	    tmp := (DAT("DF"))::pseudoReduction(eq1["ops"], eq2["ops"], 
		(DAT("DF"))::leader(eq1["ops"]));
	    tmp2 := DAT("Pivots");
	    if contains(tmp2, [rr, ss]) then
		tmp2[rr, ss] := _union(tmp2[rr, ss], {op(tmp[2])});
	    else
		tmp2[rr, ss] := {op(tmp[2])};
	    end_if;  
	    SDAT("Pivots", tmp2);
	    return(detools::r2E(tmp[1]));
	end_if;
    end_proc;
    
unalias(DAT, CDAT, SDAT, S2DAT):




