// This function is obsolete, because the functionality is
// covered by plot::ode.
// Nevertheless, we keep this function in the library, 
// because TCI uses it.
// It is neither documented nor in the interface!
//                Walter, 4.12.00
/*++ 
odeplot(d,l,<obj-opts,scene-opts>) takes the output d of a call of
numeric::odesolve (with the option Alldata) and a list l of indices.  The
indices denote the components of the solution vector that will be plotted over
the independent variable. If the option Plot is given as last argument, then
plot2d is automatically called. Otherwise only a list of graphic objects is
returned which can be combined with others to yield more complex plots.

Instead of indices the list l may also contain procedures. These procedures
should take as arguments one float number and one float vector of the same
dimension as the differential equation solved numerically. They must return
one float number.

For a fine-tuning of the plot it is possible to provide optionally two lists
with object and scene options, respectively.  Note that if options are given,
*both* lists must be given. If no options are given, the VCam default values
are used as object options and as scene options Axes=Corner and Ticks=0 are
taken. Note that scene options are only relevant, if the option Plot is given,
i.e. actually a plot is rendered. The list for the object options should have
as much elements as the list l and each element should be again a list contain
the object options for the curve generated by the corresponding entry in l.

Examples:
    F := proc(t,y) begin [y[2],-y[1]] end_proc:
    nsol := numeric::odesolve(0..7,F,[0,1],RKF78,Alldata):
    detools::odeplot(nsol,[1,2],Plot):
    H := ((t,y) -> 0.5*(y[1]^2+y[2]^2)):
    energy_plot := detools::odeplot(nsol,[H]):
    plot2d(Ticks=0,Axes=Box,op(energy_plot)):


Author: Werner M. Seiler, Uni Karlsruhe/Mannheim
	(wms@ira.uka.de, seiler@euler.math.uni-mannheim.de)
Created: October 20th, 1997
Last update: 	Mon Mar  1 20:22:51 1999
++*/


detools::odeplot := 
proc(d:DOM_LIST,l:DOM_LIST)
local res:DOM_LIST,tmp:DOM_LIST,doplot:DOM_BOOL,
      objopts:DOM_LIST,sceneopts:DOM_LIST,i:DOM_INT,j:DOM_INT;
begin

    // analyse input
    
    case args(0)
    of 2 do 
    of 3 do 
        objopts := [[] $ nops(l)];
	sceneopts := [Axes=Corner,Ticks=0];
	break;
    of 4 do 
    of 5 do 
        objopts := args(3);
	sceneopts := args(4);
	break;
    otherwise error("wrong no of args");
    end_case;
    doplot := bool(args(args(0))=Plot);

    // create plot data
    
    res := [ [Mode=List] $ nops(l) ];
    j := 0;
    for i in l do
	case domtype(i)
	of DOM_INT do 
	    tmp := map(d,((l,i)->subsop(l,2=l[2][i])),i);
	    break;
	of DOM_PROC do 
	    tmp := map(d,((l,i)->subsop(l,2=i(op(l)))),i);
	    break;
	otherwise error("illegal argument");
	end_case;	
	tmp := map(tmp,point@op);
	j := j+1;
	res[j] := res[j] . [[polygon(op(tmp))], op(objopts[j])];
    end_for;
    
    // return results
    
    if doplot then plot2d(op(sceneopts),op(res))
    else return(res) end_if;
end_proc:

