// This function is obsolete, because the functionality is
// covered by plot::ode.
// Nevertheless, we keep this function in the library,
// because TCI uses it.
// It is neither documented nor in the interface!
//                Walter, 4.12.00
/*++ 
phaseplot(d,l,<obj-opts,scene-opts>) takes the output d of a call of
numeric::odesolve (with the option Alldata) and a list l with two or three
indices. It draws a parametric 2D- or 3D-plot, respectively, of the
corresponding components of the solution vector. If the option Plot is given
as last argument, then plot2d (or plot3d) is automatically called. Otherwise
only a list of graphic objects is returned which can be combined with others
to yield more complex plots.

Instead of indices the list l may also contain procedures. These procedures
should take as arguments one float number and one float vector of the same
dimension as the differential equation solved numerically. They must return
one float number.

For a fine-tuning of the plot it is possible to provide optionally two lists
with object and scene options, respectively.  Note that if options are given,
*both* lists must be given. If no options are given, the VCam default values
are used as object options and as scene options Axes=Corner and Ticks=0 are
taken. Note that scene options are only relevant, if the option Plot is given,
i.e. actually a plot is rendered.


Author: Werner M. Seiler, Uni Karlsruhe/Mannheim
	(wms@ira.uka.de, seiler@euler.math.uni-mannheim.de)
Created: October 20th, 1997
Last update: 	Tue May 11 13:54:07 1999
++*/


detools::phaseplot := 
proc(d:DOM_LIST,l:DOM_LIST)
local i:DOM_INT,j:DOM_INT,res:DOM_LIST,tmp:DOM_LIST,
      objopts:DOM_LIST,sceneopts:DOM_LIST,twoD:DOM_BOOL,doplot:DOM_BOOL;
begin

    // analyse input
    
    case args(0)
    of 2 do 
    of 3 do 
        objopts := [];
	sceneopts := [Axes=Corner,Ticks=0];
	break;
    of 4 do 
    of 5 do 
        objopts := args(3);
	sceneopts := args(4);
	break;
    otherwise error("wrong no of args");
    end_case;
    doplot := bool(args(args(0))=Plot);
    twoD := bool(nops(l)=2);

    // create plot data
    
    res := [ [] $ nops(d) ];
    j := 0;
    for i in l do
	j := j+1;
	case domtype(i)
	of DOM_INT do 
	    tmp := map(d, ((l,i) -> l[2][i]), i);
	    res := zip(res,tmp,append);
	    break;
	of DOM_PROC do 
	    tmp := map(d, ((l,i) -> i(op(l))), i);
	    res := zip(res,tmp,append);
	    break;
	otherwise error("illegal plot function");
	end_case;
    end_for;
    if twoD then
	res := [Mode=List, [polygon(op(map(res,point@op)))], op(objopts)];
	if doplot then plot2d(op(sceneopts),res)
	else return(res) end_if;
    else
	res := [Mode=List, [polygon(op(map(res,point@op)))], op(objopts)];
	if doplot then plot3d(op(sceneopts),res)
	else return(res) end_if;
    end_if;
end_proc:
