/*++
output --- returns results in the form implied by the set options

output returns results (if they consists of differential equations) according
to the set options. Thus if detools::data[Expr]=FALSE, they are returned in
the domain detools::data[DFout]. Otherwise they are converted to DOM_EXPR
either in diff or in simplified notation depending on the value of
detools::data[Expr]. If detools::data[System]=FALSE, then a single equation
instead of a list is returned.


Author: Werner M. Seiler, Uni Karlsruhe/Mannheim
	(wms@ira.uka.de, seiler@euler.math.uni-mannheim.de)
Date created: March 1st, 1999
Last update: 	Tue May 11 14:10:55 1999
++*/

alias(DAT(x)=detools::data[x]):


detools::output :=
proc()
local sys:DOM_LIST;
begin

    // conversion
    
    case DAT("Expr")
    of TRUE   do 
	sys := map(args(1),(DAT("DFout"))::convert_to,"diff");
	break;
    of FALSE  do 
	sys := args(1);
	break;
    of "NoDiff" do 
	sys := map(args(1),(DAT("DFout"))::expr);
	break;
    otherwise error("internal error in library detools");
    end_case;
    
    // check whether system
    
    if nops(sys)>1 or DAT("System") then sys else sys[1] end_if;
    	
end_proc:


unalias(DAT):
