/* 
derivTree.mu
author: Marcus Hausdorf
created: 16.4.99
last update: 30.4.99 
*/

alias(DTABLE = detools::D_Table):

detools::derList2Tree := proc(i_l):DOM_LIST
    local nIV:DOM_INT, k:DOM_INT;
    begin
	nIV := nops(i_l[1]);
	sysassign(DTABLE, table());
	for k from 1 to nops(i_l) do
	    sysassign(DTABLE[i_l[k]], k);
	end_for;
	detools::branch(i_l, [0 $ nIV], nIV);
    end_proc;

detools::part := proc(i_l):DOM_LIST
    local ni:DOM_INT, m:DOM_ARRAY, md:DOM_INT, m_a:DOM_INT, m_b:DOM_INT,
          tmp:DOM_INT, a:DOM_INT, b:DOM_INT, a_l:DOM_LIST, b_l:DOM_LIST;
    begin
	ni := nops(i_l);
	m := array(1..ni, 1..ni, [[0 $ ni] $ ni]);
	md := 0;
	m_a := 1;
	m_b := 1;
	for a from 1 to ni do
	    for b from (a + 1) to ni do
		tmp := _plus(op(map(zip(i_l[a], i_l[b], _subtract), abs))) 
		    - abs(_plus(op(i_l[a])) - _plus(op(i_l[b])));
		m[a, b] := tmp;
		m[b, a] := tmp;
		if tmp > md then
		    md := tmp;
		    m_a := a;
		    m_b := b;
		end_if;
	    end_for;
	end_for;
	if iszero(md) then return([i_l]) end_if;
	a_l := [i_l[m_a]];
	b_l := [i_l[m_b]];
	for a from 1 to ni do
	    if a = m_a or a = m_b then next end_if;
	    if m[a, m_a] < m[a, m_b] then
		a_l := append(a_l, i_l[a]);
	    else
		b_l := append(b_l, i_l[a]);
	    end_if;
	end_for;
	[a_l, b_l];
    end_proc;
	    
detools::branch := proc(i_l:DOM_LIST, dsf:DOM_LIST, nIV:DOM_INT)
    local g:DOM_LIST, k:DOM_INT, p;
    begin
	case nops(i_l) 
	of 1 do
	    return([i_l[1], DTABLE[zip(dsf, i_l[1], _plus)]]);
	of 2 do
	    g := [min(i_l[i][j] $ i = 1..nops(i_l)) $ j = 1..nIV];
	    if g = i_l[1] then
		return([g, DTABLE[zip(dsf, g, _plus)],
		    zip(i_l[2], g, _subtract), DTABLE[zip(dsf, i_l[2], _plus)]]);
	    elif g = i_l[2] then
		return([g, DTABLE[zip(dsf, g, _plus)],
		    zip(i_l[1], g, _subtract), DTABLE[zip(dsf, i_l[1], _plus)]]);
	    else
		if g = [0 $ nIV] then
		    return([[i_l[1], DTABLE[zip(dsf, i_l[1], _plus)]], 
			[i_l[2], DTABLE[zip(dsf, i_l[2], _plus)]]]);
		else
		    return([g, [[zip(i_l[1], g, _subtract), 
			DTABLE[zip(dsf, i_l[1], _plus)]],
			[zip(i_l[2], g, _subtract), 
			DTABLE[zip(dsf, i_l[2], _plus)]]]]);
		end_if;
	    end_if;
	otherwise
	    g := [min(i_l[i][j] $ i = 1..nops(i_l)) $ j = 1..nIV];
	    if g = [0 $ nIV] then
		return([map(detools::part(i_l), detools::branch, dsf, nIV)]);
	    else
		k := contains(i_l, g);
		if iszero(k) then
		    p := null();
		else
		    delete i_l[k];
		    p := DTABLE[zip(dsf, g, _plus)];
		end_if;
		return([g, p, map(detools::part(map(i_l, 
		    (l -> zip(l, g, _subtract)))), 
			detools::branch, zip(dsf, g, _plus), nIV)]);
	    end_if;
	end_case;
    end_proc;
    
unalias(DTABLE):
	    		



