// $Date: 2000/05/21 14:53:12 $ $Author: bij $ $Revision: 1.6 $ 
/*++
Cat::AbelianSemiGroup -- the category of abelian semi-groups

An Cat::AbelianSemiGroup is a Set with an associative and commutative
operation '+'.

Methods:
_plus(x1,x2,...) - returns the sum of x1+x2+...
intmult(x,i)     - returns x+x+...+x (i times) for a positive integer i
++*/

category Cat::AbelianSemiGroup
    category Cat::BaseCategory;

    _plus;

    intmult := domains::repeatedSquaring(dom, "_plus");

begin

end_category:

