// $Date: 2000/05/29 14:31:45 $ $Author: tonner $ $Revision: 1.10 $ 

/*++
getEntry -- get entry of domain

getEntry(Dom,e)

Dom - domain
e   - name of entry

Creates domain entry e on the fly, depending on the domain 'Dom' and its
actual parameters. The new entry is returned (and inserted into the
domain by 'slot').
++*/

DomainConstructor::getEntry:= proc(DOM: DOM_DOMAIN, e: DOM_STRING)
    option noDebug;
    local m;
begin
    m:= DomainConstructor::makeEntry(DOM, e);

    // is the entry missing by fault? 
    if m[1] = hold(toBeDefined) then
        warning("missing domain entry \"".e."\"")
    end_if;

    // give method a name and domain 
    m:= m[1];
    if domtype(m) = DOM_PROC then
//  did not work for Dom::IntegerMod(7)
//        if e <> "Name" and DOM::Name <> FAIL then
//            m:= subsop(m, 6=hold(slot)(DOM::Name, e), 13=DOM)
//        else
            m:= subsop(m, 6=hold(slot)(DOM::key, e), 13=DOM)
//        end_if;
    end_if;
    m
end_proc:

// end of file 
