// kg, 05/06/98 

/*++
_constructor -- create Domain/Category/Axiom-constructor

Called by the parser, therefore only very basic testing
for errornous arguments.

Creates Domain/Category/Axiom-constructor and assigns it to
its name.
++*/

_constructor:= proc(init: DOM_PROC, arg: DOM_BOOL, cat, ax, ent, inher)
    name _constructor;
    option hold, noDebug;
    local i, nam, make_closure, cons;
begin
    make_closure:= proc()
	option noDebug;
	local seq;
    begin
	seq:= op(init,4);
	if seq = NIL then
	    init:= subsop(init,
		4=hold((clos:=_act_proc_env())),
		Unsimplified);
	elif type(seq) = "_stmtseq" then
	    init:= subsop(init,
		4=hold(_stmtseq)(hold((clos:=_act_proc_env())), op(seq)),
		Unsimplified);
	else
	    init:= subsop(init,
		4=hold(_stmtseq)(hold((clos:=_act_proc_env())), seq),
		Unsimplified);
	end;
	nam:= op(init, 6);
    end_proc;

    case args(0)
    of 2 do // axioms
	make_closure();
	//delete make_closure;
	init:= context(init);
	cons:= new(AxiomConstructor, init, newDomain(hold(remember)(nam)));
	break;

    of 5 do // categories
	make_closure();
	//delete make_closure;
	init:= context(init);
	/* Problem mit map: Listen werden simplifiziert -> 0te Operanden
	 * werden voll evaluiert -> Fehler bei Eintraegen wie dom::convert(0)
	 *
	ent:= map(ent, proc(e) option noDebug; begin
	    if domtype(e) = DOM_STRING then e = hold(toBeDefined) else e end
	end_proc);
	 *
	 */
	ent:= [ (if domtype(ent[i]) = DOM_STRING
		 then ent[i] = hold(toBeDefined)
		 else ent[i] end)
	        $ i = 1..nops(ent) ];
	ent:= newDomain(hold(entries)(nam), table(op(ent)));
	cons:= new(CategoryConstructor, init, newDomain(hold(remember)(nam)),
	    cat, ax, ent);
	break;

    of 6 do // domains
	make_closure();
	//delete make_closure;
	init:= context(init);
	cons:= select(ent, proc(e) option noDebug; begin
	    bool(domtype(e) = DOM_STRING)
	end_proc);
	if cons <> [] then
	    error("domain entry '".cons[1]."' without definition")
	end;
	ent:= newDomain(hold(entries)(nam), table(op(ent)));
	cons:= new(DomainConstructor, init, cat, ax, ent, inher);
	break;

    otherwise
	//delete make_closure;
	error("wrong no of args");
    end_case;

    // create singleton instances if constructor has no args
    if not arg then
	cons:= (domtype(cons))::func_call(cons);
    end;

    context(hold(_assign)(nam, cons));
    null()
end_proc:

// end of file 
