// $Date: 2000/05/21 14:53:49 $ $Author: bij $ $Revision: 1.9 $ 

/*++
Dom::Ideal -- domain of ideals over a ring 

Dom::Ideal(R)

R - ring


++*/

domain Dom::Ideal(R)
  

inherits Dom::BaseDomain;
category Cat::Monoid;
// no axioms 

  coeffRing:= R;

  convert :=
  proc(x)
    local xx;
  begin
    if type(x)<>DOM_LIST and type(x)<>DOM_SET then
      error("Argument must be list or set of ring elements");
    end_if;
    xx:=map(x,R::coerce);
    if has(xx,FAIL) then FAIL else new(dom,[op(xx)]) end_if
  end_proc;

  expr := x -> extop(x,1);
  
  zero := new(dom,[R::zero]);
  
  one := new(dom,[R::one]);

  iszero :=
  proc(x)
  begin
    if {op(map(extop(args(1),1),iszero))}={TRUE} then
      TRUE
    else
      FALSE
    end_if
  end_proc;

  _mult :=
  proc(x,y)
  begin
    case args(0) of 0 do
        return(dom::one)
      of 1 do return(args(1))
      of 2 do return(new(dom,
                         _concat(op(map(extop(x,1),
                                        u -> (map(extop(y,1),_mult,u))))) ))
      otherwise
        return(dom::_mult(
                          dom::_mult(args(1..args(0) div 2)),
                          dom::_mult(args(args(0) div 2 +1 ..args(0)))))
    end_case
  end_proc;

  _plus := (()->(new(dom,_concat(map(args(),extop,1)))));

  _negate := id;  // -1 is always a unit ... 
  
  _subtract:=_plus;

  _invert:=()-> FAIL;
  
  print := (()->("<".expr2text(extop(args(1),1)).">"));
  
  normal := (if R::hasProp(Cat::Polynomial) then
               (()->( extsubsop(args(1),1=groebner::gbasis
                                ([op(extop(args(1),1))])) ))
             end_if);

begin
  if args(0)<>1 then
    error("Wrong number of arguments")
  elif R::hasProp=FAIL or
    R::hasProp(Cat::Ring)=FALSE then
    error("Argument must be a ring")
  end_if
end_domain:




