// $Date: 2000/05/21 14:54:39 $ $Author: bij $ $Revision: 1.5 $ 

/* tries to compute the indefinite integral of an expression
  containing the Bessel J function.

  Reference: Integrals and Series vol. 2, 
             Prudnikov, Brychkov and Marichev, 1986, OPA (Amsterdam) */

//alias(_pattern = intlib::_pattern): geht nicht!

intlib::besselJ := proc(f,x)
local l;
save v;
begin
   delete v;
   // formula 20 page 41 
   if (l:=intlib::match1(f,1/x^2*besselJ(_pattern(v,not has,x),x)^2))<>FAIL
     then
      return(
	expand(subs(2/(4*v^2-1)/x*((x*diff(besselJ(v,x),x)+besselJ(v,x)/2)^2
	+(x^2-v^2+1/4)*besselJ(v,x)^2),op(l))))
   end_if;
   FAIL
end_proc:
