// $Date: 2000/05/21 14:54:40 $ $Author: bij $ $Revision: 1.3 $ 

/*++ ---------------- getOptions.mu ---------------------

Author: Winfried Fakler,  University of Paderborn
Date Created: 17 March  2000
Last Update : 17 March  2000


Description:
This file contains functions for handling the usergiven options.
							  
Functions: 


++*/

intlib::defaultOptions:=
table(
      "PrincipalValue"=FALSE,
      "Continuous"=FALSE
      ):

intlib::getOptions:=
  proc()
    name intlib;
    local options,o;  
  begin
    if args(0)>=1 and type(args(1))=DOM_TABLE then
      return(args(1))
    end_if;
    
    options:=intlib::defaultOptions;
    /* get options */
    if args(0)>=1 then
      for o in [args()] do
        case o
          of hold(PrincipalValue) do
            options["PrincipalValue"]:=TRUE;
            break
          of hold(Continuous) do
            options["Continuous"]:=TRUE;
            break
          otherwise
            error("Unknown option ".expr2text(o))
        end_case;
      end_for;
    end_if;
    if options["PrincipalValue"] and options["Continuous"] then
      error("Illegal combination of options")
    end_if;
    userinfo(10, "Options used: ".expr2text(options));    
    options    
  end_proc:

intlib::printOptions:=
  proc(optionTable=intlib::defaultOptions)
    local o;
  begin
    op([(if op(o,2)=TRUE then
           text2expr(op(o,1))
         else null()
         end_if) $ o in optionTable])
  end_proc:
