// $Date: 2000/05/21 14:55:07 $ $Author: bij $ $Revision: 1.7 $ 
/*++
Ax -- a library of basic axiom constructors
++*/

domains: // force loading 'domains' 

Ax:= newDomain("Ax"):
Ax::info:= "Library 'Ax': basic axiom constructors":
Ax::interface:= {
    hold(canonicalRep), 
    hold(canonicalOrder),
    hold(systemRep),
    hold(normalRep),
    hold(noZeroDivisors),
    hold(canonicalUnitNormal),
    hold(closedUnitNormals),
    hold(efficientOperation)
}:

alias(path = pathname("DOMAINS", "AXIOM")):

Ax::canonicalRep:= loadproc(Ax::canonicalRep, path, "canonRep"):
Ax::canonicalOrder:= loadproc(Ax::canonicalOrder, path, "canonOrd"):
Ax::systemRep:= loadproc(Ax::systemRep, path, "sysRep"):
Ax::normalRep:= loadproc(Ax::normalRep, path, "normForm"):
Ax::noZeroDivisors:= loadproc(Ax::noZeroDivisors, path, "noZerDiv"):
Ax::canonicalUnitNormal:= loadproc(Ax::canonicalUnitNormal, path, "canUNorm"):
Ax::closedUnitNormals:= loadproc(Ax::closedUnitNormals, path, "clUNorm"):
Ax::efficientOperation:= loadproc(Ax::efficientOperation, path, "efficient"):

stdlib::LoadlibState["Ax"]:= TRUE:

null():

// end of file 
