// $Date: 2000/07/11 13:55:56 $ $Author: tonner $ $Revision: 1.10 $ 
/*++
Cat -- a library of basic category constructors
++*/

domains: // force loading 'domains' 

Cat:= newDomain("Cat"):
Cat::info:= "Library 'Cat': basic category constructors":
Cat::interface:= {
    hold(BaseCategory),
    hold(Set),
    hold(OrderedSet),
    hold(FiniteCollection),
    hold(HomogeneousFiniteCollection),
    hold(SemiGroup),
    hold(Monoid),
    hold(Group),
    hold(AbelianSemiGroup),
    hold(AbelianMonoid),
    hold(CancellationAbelianMonoid),
    hold(AbelianGroup),
    hold(Rng),
    hold(LeftModule),
    hold(RightModule),
    hold(Ring),
    hold(EntireRing),
    hold(CommutativeRing),
    hold(Module),
    hold(Algebra),
    hold(PartialDifferentialRing),
    hold(DifferentialRing),
    hold(IntegralDomain),
    hold(GcdDomain),
    hold(FactorialDomain),
    hold(PrincipalIdealDomain),
    hold(EuclideanDomain),
    hold(SkewField),
    hold(HomogeneousFiniteProduct),
    hold(Field),
    hold(QuotientField),
    hold(Polynomial),
    hold(UnivariatePolynomial),
    hold(Matrix),
    hold(SquareMatrix),
    hold(VectorSpace),
    hold(UnivariateSkewPolynomial),
    hold(OrderedAbelianMonoid),
    hold(OrderedMonoid),
    hold(MonoidRing),
    hold(FiniteMonoidRing),
    hold(DifferentialVariable),
    hold(DifferentialFunction)
}:

alias(path = pathname("DOMAINS", "CATEGORY")):

Cat::BaseCategory:= loadproc(Cat::BaseCategory, path, "BaseCat"):
Cat::Set:= loadproc(Cat::Set, path, "Set"): 
Cat::OrderedSet:= loadproc(Cat::OrderedSet, path, "OrdSet"):
Cat::FiniteCollection:= loadproc(Cat::FiniteCollection, path, "FinCollC"):
Cat::HomogeneousFiniteCollection:= loadproc(Cat::HomogeneousFiniteCollection, path, "HFinColC"):
Cat::SemiGroup:= loadproc(Cat::SemiGroup, path, "SemiGrp"):
Cat::Monoid:= loadproc(Cat::Monoid, path, "Monoid"):
Cat::Group:= loadproc(Cat::Group, path, "Group"):
Cat::AbelianSemiGroup:= loadproc(Cat::AbelianSemiGroup, path, "AbSemGrp"):
Cat::AbelianMonoid:= loadproc(Cat::AbelianMonoid, path, "AbMonoid"):
Cat::CancellationAbelianMonoid:= loadproc(Cat::CancellationAbelianMonoid, path, "CanAbMon"):
Cat::AbelianGroup:= loadproc(Cat::AbelianGroup, path, "AbGroup"):
Cat::Rng:= loadproc(Cat::Rng, path, "Rng"):
Cat::LeftModule:= loadproc(Cat::LeftModule, path, "LeftMod"):
Cat::RightModule:= loadproc(Cat::RightModule, path, "RightMod"):
Cat::Ring:= loadproc(Cat::Ring, path, "Ring"):
Cat::EntireRing:= loadproc(Cat::EntireRing, path, "EntRing"):
Cat::CommutativeRing:= loadproc(Cat::CommutativeRing, path, "CommRing"):
Cat::Module:= loadproc(Cat::Module, path, "Module"):
Cat::Algebra:= loadproc(Cat::Algebra, path, "Algebra"):
Cat::PartialDifferentialRing:= loadproc(Cat::PartialDifferentialRing, path, "PDiffRng"):
Cat::DifferentialRing:= loadproc(Cat::DifferentialRing, path, "DiffRing"):
Cat::IntegralDomain:= loadproc(Cat::IntegralDomain, path, "IntegDom"):
Cat::GcdDomain:= loadproc(Cat::GcdDomain, path, "GcdDom"):
Cat::FactorialDomain:= loadproc(Cat::FactorialDomain, path, "FactDom"):
Cat::PrincipalIdealDomain:= loadproc(Cat::PrincipalIdealDomain, path, "PrIdDom"):
Cat::EuclideanDomain:= loadproc(Cat::EuclideanDomain, path, "EuclDom"):
Cat::SkewField:= loadproc(Cat::SkewField, path, "SkewFld"):
Cat::HomogeneousFiniteProduct:= loadproc(Cat::HomogeneousFiniteProduct, path, "HFiProdC"):
Cat::Field:= loadproc(Cat::Field, path, "Field"):
Cat::QuotientField:= loadproc(Cat::QuotientField, path, "QuoField"):
Cat::Polynomial:= loadproc(Cat::Polynomial, path, "PolyCat"):
Cat::UnivariatePolynomial:= loadproc(Cat::UnivariatePolynomial, path, "UPolyCat"):
Cat::Matrix:= loadproc(Cat::Matrix, path, "MatCat"):
Cat::SquareMatrix:= loadproc(Cat::SquareMatrix, path, "SqMatCat"):
Cat::VectorSpace:= loadproc(Cat::VectorSpace, path, "Vspace"):

Cat::UnivariateSkewPolynomial:= loadproc(Cat::UnivariateSkewPolynomial, path, "OrePolyC"):
Cat::OrderedAbelianMonoid:=loadproc(Cat::OrderedAbelianMonoid,path,"OrdAbMon"):
Cat::OrderedMonoid:=loadproc(Cat::OrderedMonoid,path,"OrdMon"):
Cat::MonoidRing:=loadproc(Cat::MonoidRing,path,"MonRing"):
Cat::FiniteMonoidRing:=loadproc(Cat::FiniteMonoidRing,path,"FinMonRing"):
Cat::DifferentialVariable:=loadproc(Cat::DifferentialVariable,path,"DVarCat"):
Cat::DifferentialFunction:=loadproc(Cat::DifferentialFunction,path,"DFunCat"):

stdlib::LoadlibState["Cat"]:= TRUE:

null():

// end of file 
