// series.mu--library for series expansions

alias(path = pathname("SERIES")):


Series:=newDomain("Series"):
Series::info:="Library 'Series': tools and data structures for series expansions":
Series::interface:={}:

// Puiseux and Laurent series expansions
Series::Puiseux:= loadproc(Series::Puiseux, path, "laurent"):
// generalized series expansions
Series::gseries:= loadproc(Series::gseries, path, "gseries"):

// internal functions used in Puiseux:
Series::series:= loadproc(Series::series, path, "series"):
Series::expr2coeff:= loadproc(Series::expr2coeff, path, "FPS"):
Series::unknown:= loadproc(Series::unknown, path, "series"):

Series::exported:= { hold(series),hold(asympt) }:

stdlib::LoadlibState["Series"]:= TRUE:

null():

