// $Date: 2000/11/30 12:14:56 $ $Author: fakler $ $Revision: 1.46 $ 

intlib:=newDomain("intlib"):
  intlib::info:="Library 'intlib': symbolic definite and indefinite integration":
  intlib::interface:={
             /*         //hold(applyEulerIdentity),
                      //hold(complexLnConversion), 
                      hold(antiderivative),
                      hold(defInt),
                      hold(defLookup),
		      hold(int),
		      hold(lookup),
		      hold(rischInt),
                      hold(simplifyComplexIntegral),*/
                      hold(byparts), 
                      hold(changevar)
                      }:

/* NOTE: There are some global (pattern-)variables in intlib defined for
        the lookup pattern matcher (see below) */  

alias(path = pathname("INTLIB")):

intlib::algdep:= loadproc(intlib::algdep,path,"algdep"):
intlib::algred:= loadproc(intlib::algred,path,"algred"):
intlib::applyEulerIdentity:=
   loadproc(intlib::applyEulerIdentity,path,"simpCInt"):
intlib::changevar:= loadproc(intlib::changevar, path, "changevr"):
intlib::besselJ:= loadproc(intlib::besselJ,path,"besselJ"):
intlib::bound:= loadproc(intlib::bound,path,"bound"):
intlib::byparts:= loadproc(intlib::byparts,path,"byparts"):
intlib::complexLnConversion:=
    loadproc(intlib::complexLnConversion,path,"simpCInt"):
intlib::diffs:= loadproc(intlib::diffs,path,"diffs"):
intlib::expandExp:= loadproc(intlib::expandExp,path,"int"):
intlib::expandSum:= loadproc(intlib::expandSum,path,"simpCInt"):
intlib::gaussian:= loadproc(intlib::gaussian,path,"gaussian"):
// now use the standard function gcdex 
// intlib::gcdex:= loadproc(intlib::gcdex,path,"gcdex"): 
intlib::gcdk_n:= loadproc(intlib::gcdk_n,path,"gcdk_n"):
intlib::getOptions:= loadproc(intlib::getOptions,path,"getOptions"):
intlib::hasLnExp:= loadproc(intlib::hasLnExp,path,"simpCInt"):
intlib::hasNegativeSquareRoots:= loadproc(intlib::hasNegativeSquareRoots,
                                         path,"simpCInt"):
intlib::hermite:= loadproc(intlib::hermite,path,"hermite"):
intlib::hyperint:= loadproc(intlib::hyperint,path,"hint"):
intlib::insert:= loadproc(intlib::insert,path,"insert"):
intlib::int:= loadproc(intlib::int,path,"int"):
intlib::int_intern:= loadproc(intlib::int_intern,path,"int"):
intlib::intOverSet:= loadproc(intlib::intOverSet, path, "OverSet"):
intlib::intt:= loadproc(intlib::intt,path,"intt"):
intlib::inttest:= loadproc(intlib::inttest,path,"inttest"):
intlib::linsys:= loadproc(intlib::linsys,path,"linsys"):
intlib::lnToArctan:= loadproc(intlib::lnToArctan,path,"simpCInt"):
intlib::lookup:= loadproc(intlib::lookup,path,"lookup"):
intlib::lookup1:= loadproc(intlib::lookup1,path,"lookup"):
intlib::lookup2:= loadproc(intlib::lookup2,path,"lookup"):
intlib::looksqrt:=loadproc(intlib::looksqrt,path,"looksqrt"):
intlib::looksqrt2:=loadproc(intlib::looksqrt2,path,"looksqrt"):
intlib::pde_exp:= loadproc(intlib::pde_exp,path,"pde_exp"):
intlib::pde_var:= loadproc(intlib::pde_var,path,"pde_var"):
intlib::pde_ln:= loadproc(intlib::pde_ln,path,"pde_ln"):
intlib::pdioe:= loadproc(intlib::pdioe,path,"pdioe"):
intlib::primpart:= loadproc(intlib::primpart,path,"primpart"):
intlib::printOptions:= loadproc(intlib::printOptions,path,"getOptions"):
intlib::removeNegativeSquareRoots:= loadproc(intlib::removeNegativeSquareRoots,
                                         path,"simpCInt"):
intlib::rischInt:= loadproc(intlib::rischInt,path,"RischInt"):
intlib::rlti:= loadproc(intlib::rlti,path,"rlti"):
intlib::sim:= loadproc(intlib::sim,path,"sim"):
intlib::simplify:= loadproc(intlib::simplify,path,"simplify"):
intlib::simplifyComplexIntegral:=
    loadproc(intlib::simplifyComplexIntegral,path,"simpCInt"):
intlib::solveRde:= loadproc(intlib::solveRde,path,"solveRde"):
intlib::spde:= loadproc(intlib::spde,path,"spde"):
intlib::split1:= loadproc(intlib::split1,path,"split1"):
intlib::split2:= loadproc(intlib::split2,path,"split2"):
intlib::sqffTab:= loadproc(intlib::sqffTab,path,"sqffTab"):
intlib::sub:= loadproc(intlib::sub,path,"sub"):
intlib::subres:= loadproc(intlib::subres,path,"subres"):
intlib::subst:= loadproc(intlib::subst,path,"subst"):
intlib::tower:= loadproc(intlib::tower,path,"tower"):
intlib::weaknorm:= loadproc(intlib::weaknorm,path,"weaknorm"):

// integration via lookup 

unalias(path):
alias(path = pathname("INTLIB", "LOOKUP")):

intlib::lookuparcsin:=loadproc(intlib::lookuparcsin,path,"asin"):
intlib::lookuparcsinh:=loadproc(intlib::lookuparcsinh,path,"asinh"):
intlib::lookuparccos:=loadproc(intlib::lookuparccos,path,"acos"):
intlib::lookuparccosh:=loadproc(intlib::lookuparccosh,path,"acosh"):
intlib::lookuparctan:=loadproc(intlib::lookuparctan,path,"atan"):
intlib::lookupbesselJ:=loadproc(intlib::lookupbesselJ,path,"besselJ"):
intlib::lookupcos:=loadproc(intlib::lookupcos,path,"cos"):
intlib::lookupexp:=loadproc(intlib::lookupexp,path,"exp"):
intlib::lookupln:=loadproc(intlib::lookupln,path,"ln"):
intlib::lookupsin:=loadproc(intlib::lookupsin,path,"sin"):
intlib::lookuptan:=loadproc(intlib::lookuptan,path,"tan"):
intlib::to_sincos:=loadproc(intlib::to_sincos,path,"sin"):

// integration of special functions 

unalias(path):
alias(path = pathname("INTLIB", "SPECFUNC")):

intlib::absInt:=loadproc(intlib::absInt,path,"specfunc"):
intlib::bigOhInt:=loadproc(intlib::bigOhInt,path,"specfunc"):
intlib::contDiffAt:= loadproc(intlib::contDiffAt,path,"diracInt"):
intlib::diff2D:= loadproc(intlib::diff2D,path,"diracInt"):
intlib::diracInt:= loadproc(intlib::diracInt,path,"diracInt"):
intlib::diracDef:= loadproc(intlib::diracDef,path,"diracInt"):
intlib::heavisideInt:= loadproc(intlib::heavisideInt,path,"heaviInt"):
intlib::isContinuousAt:= loadproc(intlib::isContinuousAt,path,"diracInt"):
intlib::linArgSolve:= loadproc(intlib::linArgSolve,path,"diracInt"):
intlib::specialFunctionDef:=
  loadproc(intlib::specialFunctionDef,path,"specfunc"):
intlib::specialFunctionInt:=
  loadproc(intlib::specialFunctionInt,path,"specfunc"):

// definite integration 

unalias(path):
alias(path = pathname("INTLIB", "DEFINITE")):

intlib::antiderivative:= loadproc(intlib::antiderivative,path,"definite"):
intlib::defInt:= loadproc(intlib::defInt,path,"definite"):
intlib::defInt_intern:= loadproc(intlib::defInt_intern,path,"definite"):
intlib::defLookup:= loadproc(intlib::defLookup,path,"intdef"):
intlib::int_eval:= loadproc(intlib::int_eval,path,"definite"):
intlib::limit:= loadproc(intlib::limit,path,"definite"):
intlib::match:= loadproc(intlib::match,path,"match"):
intlib::matchassign:= loadproc(intlib::matchassign,path,"match"):
intlib::poleLRTest:= loadproc(intlib::poleLRTest,path,"definite"):
intlib::xrngTest:= loadproc(intlib::xrngTest,path,"definite"):


stdlib::LoadlibState["intlib"]:= TRUE:

intlib::printWarningsFlag:= TRUE:
intlib::printWarnings:= proc(flag)
    local tmp;
begin
    if args(0) = 0 then 
        return( intlib::printWarningsFlag )
    else
        case flag
        of TRUE do
        of FALSE do
            tmp:= intlib::printWarningsFlag;
            sysassign( intlib::printWarningsFlag, flag );
            return( tmp )
        otherwise
            error("invalid argument")
        end_case
    end_if
end_proc:

intlib::debugWarningsFlag:= FALSE:
intlib::printDebugWarnings:= 
  proc(flag)
    local tmp;
  begin
    if args(0) = 0 then
      return( intlib::debugWarningsFlag )
    else
      case flag
        of TRUE do
        of FALSE do
          tmp:= intlib::debugWarningsFlag;
          sysassign( intlib::debugWarningsFlag, flag );
          return( tmp )
        otherwise
          error("invalid argument")
      end_case
    end_if
  end_proc:


// parameters for tuning some integration routines 
intlib::simplifyTime:=20:     // time limit for simplify within int
intlib::discontTime:=300:     // time limit for discont within int
intlib::memGrowthFactor:=200: // limit factor for allowed complexity expansion

prog::setcheckglobals(intlib,{k,n,k_sub,k_deg,k_diff,k_alg,k_ident,
                              intlibDepthLevel,_X,_Z,Q_sub,Q,
                              hypergeom,ellipticK,ellipticE,ellipticPi,
                              undefinded}):
                      



null():


