// $Date: 2000/05/21 14:55:14 $ $Author: bij $ $Revision: 1.46 $ 

/*++
	numeric -- functions for numerical mathematics
++*/

numeric:= newDomain("numeric"):
numeric::info:= "Library 'numeric': functions for numerical mathematics":
numeric::interface:= { 
 // hold(bairstow),  // durch numeric::polyroots ueberfluessig
 // hold(bisect),    // durch numeric::realroot ueberfluessig
    hold(butcher), 
    hold(cubicSpline),
    hold(complexRound),
    hold(det), 
    hold(eigenvalues), 
    hold(eigenvectors), 
    hold(expMatrix),
    hold(factorLU),
    hold(factorQR),
    hold(factorCholesky),
    hold(fft),
    hold(invfft), 
    hold(int),
    hold(fMatrix),
    hold(fsolve), 
    hold(gldata),
    hold(gtdata),
    hold(inverse),
    hold(indets),
    hold(lagrange),
 // hold(lagrange2d), // in Lagrange absorbiert
    hold(linsolve),
    hold(matlinsolve),
    hold(ncdata), 
    hold(odesolve),
    hold(odesolve2),
    hold(odesolveGeometric),
    hold(polyroots),
//  hold(polyroots2), //internal reserve solver,  should not be documented !!
    hold(polysysroots), 
    hold(quadrature),
    hold(rationalize),
    hold(realroot),
    hold(realroots),
    hold(singularvalues), 
    hold(singularvectors), 
    hold(solve),
    hold(sort),
    hold(spectralradius)
//  hold(testfloat), // utility function, not to be documented
//  hold(isnonzero)  // utility function, not to be documented
}:

alias(path = pathname("NUMERIC"));

//obsolete, durch numeric::polyroots ueberfluessig
//numeric::bairstow:= loadproc(numeric::bairstow, path, "Bairstow"):
//obsolete, durch numeric::realroot ueberfluessig
//numeric::bisect:= loadproc(numeric::bisect, path, "bisect"):
numeric::butcher:= loadproc(numeric::butcher, path, "butcher" ):
numeric::complexRound:= loadproc(numeric::complexRound,path,"cmplxrnd"):
numeric::cubicSpline:= loadproc(numeric::cubicSpline, path, "cSpline"):
numeric::det:= loadproc(numeric::det, path, "det" ):
numeric::eigenvalues:= loadproc(numeric::eigenvalues, path, "eigenval"):
numeric::eigenvectors:= loadproc(numeric::eigenvectors, path, "eigenvec"):
numeric::expMatrix:= loadproc(numeric::expMatrix, path, "expMatr"):
numeric::factorCholesky:= loadproc(numeric::factorCholesky, path, "factorCh" ):
numeric::factorLU:= loadproc(numeric::factorLU, path, "factorLU" ):
numeric::factorQR:= loadproc(numeric::factorQR, path, "factorQR" ):
numeric::fft:= loadproc(numeric::fft, path, "fft"):
numeric::invfft:= loadproc(numeric::invfft, path, "invfft"):
numeric::fMatrix:= loadproc(numeric::fMatrix, path, "fMatrix"):
numeric::fsolve:= loadproc(numeric::fsolve,path,"fsolve"):
//numeric::fsolve_Sqrfpoly in numeric::polyroots umbenannt
//numeric::fsolve_Sqrfpoly:= loadproc(numeric::fsolve_Sqrfpoly,path,"solvepol"):
numeric::gldata:= loadproc(numeric::gldata, path, "GLData"):
numeric::gtdata:= loadproc(numeric::gtdata, path, "GTData"):
numeric::inverse:= loadproc(numeric::inverse, path, "inverse" ):
numeric::indets:= loadproc(numeric::indets, path, "indets" ):
numeric::isnonzero:= loadproc(numeric::isnonzero, path, "isnonzero"):
numeric::lagrange:= loadproc(numeric::lagrange, path, "lagrange"):
//numeric::lagrange2d:= loadproc(numeric::lagrange2d, path, "lagrange"):
numeric::linsolve:= loadproc(numeric::linsolve, path, "linsolve" );
numeric::matlinsolve:= loadproc(numeric::matlinsolve, path, "matlinso" );
numeric::ncdata:= loadproc(numeric::ncdata, path, "NCData"):
numeric::odesolve:= loadproc(numeric::odesolve, path, "odesolve" ):
numeric::odesolve2:= loadproc(numeric::odesolve2, path, "odesolv2" ):
numeric::odesolveGeometric:= loadproc(numeric::odesolveGeometric, path, "odesolvG" ):
numeric::polyroots:= loadproc(numeric::polyroots, path, "polyroots"):
numeric::polyroots2:= loadproc(numeric::polyroots2, path, "polyrts2"):
numeric::polysysroots:= loadproc(numeric::polysysroots, path, "polysysroots"):
numeric::quadrature:= loadproc(numeric::quadrature, path, "Quad"):
numeric::rationalize:= loadproc(numeric::rationalize, path, "rational"):
numeric::realroot:= loadproc(numeric::realroot, path, "realroot"):
numeric::realroots:= loadproc(numeric::realroots, path, "realroots"):
numeric::singularvalues:= loadproc(numeric::singularvalues, path, "singval" ):
numeric::singularvectors:= loadproc(numeric::singularvectors, path, "singvec" ):
numeric::sort:= loadproc(numeric::sort, path, "sort" ):
numeric::spectralradius:= loadproc(numeric::spectralradius, path, "spectralradius"):
numeric::testfloat:= loadproc(numeric::testfloat, path, "tstfloat"):
numeric::get_intervals := loadproc(numeric::get_intervals, path, "getIV"):

// float attributes
numeric::int:= loadproc(numeric::int, path, "int" ):
numeric::solve:= loadproc(numeric::solve, path, "solve"):
numeric::sum:=   loadproc(sum::float, path, "floatsum"):

stdlib::LoadlibState["numeric"]:= TRUE:

null():

// end of file 
