  ode:=newDomain("ode"):
  ode::info:="Library 'ode': ordinary differential equations":
  ode::interface:={
  /*   // hold(companionSystem), hold(cyclicVector),
        hold(dAlembert), 
        hold(evalOde),
        hold(exponentialSolutions),
        hold(isFuchsian),
        hold(isLODE), //hold(isCyclicVector),
        hold(laplace), 
        hold(liouvillianSolutions), 
        hold(normalize),
        hold(polynomialSolutions),
	hold(rationalSolutions),
       // hold(scalarEquation),
       // hold(simplifySolutions),
        hold(symmetricPower),
        hold(series),
        hold(unimodular), 
        hold(vectorize),
        hold(wronskian),
        hold(wronskianMatrix)  */
  }:

alias(path = pathname ("ODE")):

ode::new:= loadproc(ode::new, path, "new"):
ode::getComponents:= loadproc(ode::getComponents, path, "new"):
ode::print:= loadproc(ode::print, path, "new"):

  //ode::print:=proc(o) begin hold(ode)(extop(o)) end_proc;
  ode::maxDepth:=2: // maximal nesting of methods 
  ode::depth:=0: // current depth 
  ode::maxdegree:=1: /* maximal degree for which solve try to find radicals
                       or numbers of solutions are allowed */
  ode::isReducibleFlag:= FALSE: // necessary for printing correct warnings 
  ode::possiblyLostSolutionsFlag:=FALSE:

ode::isResultOfSolveOK:= loadproc(ode::isResultOfSolveOK,path,"solve"):

// methods for solving ordinary differential equations and systems 

ode::adjoint:= loadproc(ode::adjoint,path,"adjoint"):
ode::auto_transform:= loadproc(ode::auto_transform,path,"autonom"):
ode::autonomous:= loadproc(ode::autonomous,path,"autonom"):
ode::autonomousEq:= loadproc(ode::autonomousEq,path,"autonom"):
ode::bernoulli:= loadproc(ode::bernoulli,path,"bernoull"):
ode::bernoulliEq:= loadproc(ode::bernoulliEq,path,"bernoull"):
ode::clairaut:= loadproc(ode::clairaut,path,"clairaut"):
ode::clairautEq:= loadproc(ode::clairautEq,path,"clairaut"):
ode::contact:= loadproc(ode::contact,path,"contact"):
ode::combination:= loadproc(ode::combination,path,"combinat"):
ode::dAlembert:= loadproc(ode::dAlembert,path,"dAlember"):
ode::differentiation:= loadproc(ode::differentiation,path,"diff"):
ode::equidimensional_in_x:= 
                loadproc(ode::equidimensional_in_x,path,"equidimx"):
ode::equidimensional_in_y:= 
                loadproc(ode::equidimensional_in_y,path,"equidimy"):
ode::euler:= loadproc(ode::euler,path,"equidimx"):
ode::exact_first_order:= loadproc(ode::exact_first_order,path,"exact1st"):
ode::exact_second_order:= loadproc(ode::exact_second_order,path,"exact2nd"):
ode::exact_nth_order:= loadproc(ode::exact_nth_order,path,"exactnth"):
ode::factor:= loadproc(ode::factor,path,"factor"):
ode::firstord:= loadproc(ode::firstord,path,"firstord"):
ode::generalReduction:= loadproc(ode::generalReduction,path,"dAlember"):
ode::homogeneous:= loadproc(ode::homogeneous,path,"homogen"):
ode::int_factors:= loadproc(ode::int_factors,path, "intfacts"):
ode::interchange:= loadproc(ode::interchange,path,"interch"):
ode::lagrange:= loadproc(ode::lagrange,path,"lagrange"):
ode::laplace:= loadproc(ode::laplace,path,"laplace"):
ode::laplaceScalar:= loadproc(ode::laplaceScalar,path,"laplace"):
ode::laplaceSystem:= loadproc(ode::laplaceSystem,path,"laplace"):
ode::linsys:= loadproc(ode::linsys,path,"linsys"):
ode::matrixRiccati:= loadproc(ode::matrixRiccati,path,"mriccati"):
ode::reduction:= loadproc(ode::reduction,path,"dAlember"):
ode::riccati:= loadproc(ode::riccati,path,"riccati"):
ode::scale_invariant:=loadproc(ode::scale_invariant,path,"scaleinv"):
ode::secondOrderReduction:= 
               loadproc(ode::secondOrderReduction,path,"dAlember"):
ode::separate:= loadproc(ode::separate,path,"separate"):
ode::solvable_for_x:= loadproc(ode::solvable_for_x,path,"solvablx"):
ode::solvable_for_y:= loadproc(ode::solvable_for_y,path,"solvably"):
ode::solve:= loadproc(ode::solve,path,"solve"):
ode::solve_intern:= loadproc(ode::solve_intern,path,"solve"):
ode::solve_eq:= loadproc(ode::solve_eq,path,"solve_eq"):
ode::solve_linear:= loadproc(ode::solve_linear,path,"solvelin"):
ode::solve_sys:= loadproc(ode::solve_sys,path,"solvesys"):
ode::solvesysinit:= loadproc(ode::solvesysinit,path,"solvesys"):
ode::undet:= loadproc(ode::undet,path,"undet"):
ode::ymissing:= loadproc(ode::ymissing,path,"ymissing"):


// algebraic methods to determine liouvillian solutions 

unalias(path):
alias(path = pathname("ODE","LIOUVILL")):

ode::combineSolutionsOfFactors:= 
                     loadproc(ode::combineSolutionsOfFactors,path,"ifReduc"):
ode::expsols:= loadproc(ode::expsols,path,"ExpSol"):
ode::exponentialSolutions:= loadproc(ode::exponentialSolutions,path,"ExpSol"):
ode::firstOrder:=    loadproc(ode::firstOrder,path,"ifReduc"):
ode::fracFreeSymPowerOrd2:=
                     loadproc(ode::fracFreeSymPowerOrd2,path,"sympower"):
ode::ifReducible:=   loadproc(ode::ifReducible,path,"ifReduc"):
ode::liouvillianSolutions:= 
                     loadproc(ode::liouvillianSolutions,path,"LiouvSol"):
ode::mkUnimodular:=loadproc(ode::mkUnimodular,path,"mkUnimod"): 
ode::polysols:= loadproc(ode::polysols,path,"PolySol"):
ode::polynomialSolutions:= loadproc(ode::polynomialSolutions,path,"PolySol"):
ode::ratInvars:= loadproc(ode::ratInvars,path,"RatSol"):
ode::rationalInvariants:= loadproc(ode::rationalInvariants,path,"RatSol"):
ode::rationalSolutions:= loadproc(ode::rationalSolutions,path,"RatSol"):
ode::ratSys:= loadproc(ode::ratSys,path,"RatSol"):
ode::ratsols:= loadproc(ode::ratsols,path,"RatSol"):
ode::reducibleCase:= loadproc(ode::reducibleCase,path,"ifReduc"):
ode::secondOrder:=   loadproc(ode::secondOrder,path,"2ndOrder"):
ode::solveIfReducible:= loadproc(ode::solveIfReducible,path,"ifReduc"):
ode::symPower:= loadproc(ode::symPower,path,"sympower"):
ode::symPowerOrd2:= loadproc(ode::symPowerOrd2,path,"sympower"):
ode::symmetricPower:= loadproc(ode::symmetricPower,path,"sympower"):
ode::thirdOrder:=    loadproc(ode::thirdOrder,path,"3rdOrder"):
ode::unimodular:=loadproc(ode::unimodular,path,"mkUnimod"): 

// methods for computing series solutions

unalias(path):
alias(path = pathname("ODE","SERIES")):

ode::repdiff:= loadproc(ode::repdiff,path,"repDiff"):
ode::repeatedDifferentiating:=
       loadproc(ode::repeatedDifferentiating,path,"repDiff"):
ode::series:= loadproc(ode::series,path,"series"):


// determining types of equations 

unalias(path):
alias(path = pathname("ODE","MATCH")):

ode::exponents:= loadproc(ode::exponents,path, "fuchsian"):
ode::indicialEquation:= loadproc(ode::indicialEquation,path, "fuchsian"):
ode::isFuchsian:= loadproc(ode::isFuchsian,path, "fuchsian"):
ode::isLODE:= loadproc(ode::isLODE,path,"isLODE"):


// tools for handling differential equations 

unalias(path):
alias(path = pathname("ODE","TOOLS")):

ode::compSys:= loadproc(ode::compSys,path,"compSys"):
ode::companionSystem:= loadproc(ode::companionSystem,path,"compSys"):
ode::cyclicVector:= loadproc(ode::cyclicVector,path,"compSys"):
ode::diffvars:= loadproc(ode::diffvars,path,"diffvars"):
ode::evalOde:= loadproc(ode::evalOde,path,"tools"): 
ode::getOrder:= loadproc(ode::getOrder,path,"tools"):
ode::indets:= loadproc(ode::indets,path,"indets"):
ode::isCyclicVector:= loadproc(ode::isCyclicVector,path,"compSys"):
ode::lodeExpr:= loadproc(ode::lodeExpr,path,"tools"): 
ode::lodoExpr:= loadproc(ode::lodoExpr,path,"tools"): 
ode::mapsol:= loadproc(ode::mapsol,path,"mapsol"):
ode::mkODE:= loadproc(ode::mkODE,path,"mkODE"):
ode::normalize:= loadproc(ode::normalize,path,"normal"):
ode::ode2poly:= loadproc(ode::ode2poly,path,"ode2poly"):
ode::order:= loadproc(ode::order,path,"order"):
ode::printMinPol:= loadproc(ode::printMinPol,path,"tools"):
ode::scalarEquation:= loadproc(ode::scalarEquation,path,"compSys"):
ode::simplifySolutions:= loadproc(ode::simplifySolutions,path,"SimpSol"):
ode::split:= loadproc(ode::split,path,"split"):
ode::subsvars:= loadproc(ode::subsvars,path,"subsvars"):
ode::vectorize:= loadproc(ode::vectorize,path,"vectoriz"):
ode::vspace:= loadproc(ode::vspace,path,"vspace"):
ode::wronskianMatrix:= loadproc(ode::wronskianMatrix,path,"wronsk"):
ode::wronskian:= loadproc(ode::wronskian,path,"wronsk"):
ode::wronskianOf:= loadproc(ode::wronskianOf,path,"wronsk"):

stdlib::LoadlibState["ode"]:= TRUE:

unalias(path):

ode::printWarningsFlag:= TRUE:
ode::printWarnings:= 
  proc(flag)
    local tmp;
  begin
    if args(0) = 0 then
      return( ode::printWarningsFlag )
    else
      case flag
        of TRUE do
        of FALSE do
          tmp:= ode::printWarningsFlag;
          sysassign( ode::printWarningsFlag, flag );
          return( tmp )
        otherwise
          error("invalid argument")
      end_case
    end_if
  end_proc:

ode::debugWarningsFlag:= FALSE:
ode::printDebugWarnings:= 
  proc(flag)
    local tmp;
  begin
    if args(0) = 0 then
      return( ode::debugWarningsFlag )
    else
      case flag
        of TRUE do
        of FALSE do
          tmp:= ode::debugWarningsFlag;
          sysassign( ode::debugWarningsFlag, flag );
          return( tmp )
        otherwise
          error("invalid argument")
      end_case
    end_if
  end_proc:

ode::simplifyTime:=300:

ode::noTrace:={hold(getComponents)}:
prog::setcheckglobals(ode,{bna,calledFromWithinDSolve}):

null():
