// $Date: 2000/07/07 12:11:04 $  $Author: frankp $   $Revision: 1.21 $

plotlib:= newDomain("plotlib"):
plotlib::info:= "Library 'plotlib' is not (any longer) supported, try 'info(plot)' instead":
plotlib::interface:={}:

alias(path = pathname("PLOTLIB")):

plotlib::cylindricalplot := loadproc(plotlib::cylindricalplot, path, "cylindricalplot"):
plotlib::fieldplot       := loadproc(plotlib::fieldplot,       path, "fieldplot"):
plotlib::implicitplot    := loadproc(plotlib::implicitplot,    path, "implplot"):
plotlib::inequalityplot  := loadproc(plotlib::inequalityplot,  path, "ineqplot"):
plotlib::polarplot       := loadproc(plotlib::polarplot,       path, "polarplot"):
plotlib::sphericalplot   := loadproc(plotlib::sphericalplot,   path, "sphericalplot"):
plotlib::vector          := loadproc(plotlib::vector,          path, "vector"):
plotlib::xrotate         := loadproc(plotlib::xrotate,         path, "xrotate"):
plotlib::yrotate         := loadproc(plotlib::yrotate,         path, "yrotate"):
plotlib::polygonplot     := loadproc(plotlib::polygonplot,     path, "polygonplot"):
plotlib::dataplot        := loadproc(plotlib::dataplot,        path, "dataplot"):
plotlib::contourplot     := loadproc(plotlib::contourplot,     path, "contplot"):
plotlib::densityplot     := loadproc(plotlib::densityplot,     path, "density"):
plotlib::Turtle		 := loadproc(plotlib::Turtle,	       path, "Turtle"):
plotlib::Lsys            := loadproc(plotlib::Lsys,            path, "Lsys"):
plotlib::clip2d          := loadproc(plotlib::clip2d,          path, "clip2d"):
plotlib::conv2d          := loadproc(plotlib::conv2d,          path, "conv2d"):
plotlib::combine         := loadproc(plotlib::combine,         path, "combine"):
plotlib::show            := loadproc(plotlib::show,            path, "show"):

// animate function for UNIX platforms
plotlib::animate2d       := loadproc(plotlib::animate2d, path,"animate"):
plotlib::animate3d       := loadproc(plotlib::animate3d, path,"animate"):
plotlib::animate         := loadproc(plotlib::animate, path,"animate"):
plotlib::show_animation  := loadproc(plotlib::show_animation, path,"animate"):
plotlib::delete_frames   := loadproc(plotlib::delete_frames, path,"animate"):
plotlib::AnimateGif      := "xanim":
plotlib::FramesDefault   := 10:
plotlib::FormatDefault   := Gif:
plotlib::tmpDir          := "/tmp":

// plotsetup for UNIX platforms
plotlib::plotsetup       := loadproc(plotlib::plotsetup, path,"plotsetup"):
plotlib::plotsetup_showplot:= loadproc(plotlib::plotsetup_showplot, path,"plotsetup"):

// Utilities from subdirectory UTILS

unalias(path):
alias(path = pathname("PLOTLIB", "UTILS")):

plotlib::check_args  := loadproc(plotlib::check_args,  path, "chkargs"):
plotlib::check_args3d:= loadproc(plotlib::check_args3d,path, "chkargs3"):
plotlib::testfloat   := loadproc(plotlib::testfloat,   path, "chkfloat"):
plotlib::check_ticks := loadproc(plotlib::check_ticks, path, "chkticks"):
plotlib::clip2d      := loadproc(plotlib::clip2d,      path, "clip2d"):
plotlib::check_vb    := loadproc(plotlib::check_vb,    path, "chkvb"):

plotlib::surf_cont   := loadproc(plotlib::surf_cont,   path, "surfcont"):

plotlib::conv2d      := loadproc(plotlib::conv2d,      path, "conv2d"):
plotlib::combine     := loadproc(plotlib::combine,     path, "combine"):
plotlib::show        := loadproc(plotlib::show,        path, "show"):
plotlib::gridlines   := loadproc(plotlib::gridlines,   path, "gridline"):

// End of UTILS

// Default options for plotfunc2d and plotfunc3d
plotlib::Options[Scene2d]       := { Labeling=TRUE, 
                                     Scaling=UnConstrained, 
                                     RealValuesOnly=TRUE, Discont=TRUE }:
plotlib::Options[Scene3d]       := { Scaling=UnConstrained, Labeling=TRUE,
                                     Axes=Box, Ticks=Automatic}:
plotlib::Options[DefaultXRange] := -5..5: 
plotlib::Options[DefaultYRange] := -5..5:
plotlib::Options[RATIO_YX]      := 10:

stdlib::LoadlibState["plotlib"]:= TRUE:

null():
