// $Date: 2000/04/08 08:34:21 $  $Author: frankp $   $Revision: 1.26 $
// frankp, 18/09/98

/*++
	polylib - a library for working with polynomials.
++*/

// polylib:=newDomain("polylib"): (already done in .mupadsysinit)

polylib::info:="Library 'polylib': utilities for polynomials":
polylib::interface:=
{
 hold(Poly),hold(divisors),
 hold(decompose), hold(discrim),hold(resultant), hold(sqrfree),
 hold(elemSym), hold(representByElemSym),
 hold(primpart), hold(randpoly), hold(cyclotomic), hold(splitfield),
 hold(primitiveElement), hold(Dpoly),
 hold(realroots),
 hold(makerat),
 hold(minpoly),
 hold(sortMonomials)
}:

alias(path = pathname("POLYLIB")):

polylib::Poly     := loadproc(polylib::Poly, path, "Poly"):
polylib::sqrfree  := loadproc(polylib::sqrfree, path, "sqrfree"):
polylib::cyclotomic := loadproc(polylib::cyclotomic, path, "cyclotom"):
polylib::decompose:= loadproc(polylib::decompose, path, "decomp"):
polylib::discrim  := loadproc(polylib::discrim, path, "discrim"):
polylib::divisors := loadproc(polylib::divisors, path, "divisors"):
polylib::elemSym  := loadproc(polylib::elemSym, path, "sympol"):
polylib::makerat  := loadproc(polylib::makerat, path, "makerat"):
polylib::minpoly  := loadproc(polylib::minpoly, path, "minpoly"):
polylib::primpart := loadproc(polylib::primpart, path, "primpart"):
polylib::randpoly := loadproc(polylib::randpoly, path, "randpoly"):
polylib::representByElemSym := loadproc(polylib::representByElemSym, path, "sympol"):
polylib::resultant := loadproc(polylib::resultant, path, "resultan"):
polylib::realroots := loadproc(polylib::realroots, path, "realroots"):

polylib::Dpoly:= funcenv(
    builtin(522,NIL,"polylib::Dpoly",NIL),
    builtin(1101,0,NIL,"polylib::Dpoly"),
    table( "type" = "Dpoly" )
): // system function 'Dpoly'

// functions for algebraic extensions

polylib::horner   := loadproc(polylib::horner, path, "horner"):
polylib::primitiveElement := loadproc(polylib::primitiveElement, path,
                                      "primelem"):
polylib::splitFieldIrreducible := loadproc(polylib::splitFieldIrreducible,
                                           path, "splitirr"):
polylib::splitfield := loadproc(polylib::splitfield, path, "splitfld"):
polylib::sqrfreeNorm := loadproc(polylib::sqrfreeNorm, path, "sqfrnorm"):


// functions for arbitrary monomial orderings :

polylib::sortMonomials:=loadproc(polylib::sortMonomials, path, "sortmon"):

ground:= loadproc(ground, path, "ground"):
lterm:= loadproc(lterm, path, "lterm"):
lmonomial:= loadproc(lmonomial, path, "lmonom"):
lcoeff:= loadproc(lcoeff, path, "lcoeff"):
tcoeff:= loadproc(tcoeff, path, "tcoeff"):
nthterm:= loadproc(nthterm, path, "nthterm"):
nthcoeff:= loadproc(nthcoeff, path, "nthcoeff"):
nthmonomial:= loadproc(nthmonomial, path, "nthmonom"):
degreevec:= loadproc(degreevec, path, "degvec"):

polylib::exported:= {
  hold(poly),hold(expr),hold(divide),hold(factor),hold(content),
  hold(coeff), hold(degreevec), hold(nthcoeff),hold(lcoeff), hold(lterm), 
  hold(lmonomial), hold(tcoeff), hold(ground)
}:

stdlib::LoadlibState["polylib"]:= TRUE:
null():

