// $Date: 2000/11/30 12:14:57 $ $Author: fakler $ $Revision: 1.43 $ 

// solvelib.mu--library for solving equations 

/*++

User functions:


solve - solve an equation or a system of equations

++*/

solvelib:=newDomain("solvelib"):
solvelib::info:="Library 'solvelib': methods for solving equations, systems of equations, and inequalities":

solvelib::interface:={conditionalSort, pdioe,
                      getElement, isFinite,
                      preImage, Union, BasicSet}:

alias(path = pathname("SOLVELIB")):

/* solve: in stdlib */

solvelib::solve_eq       := loadproc(solvelib::solve_eq,       path,"equation"):
solvelib::solve_isalgebraic:= loadproc(solvelib::solve_isalgebraic,path,"isalgeb"):
solvelib::solve_islinear := loadproc(solvelib::solve_islinear, path,"islin"):
solvelib::isolate        := loadproc(solvelib::isolate,        path,"isolate"):
solvelib::solve_poly_irred:= loadproc(solvelib::solve_poly_irred,path,"pirred"):
solvelib::solve_poly     := loadproc(solvelib::solve_poly,     path,"poly"):
solvelib::solve_poly3    := loadproc(solvelib::solve_poly3,    path,"poly3"):
solvelib::solve_poly4    := loadproc(solvelib::solve_poly4,    path,"poly4"):
solvelib::solve_sys      := loadproc(solvelib::solve_sys,      path,"system"):
solvelib::ineqs          := loadproc(solvelib::ineqs,          path,"ineqs"):
solvelib::ineqsys        := loadproc(solvelib::ineqsys,        path, "ineqs"):
solvelib::conditionalSort:= loadproc(solvelib::conditionalSort,path, "condsort"):
solvelib::makeSystem     := loadproc(solvelib::makeSystem,     path, "makeSys"):
                            :
solvelib::domsolve	 := loadproc(solvelib::domsolve,       path,"domsolve"):
solvelib::printDebugWarnings :=
                       loadproc(solvelib::printDebugWarnings, path,"disSolve"):
solvelib::discreteSolve	 := loadproc(solvelib::discreteSolve, path,"disSolve"):
solvelib::sloppySolve	 := loadproc(solvelib::sloppySolve, path,"disSolve"):
solvelib::showprops	 := loadproc(solvelib::showprops, path,"disSolve"):
solvelib::iroots	 := loadproc(solvelib::iroots,         path,"iroots"):	
solvelib::algebraic      := loadproc(solvelib::algebraic,      path,"algebraic"):
solvelib::solve_algebraic:= loadproc(solvelib::solve_algebraic,path,"algebraic"):

solvelib::vectorForm     := loadproc(solvelib::vectorForm, path,    "vecForm"):

solvelib::allvalues      := loadproc(solvelib::allvalues,      path,"allvals"):
solvelib::pdioe          := loadproc(solvelib::pdioe,          path,"pdioe"):
solvelib::diophantine    := loadproc(solvelib::diophantine,    path,"diophant"):

solvelib::getoptions     := loadproc(solvelib::getoptions,     path,"getopt"):
solvelib::nonDefaultOptions 
			 := loadproc(solvelib::nonDefaultOptions,
							       path,"getopt"):

solvelib::substituteBySet:= loadproc(solvelib::substituteBySet,path,"subsBySe"):
solvelib::preImage       := loadproc(solvelib::preImage,       path,"preImage"):
solvelib::Union          := loadproc(solvelib::Union,          path,"Union"): 
solvelib::BasicSet       := loadproc(solvelib::BasicSet,       path,"BasicSet"):
solvelib::isEmpty        := loadproc(solvelib::isEmpty,        path,"isEmpty"):
solvelib::set2prop       := loadproc(solvelib::set2prop,       path,"set2prop"):

solvelib::solve_minus    := loadproc(solvelib::solve_minus,    path,"minus"):
solvelib::getElement     := loadproc(solvelib::getElement,     path,"getElem"):
solvelib::isFinite       := loadproc(solvelib::isFinite,       path,"isFinite"):
solvelib::ignoreSpecialCases:= loadproc(solvelib::ignoreSpecialCases,
                                        path, "ignoreSp"):

solvelib::bound2Free     := loadproc(solvelib::bound2Free,     path,"boundFr"):
solvelib::project        := loadproc(solvelib::project,        path,"project"):

/* the domain over which equations are solved by default */

solvelib::BaseSet:= solvelib::BasicSet(Dom::Complex):

//////////////////////////////////////////////////////////////////////
//       define basic sets 
//////////////////////////////////////////////////////////////////////

Z_ := solvelib::BasicSet(Dom::Integer):
Q_ := solvelib::BasicSet(Dom::Rational):
R_ := solvelib::BasicSet(Dom::Real):
C_ := solvelib::BasicSet(Dom::Complex):


solvelib::LoadlibState["solvelib"]:= TRUE:

null():

