// $Date: 2000/05/21 14:55:16 $  $Author: bij $   $Revision: 1.8 $ 

/*
stats.mu -- lib-file for statistics library
*/

  stats:=newDomain("stats"):
  stats::info:="Library 'stats': statistics functions":
  stats::interface:={hold(normal), hold(ChiSquare), // remains of old statistics package 
                     hold(sample),
                     hold(calc),
                     hold(selectRow),
                     hold(tabulate),
                     hold(zipCol),
                     hold(unzipCol),
                     hold(row),
                     hold(col),
                     hold(concatCol),
                     hold(concatRow),
                     hold(sample2list),
                     hold(mean),
                     hold(meanTest),
                     hold(geometric),
                     hold(quadratic),
                     hold(harmonic),
                     hold(variance),
                     hold(stdev),
                     hold(median),
                     hold(a_quantil),
                     hold(modal),
                     hold(obliquity),
                     hold(kurtosis),
                     hold(FCorr),
                     hold(BPCorr),
                     hold(sortSample),
                     hold(linReg),
                     hold(reg),
                     hold(Tdist)
                    }:

alias(path = pathname("STATS")):


stats::meanTest    := loadproc(stats::meanTest, path, "meanTest"):
stats::normal      := loadproc(stats::normal, path, "normal"):
stats::Tdist       := loadproc(stats::Tdist, path, "Tdist"):
stats::ChiSquare   := loadproc(stats::ChiSquare, path, "chi"):

stats::sample      := loadproc(stats::sample, path, "sample"):
stats::calc        := loadproc(stats::calc, path, "calc"):
stats::selectRow   := loadproc(stats::selectRow, path, "selectRo"):
stats::tabulate    := loadproc(stats::tabulate, path, "tabulate"):
stats::zipCol      := loadproc(stats::zipCol, path, "zipCol"):
stats::unzipCol    := loadproc(stats::unzipCol, path, "unzipCol"):
stats::row         := loadproc(stats::row, path, "row"):
stats::col         := loadproc(stats::col, path, "col"):
stats::concatRow   := loadproc(stats::concatRow, path, "concatRo"):
stats::concatCol   := loadproc(stats::concatCol, path, "concatCo"):
stats::sample2list := loadproc(stats::sample2list, path, "sample2l"):
stats::testdata    := loadproc(stats::testdata, path, "testdata"):
stats::getdata     := loadproc(stats::getdata, path, "getdata"):
stats::mean        := loadproc(stats::mean, path, "mean"):
stats::geometric   := loadproc(stats::geometric, path, "geometri"):
stats::quadratic   := loadproc(stats::quadratic, path, "quadrati"):
stats::harmonic    := loadproc(stats::harmonic, path, "harmonic"):
stats::variance    := loadproc(stats::variance, path, "variance"):
stats::stdev       := loadproc(stats::stdev, path, "stdev"):
stats::median      := loadproc(stats::median, path, "median"):
stats::a_quantil   := loadproc(stats::a_quantil, path, "a_quanti"):
stats::modal       := loadproc(stats::modal, path, "modal"):
stats::obliquity   := loadproc(stats::obliquity, path, "obliquit"):
stats::kurtosis    := loadproc(stats::kurtosis, path, "kurtosis"):
stats::FCorr       := loadproc(stats::FCorr, path, "FCorr"):
stats::BPCorr      := loadproc(stats::BPCorr, path, "BPCorr"):
stats::sortSample  := loadproc(stats::sortSample, path, "sortSamp"):
stats::linReg      := loadproc(stats::linReg, path, "linReg"):
stats::reg         := loadproc(stats::reg, path, "reg"):

stdlib::LoadlibState["stats"]:= TRUE:

null():

// end of file 
