/*++
permLU(indx) -- transforms index vector as outputed by factorLU in a classical
	        permutation vector.

factorLU returns among others a list indx which represents the permutation used
for the factorization. However, this permutation is not given in form of a
classical permutation vector but in a format specially adapted to its use in
lsolvLU. permLU(indx) takes the list as returned by factorLU and transforms it
into a classical permutation

Author: Werner M. Seiler, Uni Karlsruhe/Mannheim
	(wms@ira.uka.de, seiler@euler.math.uni-mannheim.de)
Date created: Fri Jan 22 16:50:03 1999
Last update: Fri Jan 22 16:51:48 1999
++*/


linalg::permLU := 
    proc(indx:DOM_LIST):DOM_LIST
    local i:DOM_INT, n:DOM_INT, tmp:DOM_LIST, perm:DOM_LIST;
    begin
	n := nops(indx);
	perm := [ i $ i=1..n ];
	tmp := perm;
	for i from 1 to n do
	    perm[i] := tmp[indx[i]];
	    tmp[indx[i]] := tmp[i];
	end_for;
	perm;
    end_proc:

