// $Date: 2000/05/21 14:55:40 $ $Author: bij $ $Revision: 1.3 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
dualpiv.mu -- get arbitrary pivot for the dual simplex method
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):


Tableau::dualpivot	:=	proc(tbl,m,n,interval)

/* Eingabe: Tableaukomponenten tbl,m,n,interval
  Ausgabe: Pivotelement [i,j,tbl[i,j],upperboundpivot]
*/

				local i,j,		// Laufvariavblen		
				      k,l,		// Pivotzeile und -spalte	
				      mini,		/* kleinster Quotient bei der
							  Bestimmung der Pivotspalte	*/
				      intervalpiv,	/* Pivotschritt um beidseitig-
							  beschraenkte Variable?	*/
				      inter;		/* induziert die bisherige Pivot-
							  zeile einen interval-Pivot-
							  schritt ?			*/

				begin

        userinfo(8," Entering Tableau::dualpivot "):

				  k := 0:
				  l := 0:

				  for i from  3 to m+2 do
				    if interval[tbl[i,1],"greater"] <> UNKNOWN 
				    then if tbl[i,2] < 0  and (k = 0 or not inter and tbl[i,2] < tbl[k,2] 
								or inter and tbl[i,2] < interval[tbl[k,1],"lower"]-tbl[k,2] )
					   then k := i:
						inter := FALSE:
						next
					 end_if: 
					 if interval[tbl[i,1],"lower"] <> UNKNOWN and interval[tbl[i,1],"lower"]-tbl[i,2] < 0 and
						(k = 0 or inter and interval[tbl[i,1],"lower"]-tbl[i,2] < interval[tbl[k,1],"lower"]-tbl[k,2] 
							or not inter and interval[tbl[i,1],"lower"]-tbl[i,2] < tbl[k,2])
					   then k := i:
						inter := TRUE 
					 end_if
				    end_if
				  end_for:

				  if k = 0 then return([k,l]) end_if:			// primal zulaessig -> fertig 

				  if bool(tbl[k,2] >= 0) then 
				     intervalpiv := TRUE:

				     for j from 3 to n+2 do
				       if interval[tbl[1,j],"greater"] = UNKNOWN and tbl[k,j] <> 0
					 then return([k,j,tbl[k,j],intervalpiv])
				       end_if: 
				       if tbl[k,j] > 0
					 then mini := tbl[2,j]/tbl[k,j]:  
					      l := j:
					      break
				       end_if
				     end_for:

				     if j > n+2 then return([k,l]): end_if:		// dual unbeschraenkt -> primal leer 

				     j := j+1:
				     while (j <= n+2) do
				       if interval[tbl[1,j],"greater"] = UNKNOWN and tbl[k,j] <> 0 then
					 l := j:
					 break 
				       end_if:
				       if tbl[k,j] > 0 and tbl[2,j]/tbl[k,j] < mini
					 then mini := tbl[2,j]/tbl[k,j]:  
					      l := j
				       end_if:	
				       j := j+1:					     
				     end_while

				  else intervalpiv := FALSE:				// normal k found 
				     for j from 3 to n+2 do
				       if interval[tbl[1,j],"greater"] = UNKNOWN and tbl[k,j] <> 0
					 then return([k,j,tbl[k,j],intervalpiv])
				       end_if:
				       if tbl[k,j] < 0 
					 then mini := -tbl[2,j]/tbl[k,j]:  
					      l := j:
					      break
				       end_if
				     end_for:

				     if j > n+2 then return([k,l]): end_if:		// dual unbeschraenkt -> primal leer 

				     j := j+1:
				     while (j <= n+2) do
				       if interval[tbl[1,j],"greater"] = UNKNOWN and tbl[k,j] <> 0 then
					 l := j:
					 break 
				       end_if:
				       if tbl[k,j] < 0 and -tbl[2,j]/tbl[k,j] < mini
					 then mini := -tbl[2,j]/tbl[k,j]:  
					      l := j
				       end_if:	
				       j := j+1:
				     end_while
				  end_if:
				  return([k,l,tbl[k,l],intervalpiv]):						
				end_proc:



unalias(Tableau):
unalias(Heap):
