// $Date: 2000/05/21 14:55:42 $ $Author: bij $ $Revision: 1.8 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
newlower.mu --  insert a new lowerbound a in tableau T for the variable in row i
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):

Tableau::newlowerbound	:=	proc(T,i,a)

/* Eingabe: Tableau T, Zeilenindex i, untere Schranke a
  Ausgabe: das komplette neue Tableau
*/

				local /*j,*/						// Laufvariable			
				      v,						// Variable zu Zeile i		
				      tbl,n,insertedvars,equations,scrollanz,
				      interval,assoziated,integer,internalorder;	// Tablaukomponenten		

				begin
				  tbl := T[1]:
				  n := T[3]:
				  insertedvars := T[4]:
				  equations := T[5]:
				  scrollanz := T[8]:
				  interval := T[9]:
				  assoziated := T[10]:
				  internalorder := T[11]:
				  integer := T[12]:

				  v := tbl[i,1]:

				  if interval[v,"greater"] = UNKNOWN or interval[v,"lower"] = UNKNOWN
				  then scrollanz := scrollanz+1:
				       tbl := assignElements(tbl,[[i,1],linopt::scr[scrollanz]],[[i,2],tbl[i,2]-a]):
				       interval[linopt::scr[scrollanz],"greater"] := 0:
				       interval[v,"greater"] := a:
				       interval[linopt::scr[scrollanz],"lower"] := UNKNOWN:
				       integer[linopt::scr[scrollanz]] := integer[v]:

				       equations := {op(equations,[i,1]) = 
							subs(op(equations,[i,2]),{v = linopt::scr[scrollanz]+a})$ i=1..nops(equations)} 
						    union {v = linopt::scr[scrollanz]+a}:
				       assoziated[linopt::scr[scrollanz]] := [1,v,-a]:
				       insertedvars := insertedvars union {linopt::scr[scrollanz]}:
				       internalorder[linopt::scr[scrollanz]] := internalorder[v]:
				       return(new(Tableau,tbl,T[2],n,insertedvars,equations,T[6],T[7],
							scrollanz,interval,assoziated,internalorder,integer))
				  else scrollanz := scrollanz+1:
				       tbl := assignElements(tbl,[[i,1],linopt::scr[scrollanz]]):
				       if not interval[v,"greater"] then tbl := assignElements(tbl,[[i,2],tbl[i,2]-a]) end_if:
				       interval[linopt::scr[scrollanz],"greater"] := interval[v,"greater"]:
				       interval[v,"greater"] := a:
				       interval[linopt::scr[scrollanz],"lower"] := interval[v,"lower"]-a:
				       integer[linopt::scr[scrollanz]] := integer[v]:
				       equations := {op(equations,[i,1]) = 
							subs(op(equations,[i,2]),{v = linopt::scr[scrollanz]+a})$ i=1..nops(equations)} 
						    union {v = linopt::scr[scrollanz]+a}:
				       assoziated[linopt::scr[scrollanz]] := [1,v,-a]:
				       insertedvars := insertedvars union {linopt::scr[scrollanz]} minus {v}:
				       internalorder[linopt::scr[scrollanz]] := internalorder[v]:	
				       return(new(Tableau,tbl,T[2],n,insertedvars,equations,T[6],T[7],
							scrollanz,interval,assoziated,internalorder,integer))
				  end_if
				end_proc:

unalias(Tableau):
unalias(Heap):
