// $Date: 2000/05/21 14:55:44 $ $Author: bij $ $Revision: 1.3 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
pivot2.mu -- get arbitrary pivot for phase II
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):

Tableau::pivot2		:=  	proc(tbl,m,n,interval)

/* Eingabe: Tableaukomponenten tbl,m,n,interval.
  Ausgabe: Pivotelement [i,j,tbl[i,j],upperboundpivot]
*/

				local i,j,		// Laufvariablen				
				      k,l,		// Pivotzeile und -spalte		
				      mini,		/* Kleinster Quotient bei der Best. der
							  Pivotzeile				*/
				      intervalpiv;	/* Pivotschritt um beidseitig beschr.
							  Variable?				*/

				begin
        userinfo(8," Entering Tableau::pivot2 "):		  
				  l:=0:
				  k:=0:
				  j := 3:
				  i := 3:

				  while (j <= n+2) do						// Zielfunktion verbesserbar ? 
				    if tbl[2,j] < 0 or (interval[tbl[1,j],"greater"] = UNKNOWN and tbl[2,j] > 0)
				      then if l = 0 or abs(tbl[2,j]) > abs(tbl[2,l]) 
					     then l:=j 
					   end_if
				    end_if:
				    j:=j+1
				  end_while:

				  if l=0 then return([k,l]) end_if:				// nein 

				  i := 3:					
				  if tbl[2,l] < 0
				  then if interval[tbl[1,l],"lower"] <> UNKNOWN 
					 then k := 1:
					      mini := interval[tbl[1,l],"lower"]:
					      intervalpiv := TRUE
				       end_if:

				       while i <= m+2 do
					 if interval[tbl[i,1],"greater"] <> UNKNOWN 
					 then if tbl[i,l] > 0 
					      then if k = 0 or tbl[i,2]/tbl[i,l] < mini 
						   then k:=i:
							mini := tbl[k,2]/tbl[k,l]:
							intervalpiv := FALSE
						   end_if
					      elif interval[tbl[i,1],"lower"] <> UNKNOWN and tbl[i,l] < 0 and 
						   ( k = 0 or (tbl[i,2]-interval[tbl[i,1],"lower"])/tbl[i,l] < mini )
						  then k:=i:
						       mini := (tbl[k,2]-interval[tbl[k,1],"lower"])/tbl[k,l]:
						       intervalpiv := TRUE
					      end_if
					 end_if:
					 i:=i+1
				       end_while
				  else while i <= m+2 do
					 if interval[tbl[i,1],"greater"] <> UNKNOWN
					 then if tbl[i,l] < 0 
					      then if k = 0 or tbl[i,2]/tbl[i,l] > mini or tbl[i,2]/tbl[i,l] = mini
						   then k:=i:
							mini := tbl[k,2]/tbl[k,l]:
							intervalpiv := FALSE
						   end_if
					      elif interval[tbl[i,1],"lower"] <> UNKNOWN then
						if tbl[i,l] > 0 and ( k = 0 or (tbl[i,2]-interval[tbl[i,1],"lower"])/tbl[i,l] > mini )
						  then k:=i:
						       mini := (tbl[k,2]-interval[tbl[k,1],"lower"])/tbl[k,l]:
						       intervalpiv := TRUE
						end_if
					      end_if
					 end_if:
					 i:=i+1
				       end_while
				  end_if:

				  if k = 0 then return([k,l]) else return([k,l,tbl[k,l],intervalpiv]) end_if:						  
				end_proc:



unalias(Tableau):
unalias(Heap):
