// $Date: 2000/05/21 14:55:44 $ $Author: bij $ $Revision: 1.3 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
probe.mu --  test whether the solution e is feasible for the linear program A.
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):

Tableau::probe		:=	proc(A,e,integertest)

/* Eingabe: LP A, gefundenes Ergebnis e und bool integertest - falls TRUE, wird auch auf Integer-Zulaessigkeit
           geprueft.
  Ausgabe: keine
*/

				local g1,	// linke Seiten der Restriktionen	
				      g2,	// rechte Seiten der Restriktionen	
   				      i;	// Laufvariable				

				begin

				  for i in A[1] do	
				    g1 := subs(op(i,1),e):	
				    g2 := subs(op(i,2),e):	
				    if testtype(i,"_equal") 	
				      then if subs(g1-g2,{0.0=0}) <> 0 then userinfo(1,"Simplex Error: Wrong Result at ",i): end_if	
				      elif g1-g2 > 0 then userinfo("Simplex Error: Wrong Result! at ",i):
				    end_if	
				  end_for:
	
				  if args(0) = 2 or not integertest then return() end_if:
				
				  if nops(A) = 4 then
				    if testtype(A[4],DOM_SET) 
				     then for i in e do
				            if contains(A[4],op(i,1)) and not testtype(op(i,2),DOM_INT)
					      then userinfo(1,"Simplex Error: Wrong Result at ",i) end_if
				          end_for
				     else for i in e do
				            if not testtype(op(i,2),DOM_INT)
					      then userinfo(1,"Simplex Error: Wrong Result at ",i): end_if
				          end_for
				    end_if
				  end_if
				end_proc:
unalias(Tableau):
unalias(Heap):
