// $Date: 2000/05/21 14:55:52 $ $Author: bij $ $Revision: 1.4 $ 
// sello, 12.6.97 

/*++
autostep.mu -- perform the next simplex-step
++*/

alias(Heap = adt::Heap):
alias(Tableau = linopt::Tableau):
alias(Transparent = linopt::Transparent):

Transparent::autostep	:=	proc(T)

/* Eingabe: Tableau T
  Ausgabe: Folgetableau
*/


				local piv;	// Pivotelement	

				begin

				  if T = {} then return(Transparent::empty()) end_if:

				  piv := Transparent::pivot1(T[1],T[2],T[3],T[9],T[2]+2):

				  if piv[1] <> 0 and T[1][piv[1],2]=0 
				    then piv := Transparent::pivot1_deg(T[1],T[2],T[3],T[9],T[11],T[2]+2)
				  end_if:

				  if piv[1] = 0 
				    then piv := Transparent::pivot2(T[1],T[2],T[3],T[9]):
					 if piv[1] <> 0 and T[1][piv[1],2]=0 
				           then piv := Transparent::pivot2_deg(T[1],T[2],T[3],T[9],T[11])
				         end_if:
					 if piv[2] = 0 
				           then if T[8] = {} then return(Transparent::result(T)) end_if:
						if T[1][2,2] <> 0 then return(Transparent::empty()) end_if:
						piv := Transparent::drive_out(T):
						if piv[1] = 0 
						  then return(Transparent::phaseII_tableau(T))
						  else return(Transparent::optstep(T,piv))
						end_if
				           elif piv[1] = 0 
					       then return(UNBOUNDED)
					       else return(Transparent::optstep(T,piv))
				         end_if
				    elif piv[2] = 0 
					then return(Transparent::empty())
					else return(Transparent::optstep(T,piv))
				  end_if

				end_proc:


unalias(Transparent):
unalias(Tableau):
unalias(Heap):
