// $Date: 2000/05/21 14:55:54 $ $Author: bij $ $Revision: 1.12 $ 
// sello, 12.6.97 

/*++
phaseI.mu -- return the phase I tableau for the given one
++*/

alias(Heap = adt::Heap):
alias(Tableau = linopt::Tableau):
alias(Transparent = linopt::Transparent):

Transparent::phaseI_tableau :=
proc(T)
				
// Eingabe: Tableau T
// Ausgabe: Phase I Tableau

  local negab, tbl,m,n,insertedvars,//equations,
  slackanz,/*scrollanz,*/interval,
  /*assoziated,*/ internalorder,		// Tableaukomponenten		
  oldobj,				               // alte Zielfunktion		
  i,j;				                  // Laufvariablen			
  
begin
  
  if T[8] <> {} then return(T) end_if:
  
  tbl := Transparent::convert(T):
  
  slackanz := T[7]:
  m := T[2]:
  n := T[3]+slackanz:
  interval := T[9]:
  internalorder := T[11]:
  
  oldobj[0] := T[1][2,2]:
  
  for j from 3 to n+2 do
    oldobj[tbl[1,j]] := tbl[2,j]
  end_for:
  
  for i from 3 to m+2 do
    oldobj[tbl[i,1]] := 0
  end_for:
  
				  negab := []:
  for i from 3 to m+2 do
    if tbl[i,2] < 0 then negab := append(negab,i) end_if
  end_for:
  
  tbl := assignElements(tbl,[[i+2,1],hold(slk)[slackanz+i]]$ i=1..m,
                        ([[negab[i],j],-tbl[negab[i],j]]
                         $ i=1..nops(negab))$ j=2..n+2):
  
  tbl := assignElements(tbl,[[2,j],-_plus(tbl[i,j]$ i=3..m+2)]$ j=2..n+2):
  
  insertedvars := {hold(slk)[i]$ i=slackanz+1..2*slackanz} union
                  T[4] /*minus {hold(slk)[i]$ i=1..slackanz}*/:
  
  for j from 3 to n+2 do
    internalorder[tbl[1,j]] := internalorder[tbl[1,j]] + slackanz
  end_for:
  
  for i from slackanz+1 to 2*slackanz do
    interval[hold(slk)[i],"greater"] := 0:
    interval[hold(slk)[i],"lower"] := UNKNOWN:
    internalorder[hold(slk)[i]] := -2*slackanz+i
  end_for:
  
  return(new(Transparent,tbl,m,n,insertedvars,T[5],T[6],slackanz,oldobj,
             interval,T[10],internalorder))
end_proc:

unalias(Transparent):
unalias(Tableau):
unalias(Heap):
