// $Date: 2000/05/21 14:55:55 $ $Author: bij $ $Revision: 1.5 $ 
// sello, 12.6.97 

/*++
reopt.mu -- reoptimize the given tableau T
++*/

alias(Heap = adt::Heap):
alias(Tableau = linopt::Tableau):
alias(Transparent = linopt::Transparent):

Transparent::reopt	:=
proc(TT)

// Eingabe: Tableau T, dual zulaessig!
//  Ausgabe: optimales Tableau

  local   T,
  f,			// Status des Pivotelementes	
  piv,			// Pivotelement			
  internalorder,slackanz; 	// Tableaukomponenten		
  
begin
  
  T:=TT;
  
  userinfo(6," Entering (linopt::Transparent)::reopt "):
  
  if T = {} then return(Transparent::empty()) end_if:
  
  
  internalorder := T[11]:
  
  slackanz := T[7]:

  piv := Transparent::dualpivot(T[1],T[2],T[3],T[9]):
  
  repeat
    
    userinfo(10,Transparent::uinfo(T)):
        userinfo(8," Result after this step   ", Transparent::result(T)):
    userinfo(8..9," Objective Function Value ", -T[1][2,2]):
    
    if piv[1] = 0 then f := 1: break end_if:
    if piv[2] = 0 then f := 2: break end_if:
    
    userinfo(10,(" Pivot  		       ",T[1][piv[1],1],T[1][1,piv[2]])):
    
    T := Transparent::optstep(T,piv):
    
    if T[1][2,piv[2]] = 0
      then
      
      userinfo(10," Degeneration ascertained "):
      
      piv := Transparent::dualpivot_deg(T[1],T[2],T[3],T[9],T[11])
    else
      piv := Transparent::dualpivot(T[1],T[2],T[3],T[9])
    end_if
    
  until 1 = 0 end_repeat:
  
  userinfo(6," Reoptimization finished "):
  
  if f = 2 then
    return({})
  end_if:
  
  return(T)
  
end_proc:

unalias(Transparent):
unalias(Tableau):
unalias(Heap):
