// $Date: 2000/05/21 14:55:55 $ $Author: bij $ $Revision: 1.4 $ 
// sello, 12.6.97 

/*++
suggest.mu -- suggest next simplex-step
++*/

alias(Heap = adt::Heap):
alias(Tableau = linopt::Tableau):
alias(Transparent = linopt::Transparent):


Transparent::suggest	:= 	proc(T)

/* Eingabe: Tableau T
  Ausgabe: Pivotelement in Form von Basis- und Nicht-Basisvariable, oder OPTIMAL, UNBOUNDED oder phaseII_tableau
*/

				local piv;	// Pivotelement	

				begin

				  if T = {} then return(Transparent::empty()) end_if:

				  piv := Transparent::pivot1(T[1],T[2],T[3],T[9],T[2]+2):

				  if piv[1] <> 0 and T[1][piv[1],2] = 0 
				    then piv := Transparent::pivot1_deg(T[1],T[2],T[3],T[9],T[11],T[2]+2)
				  end_if:

				  if piv[1] = 0 
				    then piv := Transparent::pivot2(T[1],T[2],T[3],T[9]):
					 if piv[1] <> 0 and T[1][piv[1],2]=0 
				           then piv := Transparent::pivot2_deg(T[1],T[2],T[3],T[9],T[11])
				         end_if:
					 if piv[2] = 0 
				    	   then if T[8] = {} then return(OPTIMAL) end_if:
						if T[1][2,2] <> 0 then return(Transparent::empty()) end_if:
						piv := Transparent::drive_out(T):
						if piv[1] = 0 
						  then return("linopt::Transparent::phaseII_tableau")
						  else return(T[1][piv[1],1],T[1][1,piv[2]])
						end_if
				           elif piv[1] = 0 
					       then return(UNBOUNDED)
					       else return(T[1][piv[1],1],T[1][1,piv[2]])
				         end_if
				    elif piv[2] = 0 
					then return(Transparent::empty())
					else return(T[1][piv[1],1],T[1][1,piv[2]])
				  end_if

				end_proc:


unalias(Transparent):
unalias(Tableau):
unalias(Heap):
