// $Date: 2000/05/21 14:55:35 $ $Author: bij $ $Revision: 1.2 $ 
// sello, 12.6.97


/*++
fillpoly.mu -- generate the plot-statement for a filled polygon, to be inserted in ->plot2d
++*/

alias(Heap = adt::Heap):
alias(Tableau = linopt::Tableau):

    linopt::filled_poly	:=	proc(n)
    
				local i,k,inputList,polygonlist,color;
				
				begin
				  inputList:=[args()];
				  polygonlist:=FALSE;
				  i:=1;

				  /*
				  | Suchen innerhalb der Benutzer-Eingabe nach der Polygonliste
				  */
				  while i <= nops(inputList) do
				    if testtype(op(inputList,i),DOM_LIST) then
				      k:=i;
				      polygonlist:=inputList[k];
				      i:=nops(inputList)+1;
				    else
				      i:=i+1;
				    end_if;
				 end_while;
				  if polygonlist=FALSE then
				    error("List expected");
				  elif not testtype(polygonlist[1],DOM_POLYGON) then
				    error("Illegal argument [polygon]")
				  end_if;

				  /*
				  | Suchen innerhalb der Benutzer-Eingabe nach der
				  | Polygonkontur-Farbe
				  */
				  if testtype(op(inputList,k+1),DOM_LIST) then
				    color:=inputList[k+1];
				  elif testtype(op(inputList,k+2),DOM_LIST) then
				    color:=inputList[k+2];
				  else
				    color:=null();
				  end_if;

				  /*
				  | Suchen innerhalb der Benutzer-Eingabe nach der
				  | Polygonspezifikation
				  */
				  if not testtype(op(inputList,nops(inputList)),DOM_LIST) then

				    if inputList[nops(inputList)]=Convex then
				      return( (plotlib::polygonplot)::triconv_neu(polygonlist,color) );

				    elif inputList[nops(inputList)]=Concave then
				      return( (plotlib::polygonplot)::triconc(polygonlist,color) );
				    else
				      error("Illegal polygon specification")
				    end_if;
				  elif not testtype(op(inputList,nops(inputList)-1),DOM_LIST) and
				       nops(inputList) > 2 then
				    if inputList[nops(inputList)-1]=Convex then
				      return(
					     (plotlib::polygonplot)::triconv_neu(polygonlist,color) 
				      );
				    elif inputList[nops(inputList)-1]=Concave then
				      return( (plotlib::polygonplot)::triconc(polygonlist,color) );
				    else
				      error("Illegal polygon specification")
				    end_if;
				  else
				    return( (plotlib::polygonplot)::maintriself(polygonlist,color) );
				  end_if;

				end_proc:



				
unalias(Tableau):
unalias(Heap):
