
// 
matchlib::RatFunc:=
  proc(ex)
  begin
    bool(contains({"_plus", "_mult"}, type(ex))
         or (type(ex) = "_power" and (testtype(op(ex, 2), Type::Integer) = TRUE)))
  end_proc:

matchlib::SqrtFunc:=
  proc(ex)
  begin
    bool(type(ex) = "_power" and type(op(ex, 2)) = DOM_RAT)
  end_proc:

matchlib::TrigFunc:=
  proc(ex)
  begin
    contains({"sin", "cos", "tan", "cot"}, type(ex))
  end_proc:

matchlib::TrighFunc:=
  proc(ex)
  begin
    contains({"sinh", "cosh", "tanh", "coth"}, type(ex))
  end_proc:

matchlib::InvTrigFunc:=
  proc(ex)
  begin
    contains({"arcsin", "arccos", "arctan", "arccot"}, type(ex))
  end_proc:

matchlib::InvTrighFunc:=
  proc(ex)
  begin
    contains({"arcsinh", "arccosh", "arctanh", "arccoth"}, type(ex))
  end_proc:

matchlib::ExpFunc:=
  proc(ex)
  begin
    bool(type(ex) = "exp")
  end_proc:

matchlib::LogFunc:=
  proc(ex)
  begin
    bool(type(ex) = "ln")
  end_proc:

matchlib::ANA:=
  [matchlib::RatFunc,
   matchlib::SqrtFunc,
   matchlib::TrigFunc,
   matchlib::TrighFunc,
   matchlib::InvTrigFunc,
   matchlib::InvTrighFunc,
   matchlib::ExpFunc,
   matchlib::LogFunc
   ]:

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// Ident = [] | {} | Any
// Const = {}
// Cond =
// Plain
matchlib::analyze:=
  proc(ex)
    local analyze, noconst, CONSTS, FUNCS, x, i;
  begin
    CONSTS:= [];
    FUNCS:= matchlib::ANA;
    x:= hold(Any);
    for i from 2 to args(0) do
      if type(args(i)) = "_equal" then
        case op(args(i), 1)
          of hold(Ident) do
            x:= op(args(i), 2); break
          of hold(Const) do
            CONSTS:= op(args(i), 2); break
          of hold(Cond) do
            FUNCS:= op(args(i), 2); break
        end_case
      end_if
    end_for;

    if testargs() then
      if not testtype(x, DOM_IDENT) and x <> hold(Any) then
        error("identifier or 'Any' expected as 'Ident'")
      elif CONSTS <> [] and not testtype(CONSTS, Type::ListOf(Type::Arithmetical))
           and not testtype(CONSTS, Type::SetOf(Type::Arithmetical)) then
        error("list of expressions expected as 'Const'")
      elif FUNCS <> [] and not testtype(FUNCS, Type::ListOf(Type::Function)) then
        error("list of functions expected as 'Cond'")
      end_if
    end_if;
      
    noconst:=
      proc(RET)
        local i;
        name noconst;
      begin
        if RET = x then return(FALSE) end_if;
        if CONSTS = [] then return(TRUE) end_if;
        i:= 1;
        while matchlib::match(RET, op(CONSTS, i), {x}) = {} do
          i:= i + 1;
          if i > nops(RET) then
            return(TRUE)
          end_if
        end_while;
        FALSE
      end_proc:

    analyze:=
      proc(ex, x)
        local i, RET;
        name analyze;
      begin
        i:= 1;
        while not((op(FUNCS, i))(ex, x)) do
          i:= i + 1;
          if i > nops(FUNCS) then
            return(ex)
          end_if
        end_while;

        RET:= stdlib::Exposed(matchlib::matchgen(ex, x, op(FUNCS, i)));
        case nops(op(RET, 3))
          of 0 do
            return(RET)
          of 1 do
            if noconst(op(op(RET, 3))) /*domtype(op(RET, [3, 1])) <> DOM_IDENT*/ then
              return(RET, [analyze(op(op(RET, 3)), x)])
            else
              return(RET)
            end_if
          otherwise
            return(RET, [analyze(op(op(RET, 3), i), x)] $ i=1..nops(op(RET, 3)))
        end_case
      end_proc:

    if contains({hold(Plain), hold(None), hold(Expr)}, args(args(0))) then
      analyze(ex, x)
    else
      adt::Tree([analyze(ex, x)])
    end_if
  end_proc:

