
matchlib::match:=
  proc(e, p)
    local k, n, OPT, CONST, ASS, COMM, NULL, COND;
  begin
    OPT:= table(select(args(), X->type(X) = "_equal"));
    CONST:= {};
    ASS:= {hold(_mult), hold(_plus)};
    COMM:= {hold(_mult), hold(_plus)};
    NULL:= table(hold(_mult) = 1, hold(_plus) = 0);
    COND:= table();
    if contains(OPT, hold(Const)) then
      CONST:= CONST union OPT[hold(Const)]
    end_if;
    if contains(OPT, hold(Ass)) then
      ASS:= ASS union OPT[hold(Ass)]
    end_if;
    if contains(OPT, hold(Comm)) then
      COMM:= COMM union OPT[hold(Comm)]
    end_if;
    if contains(OPT, hold(Null)) then
      NULL:= table(op(NULL), op(OPT[hold(Null)]))
    end_if;
    if contains(OPT, hold(Cond)) then
      COND:= [];
      for k in OPT[hold(Cond)] do
        if domtype(k) = DOM_PROC and nops(op(k, 1)) = 1 then
          n:= op(k, 1);
          COND:= append(COND, n = k)
        else
          error("wrong condition")
        end_if
      end_for;
      COND:= table(op(COND))
    end_if;
    
    if ASS <> {} then
      e:= matchlib::flatass(e, ASS);
      p:= matchlib::flatass(p, ASS)
    end_if;
    
    matchlib::match_aux(e, p, CONST, COMM, ASS, NULL, COND)
  end_proc:

match:= matchlib::match:

// e, p
matchlib::match_aux:= 
  proc(e, p, CONST = {}, COMM = {}, ASS = {}, NULL = {}, COND = {})
    local r, m, i;
  begin
    userinfo(2, "trying to match", e, "with pattern", p);
    if type(p) = DOM_IDENT then // nur eine Variable
      if contains(CONST, p) then
        if e = p then
          {}
        else
          FAIL
        end_if
      elif contains(COND, p) then
        if traperror((r:= bool(COND[p](e)))) = 0 and r = TRUE then
          {p = e}
        else
          FAIL
        end_if
      else
        {p = e}
      end_if
    elif e = p then
      {}
    elif type(p) = "_power" then
      if type(e) = "_power" then
        r:= matchlib::match_aux(op(e, 1), op(p, 1), CONST, COMM, ASS, NULL, COND);
        if r = FAIL then
          // try with power 1 (power 0 cannot be because e is a power) 
          matchlib::_union(matchlib::match_aux(e, op(p, 1), CONST, COMM, ASS, NULL, COND),
                           matchlib::match_aux(1, op(p, 2), CONST, COMM, ASS, NULL, COND))
        else // op(e, 1) and op(p, 1) match 
          matchlib::_union(r, matchlib::match_aux(op(e, 2), op(p, 2), CONST, COMM, ASS, NULL, COND))
        end_if
      else // e is not a power 
        r:= matchlib::_union(matchlib::match_aux(1, op(p, 2), CONST, COMM, ASS, NULL, COND),
                             matchlib::match_aux(e, op(p, 1), CONST, COMM, ASS, NULL, COND)); // power 1 
        if r <> FAIL then
          r
        else
          matchlib::_union(matchlib::match_aux(0, op(p, 2), CONST, COMM, ASS, NULL, COND),
                           matchlib::match_aux(e, 1, CONST, COMM, ASS, NULL, COND))
        end_if
      end_if
    elif type(p) = "_plus" then
      r:= select(p, testtype, DOM_INT);
      p:= p - r;
      e:= e - r;
      if type(p) <> "_plus" then
        matchlib::match_aux(e, p, CONST, COMM, ASS, NULL, COND)
      else
        matchlib::matchcomm(_plus, 0, matchlib::t2list(e, "_plus"), [op(p)], CONST, COMM, ASS, NULL, COND)
      end_if
    elif type(p) = "_mult" then
      if e = 0 then
        for r in p do
          if (r:= matchlib::match_aux(0, r, CONST, COMM, ASS, NULL, COND)) <> FAIL then
            return(r)
          end_if
        end_for;
        return(FAIL)
      end_if;
      r:= select(p, testtype, DOM_INT);
      p:= p/r; e:= e/r;
      if type(p) <> "_mult" then matchlib::match_aux(e, p, CONST, COMM, ASS, NULL, COND)
      else
        p:= sort(matchlib::t2list(p, "_mult"), 
                ()->bool(length(args(1))>length(args(2))));
        matchlib::matchcomm(_mult, 1, matchlib::t2list(e, "_mult"), p, CONST, COMM, ASS, NULL, COND)
      end_if
    elif p = op(p) then
      if e = p then
        {}
      else
        FAIL
      end_if
    elif domtype(e) = DOM_EXPR and domtype(p) = DOM_EXPR
         and nops(e) = nops(p) and
         (m:= matchlib::match_aux(eval(op(e, 0)), eval(op(p, 0)), CONST, COMM, ASS, NULL, COND)) <> FAIL then
      if contains(COMM, op(p, 0)) then
        if contains(NULL, op(p, 0)) then
          r:= NULL[op(p, 0)]
        else
          r:= FAIL
        end_if;
        matchlib::_union(m, matchlib::matchcomm(op(p, 0), r, matchlib::t2list(e, type(p)), [op(p)],
                                                CONST, COMM, ASS, NULL, COND))
      //
      else
        for i from 1 to nops(p) do
          r:= matchlib::match_aux(op(e, i), op(p, i), CONST, COMM, ASS, NULL, COND);
          if r = FAIL then return(FAIL) end_if;
          m:= matchlib::_union(m, r);
        end_for;
        m
      end_if
    elif contains(ASS, op(p, 0)) then
      if (m:= matchlib::match_aux(eval(op(e, 0)), eval(op(p, 0)), CONST, COMM, ASS, NULL, COND)) <> FAIL then
        if contains(NULL, op(p, 0)) then
          r:= NULL[op(p, 0)]
        else
          r:= FAIL
        end_if;
        matchlib::_union(m, matchlib::matchcomm(op(p, 0), r, matchlib::t2list(e, type(p)), [op(p)],
                                                CONST, COMM, ASS, NULL, COND))
      else
        FAIL
      end_if
    elif type(p) = "exp" then
      if e = 1 then
        matchlib::match_aux(0, op(p), CONST, COMM, ASS, NULL, COND)
      elif type(e) = "_power" and type(op(e, 1)) = "exp" then
        matchlib::match_aux(op(e, [1, 1])*op(e, 2), op(p), CONST, COMM, ASS, NULL, COND)
      else
        FAIL
      end_if
    else
      FAIL
    end_if;
  end_proc:

matchlib::_union:= 
  proc(a, b)
    option hold;
    local l;
  begin
    if (a:= context(a)) = FAIL then
      FAIL
    elif (b:= context(b)) = FAIL then
      FAIL
    else
      l:= [op(map(a, op, 1) intersect map(b, op, 1))];
      if subs(l, op(a)) <> subs(l, op(b)) then
        FAIL
      else
        a union b
      end_if
    end_if
  end_proc:

matchlib::t2list:= (e, tp)->(if type(e) = tp then [op(e)] else [e] end_if):

matchlib::matchcomm:= 
  proc(OPR, N, e, p, CONST, COMM, ASS, NULL, COND)
    local i, y, j;
  begin
    if p = [] then
      if e = [] then
        {}
      else
        FAIL
      end_if
    elif e = [] then
      FAIL
    elif nops(p) = 1 then
      if nops(e) > 1 then
        matchlib::match_aux(OPR(op(e)), op(p, 1), CONST, COMM, ASS, NULL, COND)
      else
        matchlib::match_aux(op(e), op(p, 1), CONST, COMM, ASS, NULL, COND)
      end_if
    else
      for j from 1 to nops(p) do
        for i from 1 to nops(e) do
          y:= matchlib::_union(matchlib::match_aux(op(e, i), op(p, j), CONST, COMM, ASS, NULL, COND), 
                               matchlib::matchcomm(OPR, N, subsop(e, i = null()),
                                                   subsop(p, j = null()), CONST, COMM, ASS, NULL, COND));
          if y <> FAIL then return(y) end_if
        end_for;
        if N <> FAIL then
          y:= matchlib::_union(matchlib::match_aux(N, op(p, j), CONST, COMM, ASS, NULL, COND),
                               matchlib::matchcomm(OPR, N, e, subsop(p, j = null()),
                                                   CONST, COMM, ASS, NULL, COND));
          if y <> FAIL then return(y) end_if
        end_if
      end_for;
      FAIL
    end_if
  end_proc:

matchlib::flatass:=
  proc(e, ASSOP)
    local i, x;
  begin
    if ASSOP = {} then return(e) end_if;

    if domtype(e) = DOM_EXPR then
      if contains(ASSOP, op(e, 0)) then
        for i from 1 to nops(e) do
          x:= op(e, i);
          if domtype(x) = DOM_EXPR then
            x:= matchlib::flatass(x, ASSOP);
            if op(x, 0) = op(e, 0) then
              e:= subsop(e, i = op(x))
            else
              e:= subsop(e, i = x)
            end_if
          end_if
        end_for;
        e
      else
        e
      end_if
    else
      e
    end_if
  end_proc: