/*- 
 changeVertex - change the weight of one or several vertices in a Network
 changeVertex(G,x,Vweight=n)
 changeVertex(G,[x1,..,xn], Vweight=[v1,..vn])
-*/
Network::changeVertex := proc(G,v,vw)
local V,i,Vw,Lhs,Rhs;
begin
   if testargs() then
      if args(0) <> 3 then
	     error("Wrong number of arguments!")
      end_if;
      Network::graph_check(G);
      if not testtype(args(3), "_equal") then
	     error("Wrong vertex weights specification!");
      end_if;
   end_if;
   
   Lhs := op(vw,1); Rhs := op(vw,2);
   if Lhs <> hold(Vweight) then
	   error("Vertex weight specification!")
   end_if;

   if testtype(v, DOM_LIST) then
	   /*--
	   if not testtype(Rhs, Type::ListOf(Type::Numeric)) then
		  error("Non numeric vertex weights!");
	   end_if;
	   --*/
	   if nops(v) <> nops(Rhs) then
		  error("Length of lists must be equal!");
	   end_if;
	   V := Network::vertex(G);
	   Vw := Network::vWeight(G);
	   for i from 1 to nops(Rhs) do
	      if contains(V, v[i]) = 0 then
	          error("specified node isn't contained in the Network!");
	      end_if;
		  Vw[v[i]] := Rhs[i];
	   end_for;
   else
	   /*--
	   if not testtype(Rhs, Type::Numeric) then
		   error("Non numeric vertex weight!");
	   end_if;
	   --*/
	   V := Network::vertex(G);
	   if contains(V, v) = 0 then
	          error("specified node isn't contained in the Network!");
	   end_if;
	   Vw := Network::vWeight(G);
	   Vw[v] := Rhs;
   end_if;
	
   new(Network, V, Network::edge(G), Vw, Network::eCapacity(G), 
	 Network::eWeight(G), Network::epost(G), Network::epre(G));
end_proc:
