/*-
 delEdge - deletes an edge
 delEdge(G,e)
 delEdge(G,[e1,..,en])
 Parameters:
   G - Network
   e - edge or list of edges
 Deletes the specified edge(s).
-*/
Network::delEdge := proc(G,v)
local V,Ed,Vw,Ew,Ecap,Epo,Epr,b,e;
begin
  if testargs() then
    if args(0) <> 2 then
	error("Wrong number of arguments!");
    end_if;
    Network::graph_check(G);
  end_if;
  V   := Network::vertex(G);
  Ed  := Network::edge(G);
  Vw  := Network::vWeight(G);
  Ew := Network::eWeight(G);
  Ecap := Network::eCapacity(G);
  Epo := Network::epost(G);
  Epr := Network::epre(G);
  if testtype(v, Type::ListOf(DOM_LIST)) then
     for e in v do
        b := contains(Ed, e);
	if b > 0 then
	   delete Ed[b];
	   b := contains(Epo[e[1]],e[2]);
	   delete Epo[e[1]][b];
	   b := contains(Epr[e[2]],e[1]);
	   delete Epr[e[2]][b], Ew[e], Ecap[e];
        end_if;
     end_for;
  else
     b := contains(Ed, v);
     if b > 0 then
	delete Ed[b];
        b := contains(Epo[v[1]],v[2]);
        delete Epo[v[1]][b];
        b := contains(Epr[v[2]],v[1]);
        delete Epr[v[2]][b], Ew[v], Ecap[v];
      end_if;
  end_if;
  new(Network, V, Ed, Vw, Ecap, Ew, Epo, Epr);
end_proc:
