/*-
 delVertex - deletes a node 
 delVertex(G,x)
 delVertex(G,[x1,..,xn]
 Parameters:
   G - Network
   x - node, list of nodes
 Deletes all specified nodes and the incident arcs from the Network.
-*/
Network::delVertex := proc(G,v)
local V,Ed,Vw,Ew,Ecap,Epo,Epr,i,f,a,b,e;
begin
  if testargs() then
    if args(0) <> 2 then
	error("Wrong number of arguments!");
    end_if;
    Network::graph_check(G);
  end_if;
  V   := Network::vertex(G);
  Ed  := Network::edge(G);
  Vw  := Network::vWeight(G);
  Ew := Network::eWeight(G);
  Ecap := Network::eCapacity(G);
  Epo := Network::epost(G);
  Epr := Network::epre(G);
  f := proc() begin bool(contains(args(1),args(2)) <> 0) end_proc :
  if testtype(v, DOM_LIST) then
     for i in v do
        b := contains(V, i);
	if b > 0 then
	   delete V[b];
	   a := select(Ed, f, i);
	   delete Vw[i];
           for e in a do 
	      b := contains(Epo[e[1]],e[2]);
	      delete Epo[e[1]][b];
	      b := contains(Epr[e[2]],e[1]);
	      delete Epr[e[2]][b], Ew[e], Ecap[e];
	      b := contains(Ed, e);
	      delete Ed[b];
	   end_for;
           delete Epo[i], Epr[i];
        end_if;
     end_for;
  else
     b := contains(V, v);
     if b > 0 then
	delete V[b];
        a := select(Ed, f, v);
        delete Vw[v];
           for e in a do 
              b := contains(Epo[e[1]],e[2]);
              delete Epo[e[1]][b];
              b := contains(Epr[e[2]],e[1]);
              delete Epr[e[2]][b] , Ew[e], Ecap[e];
	      b := contains(Ed, e);
	      delete Ed[b];
           end_for;
           delete Epo[v], Epr[v];
      end_if;
  end_if;
  new(Network, V, Ed, Vw, Ecap, Ew, Epo, Epr);
end_proc:
