/*- 
 maxFlow - computes a maximal flow
 maxFlow(G,q,s)
 Parameters:
   G - network
   q,s - vertices in G
 Computes a maximal flow from q to s in G.
 Uses Network::pp_fifo.
-*/
Network::maxFlow := proc(G,q,s)
local V, Ed, Ecap, Epo, Epr;
begin
  if testargs() then
   	if args(0) <> 3 then
	   error("Wrong number of arguments!");
   	end_if;
	Network::graph_check(G);
	if not Network::isVertex(G,q) and not Network::isVertex(G,s) then
    	   error("Specified vertices are not contained in network!");
    	end_if;
  end_if;
  V := Network::vertex(G);
  Ed := Network::edge(G);
  Ecap := Network::eCapacity(G);
  Epo := Network::epost(G);
  Epr := Network::epre(G);
  Network::pp_fifo(V, Ed, Ecap, Epo, Epr, q,s);
end_proc:
