 /*--
 minCost - minimal cost flow
 minCost(G)
 Parameters:
   G - network
 Uses Network::relaxation
--*/
Network::minCost := proc(G)
local V, Vw, Ed, Ew, Ecap, Epo, Epr, f, i; 
begin
   if testargs() then
      if args(0) <> 1 then
         error("Wrong number of parameters!");
      end_if;
      Network::check_graph(G);
   end_if;
   V := Network::vertex(G);
   Ed := Network::edge(G);
   Vw := Network::vWeight(G);
   Ecap := Network::eCapacity(G);
   Ew := Network::eWeight(G);
   Epo := Network::epost(G);
   Epr := Network::epre(G);
   f := Network::relaxation(V, Ed, Vw, Ecap, Ew, Epo, Epr);  
   _plus(Ew[Ed[i]] * f[1][Ed[i]] $ i=1..nops(Ed)), f[1],f[2];
end_proc:
