// $Date: 2000/05/21 14:56:18 $ $Author: bij $ $Revision: 1.8 $ 

/*-
 spath - generates pathes for ShortPath, ShortPathTo and LongPath
 Parameters:
   V - list of nodes
   v - node
   d - sequence with table of distances and a table with successors or
       predecessors
   a - number, specifying the result: Length (0,1), Path (10), 
       Length & Path (11)
   ww - 1 if one distance (v,..,w) is desired, 0 if all distances are desired
   www - the target node (if ww = 1)
   app - 0 if the pathes are to one single node are desired, 1 if the pathes
         from one single node are desired
-*/
Network::spath_eval := proc(V,v,dd,a,ww,www,app=1)
local d,dist,sp,path,i,w,u,f,res;
// global v (2nd arg. of ShortPath, ShortPathTo or LongPath) 
// removed 
begin
   res := [];
   dist := op(dd,1);
   d := op(dd,2);

   if ww = 1 then  //- final node specified -
      case a
          of 0 do
            res := [dist[www]];
            break;
         of 1 do
            res := [dist[www]];
            break
         of 11 do
            res := [dist[www]];
         of 10 do
            if dist[www] = infinity then
   		res := append(res, []);
	    else
               w := www;
               path := [w];
               repeat
                  u := d[w];
                  if app =0 then
                     path := listlib::insertAt(path,u,1);
                  else
                     path := append(path,u);
                  end_if;
                  w := u;
               until (w = v) end_repeat;
               res := append(res,path);
            end_if;
      end_case;
   else //- no final node specified -
      case a
          of 0 do
            res := [dist];
            break;
         of 1 do
            res := [dist];
            break
         of 11 do
            res := [dist];
         of 10 do
     	    sp := table();
	        f := proc() begin bool((args(1) <> v) and (dist[args(1)] <> infinity)) end_proc ;
            for i in select(V, f) do
               path := [i];
               w := i;
               repeat 
	          u := d[w];
	          if app =0 then
                 path := listlib::insertAt(path,u,1);
              else
                 path := append(path,u);
              end_if;
	          w := u;
               until (w = v) or (contains(sp,w)) end_repeat;
               if contains(sp,w) then
	          delete path[1];
	          sp[i] := sp[w].path;
               else
	          sp[i] := path;
               end_if;
            end_for;
            res := append(res,sp);
      end_case;
   end_if;
   op(res);
end_proc:
