/*++ ---------------- series.mu ---------------------

Author: Winfried Fakler,  University of Paderborn

Date Created: 19 July  2000
Last Update : 19 July  2000

Description:
This file contains the main function for computing series solutions of ode's.

Functions:

 - used Parameter:

 - ode::series

See:

Example:
ode::series(ode(diff(y(x),x)+sin(x)/x,y(x)),x=a)
ode::series(diff(y(x),x)-y(x)^2-x^2,y(x),x=1)
ode::series(diff(y(x),x,x)-y(x)^2-x^2,y(x),{y(0)=0},x=0)
ode::series(ode({y''(x)-y(x)^2-x^2,y(0)=0,D(y)(0)=3},y(x)),x=0)
ode::series(ode(y''(x)-y(x)+sin(x)/x,y(x)),x)

++*/

ode::series:=
  proc(aa)  // ode(..),x=a,<order>  oder: eq,y(x),<inits>,x=a,<order>
            // ode(..),x,<order>    oder: eq,y(x),<inits>,x,<order>
  begin
    // currently this is simply an interface for ode::repeatedDifferentiating
    // later this function should also contain an ansatz (maybe modified)
    // and the method of frobenius.
    ode::repeatedDifferentiating(args());
  end_proc:
