// $Date: 2000/05/21 14:57:37 $ $Author: bij $ $Revision: 1.14 $ 
// tonner, 23/06/98 

/*++
output::CatContent -- Category of Content markup
++*/

/** Creating Content trees
 *
 *   This domain implements the infrastructure to create Content
 *   trees
 */

category output::CatContent
  category output::CatUtils;

  outputType := "Content";
  
  Ccn;        // Content Number
  Cci;        // Content Identifier
  Capply;     // apply function
//   Creln;      // equation or relation  (MML 1.0; abandoned with MML 2.0)
  Cfn;        // user-defined function
//  Cinterval;  // interval constructor
//  Cinverse;   // functional inverse
  Ccondition; // properties of an identifier
//  Cdeclare;   // declaration
//  Clambda;    // user defined functions
  
//  Csep;       // separator
//  Ccompose;   // composition operator
  Cident;     // identity function

  // Arithmetic, Algebra and Logic
  Cquotient;  Cexp;  Cfactorial;  Cdivide;  Cmax;  Cmin;
  Cminus;  Cplus;  Cpower;  Crem;  Ctimes;  Croot;

// Cgcd;
  Cand;  Cor;  
// Cxor;  
  Cnot;  
// Cimplies;  Cforall;  Cexists;
  Cabs;  
// Cconjugate;

  // Relations
  Ceq;  Cneq;  
// Cgt;  
  Clt;  
// Cgeq;  
  Cleq;

  // Calculus
  Cln;  
// Clog;  
  Cint;  
// Cdiff;  Cpartialdiff;  
  Clowlimit;  Cuplimit;  Cbvar;  Cdegree;

  // Theory of sets
  Cset;  Clist;  Cunion;  Cintersect;  
// Cin;  Cnotin;  Csubset;  Cprsubset;  Cnotsubset;  
  Csetdiff;

  // Sequences and Series
  Csum;  
// Cproduct;  
  Climit;  Ctendsto;

  // Trigonometry
  Csin;    Ccos;    Ctan;    Csec;   Ccsc;   Ccot;
  Csinh;   Ccosh;   Ctanh;   Csech;  Ccsch;  Ccoth;
  Carcsin; Carccos; Carctan;

  // Statistics
//  Cmean;  Csdev;  Cvar;  Cmedian;  Cmode;  Cmoment;

  // Linear Algebra
//  Cvector;  
  Cmatrix;  Cmatrixrow;  
//  Cdeterminant;  Ctranspose;  Cselect;

  // Semantic Mapping Elements
//  Cannotation;  Csemantics;  CannotationXml;


  // special MuPAD constructs
  Cexprseq;
  Csqrt;  // NOT IN MathML !!!  
//  Ctext;

  statement := () -> error("not yet implemented");
  
  // mappe Argument auf MMLcontent-Token oder Token-Definition
  funcType :=
  proc()
    local ownType;
    option escape;
  begin
    ownType := dom::Cfn(args());
    proc()
    begin
      ownType, args()
    end_proc
  end_proc;
    
  // print a standard function f(a,b)
  stdFunc :=
  proc()
    local arg1;
  begin
    if nops(args()) = 0 then
	  arg1 := null();
    else
      arg1 := op(map([op(args())], dom));
    end_if;
    dom::create("apply", "", "", dom::Capply(dom::funcType(op(args(), 0)), arg1));
  end_proc;

end_category:
  
// end of file 
