DOM_EXPR::Content := 
proc(Out:DOM_DOMAIN)
  local arg1, op0, arg0, method;
begin
  arg1 := args(2..args(0));
  op0 := op(arg1, 0);
  if domtype(op0)=DOM_IDENT or type(op0) = "slot" then
    arg0 := eval(%);
  else
    arg0 := op0;
    op0 := text2expr(expr2text(op0));
  end_if;
  
  if domtype(arg0) = DOM_FUNC_ENV then
    if (method := slot(arg0, Out::Name)) <> FAIL then
      method(Out, arg1);
    elif (method := arg0::Content) <> FAIL then
      context(subsop(hold(sysassign(NIL, NIL)),
		     1=op0,
		     2=slot(arg0, Out::Name, method)));
      method(Out, arg1);
    elif op(arg0, 2) <> NIL and domtype(op(arg0, 2)) <> DOM_EXEC then
      Out(op(arg0, 2)(arg1))
    else
	// functional output
      Out::stdFunc(arg1)
    end_if;
  else
    // functional output
    Out::stdFunc(arg1)
  end_if;
end_proc:


DOM_EXPR::Presentation :=
proc(Out:DOM_DOMAIN)
  local arg1, op0, arg0, method;
begin
  arg1 := args(2..args(0));
  op0 := op(arg1, 0);
  if domtype(op0)=DOM_IDENT or type(op0) = "slot" then
    arg0 := eval(%);
  else
    arg0 := op0;
    op0 := text2expr(expr2text(op0));
  end_if;
  
  if domtype(arg0) = DOM_FUNC_ENV then
    if (method := slot(arg0, Out::Name)) <> FAIL then
      method(Out, arg1);
    elif (method := arg0::Presentation) <> FAIL then
      context(subsop(hold(sysassign(NIL, NIL)),
		     1=op0,
		     2=slot(arg0, Out::Name, method)));
      method(Out, arg1);
    elif op(arg0, 2) <> NIL and domtype(op(arg0, 2)) <> DOM_EXEC then
      Out(op(arg0, 2)(arg1))
    else
	// functional output
      Out::stdFunc(arg1)
    end_if;
  else
    // functional output
    Out::stdFunc(arg1)
  end_if;
end_proc:


/********************** Content **********************/

_exprseq::Content    := Out -> Out::Cexprseq(map(args(2..args(0)), Out)):
modp::Content        := (Out, data) -> Out::Capply(Out::Crem, map(op(data), Out)):
mods::Content        := (Out, data) -> Out::Capply(Out::Crem, map(op(data), Out)):
_mod::Content        := (Out, data) -> Out::Capply(Out::Crem, map(op(data), Out)):
_div::Content        := (Out, data) -> Out::Capply(Out::Cquotient, map(op(data), Out)):
_union::Content      := (Out, data) -> Out::Capply(Out::Cunion, map(op(data), Out)):
_intersect ::Content := (Out, data) -> Out::Capply(Out::Cintersect, map(op(data), Out)):
_minus ::Content := (Out, data) -> Out::Capply(Out::Csetdiff, map(op(data), Out)):
_concat::Content     := Content::infixOperator("."):

_equal::Content      := (Out, data) -> Out::Capply(Out::Ceq, map(op(data), Out)):
_fconcat::Content    := (Out, data) -> Out::Capply(Out::Ccompose, map(op(data), Out)):
_leequal::Content    := (Out, data) -> Out::Capply(Out::Cleq, map(op(data), Out)):
_less::Content       := (Out, data) -> Out::Capply(Out::Clt, map(op(data), Out)):
_or::Content         := (Out, data) -> Out::Capply(Out::Cor, map(op(data), Out)):
_and::Content        := (Out, data) -> Out::Capply(Out::Cand, map(op(data), Out)):
_range::Content      := (Out, data) -> Out::Capply(Out::Crange, map(op(data), Out)):
_unequal::Content    := (Out, data) -> Out::Capply(Out::Cneq, map(op(data), Out)):
binomial::Content    := (Out, data) -> Out::Capply(Out::Cbinomial, map(op(data), Out)):
fact::Content        := (Out, data) -> Out::Capply(Out::Cfactorial, Out(op(data))):

last::Content        := Content::prefixOperator("&percnt;"):
_not::Content        := (Out, data) -> Out::Capply(Out::Cnot, Out(op(data))):
_negate::Content     := (Out, data) -> Out::Cminus(Out(op(data,1))):
_divide::Content     := (Out, data) -> Out::Cdivide(Out(op(data,1)), Out(op(data,2))):
conjugate::Content        := (Out, data) -> Out::Capply(Out::Cconjugate, Out(op(data))):
norm::Content        := (Out, data) -> Out::Capply(Out::Cnorm, map(op(data), Out)):
polylog::Content        := (Out, data) -> Out::Capply(Out::Cpolylog, map(op(data), Out)):
dilog::Content        := (Out, data) -> Out::Capply(Out::Cpolylog, 2, Out(op(data))):
log::Content        := (Out, data) -> Out::Capply(Out::Clog, map(op(data), Out)):

//++++++++++++++++ default output of statements   +++++++++++++++++
/* _assign::Content   := Content::statement: defined in sysinit.mu */
sysassign::Content := Content::statement:
_break::Content    := Content::statement:
_case::Content     := Content::statement:
_for::Content      := Content::statement:
_for_down::Content := Content::statement:
_for_in::Content   := Content::statement:
_if::Content       := Content::statement:
_next::Content     := Content::statement:
_quit::Content     := Content::statement:
_repeat::Content   := Content::statement:
_stmtseq::Content  := Content::statement:
_while::Content    := Content::statement:
//++++++++++++++++ default output of statements   +++++++++++++++++


alias(path=pathname("OUTPUT", "EXPR")):


abs::Content      := (Out, data) -> Out::Capply(Out::Cabs, Out(op(data))):
exp::Content      := (Out, arg1) -> Out::Capply(Out::Cexp, Out(op(arg1))):
_index::Content   := (Out, data) -> Out::Cci(Out::Cindex(Out(op(data, 1)),
                                              Out(op(data, 2..nops(data))))):
diff::Content     := proc(Out, data) 
                       local i, bvar, varList;
                     begin
                         if nops(data) = 1 then return(Out(op(data))) end:

                         bvar := op(data, nops(data)); i := nops(data);
                         while i > 2 and op(data, i-1) = bvar do
                           i := i-1;
                         end_while; 
                         varList := op(data, 2..i-1);
                         if i = nops(data) then
                            Out::Capply(Out::Cpartialdiff, 
                                        Out(hold(diff)(op(data, 1), varList)), 
                                        Out(bvar)):
                         else
                            Out::Capply(Out::Cpartialdiff, 
                                        Out(hold(diff)(op(data, 1), varList)),
                                        Out(bvar), nops(data)-i+1):
                         end_if;
                     end_proc:
int::Content      := proc(Out, data)
                     begin
                       if type(op(data, 2)) = "_equal" then
                         // definite integral
                         Out::Capply(Out::Cint,
                                     Out::Cbvar(Out(op(data, [2,1]))),
                                     Out::Clowlimit(Out(op(data, [2,2,1]))),
                                     Out::Cuplimit( Out(op(data, [2,2,2]))),
                                     Out(op(data,1)));
                       else
                         // indefinite integral
                         Out::Capply(Out::Cint,
                                     Out::Cbvar(Out(op(data, 2))),
                                     Out(op(data,1)));
                       end_if;
                     end_proc:
_mult::Content    := loadproc(_mult::Content, path, "mult"):
_plus::Content    := (Out, data) -> Out::Capply(Out::Cplus, op(map([op(data)],Out))):
_subtract::Content:= (Out, data) -> Out(hold(_plus)(op(data,1), - op(data,2))):
_power::Content   := loadproc(_power::Content, path, "power"):
_seqgen::Content  := (Out, data) -> error("not yet implemented"):
slot::Content     := proc(Out, data) 
                       local x, key;
                     begin
                       key := op(data, 2);
                       if domtype(key) = DOM_STRING and
                          traperror((x := text2expr(key))) = 0 and
                          nops(data) = 2 then
                         Out::Capply(Out::Cslot, Out(op(data,1)), x)
                       else
                         Out(hold(slot)(op(data)))
                       end_if:
                     end_proc:



/********************** Presentation **********************/

alias(MathML = output::MMLpresentation):

_exprseq::Presentation   := MathML::infixOperator(","):
modp::Presentation       := MathML::infixOperator(" ","mod",""):
mods::Presentation       := MathML::infixOperator("mod"):
_mod::Presentation       := MathML::infixOperator("mod"):
_div::Presentation       := MathML::infixOperator("div"):
_union::Presentation     := MathML::infixOperator("&Union;"):
_intersect::Presentation := MathML::infixOperator("&Intersect;"):
_concat::Presentation    := MathML::infixOperator("."):
_equal::Presentation     := MathML::infixOperator("&Equal;"):
_fconcat::Presentation   := MathML::infixOperator("@"):
_leequal::Presentation   := MathML::infixOperator("&leq;"):
_less::Presentation      := MathML::infixOperator("<"):
_or::Presentation        := MathML::infixOperator("&Or;"):
_and::Presentation       := MathML::infixOperator("&And;"):
_range::Presentation     := MathML::infixOperator(".."):
_unequal::Presentation   := MathML::infixOperator("&NotEqual;"):
fact::Presentation       := MathML::postfixOperator("!"):
last::Presentation       := MathML::prefixOperator("&percnt;"):
_not::Presentation       := MathML::prefixOperator("&Not;"):


//++++++++++++++++ default output of statements   +++++++++++++++++
_assign::Presentation   := MathML::statement:
sysassign::Presentation := MathML::statement:
_break::Presentation    := MathML::statement:
_case::Presentation     := MathML::statement:
_for::Presentation      := MathML::statement:
_for_down::Presentation := MathML::statement:
_for_in::Presentation   := MathML::statement:
_if::Presentation       := MathML::statement:
_next::Presentation     := MathML::statement:
_quit::Presentation     := MathML::statement:
_repeat::Presentation   := MathML::statement:
_stmtseq::Presentation  := MathML::statement:
_while::Presentation    := MathML::statement:
//++++++++++++++++ default output of statements   +++++++++++++++++


    //------------------------------------------------------------
    //                           abs(x)  -> |x|                   
    //------------------------------------------------------------

abs::Presentation := (Out, data) -> Out::mfenced("open"="|", "close"="|",
                                                 Out(op(data))):

_index::Presentation := (Out, data) -> Out::msub(Out(op(data, 1)),
                                                 Out(op(data, 2..nops(data)))):
binomial::Presentation := loadproc(binomial::Presentation, path, "binomial"):
diff::Presentation     := loadproc(diff::Presentation, path, "diff"):
exp::Presentation      := loadproc(exp::Presentation, path, "exp"):
int::Presentation      := loadproc(int::Presentation, path, "int"):
limit::Presentation    := loadproc(limit::Presentation, path, "limit"):
_mult::Presentation    := loadproc(_mult::Presentation, path, "mult"):
_plus::Presentation    := loadproc(_plus::Presentation, path, "plus"):
_power::Presentation   := loadproc(_power::Presentation, path, "power"):
_seqgen::Presentation  := loadproc(_seqgen::Presentation, path, "seqgen"):
slot::Presentation     := loadproc(slot::Presentation, path, "slot"):
sum::Presentation      := loadproc(sum::Presentation, path, "sum"):
