_mult_intern::Presentation := 
output::MMLpresentation::infixOperator("&InvisibleTimes;"):
//  map Out::new instead of Out because strange behaviour of map (Content(hold(2^2*3))) 
_mult_intern::Content := (Out, data) -> Out::Capply(Out::Ctimes, map(op(data), Out::new));

_mult::Content :=
proc(Out, data)
  local value, numerator, denum, result;
begin
  value := Out::splitProduct(data);
  if nops(op(value, 2)) = 1 then
    numerator := Out(op(op(value, 2)));
  else
    numerator := Out(hold(_mult_intern)(op(op(value, 2))));
  end_if;
  if op(value, 3) = [] then
    if op(value, 1) = -1 then
      return(Out::Capply(Out::Cminus, numerator));
    else
      return(numerator);
    end_if;
  end_if;
  if nops(op(value, 3)) = 1 then
    denum := Out(op(op(value, 3)));
  else
    denum := Out(hold(_mult_intern)(op(op(value, 3))));
  end_if;
  
  result := Out::Capply(Out::Cdivide, numerator, denum);
  if op(value, 1) = -1 then
    Out::Capply(Out::Cminus,  result);
  else
    %
  end_if;
end_proc:


    //------------------------------------------------------------
    //        a              a - b                (a - b) c       
    // a/b -> - , (a-b)/c -> ----- , (a-b)*c/d -> --------- , ... 
    //        b                c                      d           
    //------------------------------------------------------------
_mult::Presentation :=
proc(Out, data)
  local value, numerator, denum, result;
begin
  if nops(data) < 2 then
    return(Out::mrow(Out(op(data, 0)),
                     Out::parenthesis(Out(op(data)))))
  end_if;
  value := Out::splitProduct(data);
  if nops(op(value, 2)) = 1 then
    numerator := Out(op(op(value, 2)));
  else
    numerator := Out(hold(_mult_intern)(op(op(value, 2))));
  end_if;
  if op(value, 3) = [] then
    if op(value, 1) = -1 then
      return(Out::mrow(Out::mo("-"), numerator));
    else
      return(numerator);
    end_if;
  end_if;
  if nops(op(value, 3)) = 1 then
    denum := Out(op(op(value, 3)));
  else
    denum := Out(hold(_mult_intern)(op(op(value, 3))));
  end_if;
  
  result := Out::mfrac(numerator, denum);
  if op(value, 1) = -1 then
    Out::mrow(Out::mo("-"),  result);
  else
    result
  end_if;
end_proc:
