    //------------------------------------------------------------
    //                                   b                        
    //                         a^b  ->  a                         
    //------------------------------------------------------------
_power::Content := 
proc(Out, data) 
  local root, exponent, base, factors, toBeInverted, res;
begin
  base := op(data, 1);
  if domtype(op(data, 2)) = DOM_RAT then
    root := op(data, [2,2]);   
    exponent := op(data, [2,1]); 
  elif type(op(data, 2)) = "_mult" and 
      (factors := Out::splitProduct(op(data, 2));  
       nops(op(factors, 3)) > 0) then
    
    root := hold(_mult)(op(op(factors, 3)));
    if op(factors, 1) = -1 then
       exponent := hold(_mult)(op(op(factors, 2)), -1);
    else
       exponent := hold(_mult)(op(op(factors, 2)));
    end_if;
  else
    root := 1;   
    exponent := op(data, 2); 
  end_if;


  case root 
    of 1 do 
       res := Out(base); break;
    of 2 do
       res := Out::Csqrt(Out(base)); break;
    otherwise
       res := Out::Croot(Out(base), Out::Cdegree(Out(root))); 
  end_case;

  toBeInverted := FALSE;
  if Out::isNeg(exponent) and not testtype(base, Type::Real) then
    toBeInverted := TRUE;
    if exponent <> -1 then
        res := Out::Capply(Out::Cpower, res, Out(-exponent))
    end_if;
  else
    if exponent <> 1 then
      res := Out::Capply(Out::Cpower, res, Out(exponent)):
    end_if;
  end_if;

  if toBeInverted then
    Out::Cdivide(Out(1),res)
  else
    res
  end_if;
end_proc:

_power::Presentation :=
proc(Out, data)
begin
  if Out::isNeg(op(data, 2)) then
    if op(data, 2) = -1 then

/* ist Quatsch, sollte aber entsprechend laufen */
        Out::Cdivide(1,Out(op(data,1)))
    else
        Out(hold(_mult)(1, data));
    end_if;
  else
    Out::msup(
              Out::parenthesisOut(
                                  output::Priority::Power,
                                  [op(data,1)]),
              Out(op(data,2)))
  end_if;
end_proc:
    
