// $Date: 2000/11/01 13:41:23 $  $Author: frankp $   $Revision: 1.3 $

// frankp, 21.02.00
/*
    yrotate( f,  range = a..b <, op1, op2, ...>  )
*/


plot::yrotate := proc(f, range, angle=null())
    local r, options, i, tmp;
begin
    tmp := args(0);

    if tmp = 0 then 
        error("no argument given");
    elif tmp < 2 then
        error("at least two arguments expected");        
    end_if;
    
    options := [args(3..args(0))];
    
    r := genident("angle");
    
    if (range:= plot::conv2range(range)) = FAIL then
        error("2nd argument: illegal type (form 'ident = a..b' expected)");
    end_if:

    if not contains({op(map(options, op, 1))}, hold(Angle)) then
        angle := r = 0..2*PI;                
    else
        for i from 1 to nops(options) do
            tmp := options[i];
            if op(tmp, 1) = hold(Angle) then
                angle := r = op(tmp, 2);
                options[i]:= FAIL
            end_if
        end_for;
        options:= subs( options,FAIL = null() )
    end_if;

    f:= [ op(range, 1), f];;
    f:= [ f[1] * cos(op(angle,1)), f[1] * sin(op(angle,1)), f[2] ];
    return( plot::Surface3d(f, range, angle, op(options, 1..nops(options))) )
end_proc:

