plotlib::check_args3d := proc()
  local  axes, cgrid, color, l, labeling, LogXYZ, n, na,
         new_args, new_list, p, sgrid, t, ticks, vbox;
begin

  axes     := Box;
  ticks    := [5, 5, 5];
  LogXYZ   := [Lin, Lin, Lin];
  labeling := TRUE;
  vbox     := [XMin, XMax, YMin, YMax, ZMin, ZMax];
  cgrid    := 100;    // Mode = Curve  : Default grid points
  sgrid    :=  20;    // Mode = Surface: Default grid points
  // Mode = Surface: Default coloring [Height, RGB::Yellow, RGB::Red]
  color    := [Height, [1.0,1.0,0.0], [1.0,0.0,0.0]];

  new_args := [args()];

  t := select(new_args, has, AxesScaling);
  if t <> [] then 
     if not ( type(t[1]) = "_equal" and type((l:=op(t[1], 2))) = DOM_LIST and 
              nops(l) = 3 and (l[1] = Lin or l[1] = Log) and 
       	      (l[2] = Lin or l[2] = Log) and (l[3] = Lin or l[3] = Log) 
 	    ) then
        error(expr2text(op(t[1], 1)).": [x, y, z] expected (x, y and z are Lin or Log)")
     else
        if l[1] = Log then LogXYZ[1] := TRUE; end_if;
        if l[2] = Log then LogXYZ[2] := TRUE; end_if;
	if l[3] = Log then LogXYZ[3] := TRUE; end_if;
     end_if;
  end_if;

  t := select(new_args, has, Ticks);
  if t <> [] then 
     if not ( type(t[1]) = "_equal" ) then
        error("Illegal Ticks.")
     end_if;
     // Ersetze die Option Ticks = ... durch neuen Wert
     p := plotlib::check_ticks(op(t[1],2), vbox, ticks, LogXYZ);
     new_args := subs(new_args, op(t)=p);
  else
     new_args := [Ticks = ticks] . new_args // Insert default value
  end_if;

  t := select(new_args, has, Labeling);
  if t = [] then 
     new_args := [Labeling = labeling] . new_args // Insert default value
  end_if;

  t := select(new_args, has, Axes);
  if t = [] then 
     new_args := [Axes = axes] . new_args // Insert default value
  end_if;

  if hastype(new_args, DOM_POLYGON) or
     has(new_args, {Mode=Curve, Mode=Surface}) then
     
  na := [];

  for l in new_args do
      if type(l) = DOM_LIST and type(l[1]) = "_equal" and
         op(l[1], 1) = Mode then

	 if op(l[1], 2) = List then
            // [Mode=List, l2], l2 = [...]
            new_list := [];
            for p in l[2] do
                if domtype(p) = DOM_POLYGON then
		   n := nops(p);

		   // Nehme alle Punkte einzeln auf, die Farbinformationen
		   // enthalten.
                   // new_list := new_list . select([op(p, i)$i=1..n-3], 
		   //                              x-> testtype(op(x,4), DOM_LIST));
		   if domtype(op(p, n-2)) <> NIL then
		      // polygon definiert selbst eine Farbe
		      // Loesche alle Farbinformationen in point,
		      // d.h. point(x,y,z,Color=...) -> point(x,y,z)
		      p := subsop(p, [i,nops(op(p,i))]=NIL $ i=1..n-3)
		   end_if;
		   if n > 6 and op(p, n-1) and (not op(p, n)) then
                      // Geschlossenes, aber nicht gefuelltes Polygon 
                      // bestehend aus mehr als 3 Punkten
		      p := polygon(op(p, 1..n-3),op(p,1), 
		                   Color =op(p, n-2),
				   Closed=FALSE,
				   Filled=op(p, n))
                   end_if;
                end_if;
                new_list := append(new_list, p)
            end_for;
            na := append(na, [Mode=List, new_list, l[i]$i=3..nops(l)]);
         elif op(l[1], 2) = Surface then  
	    // [Mode=Surface, ...]
            if not has(l, Color) then
	       l := l.[Color=color]
            else
	       p := contains(l, Color=[Height]);
	       if p <> 0 then
	          l := subsop(l, p=(Color=color))
	       end_if
	    end_if;
            if not has(l, Grid) then
	       l := l.[Grid=[sgrid,sgrid]]
	    end_if;
	    na := append(na, l)
	 elif op(l[1], 2) = Curve then  
	    // [Mode=Curve, ...]
            if not has(l, Grid) then
	       l := l.[Grid=[cgrid]]
	    end_if;
	    na := append(na, l)
	 else
            na := append(na, l);
         end_if
      else
         na := append(na, l);
      end_if
  end_for;

  new_args := na
  
  end_if; // hastype

  return(op(new_args))

end_proc:
