plotlib::surf_cont := proc()
  local args_cont, args_plot3d, color, err, g1, g2, g3, grid, i, gp,
        largs, obj, objc, obji, objp;
begin
  largs := [args()]; args_cont := null(); args_plot3d := null();
  gp := 20;
  for obj in largs do
      objc := obj; objp := obj; grid:= Grid=[gp,gp];
      if domtype(obj) = DOM_LIST and op(obj, [1,2]) = Surface then
         for i from 1 to nops(obj) do
             obji := obj[i]; color := null();
             if type(obji) = "_equal" then
                if op(obji, 1) = Style then
                   obj := subsop(obj, i=null())
                elif op(obji, 1) = Color then
                   color := obji;
                   obj := subsop(obj, i=null())
                elif op(obji, 1) = Grid then
                   grid := obji;
                   obj := subsop(obj, i=null())
                end_if;
             end_if;
         end_for;
         objp := append(obj, grid, color, Style=[ColorPatches,Only]);
         obj := subsop(obj, 1=null());

         if op(grid, [2,1]) < gp then
            grid := subsop(grid, [2,1]=gp)
         end_if;
         if op(grid, [2,2]) < gp then
            grid := subsop(grid, [2,2]=gp)
         end_if;

         objc := append(obj, grid, Colors=[Flat, RGB::Black]);
      end_if;
      args_cont := args_cont, objc;
      args_plot3d := args_plot3d, objp;
  end_for;

  args_cont := args_cont, Style = Attached;

  err := traperror((
     plotlib::show(FALSE);
     g1 := plotlib::contourplot(args_cont);
     g2 := plot3d(args_plot3d);
     g3 := plotlib::combine(g2, g1);
     plotlib::show(g3);
     plotlib::show(TRUE);
  ));

  if err <> 0 then
     plotlib::show(TRUE);
     error("Illegal plot command");
  end_if;

  null()

end_proc:
