/* Letzte Ueberarbeitungen: 10.12.1999, Walter Oevel
                            03.03.2000, Oliver Kluge
                            16.03.2000, Walter Oevel 
                              Line->Lines
                              LinePoint->LinesPoints (so schon von VCam benutzt)
                              Point->Points    (so schon von VCam benutzt)
                              Curve->Curves
                              CurvePoint->CurvesPoints
 

1) Neue Diagrammtypen:
   Points      : Nur Datenpunkte werden gezeichnet 
                 Point ist fuer 2D und 3D implementiert.
   LinesPoints : Zeichnen der Verbindungslinien und der 
                 Datenpunkte
   CurvesPoints: Zeichnen der Verbindungskurven mittels
                 kubischer Splines und der Datenpunkte

2) Die Achsenbeschriftung wurde vollstaendig ueberarbeitet. 

3) Bzgl. Points, Lines, Curves, LinesPoints und CurvesPoints
   koennen nun nicht-equidistante Datenpunkte gezeichnet
   werden. Ausserdem kann die Anzahl der Datenpunkte in
   den Datenlisten unterschiedlich sein.
   Auch kann anstelle einer Liste ein array angegeben werden.
   Wird ein Objekt vom Typ Dom::Matrix angegeben, so wird
   dieses immer als 2D-Array interpretiert, unabh. davon,
   ob es sich u.U. nur um einen Spalten- oder Zeilen-Vektor
   handelt, d.h. nur der Diagrammtyp Points steht derzeit fuer
   Dom::Matrix zur Verfuegung.


to do:
* Generieren und Positionieren der Titles laeuft zwar, 
  ist aber "zufaellig". Muss voellig neu implementiert werden.
  Problem: Die Positionierung ist an Bildschirmkoordinaten
  gekoppelt, nicht an tatsaechliche (x,y) bzw. (x,y,z) Werte.
* Es koennen mittels SceneOptions = [ ... ] beliebige
  Szene-Optionen an plot2d, plot3d weitergereicht werden.
  Diese koennen sich intern mit den fest eingestellten
  Szene-Optionen wie z.B. Axes = None etc. beissen und
  zum Fehler in plot2d, plot3d fuehren.
  Die fest eingestellten Szene-Optionen muessen als
  Defaults realisiert werden, die dann gegebenenfalls
  von user-Szene-Optionen ueberschrieben werden.
* Implementierungsbedarf fuer "Surface": wir brauchen
  noch eine 2d-Spline-Approximation von Daten, um das
  unselige (und langsame) numeric::lagrange ersetzen
  zu koennen. In "Curves" ist dies bereits geschehen:
  altes numeric::lagrange --> numeric::cubicSpline.
*/

/*

export(plotlib): export(RGB):

dataplot(Piechart, [5,12,38,14,25]):

dataplot(Piechart3d, [5,12,38], Colors=[RoyalBlue,VioletRed,GreenPale]):

dataplot(Lines,   [[5,10,24,-3],[6,5,2,18],[19,45,12,-10]], Colors=[Red,Green,Blue]):

dataplot(LinesPoints, [
           [[1,5],[2,10],[4,24],[7,-3]],
           [[0,6],[1,5],[2,2],[3,18]],
           [[-2,19],[1,45],[2,12],[7,-10]] 
	 ],
         Colors=[Red,Green,Blue]):

dataplot(Curves, [[5,10,24,-3],[6,5,2,18],[19,45,12,-10]], Colors=[Red,Green,Blue]):
dataplot(CurvesPoints, [[5,10,24,-3],[6,5,2,18],[19,45,12,-10]], Colors=[Red,Green,Blue]):

dataplot(Columns, [[5,10,24,-3],[6,5,2,18],[19,45,12,-10]], Colors=[Red,Green,Blue]):

dataplot(Beams, [[5,10,24,-3],[6,5,2,18],[19,45,12,-10]], Colors=[Red,Green,Blue]):

dataplot(Columns, [[5,10,24,-3,6,5,2,18]]):

dataplot(Plain, [[5,10,24,-3],[6,5,2,18],[19,45,12,-10]], Colors=[Red,Red,Green]):

dataplot(Surface, [[5,10,24,-3],[6,5,2,18]]):

*/

alias(Gray   = RGB::Gray):
alias(Black  = RGB::Black):

plotlib::dataplot := proc(dtyp, l)
  local c, i, t, set_option, sceneoptions;
begin

  set_option := proc(eqn)
  begin
     if not testtype(eqn, "_equal") then
        error("Colors = [...] or Titles = [...] or SceneOptions = [...] expected")
     end_if;
     case op(eqn,1) 
         of Titles do
            t := op(eqn,2); break;
         of Colors do
            c := op(eqn,2); break;
         of SceneOptions do
            sceneoptions := op(eqn,2); break;
         otherwise
            error("Unknown option")
     end_case;
  end_proc:
  
  c := RGB::ColorList;
  t := [];
  sceneoptions:= [];
  l := plotlib::dataplot_check_format(l, dtyp);

  case args(0) 
    of 5 do
       set_option(args(5));
    of 4 do
       set_option(args(4));
    of 3 do
       set_option(args(3));
    of 2 do  
       if not testtype(c, DOM_LIST) or nops(c) < nops(l) then
          error("3rd argument must be a list with ".nops(l)." color names")
       end_if;
       case dtyp 
         of Piechart   do
         of Piechart3d do
            if not testtype(l, Type::ListOf(Type::Real,1)) or
               _or(l[i]<=0$i=1..nops(l)) then
               error("List of positive real numbers expected")
            end_if;
            next;
         of Piechart   do
            plotlib::piechart(l, c, t, 2, sceneoptions); break;
         of Piechart3d do
            plotlib::piechart(l, c, t, 3, sceneoptions); break;
         of Lines       do
	 of Points      do
	 of LinesPoints do
	 of Curves      do
	 of CurvesPoints do
            if testtype(l, Type::ListOf(Type::ListOf(Type::Real,1),1)) then
	       if _or(nops(l[i])<>nops(l[i+1])$i=1..nops(l)-1) then
                  error("Lists must have the same number of elements")
	       else
	          next
	       end_if
	    elif testtype(l, Type::ListOf(Type::ListOf(DOM_LIST),1)) then
	       if _or((nops(l[i][j])<>nops(l[i][j+1])$j=1..nops(l[i])-1)$i=1..nops(l)) then
                  error("Lists must have the same number of elements")
	       else
	          next
	       end_if
	    else error("\n2nd argument must be a list of lists and all inner\n".
                       "lists must have the same form:\n".
                       "   [y1,...,y.N]\n".
                       "or [[x1,y1],...,[x.N,y.N]]\n".
                       "or [[x1,y1,z1],...,[x.N,y.N,z.N]]\n\n");
	    end_if;
            next;
         of Columns    do
         of Beams       do
      // of Histogram  do
         of Plain      do
         of Surface    do
            if not testtype(l, Type::ListOf(Type::ListOf(Type::Real,1),1)) then
               error("2nd argument must be a list of lists")
            elif _or(nops(l[i])<>nops(l[i+1])$i=1..nops(l)-1) then
              error("Lists must have the same number of elements")
            end_if;
            next;
	 of Points     do
	    plotlib::line(l, c, t, 1, sceneoptions); break;
         of Lines     do
	    plotlib::line(l, c, t, 2, sceneoptions); break;
	 of LinesPoints do
            plotlib::line(l, c, t, 3, sceneoptions); break;
         of Columns do
            plotlib::column(l, c, t, sceneoptions); break;
         of Beams do
            plotlib::beam(l, c, t, sceneoptions); break;
      // of Histogram do
      //    plotlib::histogram(l, c, t, sceneoptions); break;
         of Plain do
            plotlib::solid_plain(l, c, t, sceneoptions); break;
         of Surface do
            plotlib::surface(l, c, t, sceneoptions); break;
         of Curves do
            plotlib::curve(l, c, t, 1, sceneoptions); break;
	 of CurvesPoints do
            plotlib::curve(l, c, t, 2, sceneoptions); break;
         otherwise
            error("Unknown diagram type")
       end_case;
       break;
   otherwise
      error("Wrong number of parameters")
 end_case
end_proc: 

/*--------------------------------------------------*/
/* to do: replace 3D plot by 2D plot using polygons */

plotlib::piechart := proc(l, c, t, d, sceneoptions)
  local a, b, db, fsin, fcos, grid, i, obj, p, rgb1,
        s, u, v, segment_angle;
begin

  rgb1 := proc(c)
  begin
      c[1] := max(0,c[1]-0.2);
      c[2] := max(0,c[2]-0.2);
      c[3] := max(0,c[3]-0.2);
      c
  end_proc:

  [u,v] := [genident(),genident()];
     
  fsin := slot(sin, "float"): 
  fcos := slot(cos, "float"): 
 
  s := _plus(op(l)); obj := null(); 
  p := float(PI); b := 0; 
  t := plotlib::set_titles(t, l, nops(l)*(d-1));
  // divide each slice into segements of 6 degrees each.
  // This angle is small enough to generate a smooth slice
  segment_angle:= 0.1047197551; // = float(6/180*PI) = 6 degrees

  for i from 1 to nops(l) do
      db:= l[i]/s*2*p;
      // use at least 2 segments per slice, i.e., grid >=3
      grid:= max(3, round(db/segment_angle)); 
      a := b; b := b+db;
      obj := obj, [Mode=Surface,[v*fcos(u),v*fsin(u), 0],u=[a,b],v=[0,1],
                   Style=[ColorPatches,Only], Color=[Flat, c[i]],
                   Grid=[grid,2], Title=t[(d-1)*(i-1)+1]];
      if d = 3 then
         obj := obj, [Mode=Surface,[fcos(u),fsin(u), v], u=[a,b], v=[-0.2,0],
                      Style=[ColorPatches,Only], Color=[Flat, rgb1(c[i])],
                      Grid=[grid,2], Title=t[2*i]]
      end_if
  end_for;

  if d=2 then
     plot3d(
       op(sceneoptions), 
       Axes=None, 
       Scaling=Constrained,
       CameraPoint=[0,-0.01,1],
       FocalPoint=[0,0,0],
       obj)
  end_if;
  if d=3 then
     plot3d(
      op(sceneoptions),
      Axes=None,
      obj)
  end_if;
  null():
end_proc:

/*-----------------------------------------------------------*/

plotlib::line := proc(l, c, t, typ, sceneoptions)
  local i, j, m, objs, ti;
begin
  
  // typ: 1 -> Points, 2 -> Lines, 3 -> LinesPoints 

  m := nops(l); 

  if domtype(l[1][1]) = DOM_LIST then
   case nops(l[1][1])
     of 2 do
        break;
     of 3 do
        if typ <> 1 then
	  error("Only option Points available for 3D lists")
	else
	  t := plotlib::set_titles(t, l, 2*m);
	  plot3d(
           op(sceneoptions),
	   Axes=Box,
           Scaling=UnConstrained,
           Labeling=TRUE,
	   Ticks=plotlib::dataplot_ticks(l),
	   plotlib::point3d_list(l, t, c)
	  )
	end_if;
	return()
     otherwise
        error("lists of 2 or 3 numbers expected")
   end_case
  end_if;

  objs := null(); 
  t := plotlib::set_titles(t, l, 2*m);

  // typ: 1 -> Points, 2 -> Lines, 3 -> LinesPoints 

  if type(l[1][1]) <> DOM_LIST then
     // [y1,..., yN] -> [[0,y1],...[N-1, yN]]
     l := [ [ [i, l[j][i+1]] $ i=0..nops(l[j])-1 ] $ j=1..m ]
  end_if;

  // l = [ [ [x_1_1, y_1_1], ..., [x_1_m1, y_1_n1] ], ... , ]

  if typ = 1 or typ = 3 then
     objs := plotlib::point2d_list(l, t, c) 
  end_if;

  if typ = 2 or typ = 3 then
     objs := objs,
          ([Mode=List,
           [polygon(
            (point(l[j][i][1],l[j][i][2]),
             point(l[j][i+1][1],l[j][i+1][2])
            )$i=1..nops(l[j])-1
	    ,Color=c[j])
           ],
           Title=t[m+j], TitlePosition=[0,0]
          ]) $ j=1..m
   end_if;
   ti := plotlib::dataplot_ticks(l);
   plot2d(
    op(sceneoptions),
    Scaling=UnConstrained,
    //Ticks=min(max(2,n-2),10),
    Ticks=ti,
    Labeling=TRUE,
    Labels=["",""],
    Axes=Corner,
    // Axes=Origin,
    // AxesOrigin=[ti[1][1], ti[2][1]],
    objs
   )

end_proc:

/* -------------------------------------------------------------- */
/* to do: we presently assume equidistant data points, all
          sublists presently must have the same number of points

   Should be generalized to:
   *) non-equidistant data points
   *) each sub-list of data may have different nodes,
      the number of nodes may differ between sub-lists

   Works now if lists are specified as follows:
   [ [[x_1_1, y_1_1],...,[x_1_N1, y_1_N1]], 
     ... , 
     [[x_M_1, y_M_1],...,[x_M_NM, y_M_NM]] ]   
*/
/* -------------------------------------------------------------- */

plotlib::curve := proc(l, c, t, typ, sceneoptions)
  local i, j, m, n, objs, x, 
        xmax, xmin, ymax, ymin, SplineFunc;
begin

  m := nops(l); x:= genident();

  if type(l[1][1]) <> DOM_LIST then
     // [y1,..., yN] -> [[0,y1],...[N-1, yN]]
     l := [ [ [i, l[j][i+1]] $ i=0..nops(l[j])-1 ] $ j=1..m ]
  end_if;

  t := plotlib::set_titles(t, l, 2*m);
  (SplineFunc[j]:= numeric::cubicSpline(op(l[j])))      $ j=1..m;
  (xmin[j] := float(min(l[j][i][1] $ i=1..nops(l[j])))) $ j=1..m;
  (xmax[j] := float(max(l[j][i][1] $ i=1..nops(l[j])))) $ j=1..m;
     
  objs := ([Mode=Curve, 
            [x, hold(fp::apply)(SplineFunc[j],x)], 
            x=[xmin[j],xmax[j]], Color=[Flat,c[j]],
	    Title=t[m+j], TitlePosition=[0,0]
           ]) $ j=1..m;

  if typ = 2 then
     // the data points
     objs := objs , plotlib::point2d_list(l, t, c)       
  end_if;

  // Folgende 2 Zeilen nur interessant, falls kleinster
  // und groesster y-Wert ermittelt werden soll.
  n := plotlib::curve_min_max(SplineFunc, xmin, xmax, 100);
  ymin := n[1]; ymax := n[2];

  plot2d(
       op(sceneoptions),
       Scaling=UnConstrained,           // scene options
       //Ticks=min(max(2,n-2),10),      
       Ticks=plotlib::dataplot_ticks(l,ymin, ymax),
       Labeling=TRUE, Labels=["",""],   // scene options
       Axes=Corner,                     // scene options
       objs
  )
  
end_proc:

/* -------------------------------------------------------------- */
// Dies ist noch zu ueberarbeiten: die Poly-Interpolation per 
// numeric::lagrange sollte durch eine Spline-Interpolation 
// ersetzt werden, eine entsprechende Lib-Funktion existiert
// aber noch nicht. W. Oevel
/* to do: we presently assume equidistant data points, all
          sublists presently must have the same number of points

   Should be generalized to:
   *) non-equidistant data points
   *) each sub-list of data may have different nodes,
      the number of nodes may differ between sub-lists
*/

/* -------------------------------------------------------------- */
plotlib::surface := proc(l, c, t, sceneoptions)
  local j, m, n, x, y, interpoly;
begin    
  m := nops(l); n := nops(l[1]);
  t := plotlib::set_titles(t, l, 1);
  [x, y] := [genident(), genident()];
  // the symbolic interpolation polynomial
  interpoly:= numeric::lagrange(
               [[j$j=0..m-1],[j$j=0..n-1]],
               array(1..m,1..n,l),[x,y]):
  interpoly:= expr(interpoly);
  plot3d(
   op(sceneoptions),
   Scaling=UnConstrained,
   Labeling=FALSE,
   Axes=Box,
   ([Mode=List, // the data points
     [point(i, j, l[i+1][j+1])], 
  // Title=t[i*m+j],
  // TitlePosition=[0,0],
     PointWidth = 40,
     PointStyle = FilledCircles
    ]$i=0..m-1
   )$j=0..n-1,
   [Mode=Surface, // the interpolating surface
    [x, y, interpoly], x=[0,m-1], y=[0,n-1],
    Grid = [m, n],
    Style=[HiddenLine,Mesh]
   ]
  )
end_proc:
/* -------------------------------------------------------------- */
/*
Rechtecke muessen durch zwei Polygone, die jeweils ein Dreieck bilden,
dargestellt werden, da derzeit nur Dreiecke mit einer Farbe gefuellt
werden koennen. Ein weiteres Polygon bildet den Rahmen des Rechtecks.
Ein Rechteck besteht daher aus drei Polygonen.

Das gesamte Saeulen- oder Balkendiagramm koennte durch ein Objekt dar-
gestellt werden. Man knnte dann aber nur zwei Beschriftungen eingeben,
eine fuer die Szene und eine fuer das Objekt. Aus diesem Grund wird
jedes Polygon als ein eigenes Objekt dargestellt. Demnach koennen
3*m*n+1 Beschriftungen eingefuegt werden.
*/
/*-----------------------------------------------------------*/
plotlib::column := proc(l, c, t, sceneoptions)
  local i, j, m, n, nc, offset, d;
begin
  m := nops(l); n := nops(l[1]); nc := nops(c);
  offset := (if m = 1 then 0.2 else 1 end_if);
  t := plotlib::set_titles(t, l, 3*m*n);
  if m = 1 then
     d := (max(op(l[1]))-min(op(l[1])))/50.0
  end_if;
  plot2d(
    op(sceneoptions),
    Scaling=UnConstrained,
    //Ticks=min(n,10),
    Ticks=plotlib::dataplot_ticks(l),
    Labeling=TRUE,
    Labels=["",""],
    Axes=Origin,
    (plotlib::rectangle(
       j+i*(m+offset),0,j+1+i*(m+offset),l[j+1][i+1],
       (if m=1 and nc=n then c[i+1] else c[j+1] end_if),t[i*m+j+1],
       (if m=1 then /*0.1,0.3,TRUE*/ 0.1,d,TRUE else null() end_if)
    )$j=0..m-1)$i=0..n-1
 )
end_proc:
/*-----------------------------------------------------------*/
plotlib::beam := proc(l, c, t, sceneoptions)
  local i, j, m, n, nc, offset;
begin
  m := nops(l); n := nops(l[1]); nc := nops(c);
  offset := (if m = 1 then 0.2 else 1 end_if);
  t := plotlib::set_titles(t, l, 3*m*n);
  plot2d(
    op(sceneoptions),
    Axes=None,
    Scaling=UnConstrained,
    [Mode=List,[polygon(point(0,0),point(0,(m+offset)*n-offset),Color=Black)]],
    (plotlib::rectangle(
           0,j+i*(m+offset),l[j+1][i+1],j+1+i*(m+offset),
           (if m=1 and nc=n then c[i+1] else c[j+1] end_if),t[i*m+j+1],
           (if m=1 then 0.3,0.1,FALSE else null() end_if)
    )$j=0..m-1)$i=0..n-1
  )
end_proc:

/*-----------------------------------------------------------------
plotlib::plain := proc(l,c,t, sceneoptions)
  local i, j, m, n;
begin
  m := nops(l); n := nops(l[1]);
  plot3d(
    op(sceneoptions),
    Axes=Corner,
    Scaling=UnConstrained,
    [Mode=List,[polygon(point(i,j,l[j+1][i+1])$j=0..m-1)$i=0..n-1,
                polygon(point(i,j,l[j+1][i+1])$i=0..n-1)$j=0..m-1
    ]]
  )
end_proc:
-----------------------------------------------------------------*/

plotlib::solid_plain := proc(l,c,t, sceneoptions)
  local i, j, m, n;
begin
  m := nops(l); n := nops(l[1]);
  plot3d(
    op(sceneoptions),
    Axes=Box, Scaling=UnConstrained,Ticks=0,
    [Mode=List,
     [((polygon(point(i,j,l[j+1][i+1]), point(i,j+1,l[j+2][i+1]),
        point(i+1,j+1,l[j+2][i+2]), Color=c[j+1],Filled=TRUE),
        polygon(point(i,j,l[j+1][i+1]),point(i+1,j,l[j+1][i+2]),
        point(i+1,j+1,l[j+2][i+2]), Color=c[j+1],Filled=TRUE),
        polygon(point(i,j,l[j+1][i+1]), point(i,j+1,l[j+2][i+1]),
        point(i+1,j+1,l[j+2][i+2]), point(i+1,j,l[j+1][i+2]),
        point(i,j,l[j+1][i+1]),Color=c[m])
       )$i=0..n-2)$j=0..m-2]]
  )
end_proc:

/*-----------------------------------------------------------

plotlib::histogram := proc(l, c, t, sceneoptions)
  local i, j, m, n, offset;
begin
  m := nops(l); n := nops(l[1]);
  offset := (if m = 1 then 0.2 else 0.2 end_if);
  t := plotlib::set_titles(t, l, m*n);
  plot3d(
    op(sceneoptions),
    Scaling=UnConstrained,Axes=None,
    (plotlib::cube(i+i*offset,j+j*offset,0,
          i+1+i*offset,j+1+j*offset,l[j+1][i+1],
          c[j+1],t[i*m+j+1]
         )$i=0..n-1
    )$j=0..m-1
 )
end_proc:

-------------------------------------------------------------*/

/*-----------------------------------------------------------*/
/*-------------------- Utilities ----------------------------*/
/*-----------------------------------------------------------*/

plotlib::set_titles := proc(t, l, n)
  local i, j, k, m;
begin
  if (k:=contains(t, Values)) <> 0 then
     delete t[k];
     if testtype(l[1], DOM_LIST) then
        t := t.[(expr2text(l[i][j])$i=1..nops(l))$j=1..nops(l[1])]
     else
        t := t.[expr2text(l[i])$i=1..nops(l)]
     end_if
  end_if;
  m := nops(t);
  if m < n then t := t.[""$ i=1..n-m] end_if;
  t
end_proc:

/*-----------------------------------------------------------*/

plotlib::rectangle := proc(a,b,c,d,co,ti,sx,sy,vertical)
begin
  [Mode=List,
   [polygon(point(a,b), point(a,d), point(c,d), Filled=TRUE,Color=co)],
   Title=ti,
   TitlePosition=[0,0]
  ],
  [Mode=List,
   [polygon(point(a,b), point(c,b), point(c,d), Filled=TRUE,Color=co)]
  ],
  (if args(0) = 6 then
     // Draw frame 
     [Mode=List,[polygon(point(a,b), point(a,d), point(c,d), point(c,b), point(a,b),
                 Color=Black)]]
   else
     // Draw shadow frame 
     if vertical then
        if d < 0 then sy := -sy; end_if;
        [Mode=List,
         [polygon(point(a+sx,b),point(a+sx,d+sy),point(c+sx,d+sy),Filled=TRUE,Color=Gray),
          polygon(point(a+sx,b),point(c+sx,b),point(c+sx,d+sy),Filled=TRUE,Color=Gray)]
        ]
     else
       if c < 0 then sx := -sx; end_if;
       [Mode=List,
         [polygon(point(a,b-sy),point(a,d-sy),point(c+sx,d-sy),Filled=TRUE,Color=Gray),
             polygon(point(a,b-sy),point(c+sx,b-sy),point(c+sx,d-sy),Filled=TRUE,Color=Gray)]
       ]
       end_if
  end_if)
end_proc:

/*-----------------------------------------------------------

plotlib::rectangle3d := proc(a,b,c,d,e,f,co,ti,x)
  local p1, p2;
begin
  if x then 
     p1 := a,e,f; p2 := d,b,c;
  else
     p1 := a,b,f; p2 := a,e,c
  end_if;

  [ Mode=List, [ 
       polygon(point(a,b,c), point(p1), point(d,e,f), Filled=TRUE, Color=co),
       polygon(point(a,b,c), point(p2), point(d,e,f), Filled=TRUE, Color=co),
       polygon(point(a,b,c), point(p1), point(d,e,f), point(p2), point(a,b,c),
               Color=Black)
     ], Title=ti, TitlePosition=[0,0]
  ]
end_proc:

plotlib::cube := proc(a,b,c,d,e,f,co,ti)
begin
  plotlib::rectangle3d(a,b,c,d,e,c,co,ti,TRUE),  # Bottom #
  plotlib::rectangle3d(a,b,f,d,e,f,co,ti,TRUE),  # Top    #
  plotlib::rectangle3d(a,b,c,d,b,f,co,ti,TRUE),  # Front  #
  plotlib::rectangle3d(a,e,c,d,e,f,co,ti,TRUE),  # Back   #
  plotlib::rectangle3d(a,b,c,a,e,f,co,ti,FALSE), # Left   #
  plotlib::rectangle3d(d,b,c,d,e,f,co,ti,FALSE)  # Right  #
end_proc:

-----------------------------------------------------------*/

plotlib::dataplot_ticks := proc(l, ymin=FAIL, ymax=FAIL)
   local i, tx, ty, tz;
begin
   if type(l[1][1]) = DOM_LIST then
      tx := [ l[i][j][1] $ j = 1..nops(l[i]) $ i = 1..nops(l) ];
      tx := plotlib::dataplot_xyzticks(tx);
      ty := [ l[i][j][2] $ j = 1..nops(l[i]) $ i = 1..nops(l) ];
      ty := plotlib::dataplot_xyzticks(ty, ymin, ymax);
      if nops(l[1][1]) = 2 then
         [ tx, ty ]
      else
         tz := [ l[i][j][3] $ j = 1..nops(l[i]) $ i = 1..nops(l) ];
         tz := plotlib::dataplot_xyzticks(tz);
         [ tx, ty, tz ]
      end_if
   else 
      ty := [ op(l[i]) $ i = 1..nops(l) ];
      [ 0, plotlib::dataplot_xyzticks( ty ) ]
   end_if
end_proc:

plotlib::dataplot_xyzticks := proc(l, ymin=FAIL, ymax=FAIL)
   local d, i, j, n;
begin
   // Convert ty to a set to remove multiple entries
   // and re-convert into a list
   l := [op({op(l)})]; 
   l := sort(l); 
   n := nops(l);
   // Maximal tick marks: 40 (Internal upper bound!)
   if  n > 40 then
      // 10 (arbitrary) tick marks 
      return( 10 )
   end_if;
   if type(ymin) = DOM_FLOAT then
      d := (ymax-ymin)/20.0
   else
      d := (l[n]-l[1])/20.0
   end_if;
   j := l[1];
   for i from 2 to n do
       if l[i] - j < d then
          l[i] := l[i]=""
       else
          j := l[i]
       end_if
   end_for;

   l

end_proc:

plotlib::curve_min_max := proc(p, a, b, g)
  local j, ma, mi, v, x;
begin
  mi := infinity; ma := -infinity;
  for j from 1 to nops(p) do
      for x from a[j] to b[j] step (b[j]-a[j])/g do
          v := p[j](float(x));
          if v < mi then 
             mi := v
          elif v > ma then
             ma := v
          end_if
      end_for;
  end_for;
  [mi, ma]
end_proc:

plotlib::point2d_list := proc(l, t, c)
  local i, j;
begin
  ([Mode=List,                     
    [point(l[j][i][1],l[j][i][2],Color=c[j]) $i=1..nops(l[j])], 
    Title=t[j], TitlePosition=[0,0],
    PointWidth = 40, PointStyle = FilledCircles
   ]) $ j=1..nops(l)
end_proc:

plotlib::point3d_list := proc(l, t, c)
  local i, j;
begin
  ([Mode=List, 
    [point(l[j][i][1],l[j][i][2],l[j][i][3],Color=c[j])$i=1..nops(l[j])],
    Title=t[j], TitlePosition=[0,0]
   ]) $ j=1..nops(l)
end_proc:

plotlib::dataplot_check_format := proc(l, dtyp)
  local j;
begin
  if type(l) = DOM_LIST then
     [ plotlib::dataplot_check(l[j], dtyp) $ j = 1..nops(l) ]
  else
     [ plotlib::dataplot_check(l, dtyp) ]
  end_if
end_proc:

plotlib::dataplot_check := proc(l, dtyp)
  local a, b, dim, i, j, nl, t;
begin
  if type(l) = DOM_ARRAY or 
     l::dom::hasProp( Cat::Matrix ) = TRUE then
     if (dim := op(l,[0,1])) > 2 then 
        error("1 or 2 dimensional array/matrix expected")
     end_if
  else
     return( l )
  end_if;

  (a[i] := op(l, [0, i+1, 1])) $ i=1..dim;
  (b[i] := op(l, [0, i+1, 2])) $ i=1..dim;

  nl := [];

  if dim = 1 then
     t := {Points, Lines, Curves, LinesPoints, CurvesPoints};
     for i from a[1] to b[1] do
 	 if testtype(l[i], Type::Real) then
	    if contains(t, dtyp) then
	       nl := append(nl, [i, l[i]])
	    else
	       nl := append(nl, l[i])
	    end_if
	 end_if
      end_for
  else // dim = 2
     for i from a[1] to b[1] do
         for j from a[2] to b[2] do
 	     if testtype(l[i,j], Type::Real) then
	        nl := append(nl, [i, j, l[i,j]])
	     end_if
	 end_for
      end_for
  end_if;

  nl

end_proc:
