// $Date: 2000/05/21 14:57:57 $ $Author: bij $ $Revision: 1.4 $ 


/*
   nthmonomial(f, n, <order>)

   return the n-th monomial of f w.r.t. to order (default is LexOrder)

*/


nthmonomial:=
proc(f, n, ord)

begin
  if args(0)=0 then
    error("nthmonomial called without arguments")
  end_if;
  if f::dom::nthmonomial <> FAIL then
    return(f::dom::nthmonomial(args()))
  end_if;
  if args(0)<2 or args(0)>4 then
    error("Wrong number of arguments")
  end_if;
  if type(n)=DOM_LIST then
    nthmonomial(poly(f, n), args(3..args(0)));
    if testtype(f, Type::Arithmetical) then
      return(expr(%))
    else
      return(%)
    end_if
  end_if;
  if args(0)=2 or ord=hold(LexOrder) then
    polylib::nthmonomial(f, n)
  else
    op(polylib::sortMonomials(f, ord), n)
  end_if
end_proc:


