// $Date: 2000/10/04 08:28:21 $ $Author: kg $ $Revision: 1.4 $

//
// This file contains informations about changes
// between MuPAD 1.4.2 and MuPAD 2.0
//
// new objects
// 

prog::Changes::newKeywords:=
  ["domain", "save", "delete"]:

prog::Changes::newLibs:=
  [hold(matchlib), hold(adt), hold(polylib), hold(prog), hold(output),
   hold(solvelib), hold(detools), hold(intlib), hold(listlib)]:

prog::Changes::newFunctions:=
  table(
        hold(System)   = [hold(lhs), hold(rhs), hold(package), hold(piecewise),
                          hold(newDomain), hold(matrix), hold(coerce),
                          hold(operator), hold(ground), hold(lasterror),
                          hold(unexport), hold(int2text), hold(unfreeze),
                          hold(external), hold(Factored), hold(universe),
                          hold(share), hold(slot), hold(clientCall), 
                          hold(clientObject), hold(ClientObject),
                          hold(outputFormat), hold(outputType),
                          hold(rdabs), hold(rddivide), hold(rdfloat2text),
                          hold(rdgetsign), hold(rdint2float), hold(rdisfinite),
                          hold(rdmult), hold(rdnegate), hold(rdplus),
                          hold(rdround), hold(rdsubtract), hold(rdtext2float)],
        hold(adt)      = [hold(Tree), hold(Stack), hold(Queue)],
        hold(Cat)      = [hold(Set)],
        hold(Dom)      = [hold(ImageSet), hold(MonomOrdering), hold(SparseMatrixF2), hold(SubSet)],
        hold(domains)  = [hold(grouporder)],
        hold(linalg)   = [hold(minpoly), hold(pseudoInverse), hold(inverseLU),
                          hold(factorLU), hold(hessenberg), hold(wiedemann), hold(frobeniusForm),
                          hold(hilbert), hold(invhilbert), hold(vandermondeSolve),
                          hold(companion), hold(permanent), hold(substitute), hold(smithForm)],
        hold(matchlib) = [hold(match), hold(analyze)],
        hold(numeric)  = [
                          hold(complexRound),
                          hold(cubicSpline), 
                          hold(expMatrix),
                          hold(fMatrix),
                          hold(fsolve),
                          hold(indets),
                          hold(int),
                          hold(lagrange),
                          hold(linsolve),
                          hold(matlinsolve),
                          hold(odesolve2),
                          hold(odesolveGeometric),
                          hold(polyroots),
                          hold(polysysroots),
                          hold(rationalize),
                          hold(realroot),
                          hold(realroots),
                          hold(solve),
                          hold(sort),
                          hold(spectralradius)
                         ],
        hold(output)   = [hold(tree)],
        hold(plotlib)  = [hold(inequalityplot)],
        hold(plotlib)  = [hold(ode)],
        hold(polylib)  = [hold(realroots)],
        hold(prog)     = [hold(check), hold(getname), hold(remember), hold(calltree),
                          hold(exprtree), hold(init), hold(traced), hold(find)],
        hold(property) = [hold(hasprop)],
        hold(specfunc) = [hold(arg), hold(log), hold(lambertV),
                          hold(lambertW), hold(polylog), hold(BesselI),
                          hold(BesselK), hold(Ci), hold(signIm)],
        hold(stats)    = [hold(BPCorr), hold(FCorr), hold(Tdist), hold(a_quantil), hold(calc),
                          hold(col), hold(concatCol), hold(concatRow), hold(geometric),
                          hold(harmonic), hold(kurtosis), hold(linReg), hold(mean),
                          hold(meanTest), hold(median), hold(modal), hold(normal),
                          hold(obliquity), hold(quadratic), hold(reg), hold(row),
                          hold(sample), hold(sample2list), hold(selectRow), hold(sortSample),
                          hold(stdev), hold(tabulate), hold(unzipCol), hold(variance), hold(zipCol)],
        hold(student)  = [hold(simpson), hold(trapezoid), hold(riemann)]
        ):

