

//
// overview of all defined function determined with 'anames'
//

prog::allFunctions:=
  proc(OPT = hold(None), OPTR = hold(None))
    local DP, DE, DFE, DD, DF;
  begin
    // init all
    warning("Reading all MuPAD objects, this may take a while...");
    prog::init(All, All);
    // paranoia
    prog::init(All, All);

    // DOM_PROC /////////////////////////////////////////////////////////////
    userinfo(Text, 1, "all DOM_PROC");
    DP:= sort([op(select(stdlib::anames(3), X -> type(context(X)) = DOM_PROC))],
              (X, Y) -> expr2text(X) < expr2text(Y));
    // DOM_FUNC_ENV /////////////////////////////////////////////////////////
    userinfo(Text, 1, "all DOM_FUNC_ENV");
    DFE:= {op(select(stdlib::anames(3), X -> type(context(X)) = DOM_FUNC_ENV))};
    userinfo(Text, 1, "extracting all DOM_EXEC");
    DE:= select(DFE, X -> type(op(context(X), 1)) = DOM_EXEC);
    DFE:= DFE minus DE;
    DFE:= sort([op(DFE)], (X, Y) -> expr2text(X) < expr2text(Y));
    DE:= sort([op(DE)], (X, Y) -> expr2text(X) < expr2text(Y));
    // DOM_DOMAIN ///////////////////////////////////////////////////////////
    userinfo(Text, 1, "pre-init most DOM_DOMAIN");
    DD:= sort([op(select(stdlib::anames(3), X -> type(context(X)) = DOM_DOMAIN))],
              (X, Y) -> expr2text(X) < expr2text(Y));
    for DF in DD do
      DF:= context(DF);
      if domtype(DF) = DOM_DOMAIN then
	//if contains(context(DF), "constructor") then
	  prog::init(DF);
	  sysdelete(prog::init(DF))
	//end_if
      end_if
    end_for;

    fprint(Unquoted, 0, "DOM_EXEC: [", nops(DE), "]");
    output::tableForm(DE);
    
    fprint(Unquoted, 0, "\nDOM_PROC: [", nops(DP), "]");
    output::tableForm(DP);
    
    fprint(Unquoted, 0, "\nDOM_FUNC_ENV: [", nops(DFE), "]");
    output::tableForm(DFE);
    
    fprint(Unquoted, 0, "\nDOM_DOMAIN: [", nops(DD), "]");
    output::tableForm(DD);
    
    if OPT = hold(Recursive) then
      fprint(Unquoted, 0, "\n");
      map(DD, prog::allDomainMethods, OPTR)
    end_if;
    null()
  end_proc:

prog::allDomainMethods:=
  proc(DOM, OPT = None, HR = [])
    local OPR, DM;
  begin
    HR:= append(HR, DOM);

    DOM:= context(DOM);
    prog::init(DOM, hold(All));
    for OPR in select(map({op(DOM)}, op, 1),
                      X -> type(X) in {DOM_DOMAIN, DOM_EXEC, DOM_PROC, DOM_FUNC_ENV}) do
      prog::init(OPR)
    end_for;

    OPR:= map({op(DOM)}, op, 1);

    fprint(Unquoted, 0, "\nDomain: '", DOM, "'",
           _if(args(0) > 3, "  (sub domain of '".expr2text(args(4))."')", ""));

    fprint(Unquoted, 0, "\nAll domains of '", DOM, "'");
    output::tableForm(select(OPR, X -> type(slot(DOM, X)) = DOM_DOMAIN));

    fprint(Unquoted, 0, "\nAll methods of '", DOM, "'");
    output::tableForm(select(OPR, X -> type(slot(DOM, X)) in {DOM_EXEC, DOM_PROC, DOM_FUNC_ENV}));

    fprint(Unquoted, 0, "\nAll entries of '", DOM, "'");
    output::tableForm(select(OPR, X -> not (type(slot(DOM, X)) in {DOM_DOMAIN, DOM_EXEC,
                                                                   DOM_PROC, DOM_FUNC_ENV})));

    if OPT = hold(Recursive) then
      for DM in sort(map([op(select(OPR, X -> type(slot(DOM, X)) = DOM_DOMAIN))], X -> slot(DOM, X))) do
        if contains(HR, DM) = 0 then
          prog::allDomainMethods(DM, hold(Recursive), (HR:= append(HR, DM)), DOM)
        end_if
      end_for
    end_if;

    null()
  end_proc:
