

// statement <, maxdepth > <, {excl_funcs} > <, {< Plain > <, Args > <, Tree >} >
 
prog::calltree:=
  proc()
    local fd, l, getentry, options, f, stack, S, stackpointer,
          stackr, getline, result, fname, foutput, outopt, E2T,
          buildstack, maxdepth, exclude, i, getnextdep, xsort, ERROR;
    option hold, escape;
  begin

    S:= newDomain("S"):
    S::new:= (a,b,c,d)->new(S, a, b, c, d):

    getline:=
      proc()
        local a, b, c, d, e;
      begin
        if finput(fd, a, b, c, d, e) = null() then
          fclose(fd); return(null())
        end_if;
        a, b, e
      end_proc:
    
    stackpointer:= 0;
    getentry:=
      proc()
      begin
        stackpointer:= stackpointer - 1;
        if stackpointer >= 0 then
//fprint(0, op(stackr, stackpointer + 1));
          op(stackr, stackpointer + 1)
        else
          NIL
        end_if
      end_proc:

    getnextdep:=
      proc()
      begin
        if stackpointer >= 0 then
          op(stackr, [stackpointer + 1, 2])
        else
          0
        end_if
      end_proc:
    
    // Einlesen der Kernel-Profile-Daten
    buildstack:=
      proc(dep, pname, ARGS)
        local inp, stack, depth, i;
      begin
        if dep > maxdepth then
          return(S("...", dep, FALSE, []))
        end_if;
        stack:= [S(pname, dep, TRUE, ARGS)]; // neuer Stack
        while (inp:= getentry()) <> NIL do
          pname:= inp[1]; depth:= abs(inp[2]);
          ARGS:= inp[3];
          if not(contains(exclude, pname)) then
            if getnextdep() > dep then
              stack:= append(stack, (buildstack(depth, pname, ARGS)))
            elif getnextdep() = dep then
              stack:= append(stack, S(pname, depth, TRUE, ARGS));
              f:= FALSE;
            else
              stackpointer:= stackpointer + 1;
              return(stack)
            end_if
          end_if
        end_while;
        stack
      end_proc:

    // Sortieren der Profile-Daten und Umwandeln in DOM_STRING
    xsort:=
      proc(stack)
        local i, st, cur, n;
      begin
        st:= [];
        cur:= null();
        n:= 1;
        for i from 1 to nops(stack) do
          if type(op(stack, i)) = DOM_LIST then
            cur:= cur . (xsort(op(stack, i)));
          else
            st:= st . [cur];
            cur:= [expr2text(op(stack, i))];
            n:= n + 1
          end_if;
        end_for;
        revert(st . [cur])
      end_proc:

    //-------------------- Argumente ---------------------

    if args(0) = 0 then
       return();
    end_if;

    // statement <, maxdepth > <, [output_options]>
    //                         <, {excl_funcs} > <, {< Plain:option > <, Args:option >} >

    options:= {};
    exclude:= {"_check_global", "loadproc"};
    foutput:= "";
    outopt:= null();
    maxdepth:= (floor(TEXTWIDTH/2 - 20/2))*2;

    if args(0) > 1 then
      i:= 2;
      while i <= args(0) do
        case type(args(i))
//          of DOM_STRING do
//            foutdat:= fopen(args(i));
//            if foutdat = FAIL then error("could not open file ".args(i)) end_if;
//            break;
          of DOM_INT do maxdepth:= args(i); break
          of DOM_LIST do
            outopt:= op(args(i));
            break
          of DOM_IDENT do
            options:= {args(i)};
            break
          of DOM_SET do
            if i < args(0) then
              options:= args(i)
            else
              if type(op(args(i), 1)) = DOM_STRING then
                exclude:= args(i)
              else
                options:= args(i)
              end_if
            end_if;
            break
        end_case;
        i:= i + 1
      end_while
    end_if;

    E2T:=
      proc(X)
      begin
        if domtype(X) = DOM_PROC then
          prog::getname(X)
        else
          expr2text(X)
        end_if
      end_proc;

    if contains(options, hold(Args)) then
      S::expr2text:= (s)->op(s,1)."(".E2T(op(s, 4)).")"
    else
      S::expr2text:= (s)->op(s,1)
    end_if:
    
    //------------------ Hauptprogramm -------------------

    fname:= "call".getpid().".dat";
    if sysname() = "UNIX" then
      fname:= "/tmp/".fname
    else
      if( domtype(WRITEPATH) = DOM_STRING ) then
          fname := WRITEPATH.pathname("").fname;
      end_if
    end_if;

    // normales Kernel-Profiling
    if traperror((result:= gprof(context(args(1)), fname, Args))) > 0 then
      warning("while profiling");
      ERROR:= TRUE
    else
      ERROR:= FALSE
    end_if;
        
    fd:= fopen(fname);
    if fd = FAIL then error("can not open file ".fname) end_if;

    stackr:= [];
    while domtype((l:= getline())) <> DOM_NULL do
//fprint(0, "Line", map(op(l, 1..nops(l)-1), E2T));
      //pname:= l[1]; depth:= abs(l[2]);
      //* Argumente *// ARGS:= l[3];
      stackr:= stackr . [[op(l)]]
    end_while;
    stackpointer:= nops(stackr);

    stack:= getentry();
    
    stack:= buildstack(op(stack, 2), op(stack, 1), op(stack, 3));

    //gprof(NIL, fname);

    stack:= op(xsort(stack));

    l:= adt::Tree(stack, outopt);
    if contains(options, hold(Tree)) then
      l
    else
      l::print();
      if ERROR then
        lasterror()
      else
        result
      end_if
    end_if

  end_proc:
