alias(LOCAL(XXX) = (if _intersect(prog::OPT, {hold(Local), hold(Localf)}) <> {} then XXX end)):
alias(ASSIGN(XXX) = (if contains(prog::OPT, hold(Assign)) then XXX end)):
alias(GLOBAL(XXX) = (if contains(prog::OPT, hold(Global)) then XXX end)):
alias(DOMENT(XXX) = (if contains(prog::OPT, hold(Domain)) then XXX end)):
alias(LEV(XXX) = (if contains(prog::OPT, hold(Level)) then XXX end)):
alias(ENV(XXX) = (if contains(prog::OPT, hold(Environment)) then XXX end)):
alias(SPEC(XXX) = (if contains(prog::OPT, hold(Special)) then XXX end)):
alias(PROT(XXX) = (if contains(prog::OPT, hold(Protect)) then XXX end)):
alias(ESC(XXX) = (if contains(prog::OPT, hold(Escape)) then XXX end)):
alias(COMP(XXX) = (if contains(prog::OPT, hold(Changes)) then XXX end)):

// prog::OPT
// 0: Global
// 1: 
// 2: Local (unused local variables)
// 3: 
// 4: 
// 5: Level (level(DOM_VAR))
// 6: Assign (assignment to formal parameters)
// 7: 
// 8: 
// 9:

prog::check:=
  proc(FUN = hold(All), uinf = 1:Type::PosInt,
       opt = {hold(Local),
              //hold(Localf),
              //hold(Assign), kein Standard
              hold(Global),
              hold(Domain),
              hold(Level),
              //hold(Environment),
              //hold(Special),
              hold(Protect)})
    local GF, DF, INP, UI;
  begin
    UI:= _userinfo_level();
    setuserinfo(prog, 0);
//    sysassign(prog::LOCAL, table("level" = -1));
//    sysassign(prog::LOCALuse, table("level" = -1));
//    sysassign(prog::WARNINGS, 0);
    // Reset nach Fehler
    sysassign(prog::init, subsop(prog::init, 5 = NIL));
    sysassign(prog::checkNone, subsop(prog::checkNone, 5 = NIL));

    if (GF:= fopen("check.globals")) <> FAIL then
      while (INP:= finput(GF)) <> null() do
        prog::init(op(INP, 1));
        prog::setcheckglobals(INP)
      end_while
    end_if;
    setuserinfo(prog, uinf, Quiet);
    if FUN = hold(All) then
      sysassign(prog::Summe, [0, 0]);
      // DOM_PROC /////////////////////////////////////////////////////////////
      userinfo(Text, 2, "pre-init all DOM_PROC");
      map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_PROC)))],
               (X, Y)->(expr2text(X)<expr2text(Y))),
          prog::init);
      userinfo(Text, 2, "checking all DOM_PROC");
      map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_PROC)))],
               (X, Y)->(expr2text(X)<expr2text(Y))),
          prog::checkFunc, opt);
      // DOM_EXEC /////////////////////////////////////////////////////////////
//      userinfo(Text, 2, "pre-init all DOM_EXEC");
//      map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_EXEC)))],
//             (X, Y)->(expr2text(X)<expr2text(Y))),
//        prog::init, opt);
//      userinfo(Text, 2, "checking all DOM_EXEC");
//      map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_EXEC)))],
//             (X, Y)->(expr2text(X)<expr2text(Y))),
//        prog::checkFunc, opt);
    // DOM_FUNC_ENV /////////////////////////////////////////////////////////
      userinfo(Text, 2, "pre-init all DOM_FUNC_ENV");
      map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_FUNC_ENV)))],
               (X, Y)->(expr2text(X)<expr2text(Y))),
          prog::init);
      userinfo(Text, 2, "checking all DOM_FUNC_ENV");
      map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_FUNC_ENV)))],
               (X, Y)->(expr2text(X)<expr2text(Y))),
          prog::checkFunc, opt);
      // DOM_DOMAIN ///////////////////////////////////////////////////////////
      userinfo(Text, 2, "pre-init most DOM_DOMAIN");
      GF:= sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_DOMAIN)))],
                (X, Y)->(expr2text(X)<expr2text(Y)));
      for DF in GF do
        if domtype(DF) = DOM_DOMAIN then
          //if contains(context(DF), "constructor") then
            prog::init(DF);
            sysdelete(prog::init(DF))
          //end_if
        end_if
      end_for;
      userinfo(Text, 2, "checking all DOM_DOMAIN");
      map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_DOMAIN)))],
               (X, Y)->(expr2text(X)<expr2text(Y))),
          prog::checkFunc, opt);
    //            /////////////////////////////////////////////////////////////
      userinfo(Text, 1, "*** All warnings: ",
               op(prog::Summe, 1), " (", op(prog::Summe, 2), ") [All] ***");
    //            /////////////////////////////////////////////////////////////
    elif contains({DOM_LIST, DOM_SET}, domtype(FUN)) then
      map(op(FUN), prog::checkFunc, opt)
    else
      prog::init(FUN);
      prog::checkFunc(FUN, opt)
    end_if;
    sysassign(prog::init, subsop(prog::init, 5 = NIL));
    sysassign(prog::checkNone, subsop(prog::checkNone, 5 = NIL));
//    //sysassign(prog::LOCAL, table("level" = -1));
//    //sysassign(prog::LOCALuse, table("level" = -1));
    _userinfo_level(UI);
    null()
  end_proc:

// Check ///////////////////////////////////////////////////////////////////////
prog::checkFunc:=
  proc(FUN, opt)
    local AE, EN, ENV;
  begin
    FUN:= context(FUN);
    userinfo(Text, 5, "checking ".prog::getname(FUN)
                           ." (".expr2text(type(FUN)).")");

    sysassign(prog::LOCAL, table("level" = -1));
    sysassign(prog::LOCALuse, table("level" = -1));
    prog::warn(0);
    prog::nowarn(0);
    sysassign(prog::GLOV, table()); // global idents
    sysassign(prog::LOV, table());  // local unused
    sysassign(prog::ASS, table());  // assignments to formal parameters
    sysassign(prog::LEV, table());  // level on var's
    sysassign(prog::ESC, table());  // 
    
    opt:= eval(subs(opt, hold(All) = {hold(Local), hold(Localf),
                                      hold(Assign), hold(Global),
                                      hold(Domain), hold(Level),
                                      hold(Environment), hold(Special),
                                      hold(Protect), hold(Escape)}));

    sysassign(prog::OPT, _if(domtype(opt) = DOM_SET, opt, {opt}));

    prog::init(context(FUN));
    case domtype(FUN)
      of DOM_EXEC do
      of DOM_PROC do
        sysassign(prog::LOCALused, {});
        prog::checkNone(FUN); //checkGlobal?
        break
      of DOM_FUNC_ENV do
        prog::path(prog::getname(FUN));
        prog::checkNone(op(FUN, 1));
        prog::checkNone(op(FUN, 2));
        if domtype(op(FUN, 3)) = DOM_TABLE then
          for AE in prog::Entries(FUN) do
            userinfo(Text, 14, "slot ".prog::getname(FUN)."::".AE);
            userinfo(Text, 6..9, "slot ".prog::getname(FUN)."::".AE);
            prog::checkNone(slot(FUN, AE), opt)
          end_for
        end_if;
        prog::path();
        break
      of DOM_DOMAIN do
        if not contains({AxiomConstructor, CategoryConstructor, DomainConstructor,
                         Dom, Cat, Ax}, FUN) then
          // undefined Entries
          DOMENT(prog::undefEntr(FUN));
          for EN in prog::Entries(FUN) do
            userinfo(Text, 14, "checking entry ".EN." of domain ".expr2text(FUN));

            if contains(FUN, "Name") then
              prog::path(expr2text(FUN));
            else
              prog::path(prog::getname(FUN))
            end_if;
            ENV:= prog::Env(FUN, EN);
            if ENV <> FAIL then
              //userinfo(Text, 2, "Use context of ", FUN, " : ", op(ENV, 1));
              sysassign(prog::LOCAL,
                        table(op(prog::LOCAL), "level" = prog::LOCAL["level"] + 1,
                              prog::LOCAL["level"] + 1 = op(ENV, 1),
                              prog::LOCAL["level"] + 1001 = op(ENV, 2)))
            end_if;
            //userinfo(Text, 2, "check entry ".EN." of domain ".prog::getname(FUN));
            prog::checkNone(slot(FUN, EN));
            prog::path();

            if ENV <> FAIL then
              sysdelete(prog::LOCAL[prog::LOCAL["level"]]);
              sysdelete(prog::LOCAL[prog::LOCAL["level"] + 1000]);
              sysassign(prog::LOCAL,
                        table(op(prog::LOCAL), "level" = prog::LOCAL["level"] - 1))
            end_if;

          end_for;
        end_if;
        break
      otherwise
    end_case;
    
    //sysassign(prog::LOCAL, table("level" = -1));
    //sysassign(prog::LOCALuse, table("level" = -1));
    userinfo(Text, op([2..2, 1], sign(prog::warn() + prog::nowarn()) + 1),
             "Warnings: ", prog::warn(),
             _if(prog::nowarn() > 0, (" (", prog::nowarn(), " Assign)"), ""),
             " [".prog::getname(FUN)."]");
    sysassign(prog::Summe, [op(prog::Summe, 1) + prog::warn(),
                            op(prog::Summe, 2) + prog::nowarn()]);
    null()
  end_proc:


prog::checkNone:=
  proc(FUN = null())
    option remember;
    local EN, ENV;
  begin
    sysassign(prog::checkNone(args()), "ready");
    prog::init(FUN);
    case domtype(FUN)
      of DOM_EXEC do
        break
      of DOM_PROC do
        sysassign(prog::LOCALused, {});
        prog::checkGlobal(FUN);
        break
      of DOM_DOMAIN do
        DOMENT(prog::undefEntr(FUN));
        for EN in prog::Entries(FUN) do
          userinfo(Text, 14, "checking entry ".EN." of domain ".expr2text(FUN));

          if contains(FUN, "Name") then
            prog::path(expr2text(FUN));
          else
            prog::path(prog::getname(FUN))
          end_if;
          ENV:= prog::Env(FUN, EN);
          if ENV <> FAIL then
            //userinfo(Text, 2, "Use context of ", FUN, " : ", op(ENV, 1));
            sysassign(prog::LOCAL,
                      table(op(prog::LOCAL), "level" = prog::LOCAL["level"] + 1,
                            prog::LOCAL["level"] + 1 = op(ENV, 1),
                            prog::LOCAL["level"] + 1001 = op(ENV, 2)))
          end_if;
          prog::checkNone(slot(FUN, EN));
          prog::path();

          if ENV <> FAIL then
            sysdelete(prog::LOCAL[prog::LOCAL["level"]]);
            sysdelete(prog::LOCAL[prog::LOCAL["level"] + 1000]);
            sysassign(prog::LOCAL,
                      table(op(prog::LOCAL), "level" = prog::LOCAL["level"] - 1))
          end_if;

        end_for;
        break
      otherwise
    end_case
  end_proc:

prog::checkGlobal:=
  proc(FUN)
    //option remember;
    local BODY, UE, FU, STMT, NAME, ENV;
  begin
    //sysassign(prog::checkGlobal(args()), "ready");
    // lokale Variablen + Parameterliste
    if domtype(FUN) <> DOM_PROC then
      error("DOM_PROC expected (".expr2text(domtype(FUN)).")")
    end_if;
    BODY:= op(FUN, 4);               // Rumpf
    NAME:= prog::getname(FUN);            // NAME
    prog::path(NAME);
    ENV:= prog::Env(FUN);
    sysassign(prog::LOCAL,
              table(op(prog::LOCAL), "level" = prog::LOCAL["level"] + 1,
                    prog::LOCAL["level"] + 1 = op(ENV, 1),
                    prog::LOCAL["level"] + 1001 = op(ENV, 2)));

    //userinfo(Text, 2, "Level up to ", prog::LOCAL["level"]);
    userinfo(Text, 10, "checking ".NAME." ",
                 (subsop(prog::PATH, nops(prog::PATH) = null())));
    if prog::type(BODY) <> "_stmtseq" then BODY:= [BODY] end_if;
    for STMT in BODY do
      prog::indets([STMT], NAME);
    end_for;
    
    GLOBAL(if contains(prog::GLOV, prog::PATH) then
             userinfo(Text, 3, "Global idents: ",
                      prog::GLOV[prog::PATH],
                      " in ", prog::PATH);
             prog::warn(nops(prog::GLOV[prog::PATH]))
           end_if);
    LOCAL((if contains(prog::LOV, prog::PATH) then
             UE:= map(prog::LOV[prog::PATH], prog::VNM)
           else
             UE:= {}
           end_if;
           UE:= {op(prog::LOCAL[prog::LOCAL["level"]])}
                minus UE // local used
                minus (FU:= _if(/*not contains(prog::OPT, hold(Localf))*/TRUE,
                                _if(prog::LOCAL[prog::LOCAL["level"] + 1000] > 0,
                                    {op(prog::LOCAL[prog::LOCAL["level"]],
                                        (//nops(prog::LOCAL[prog::LOCAL["level"]])
                                        /*-*/ prog::LOCAL[prog::LOCAL["level"] + 1000])..
                                       nops(prog::LOCAL[prog::LOCAL["level"]]))},
                                    {}),
                                {})
                       minus UE);
           UE:= UE minus {hold(procname), hold(dom)};
           if nops(UE) > 0 then
             userinfo(Text, 3, "Unused local  var's:  ", UE, " in ", prog::PATH);
             prog::warn(nops(UE));
             //prog::XV(prog::LOV, prog::PATH) // aufraumen
           end_if;
           if nops(FU) > 0 and contains(prog::OPT, hold(Localf)) then
             userinfo(Text, 3, "Unused formal par's:  ", FU, " in ", prog::PATH);
             prog::warn(nops(FU));
             //prog::XV(prog::LOV, prog::PATH) // aufraumen
           end_if));
    ASSIGN(if contains(prog::ASS, prog::PATH) then
             userinfo(Text, 5, "Assignments to formal parameters: ",
                      (prog::ASS[prog::PATH]),
                      " in ", (prog::PATH));
//           prog::warn(nops(prog::ASS[prog::PATH]));
//           prog::nowarn(nops(prog::ASS[prog::PATH]));
             if contains(prog::ASS, prog::PATH.["W"]) then
               if contains(prog::ASS[prog::PATH.["W"]], TRUE) then
                 userinfo(Text, 3, "Critical assignments to formal par's: ",
                          (prog::ASS[prog::PATH]),
                          " in ", (prog::PATH));
                 prog::warn(nops(prog::ASS[prog::PATH]));
                 prog::nowarn(nops(prog::ASS[prog::PATH]));
                 userinfo(Text, 3, "Usage of 'args' after assignment to formal parameters in ",
                          prog::PATH);
                 //prog::warn(1);
               end_if
             end_if;
             //prog::XV(prog::ASS, prog::PATH.["W"]); // aufraumen
             //prog::XV(prog::ASS, prog::PATH) // aufraumen
           end_if);
    LEV(if contains(prog::LEV, prog::PATH) then
          userinfo(Text, 3, "'level' applied to variables: ",
                   (prog::LEV[prog::PATH]),
                   " in ", (prog::PATH));
          prog::warn(nops(prog::LEV[prog::PATH]));
          //prog::XV(prog::LEV, prog::PATH) // aufraumen
        end_if);
    ESC(if contains(prog::ESC, prog::PATH) then
          prog::warn(1);
          userinfo(Text, 3, "Procedure environment of [".
                   op(prog::ESC[prog::PATH]).
                   "] used by\n         [".
                   op(zip(prog::PATH, [", " $ nops(prog::PATH) - 1], _concat, "")).
                   "]")
          //prog::XV(prog::LEV, prog::PATH) // aufraumen
        end_if);
    //prog::XV(prog::LOV, prog::PATH);
    //userinfo(Text, 2, "Level down to ", prog::LOCAL["level"] - 1);
    prog::path();
    sysdelete(prog::LOCAL[prog::LOCAL["level"]]);
    sysdelete(prog::LOCAL[prog::LOCAL["level"] + 1000]);
    sysassign(prog::LOCAL,
              table(op(prog::LOCAL), "level" = prog::LOCAL["level"] - 1));
  end_proc:

//        //////////////////////////////////////////////////////////////////////
prog::indets:=
  proc(STMT, NAME)
    //option hold;
    local i, PT, REC;
  begin
    STMT:= op(STMT);
    REC:= TRUE;
    case domtype(STMT)
      of DOM_IDENT do
        COMP(if contains(prog::changeSet(prog::Changes::removed, hold(Sysvar)), STMT) then
               prog::warning("environment variable '".prog::getname(STMT)."' does not longer exist!");
               prog::warn(1);
               break
             end_if);
        GLOBAL(if not prog::isGlobal(STMT) then
                 prog::warning("Global variable '".prog::getname(STMT).
                               "' in ".NAME);
                 prog::XV(prog::GLOV, prog::PATH, prog::getname(STMT))
               end_if);
        break
      of DOM_PROC do
        prog::checkGlobal(STMT); break
      of DOM_VAR do
        LOCAL((PT:= prog::PATH;
               prog::XV(prog::LOV, PT, /*prog::VNM*/([op(STMT)]));
               if op(op(STMT), 1) > 0 then
                 PT:= subsop(PT, nops(PT) - i = null() $ i = 0..(op(op(STMT), 1) - 1));
                 prog::XV(prog::LOV, PT, /*prog::VNM*/([0, op(STMT, 2)]))
               end_if)); // local used
        ESC((if op(STMT, 1) > 0 then
               PT:= prog::PATH;
               (PT:= subsop(PT, nops(PT) = null())) $ i = 1..op(STMT, 1);
               if nops(PT) > 1 then
                 PT:= _concat(op(zip(PT, [", " $ nops(PT) - 1], _concat, "")))
               else
                 PT:= _concat(op(PT))
               end_if;
               prog::XV(prog::ESC, prog::PATH, PT)
             end_if));
        break
      of DOM_INT do
      of DOM_RAT do
      of DOM_FLOAT do
      of DOM_COMPLEX do
      of DOM_STRING do
      of DOM_BOOL do
      of DOM_POINT do
      of DOM_POLYGON do
      of DOM_NIL do
      of DOM_NULL do
      of DOM_FAIL do
        break;
      of DOM_SET do
      of DOM_LIST do
      of DOM_EXPR do
        
        if domtype(op(STMT, 0)) = DOM_EXPR then
          prog::indets([op(STMT, 0)], NAME)
        else
          case prog::type(STMT)
            of "hold" do
              REC:= FALSE;
              //nichts
              break
            of "DOM_VAR" do
              prog::indets([op(STMT, 0)], NAME);
              break
            of "function" do
              prog::indets([op(STMT, 0)], NAME);
              break
            of "_seqin" do
              if op(STMT, 0) = hold(_seqin) or op(STMT, 0) = _seqin then
                if nops(STMT) = 3 and type(op(STMT, 2)) = DOM_IDENT then
                  REC:= FALSE;
                  prog::indets([subs(op(STMT, 1), op(STMT, 2) = FAIL, Unsimplified)], NAME);
                  prog::indets([op(STMT, 3)], NAME)
                else
                  prog::indets([op(STMT, 0)], NAME)
                end_if
              else
                prog::indets([op(STMT, 0)], NAME)
              end_if;
              break
            of "_seqgen" do
            of "_seqin" do
              if nops(STMT) = 3 and type(op(STMT, 2)) = DOM_IDENT then
                REC:= FALSE;
                prog::indets([subs(op(STMT, 1), op(STMT, 2) = FAIL, Unsimplified)], NAME);
                prog::indets([op(STMT, 3)], NAME);
              end_if;
              break
            of "sysassign" do
            of "sysevalassign" do
            of "_assign" do
            of "evalassign" do
              ENV((prog::envAss(op(STMT, 1), NAME)));
              PROT((prog::protAss(op(STMT, 1), NAME)));
              SPEC(prog::specAss(op(STMT, 1), op(STMT, 2), NAME)
                   );
              ASSIGN(prog::localAss(op(STMT, 1), NAME)); break
            of "level" do
              LEV(if domtype(op(STMT, 1)) = DOM_VAR then
                    prog::warning("critical usage of 'level' on local variable '".
                                  prog::VNM(op(STMT, 1))."' in ".NAME);
                    prog::XV(prog::LEV, prog::PATH, prog::VNM(op(STMT, 1)))
                  end_if);
              break
            of "args" do
              if contains(prog::ASS, prog::PATH.["W"]) then
                if not(contains(prog::ASS[prog::PATH.["W"]], TRUE)) then
                  prog::warning("usage of 'args' after assignment to formal parameters in ".NAME);
                  prog::XV(prog::ASS, prog::PATH.["W"], TRUE)
                end_if
              end_if;
              break
            otherwise
          end_case;
        end_if;
        if REC then
          for i from 1 to nops(STMT) do
            if domtype(op(STMT, i)) = DOM_PROC and op(STMT, [i, 6]) = NIL then
              // set default name 'anonymous' for unnamed procedures in the static scope
              prog::indets([subsop(op(STMT, i), 6 = "proc in '".NAME."'")], NAME)
            else
              prog::indets([op(STMT, i)], NAME)
            end_if
          end_for;
          REC:= FALSE
        end_if;
        break
      otherwise
//        GLOBAL(map(indets(STMT),
//                 (X)->(if not prog::isGlobal(X) then
//                         prog::warning("Global variable '".expr2text(X).
//                                       "' in ".NAME);
//                         prog::XV(prog::GLOV, prog::PATH, X)
//                       end_if)));
    end_case
  end_proc:

// returns a set produced from a table
prog::changeset:=
  proc(TAB, LIB)
    local RET;
  begin
    RET:= select(TAB, X -> op(X, [1, 1]) = LIB);
    {op(map(RET, op, [1, 2]))}
  end_proc:

prog::ENVIRONMENT_VARIABLES:= {hold(TESTPATH), hold(MAXDEPTH), hold(LEVEL),
                               hold(MAXLEVEL), hold(WRITEPATH), hold(HIST).hold(ORY),
                               hold(ORDER), hold(LIBPATH), hold(READPATH),
                               hold(SEED), hold(PRETTYPRINT), hold(DIGITS),
                               hold(ROUNDING), hold(TEXTWIDTH)}:

// local ///////////////////////////////////////////////////////////////////////
// Variablen, die nur in geschachtelten Prozeduren verwendet werden
prog::localUsed:= 
  proc(PATH)
    local AU, FN;
  begin
    if nops(PATH) > 1 then FN:= op(PATH, nops(PATH)) else FN:= op(PATH) end_if;
    AU:= select(prog::LOV, (X->bool(contains(op(X, 1), FN) > 0)));
    {}
  end_proc:

prog::localAss:= 
  proc(VAR, NAME)
  begin
    if prog::isFormal(VAR) then
      prog::XV(prog::ASS, prog::PATH.["W"], UNKNOWN);
      prog::warning("assignment to FORMAL parameter '".prog::VNM(VAR)."' in ".NAME);
      prog::XV(prog::ASS, prog::PATH, prog::VNM(VAR))
    end_if
  end_proc:

prog::isFormal:= 
  proc(VAR)
    local IND;
  begin
    if domtype(VAR) = DOM_VAR then
      IND:= prog::LOCAL["level"] + 1000 - op(VAR, 1);
      if not contains(prog::LOCAL, IND) then
      else
        if prog::LOCAL[IND] < op(VAR, 2) + 2 then
          return(TRUE)
        end_if
      end_if
    end_if;
    FALSE
  end_proc:

prog::protAss:= 
  proc(VAR, NAME)
  begin
    if domtype(VAR) = DOM_IDENT then
      if protected(VAR) <> hold(None) then
        prog::warning("assignment to PROTECTED identifier '".expr2text(VAR)."' in ".NAME);
        prog::warn(1)
      end_if
    end_if
  end_proc:

prog::envAss:= 
  proc(VAR, NAME)
  begin
    if contains(level(prog::ENVIRONMENT_VARIABLES, 1), VAR) then
      if not prog::isSaved(VAR) then
        prog::warning("assignment to ENVIRONMENT variable '".expr2text(VAR)."' in ".NAME);
        prog::warn(1)
      end_if
    end_if
  end_proc:

prog::isSaved:=
  proc(VAR)
  begin
    
    FALSE
  end_proc:

prog::specAss:= // Spezialfalle
  proc(VAR, EX, NAME)
  begin
    case VAR
      of hold(HIS).hold(TORY) do
        if not contains({DOM_INT, "DOM_VAR"}, prog::type(EX)) then
          prog::warning("illegal argument assigned to 'HISTORY' in ".NAME);
          prog::warn(1)
        end_if
    end_case
  end_proc:

//prog::chkStmt:=
//  proc(STMT, NAME)
//    local i;
//  begin
//    i:= 0;
//    case prog::type(STMT)
//      of "level" do
//      //userinfo(Text, 5, "** level in use");
//      if domtype(op(STMT, 1)) = DOM_VAR then
//        prog::warning("critical using of 'level' on local variable ".
//                      prog::VNM(op(STMT, 1))." [".NAME."]" )
//      end_if;
//      otherwise
//      //if domtype(STMT) = DOM_EXPR #and nops(STMT) > 1# then
//      prog::chkStmt(op(STMT, i), NAME) $ i = 1..nops(STMT)
//      //end_if
//    end_case;
//    null()
//  end_proc:

// undefined Entries
prog::undefEntr:=
  proc(DOM)
    local AE;
  begin
    if (AE:= (DOM)::undefinedEntries()) <> FAIL and
      AE <> {} and DOM <> stdlib::Undefined then
      prog::warning("Warning: undefined entries ".expr2text(AE)." in ".prog::getname(DOM), 3);
      prog::warn(1)
    end_if
  end_proc:

////////////////////////////////////////////////////////////////////////////////
// Hilfsfunktionen
////////////////////////////////////////////////////////////////////////////////

prog::warning:=
  proc(MSG, LEV = 5)
  begin
    userinfo(Text, LEV, "Warning: ".MSG." ",
                  (subsop(prog::PATH, nops(prog::PATH) = null())));
  end_proc:

prog::warn:=
  proc(X = null())
  begin
    if args(0) > 0 then
      if X = 0 then
        sysassign(prog::WARNINGS, 0)
      else
        sysassign(prog::WARNINGS, prog::WARNINGS + X)
      end_if
    else
      prog::WARNINGS - prog::NWARNINGS
    end_if
  end_proc:

prog::nowarn:=
  proc(X = null())
  begin
    if args(0) > 0 then
      if X = 0 then
        sysassign(prog::NWARNINGS, 0)
      else
        sysassign(prog::NWARNINGS, prog::NWARNINGS + X)
      end_if
    else
      prog::NWARNINGS
    end_if
  end_proc:

prog::VNM:=
  proc(VAR)
  begin
    if not contains(prog::LOCAL, prog::LOCAL["level"] - op(VAR, 1)) then
      prog::warning("*** a problem with context of DOM_VAR(".expr2text(op(VAR)).")");
      prog::warn(1);
      FAIL
    else
      op(prog::LOCAL[prog::LOCAL["level"] - op(VAR, 1)], op(VAR, 2) + 1)
    end_if
  end_proc:

// prog::VNMM:=
//   proc(VAR)
//   begin
//     userinfo(Text, 2, "VNMM ".expr2text(domtype(eval(VAR)), VAR));
//     case domtype(VAR)
//       of DOM_VAR do
//         if prog::VNM(VAR) <> FAIL then
//           prog::VNM(VAR)
//         else
//           expr2text(VAR)
//         end_if;
//         break
//       of DOM_STRING do
//         expr2text(prog::VNMM(eval(text2expr(VAR))));
//         break
//       otherwise
//         VAR
//     end_case
//   end_proc:

//initiaized in prog.mu
//prog::PATH:= []:

prog::path:=
  proc(OBJ)
  begin
    if args(0) = 0 then
      sysassign(prog::PATH, subsop(prog::PATH, nops(prog::PATH) = null()))
    else
      sysassign(prog::PATH,
                append(prog::PATH, OBJ))
    end_if
  end_proc:

// LV, GV, AS
prog::XV:=
  proc(CON, FUN, ID = null())
    option hold;
  begin
    if args(0) = 2 then
      sysdelete(context(CON)[context(FUN)])
    else
      if contains(context(CON), context(FUN)) then
        sysevalassign(CON[context(FUN)], _union(context(CON[context(FUN)]), {context(ID)}), 2)
      else
        sysevalassign(CON[context(FUN)], {context(ID)}, 2)
      end_if
    end_if
  end_proc:

prog::type:=
  proc(EXPR)
  begin
    if domtype(EXPR) = DOM_EXPR then
      if domtype(op(EXPR, 0)) = DOM_EXPR then
        prog::type(op(EXPR, 0))
      elif type(op(EXPR, 0)) = DOM_VAR then
        "DOM_VAR"
      else
        type(EXPR)
      end_if
    else
      type(EXPR)
    end_if
  end_proc:

prog::Env:=
  proc(FUN, EN = null())
    local FRM, DOM, LOC;
  begin
    case domtype(FUN)
      of DOM_DOMAIN do
        if not contains({AxiomConstructor, CategoryConstructor, DomainConstructor,
                         Dom, Cat, Ax, Axiom, Category}, FUN) then
          DOM:= FUN::whichEntry(EN);
          if DOM <> FAIL then
            if not contains({Category, Axiom}, type(DOM)) then
              if contains(DOM, "constructor") then
                return(prog::Env(DOM::constructor))
              end_if
            else
              FUN:= op(extop(DOM, 1), 1)
            end_if
          end_if
        end_if;
        break
      of DomainConstructor do
        FUN:= op(FUN, 1);
        break
      of CategoryConstructor do
        FUN:= op(FUN, 1);
        break
    end_case;
    if domtype(FUN) <> DOM_PROC then
      return(FAIL)
    end_if;
    FRM:= subs(op(FUN, 2), NIL = null(), FAIL = null())/*, hold(procname), hold(dom)*/;
    LOC:= subs(op(FUN, 1), NIL = null(), FAIL = null());
    if (DOM:= {FRM} intersect {LOC}) <> {} then
      userinfo(Text, 3, "Duplicate parameter or variable ", DOM, " in ", prog::PATH);
      prog::warn(1)
    end_if;
    // save
    if (DOM:= {op(FUN, 11)} minus {NIL, FAIL}) <> {} then
      prog::setcheckglobals(FUN, DOM)
    end_if;
    // DOM_PROC_ENV
    // Achtung: Konnte Daten uberschreiben!?
    if type((DOM:= op(FUN, 12))) = DOM_PROC_ENV then
      sysassign(prog::LOCAL,
                table(op(prog::LOCAL), //"level" = prog::LOCAL["level"] + 1,
                      prog::LOCAL["level"] = [hold(procname), hold(dom),
                                                  op(DOM, [1, 2]), op(DOM, [1, 1])],
                      prog::LOCAL["level"] + 1000 = nops([op(DOM, [1, 2]), op(DOM, [1, 1])]) + 3))
    end_if;
    
    return([hold(procname), hold(dom), FRM, LOC], nops(FRM) + 1 + 2) // procname, dom
  end_proc:

