
//
//
//
prog::memuse:=
  proc(STMT, OPT = 0)
    local OUT, RET, BY, TAB, PATH, ret, SUM, all, FORMAT;
    option hold;
  begin

    OUT:= fopen(Text, "/tmp/mem.tmp", Write);
    if OUT = FAIL then error("while opening '/tmp/mem.tmp'") end_if;

    //INIT
    if OPT < 2 then
      sysassign(prog::oldloadproc, stdlib::LoadProc::read_file);
      sysassign(stdlib::LoadProc::read_file,
                proc(PATH, PR)
                  local ret;
                  option noDebug;
                begin
                  fprint(OUT, [1, PATH, PR, [bytes()]]);
                  // evaluation
                  ret:= prog::oldloadproc(args());
                  fprint(OUT, [-1, PATH, PR, [bytes()]]);
                  return(ret)
                end_proc)
    end_if;

    BY:= [bytes()];

    // exec statement
    RET:= context(STMT);
    
    //EXIT
    BY:= zip([bytes()], BY, _subtract);
    
    if OPT < 2 then
      sysassign(stdlib::LoadProc::read_file, prog::oldloadproc);
      sysdelete(prog::oldloadproc)
    end_if;

    //INFO
    fclose(OUT);
    FORMAT:=
      proc(X)
        local ret;
      begin
        expr2text(trunc(X/1000.0)).".".expr2text(abs(trunc((X/100.0 - trunc(X/100.0))*10)))
      end_proc;
    OUT:= fopen("/tmp/mem.tmp");
    all:= 0; PATH:= [];
    while finput(OUT, ret) <> null() do
      if op(ret, 1) > 0 then // in
        PATH:= [op(ret, 2).op(ret, 3)].PATH; // up
        TAB[op(ret, 2).op(ret, 3)]:= op(ret, [4, 1]); // first byte
      else // out
        if op(PATH, 1) <> op(ret, 2).op(ret, 3) then
          error("'".op(ret, 2).op(ret, 3)."' expected but '".op(PATH, 1)."'")
        end_if;
        // Abzuge
        SUM:= op(ret, [4, 1]) - TAB[op(ret, 2).op(ret, 3)]; // last byte
        delete TAB[op(ret, 2).op(ret, 3)];
        PATH:= subsop(PATH, 1 = null()); // down
        TAB[op(PATH, 1)]:= TAB[op(PATH, 1)] + SUM;
        all:= all + SUM;
        // Ausgabe
        fprint(Unquoted, 0,
               stringlib::format("'".op(ret, 2).op(ret, 3)."'", 32), " : ",
               FORMAT(SUM), " kB")
      end_if
    end_while;
    fclose(OUT);

    fprint(Unquoted, 0, "\n", stringlib::format("loadproc", 32), " = ",
                        FORMAT(all), " kB");
    SUM:= op(BY, 1);
    fprint(Unquoted, 0, stringlib::format("executing", 32), " = ",
                        FORMAT(SUM - all), " kB");
    fprint(Unquoted, 0, stringlib::format("All", 32), " = ",
                        FORMAT(SUM), " kB");

    delete FORMAT;
    //gprof(NIL, "/tmp/mem.tmp"); // del file
    
    RET
  end_proc:

