// $Date: 2000/10/16 08:33:43 $  $Author: andi $  $Revision: 1.15 $ 

prog::profile := proc()
    local depth, fd, l, last_depth, pname, Time, Rtime, t,
          pop, push, init_stack, stack, stackpointer, 
          statistic, show_statistic, Info, getline,
          float2string, Sort, init, format, LENGTH, 
	  rprint, lprint, result, fname,
	  statistic2, show_statistic2, info2;
    save MAXDEPTH;
    option hold;
begin

    // Stackoperationen push , pop, init_stack                  
    // Stack ist eine Tabelle. Tabellenindizes sind nat"urliche 
    // Zahlen. stackpointer zeigt auf oberstes Element. Ein-    
    // im Stack sind Zeiten, die aus dem Datenfile stammen.     

    pop := proc()
       begin 
            stackpointer := stackpointer - 1; 
            stack[stackpointer]
      end_proc:
    push := proc(elem)
      begin
           stack[stackpointer] := elem;
           stackpointer := stackpointer + 1; 
      end_proc:
    init_stack := proc() begin stackpointer := 0 end_proc:

    getline := proc()
        local a, b, c, d;
    begin
          if finput(fd, a, b, c, d) = null() then
             fclose(fd); return(null())
          end_if;
          expr2text(a), b, c, d
    end_proc:

    // MAXDEPTH ist der unterste Eintrag im Stack, also 
    // bottom of stack, und dient als Stopmarke beim Ab- 
    // bau des Stacks. Der Alg. l"auft nur dann korrekt, 
    // wenn eine Prozedurtiefe von >= MAXDEPTH niemals  
    // erreicht wird. Bei dem hier gew"ahlten Wert 10000 
    // ist davon aber auszugehen.                        

    init := proc()
        begin
            init_stack(); MAXDEPTH := 100000;
            push(-MAXDEPTH-1); last_depth := MAXDEPTH;
	    Info:= table();
	    info2:= table();
	end_proc:

    // Profile-Protokoll. Informationen werden in der Tabelle   
    // Info gespeichert, die "uber den Prozedurnamen pname      
    // indiziert wird. Jeder Eintrag der Tabelle ist eine Liste 
    // mit 3 Elementen, zum einem der Laufzeit innerhalb der    
    // Prozedur pname , der Anzahl der Aufrufe der Prozedur     
    // die ein Ergebnis durch Evaluierung des Prozedurrumpfes   
    // berechneten, und der Anzahl der Prozeduraufrufe, die ein 
    // Ergebnis durch Lookup in der Remember-Tabelle berech-    
    // neten. Die Laufzeit ist nur die Zeit, die direkt in der  
    // Prozedur verbracht wurde.                                
 
    statistic := proc(pname, Time, depth)
        local l;
      begin
            if domtype(Info[pname]) = DOM_LIST then
 
                // Prozedur pname ist bereits vorhanden.        
                // Addiere Zeit und erh"ohe Aufrufz"ahler um 1. 
 
                l := Info[pname];  l[1] := l[1] + Time;
 
                // Ist depth < 0, dann handelt es sich um einen 
                // Prozeduraufruf, dessen Wert durch ein Lookup 
                // in der Remember-Tabelle berechnet wurde.     
 
                if depth < 0 then
                    l[3] := l[3] + 1
                else
                    l[2] := l[2] + 1
                end_if
 
             // Prozedur pname ist noch nicht vorhanden.           
             // Initialisiere Laufzeit mit Time und Z"ahler mit 1. 
 
             elif depth < 0 then
                    l := [Time, 0, 1]
             else
                    l := [Time, 1, 0]
             end_if;
            Info[pname] := l
      end_proc:

    statistic2 := proc(father, son)
    begin
	if domtype(info2[father][son]) = DOM_INT then
           info2[father][son] := info2[father][son] + 1;
        else
           info2[father][son] := 1
        end_if
    end_proc:

    show_statistic2 := proc()
	local i, j, len1, len2;
	save PRETTYPRINT;
    begin
	if domtype(info2) = DOM_IDENT then
           return()
        end_if;
        PRETTYPRINT:=FALSE;
	print(Unquoted);
	for i in info2 do
            print(Unquoted, "<".op(i,1)."> calls");
	    len1 := max(length(op(i,[2,j,1])) $ j = 1 .. nops(op(i,2)));
	    len2 := max(LENGTH(op(i,[2,j,2])) $ j = 1 .. nops(op(i,2)));
            for j in op(i, 2) do
                print(Unquoted, "   ".rprint(op(j,1), len1)." : ".lprint(op(j,2), len2)." time(s)")
	    end_for;
	    print(Unquoted);
        end_for;
	print(Unquoted);
    end_proc:

    // Aufbereitung des Profile-Protokolls Info f"ur die Bild-    
    // schirmausgabe. Jede Zeile der Ausgabe enth"alt 6 Informa-  
    // tionen, die an folgendem Beispiel erkl"art werden:         
    // h: 32.5 % 13 ms total 3 calls 1 lookups 4.3 ms per call    
    // Die Laufzeit, die direkt in der Prozedur h ben"otigt wurde 
    // betr"agt insgesamt 13 ms. Dies sind 32.5 % der Gesamtlauf- 
    // zeit. Die Prozedur wurde 3-mal aufgerufen. 4.3ms ist daher 
    // daher das Mittel der Laufzeit pro Aufruf der Prozedur h.   
    // Das Ergebnis eines Aufrufes wurde durch ein Lookup in der  
    // Remember-Tabelle der Prozedur h berechnet, 2 Ergebnisse    
    // wurden durch Evaluierung des Prozedurrumpfes berechnet.    

    show_statistic := proc()
       local calls, cnt, i, out, Time, total, total_time,
             time_seq, time_len, name_len, call_len, rcall_len;
       save PRETTYPRINT;
       begin

	   PRETTYPRINT := FALSE;

           cnt := Sort(); // Beachte: Info ist nun ein Feld! 
	   print(Unquoted);

           if cnt = 0 then
              print(Unquoted, "No library function was called during profile.");
	      return();
           end_if;

           time_seq := op(Info[i], [2,1]) $ i = 1..cnt;
           total_time := _plus(time_seq);
           time_len := LENGTH(max(time_seq));
           name_len := max(length(op(Info[i], 1)) $ i=1..cnt);
           call_len := LENGTH(
              max(op(Info[i], [2,2]) + op(Info[i], [2,3]) $ i = 1..cnt));
           rcall_len := LENGTH(max(op(Info[i], [2,3]) $ i = 1..cnt));

	   if total_time = 0 then
              print(Unquoted, "Total time < 10 ms. No timing informations possible.");
              print(Unquoted, "----------------------------------------------------");
              for i from cnt downto 1 do
		 calls := op(Info[i], [2,2]) + op(Info[i], [2,3]);
	         out := rprint(op(Info[i], 1),  name_len).":";
                 out := out.lprint(calls, call_len)." call(s) ";
                 out := out.lprint(op(Info[i], [2,3]), rcall_len)." lookup(s)";
                 print(Unquoted, out);
              end_for
	   else
	      total := 100.0 / total_time;
	      out := "Total time: ".total_time." ms"; print(Unquoted, out);
              print(Unquoted, format("", length(out), "-", TRUE));
              for i from cnt downto 1 do
                 calls := op(Info[i], [2,2]) + op(Info[i], [2,3]);
                 Time := op(Info[i], [2,1]);
                 out := rprint(op(Info[i], 1),  name_len).":";
                 out := out.lprint(float2string(Time*total,1), 5);
                 out := out." % ".lprint(Time, time_len)." ms total ";
                 out := out.lprint(calls, call_len)." call(s) ";
                 out := out.lprint(op(Info[i], [2,3]), rcall_len)." lookup(s) ";
                 out := out.float2string(float(Time/calls),1);
                 out := out." ms/call";
		 print(Unquoted, out);
              end_for
	    end_if
       end_proc:

       // Konvertiere Gleitkommazahl f in eine Zeichenkette. 
       // Die Zeichenkette enth"lat alle Vorkommastellen,    
       // und digits Nachkommastellen von f.                 

       float2string := proc(f,digits)
          begin "".trunc(f).".".trunc(frac(f)*10^digits) end_proc:

       // Erzeugt Zeichenkette der L"ange width.               
       // Ist length(String) < width, so wird der rechte Teil  
       // der Zeichenkette mit fill_pattern aufgef"ullt, falls 
       // falls right = TRUE, sonst der linke Teil.            
 
       format := proc(String, width, fill_pattern, right)
           name format;
           local i;
       begin
           String := "".String;
           for i from 1 to width - length(String) do
                 if right then
                     String := String.fill_pattern
                 else
                     String := fill_pattern.String
                 end_if
           end_for;
           String
       end_proc:
 
       rprint := proc(String, width)
          begin format(String, width, " ", TRUE) end_proc:
 
       lprint := proc(String, width)
          begin format(String, width, " ", FALSE) end_proc:
 
       LENGTH := proc(f)
            begin ceil(float(ln(f))/ln(10.0)) end_proc:

       LENGTH(0) := 1;

       // Sortiere Profile-Protokoll Info mittels `straight- 
       // insertion. Zu diesem Zweck wird die Tabelle Info  
       // in ein Feld umgewandelt (*). Sortiert wird bzgl.   
       // der Laufzeit der einzelnen Prozeduren.             
       // (*) Vor Sort(): Info[pname] -> [Time, calls]       
       //     Nach  "   : Info[i]    -> pname=[Time, calls]  

       Sort := proc()
          local cnt, i, j, tmp, x;
          begin 
              cnt := nops(Info);

              if cnt = 0 then 
                 Info := array(1..1, 1=("none"=[0,0,0])); return(0);
              end_if;
              tmp := array(0..cnt); tmp[1] := op(Info, 1);
              for i from 2 to cnt do
                    tmp[i] := op(Info, i);  x:= tmp[i]; tmp[0] := x; j := i - 1;
                    while op(x,  [2,1]) < op(tmp[j], [2,1]) do 
                        tmp[j+1] := tmp[j]; j := j -1 
                    end_while;
                    tmp[j+1] := x
               end_for;
               Info := tmp; cnt
       end_proc:

    //------------------ Hauptprogramm -------------------

    if args(0) = 0 then
       return();
    end_if;

    fname := "prof".getpid().".dat";
    if sysname() = "UNIX" then
       fname := "/tmp/".fname
    else
      if( domtype(WRITEPATH) = DOM_STRING ) then
          fname := WRITEPATH.pathname("").fname;
      end_if
    end_if;
      
    // Aufruf des internen generischen Profilers (gprof). 
    // Dieser schreibt die in der Datei PROFILE.README    
    // beschriebenen Daten in die Datei profile.dat, die  
    // nun im folgenden aufbereitet werden.               

    result := gprof(context(args(1)), fname);
    init(); fd := fopen(fname);
    if fd = FAIL then error("could not open file ".fname) end_if;

    // Der wesentliche Algorithmus, der das Datenfile      
    // ausliest, und Laufzeiten der einzelnen Prozeduren   
    // berechnet und aufbereitet.                          

    while domtype((l := getline())) <> DOM_NULL do
         pname := l[1]; depth := abs(l[2]); Time := l[3]; Rtime := Time;
         if depth > last_depth then
             push(-last_depth)
         elif depth < last_depth then
                repeat
                    while (t := pop()) >= 0 do
                         Rtime := Rtime - t;
                         statistic2(pname, pop());
                     end_while
                until -t <> last_depth end_repeat;
               push(t)
         end_if;
	 if Rtime < 0 then
            Time := Time - Rtime; Rtime:=0;
         end_if;
         last_depth := depth; 
	 push(pname); push(Time); 
         statistic(pname, Rtime, l[2])
    end_while;
    if domtype(Info) <> DOM_TABLE then
      print(Unquoted, "No timing informations available.");
    else
      show_statistic();
      if args(args(0)) <> hold(Short) then
        show_statistic2()
      end_if
    end_if;

    gprof(NIL,fname); // Unlink profile 

    result

end_proc:
