      
/*(
   EO - domain of even/odd
          
)*/

alias(EO = property::EO):
alias(Divs = property::Divs):
alias(MOD(X) = extop(X, 5) mod 2):

EO:= newDomain("property::EO"):
EO::info:= "Domain of Even/Odd":
EO::domtype:= ()->Type:
EO::type:= "EO":
EO::prop:= TRUE:
EO::propdom:= ()->property::EO:
EO::autoload:= TRUE:
EO::testtype:= Type::testtype:

EO::noTrace:= {hold(print), hold(testtype), hold(domtype)}:

EO::ax:= []:

EO::new:= 
	proc(X)
	begin
          new(EO, FALSE, FALSE, FALSE, FALSE, X mod 2)
	end_proc:

EO::is:=
	proc(eo1, eo2)
	begin
	  if type(eo1) <> "EO" or type(eo2) <> "EO" then
            UNKNOWN
          else
            bool(MOD(eo1) = MOD(eo2))
	  end_if
	end_proc:

// EO::_and:=
// 	proc()
// 	begin
// 	  if op(args()) = 0 then
// 	  else
// 	  end_if
// 	end_proc:
	
EO::_plus:=
	proc()
	begin
	  property::_Op(EO, _plus,
	    proc(eo1, eo2)
	    begin
	      EO(MOD(eo1) + MOD(eo2))
	    end_proc, args())
	end_proc:

EO::_subtract:=
	proc()
	begin
	  property::_Op(EO, _subtract,
	    proc(eo1, eo2)
	    begin
	      EO(MOD(eo1) + MOD(eo2))
	    end_proc, args())
	end_proc:

EO::_negate:= id:

EO::_mult:=
	proc()
	begin
	  property::_Op(EO, _mult,
	    proc(eo1, eo2)
	    begin
	      EO(MOD(eo1)*MOD(eo2))
	    end_proc, args())
	end_proc:

EO::_divide:=
	proc()
	begin
          Type::Real
	end_proc:

EO::_invert:=
	proc()
	begin
	  Type::Real
	end_proc:

EO::_power:=
	proc()
	begin
	  property::_Op(EO, _power,
	    proc(eo1, eo2)
	    begin
              if property::_is(eo2, Type::PosInt) = TRUE then
                eo1
              else
                Type::Real
              end_if
	    end_proc, args())
	end_proc:

EO::Divs:=
	proc(eo)
	begin
	  _if(MOD(eo) = 0, Divs(2), not(Divs(2)))
	end_proc:
	
EO::NRange:=
	proc()
	begin
	  Type::Integer
	end_proc:
	
EO::print:=
	proc(eo)
	begin
	  if MOD(eo) = 0 then
	    "Type::Even"
	  else
	    "Type::Odd"
	  end_if
	end_proc:
	
stdlib::LoadlibState["property::EO"]:= TRUE:

userinfo(1, "Loading 'EO' done ..."):
unalias(EO):
