

/*(
   Func - Domain of property
	  'Properties of functional expressions with one argument DOM_IDENT'
)*/

alias(Func = (property::Func)):
alias(FUNC(x) = op(extop(x, 5), 1)):
alias(PROP(x) = op(extop(x, 5), 2)):
alias(FUN = [5, 1]):
alias(PRO = [5, 2]):

Func:= newDomain("property::Func"):
Func::info:= "Functional expressions with one argument DOM_IDENT";
Func::domtype:= ()->(Type):
Func::type:= "Func":
Func::prop:= TRUE:
Func::propdom:= slot(property, "Func"):
//Func::testtype:= Type::testtype:

Func::noTrace:= {hold(print), hold(testtype), hold(domtype)}:

Func::ax:= []:

Func::new:= 
	proc(FU = id, PR = null())
	begin
	  new(Func, "Func", testtype, FALSE, FALSE, [FU, PR])
	end_proc:

Func::Func:= 
	proc(FU1)
	begin
	  FUNC(FU1)
	end_proc:

Func::Prop:= 
	proc(FU1)
	begin
	  PROP(FU1)
	end_proc:

Func::is:= 
	proc(FU1, FU2)
	begin
	  if FUNC(FU1) = FUNC(FU2) then
	    return(property::implies(PROP(FU1), PROP(FU2)))
	  end_if;
	  UNKNOWN
	end_proc:

Func::_and:=
	proc()
	begin
	  property::_Op
	  (Func, _and,
	   proc(FU1, FU2)
	     local ret;
	   begin
	     if FUNC(FU1) = FUNC(FU2) then
	       ret:= PROP(FU1) and PROP(FU2);
	       return(subsop(FU1, PRO = ret))
	     end_if;
	     case [FUNC(FU1), FUNC(FU2)]
	       of [hold(Re), hold(Im)] do
		 if property::implies(PROP(FU2), property::Rel(_equal, 0)) = TRUE then
		   return(Type::Real and PROP(FU1))
		 end_if;
	         break
	       of [hold(Im), hold(Re)] do
		 if property::implies(PROP(FU1), property::Rel(_equal, 0)) = TRUE then
		   return(Type::Real and PROP(FU2))
		 end_if;
	         break
	       otherwise
	         FAIL
	     end_case
	   end_proc, args())
	end_proc:

Func::_or:=
	proc()
	begin
	  property::_Op
	  (Func, _or,
	   proc(FU1, FU2)
	     local ret;
	   begin
	     if FUNC(FU1) = FUNC(FU2) then
	       ret:= PROP(FU1) or PROP(FU2);
	       return(subsop(FU1, PRO = ret))
	     end_if;
	     hold(_or)(FU1, FU2)
	   end_proc, args())
	end_proc:

Func::_plus:=
	proc()
	begin
	  property::_Op
	  (Func, _plus,
	   proc(FU1, FU2)
	     local ret;
	   begin
	     if FUNC(FU1) = FUNC(FU2) then
	       ret:= PROP(FU1)+PROP(FU2);
	       return(subsop(FU1, PRO = ret))
	     end_if;
	     hold(_plus)(FU1, FU2)
	   end_proc, args())
	end_proc:

Func::_subtract:=
	proc()
	begin
	  property::_Op
	  (Func, _subtract,
	   proc(FU1, FU2)
	     local ret;
	   begin
	     if FUNC(FU1) = FUNC(FU2) then
	       ret:= _subtract(PROP(FU1), PROP(FU2));
	       return(subsop(FU1, PRO = ret))
	     end_if;
	     hold(_subtract)(FU1, FU2)
	   end_proc, args())
	end_proc:

Func::_negate:=
	proc(FU1)
	begin
	  hold(_negate)(FU1)
	end_proc:

Func::_mult:=
	proc()
	begin
	  property::_Op
	  (Func, _mult,
	   proc(FU1, FU2)
	     local ret;
	   begin
	     if FUNC(FU1) = FUNC(FU2) then
	       ret:= PROP(FU1)*PROP(FU2);
	       return(subsop(FU1, PRO = ret))
	     end_if;
	     hold(_mult)(FU1, FU2)
	   end_proc, args())
	end_proc:

Func::_divide:=
	proc()
	begin
	  property::_Op
	  (Func, _divide,
	   proc(FU1, FU2)
	     local ret;
	   begin
	     if FUNC(FU1) = FUNC(FU2) then
	       ret:= _divide(PROP(FU1), PROP(FU2));
	       return(subsop(FU1, PRO = ret))
	     end_if;
	     hold(_divide)(FU1, FU2)
	   end_proc, args())
	end_proc:

Func::_invert:=
	proc(FU1)
	begin
	  hold(_invert)(FU1)
	end_proc:

//Func::NRange:= 
//	proc(FU)
//	begin
//	  case FUNC(FU)
//	    of Re do
//	      return(PROP(FU) and Type::Real); break
//	    otherwise
//	      return(Type::Complex)
//	  end_case
//	end_proc:

Func::Re:=
	proc(FU1)
	begin
	  case FUNC(FU1)
	    of hold(Re) do
	      return(PROP(FU1))
	    of hold(Im) do
	      print(1);
	      return(property::Rel(_equal, 0))
	    otherwise
	      return(hold(Re)(FU1))
	  end_case
	end_proc:

Func::Im:=
	proc(FU1)
	begin
	  case FUNC(FU1)
	    of hold(Im) do
	      return(PROP(FU1))
	    of hold(Re) do
	      return(property::Rel(_equal, 0))
	    otherwise
	      return(hold(Im)(FU1))
	  end_case
	end_proc:

Func::print:=
	proc(XX)
	begin
	  expr2text(FUNC(XX)) . "(.) " .
	  (_if((PROP(XX))::dom::Z <> FAIL, (PROP(XX))::dom::Z, "")) . expr2text(PROP(XX))
	end_proc:

//property::autoload(Func):

unalias(PROP):
unalias(FUNC):
unalias(Func):
