

// Pid - Domain of 'Id of Properties' 

alias(Pid = (property::POp)::Pid):
alias(POp = (property::POp)):

Pid:= newDomain("POp::Pid"):
Pid::info:= "Identity of Properties":
Pid::type:= "Pid":
  
Pid::new:=
	proc()
	begin
	  new(Pid, args())
	end_proc:

Pid::expr:=
	proc()
	begin
	  map(op(args()), POp::expr)
	end_proc:
	
Pid::_subtract:=
	proc() begin hold(_subtract)(args()) end_proc:

Pid::_mult:=
	proc() begin hold(_mult)(args()) end_proc:

Pid::_divide:=
	proc() begin hold(_divide)(args()) end_proc:

Pid::_and:=
	proc() begin hold(_and)(args()) end_proc:

Pid::_or:=
	proc() begin hold(_or)(args()) end_proc:

Pid::_not:=
	proc() begin hold(_not)(args()) end_proc:

Pid::print:=
	proc()
	begin
	  expr2text(op(args()))
	end_proc:

unalias(Pid):
unalias(POp):
