
/*(
   Prop - generic property domain
          primitive implementation - only table rules
)*/

alias(Prop = (property::Prop)):

Prop:= newDomain("property::Prop"):
Prop::info:= "Domain of generic property 'Prop'":
Prop::domtype:= (()->(Type)):
Prop::type:= "Prop":
Prop::prop:= TRUE:
Prop::propdom:= slot(property, "Prop"):
Prop::autoload:= TRUE:
Prop::testtype:= Type::testtype:

Prop::ax:= []:

Prop::new:= 
        proc()
        begin
          if args(0) > 0 then
            new(Prop, hold(Prop), FALSE, FALSE, FALSE, args())
          else
            new(Prop, NIL)
          end_if
        end_proc:

// gibt bool zuruck, ob aus arg1, ..., argn-1 -> argn folgt 
Prop::is:=
        proc()
        begin
          if args(args(0)) = args(1) then return(TRUE) end_if;
          return(UNKNOWN)
        end_proc:

Prop::op:=
        proc(X)
        begin
          extop(X, 5)
        end_proc:

Prop::_and:=
        proc()
        begin
          property::_Op(Prop, _and, (()->(hold(_and)(args()))), args())
        end_proc:

Prop::_or:=
        proc()
        begin
          property::_Op(Prop, _or, (()->(hold(_or)(args()))), args())
        end_proc:

Prop::_not:=
        proc()
        begin
          property::_Op(Prop, _not, (()->(hold(_not)(args()))), args())
        end_proc:

Prop::_plus:=
        proc()
        begin
          property::_Op(Prop, _plus, (()->(hold(_plus)(args()))), args())
        end_proc:

Prop::_subtract:=
        proc()
        begin
          property::_Op(Prop, _subtract, (()->(hold(_subtract)(args()))), args())
        end_proc:

Prop::_negate:=
        proc()
        begin
          property::_Op(Prop, _negate, (()->(hold(_negate)(args()))), args())
        end_proc:

Prop::_mult:=
        proc()
        begin
          property::_Op(Prop, _mult, (()->(hold(_mult)(args()))), args())
        end_proc:

Prop::_divide:=
        proc()
        begin
          property::_Op(Prop, _divide, (()->(hold(_divide)(args()))), args())
        end_proc:

Prop::_invert:=
        proc()
        begin
          property::_Op(Prop, _invert, (()->(hold(_invert)(args()))), args())
        end_proc:

Prop::_power:=
        proc()
        begin
          property::_Op(Prop, _power, (()->(hold(_power)(args()))), args())
        end_proc:

Prop::print:=
        proc(X)
        begin
          //if extop(X, 1) <> hold(Prop) then
          //  extop(X, 1)
          //else
            "Prop(" . expr2text(op(X, 5)) . ")"
          //end_if
        end_proc:

