// $Date: 2000/11/30 10:41:53 $ $Author: bij $ $Revision: 1.10 $

property::prop2set:=
        proc(EX)
        begin
          if domtype(EX) = DOM_EXPR then
            if type(EX) = "_in" then
              EX:= map(EX, property::prop2set);
              if contains({"_and", "_or", "_not"}, type(op(EX, 2))) then
                map(map(op(EX, 2), X -> op(EX, 1) in X), property::prop2set)
              else
                EX
              end_if
            else
              map(EX, property::prop2set)
            end_if
          elif contains(EX::dom, "prop2set") then
            EX::dom::prop2set(EX)
          else
            EX
          end_if
        end_proc:

// Konvertierung - Schnittstelle 
property::convert_to:=
        proc(prop, _to = FAIL, Opt = FAIL, _dir = FAIL)
          local ret;
          //option remember;
        begin
          // kein Ziel
          if _to = FAIL then
            // numerisch
            if Opt = hold(Exact) then
              if contains(Type::ConstantIdents, prop) then
                return(property::Rel(_equal, prop))
              elif not(contains({DOM_INT, DOM_RAT, DOM_FLOAT}, domtype(prop))) and
                contains({DOM_FLOAT, DOM_COMPLEX}, domtype((ret:= property::carefloat(prop)))) then
                //return(ret)
                return(property::Rel(_equal, prop))
              end_if
            end_if;
            return(prop)
          end_if;
          // expressions
          if domtype(prop) = DOM_EXPR then
            if contains({DOM_FLOAT, DOM_COMPLEX}, domtype((ret:= property::carefloat(prop)))) then
              return(property::_convert(Opt, ret, _to, _dir))
            else
              return(map(prop, property::convert_to, _to, Opt, _dir))
            end_if
          end_if;
          
          property::_convert(Opt, prop, _to, _dir)
        end_proc:

property::_convert:=
        proc(Opt = hold(Exact), prop = property::Unknown, _to = FAIL, _dir = FAIL)
          local ret;
        begin
          if property::Fail(prop) then
            return(prop)
          end_if;
          if domtype(_to) <> DOM_DOMAIN then
            _to:= _to::dom
          end_if;
          // nichts zu konvertieren
          if prop::dom = _to then
            return(prop)
          end_if;

//           if Opt = hold(Subset) then
            
//           end_if;

          // Generierung von Eigenschaften, Konvertierung
          _to:= _if(_to::type <> FAIL, _to::type, expr2text(_to));
          //userinfo(3, "convert_to: ".expr2text(prop)." --> ".expr2text(_to));
          ret:= slot(prop::dom, _to)(prop, Opt, _dir);
          if ret <> FAIL then
            return(ret)
          end_if;

          //if testtype(prop, Type::Constant) then
          //  return(property::_convert(Opt, property::Rel(_equal, prop), _to, _dir))
          //end_if;

          // System-Konstanten und auswertbare Funktionen
          if Opt = hold(Exact) and contains({DOM_IDENT, DOM_EXPR}, domtype(prop)) then
            if contains(Type::ConstantIdents, prop) then
              return(property::Rel(_equal, prop))
            elif testtype(prop, Type::Constant) then
              return(property::_convert(Opt, property::Rel(_equal, prop), _to, _dir))
              //elif domtype((ret:= float(prop))) <> domtype(prop) then
              //  //userinfo(9, "convert_to: float ".expr2text(ret));
              //  return(property::convert_to(ret, _to))
            end_if
          end_if;
          if domtype(prop) = DOM_EXPR then
            return(FAIL)
          end_if;
          // solver
          if contains(prop::dom, "set2prop") then
            return(prop::dom::set2prop(prop))
          end_if;

          // nicht konvertieren?
          return(prop)
        end_proc:

// DOM_EXPR - keine Kern-Typen
property::carefloat:=
  proc(x)
    local xf, xff, x12, x22;
  begin
    // float test
    xf:= float(x);
    if not has({DOM_COMPLEX}, domtype(xf)) then
      // "real" mode
      return(xf) // ??? xf
    end_if;
    if iszero(xf) then
      // ??? UNKNOWN
      DIGITS:= DIGITS + 10;
      xff:= float(x);
      DIGITS:= DIGITS - 10;
      if iszero(xff) then
        return(0.0)
      else
        return(x)
      end_if
    end_if;
    // Heuristics: increase DIGITS to verify that t is not complete round-off trash
    // We need at least DIGITS + 10 to make sure, that PARI adds a further block
    //x11:= specfunc::abs(op(xf, 1));
    x12:= specfunc::abs(op(xf, 2));
    DIGITS:= DIGITS + 10;
    xff:= float(x);
    DIGITS:= DIGITS - 10;
    if domtype(xff) <> DOM_COMPLEX then
      // ??? UNKNOWN
      return(op(xf, 1))
    else
      //x21:= specfunc::abs(op(xff, 1));
      x22:= specfunc::abs(op(xff, 2))
    end_if;
    // the leading digit of x1 is reliable, if 1/2 < x1/x2 < 2;
    if (x12<2*x22 and x22<2*x12) then
      return(xf)
    else
      // ??? UNKNOWN
      return(op(xf, 1))
    end_if
  end_proc:

property::_convert:= prog::remember(property::_convert, property::depends):
