// $Date: 2000/11/30 16:04:50 $ $Author: bij $ $Revision: 1.69 $

// Kern-is
is:=
  proc(ex, prop)
  begin
    if testtype(ex, Type::Relation) then
      if property::isConstant(ex) then
        //fprint(Unquoted, 0, "Warning: kernel 'is' would found this (1) [is]");
        if contains({"_equal", "_unequal"}, type(ex)) then
          return(bool(ex))
        elif contains({map(op(ex), domtype)}, DOM_COMPLEX) then
// !!!!!!!!!!!!!!!!!!!!!!!!! COMPLEX !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          //return(FALSE)
        elif contains({map(op(ex), domtype)}, DOM_IDENT) then
          return(bool(map(ex, float)))
        elif contains({map(op(ex), domtype@float)}, DOM_COMPLEX) then
// !!!!!!!!!!!!!!!!!!!!!!!!! COMPLEX !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          // nothing !
        elif traperror(bool(map(ex, float))) = 0 then
          return(bool(map(ex, float)))
        else
          return(bool(ex))
        end_if
      end_if;
//       if type(op(ex, 1)) = DOM_IDENT then
//         if property::sysisprop(op(ex, 1), prop) then // sysprop
//           return(TRUE)
//         end_if;
//         if type(op(ex, 2)) = DOM_IDENT then
//           if property::sysisprop(op(ex, 2), prop) then // sysprop
//             return(TRUE)
//           end_if
//         end_if
//       end_if
    elif type(ex) = DOM_IDENT then
      if property::_getprop(ex) = ex then
        if property::_getprop(hold(Global)) = undefined then
          //fprint(Unquoted, 0, "Warning: kernel 'is' would found this (2) [is]");
          return(UNKNOWN)
        end_if
      elif contains(Type::ConstantIdents, ex) then
        //
      elif property::sysidprop(ex, prop) then
        if property::_getprop(hold(Global)) = undefined then
          //fprint(Unquoted, 0, "Warning: kernel 'is' would found this (3) [is]");
          return(TRUE)
        elif property::_getprop(hold(Global)) = property::_getprop(ex) then
          //fprint(Unquoted, 0, "Warning: kernel 'is' would found this (5) [is]");
          return(TRUE)
        end_if
      elif property::_getprop(ex) = ex and
           property::sysidprop(hold(Global), prop) then
        //fprint(Unquoted, 0, "Warning: kernel 'is' would found this (4) [is]");
        return(TRUE)
      end_if
    elif contains({TRUE, FALSE, UNKNOWN, FAIL}, ex) then
      return(ex)
    end_if;
    //fprint(Unquoted, 0, "Warning: kernel 'is' would not found this [is]");
    property::is(args())
  end_proc:

property::isConstant:=
  proc(ex)
  begin
    case domtype(ex)
      of DOM_IDENT do
        return(contains(Type::ConstantIdents, ex))
        
      of DOM_EXPR do
        return(not has(map([op(ex)], property::isConstant), FALSE) and
               bool(domtype(op(ex, 0)) = DOM_IDENT))
        
      of DOM_INT do
      of DOM_RAT do
      of DOM_FLOAT do
      of DOM_COMPLEX do
      of DOM_BOOL do
      of DOM_NIL do
      of DOM_NULL do
      of DOM_FAIL do
        return(TRUE)
    end_case;
    FALSE
  end_proc:

property::hastype:=
  proc(ex)
    local SUB;
  begin
    SUB:=
      proc()
        //local RET;
      begin
      end_proc
  end_proc:

// gibt BOOL zuruck, ob prop eine Eigenschaft von ex ist
property::is:=
  proc(ex, prop = null())
    local ret, lev;
  begin
    
    if testargs() then
      if args(0) = 1 then
        if ex::dom::prop = TRUE then
          // globale Eigenschaft
        elif domtype(ex) = DOM_EXPR then
          //if misc::maprec(ex, {"NRange", "IV", "IVnat", "Prop",
          //                        "Rel", "Complex", "Residue"} = TRUE) = TRUE then
          if contains({"NRange", "IV", "IVnat", "Prop",
                       "Rel", "Complex", "Residue"}, type(ex)) then
            // globale Eigenschaft
          elif contains({"_less", "_leequal", "_equal", "_unequal",
                         "_and", "_or", "_not", "_in"}, type(ex)) then
            // expression
          else
            error("wrong expression type of first argument")
          end_if
        else
          error("wrong type of first argument")
        end_if
      elif args(0) = 2 then
        if prop::dom::prop = TRUE then
          // globale Eigenschaft
        elif domtype(prop) = DOM_EXPR
             and contains({"NRange", "IV", "IVnat", "Prop",
                           "Rel", "Complex", "Residue"}, type(ex)) then
             //and misc::maprec(ex, {"NRange", "IV", "IVnat", "Prop",
             //                         "Rel", "Complex", "Residue"} = TRUE) = TRUE then
            // globale Eigenschaft
        else
          error("wrong type of second argument (property expected)")
        end_if
      else
        error("wrong number of arguments")
      end_if
    end_if;

    //userinfo(Text, 1, ">**(", property::RESET, ") is --> ", [args()]);

   // testtype
    if domtype(prop) = Type and not(contains(prop::dom, "prop")) then
      if nops(prop) > 4 then // provisorische Type's
        return(slot(property, op(prop, 5))(ex))
      else
        error("wrong type of second argument '".expr2text(prop)."' ('Type::Property' expected)")
        //userinfo(10, "testtype(".expr2text(args()).")");
        //return(testtype(ex, prop) or UNKNOWN)
      end_if
    end_if;

    // enter recursion
    property::reset(1);
    ret:= args();
    if testtype(ex, Type::Property) then
      // globale Eigenschaft
      ret:= hold(Global), ret
    end_if;
    if property::RESET > 1 then // inline of recursion
      lev:= 0;
      ret:= property::_is(ret)
    elif property::NoErrors then
      warning("Don't forget to call 'property::reset()' after any error!");
      lev:= 0;
      ret:= property::_is(ret)
    else // first call
      lev:= traperror((ret:= property::_is(ret)))
    end_if;
    if lev > 0 then
      sysassign(property::RESET, 0);
      property::reset();
      lasterror()
    end_if;
    // leave recursion
    property::reset(-1);
    if contains({TRUE, FALSE}, ret) then
      return(ret)
    else
      return(UNKNOWN)
    end_if
  end_proc:

// gibt BOOL zuruck, ob prop eine Eigenschaft von ex ist
property::_is:=
  proc(ex, prop = null())
    local __ret__, __f_, M, GLOBAL, G, CONST, minprop;
    //option remember;
  begin
    //remember

//        if property::RECLEVEL < property::MAXREC then
//          sysassign(property::RECLEVEL, property::RECLEVEL + 1)
//        else
//          userinfo(1, "*<* is: max recursion reached");
//          return(UNKNOWN)
//        end_if;
    // Operand undefined
    if property::Fail(ex, op(ex), prop) then
      return(UNKNOWN)
    end_if;

    // zu grosse Eingaben
    //userinfo(Text, 8, "Input length: ", length(ex));
    if length(ex) > property::MAXLENGTH then
      userinfo(2, "Break: input expression is too long! [property::is]");
      //return(UNKNOWN)
    end_if;
    // Globale Eigenschaft
//    GLOBAL:= property::_getprop(hold(Global));
//    if not property::hasprop(GLOBAL) then
//    if GLOBAL = hold(Global) or GLOBAL = undefined then
    if args(0) = 1 and testtype(ex, Type::Property) then
      prop:= ex;
      ex:= hold(Global);
      GLOBAL:= null();
      G:= FALSE
    else
      // Globale Eigenschaft
      GLOBAL:= property::_getprop(hold(Global));
      if GLOBAL = hold(Global) or GLOBAL = undefined then
        GLOBAL:= null();
        G:= FALSE
      else
        G:= TRUE
      end_if
    end_if;

    minprop:=
      if domtype(ex) = DOM_EXPR and domtype((minprop:= eval(op(ex, 0)))) = DOM_FUNC_ENV then
        slot(minprop, "minprop")
      else
        FAIL
      end_if;
    
    // Bezeichner ohne Eigenschaften
    __f_:= indets(ex) minus Type::ConstantIdents;
//fprint(0, "1", __f_, map(__f_, property::_getprop), _if(args(0) > 1, indets(prop), null()));
    if __f_ <> {} then //__f_ = map(__f_, float) then
      if map(__f_, property::_getprop) = __f_ then
        if __f_ intersect _if(args(0) > 1, indets(prop), null()) = {} then
          userinfo(2, "Info: identifiers without properties [property::_is]");
          if minprop <> FAIL then
            return(property::implies(minprop, prop))
          else
            return(UNKNOWN)
          end_if
        end_if
      end_if
    end_if;
//fprint(0, "2", ex);

    if prop <> null() and GLOBAL <> null() and contains(prop::dom, "prop") then
      prop:= prop and GLOBAL
    elif prop = null() then
      if contains({TRUE, FALSE, UNKNOWN}, ex) then
        return(ex)
      end_if
    end_if;
    // Bezeichner, Systemeigenschaft
    if domtype(ex) = DOM_IDENT then
      if property::sysidprop(ex, prop) then
        return(TRUE)
      end_if
    end_if;

    //userinfo(Text, 8, "**> _is: ", ex, " ?-> ", prop);
    __ret__:= UNKNOWN;
    CONST:= not property::isConstant(ex) and UNKNOWN;

    // prop keine Eigenschaft
    if prop <> null() and not testtype(prop, Type::Property) then
      if prop::dom::set2prop <> FAIL then
        prop:= prop::dom::set2prop(prop, hold(Exact));
        if prop = FAIL then
          return(UNKNOWN)
        end_if
      else
        //warning("wrong type of second argument, cannot recognize or convert to a property");
        return(UNKNOWN)
      end_if
    end_if;
    
    __f_:= op(ex, 0);
    if domtype(ex) = DOM_EXPR then
      if contains({"_and", "_or", "_not"}, type(ex)) then
        __ret__:= property::_is(map(ex, property::_is, prop));
        if __ret__ = UNKNOWN then
          // gegenseitiger Ausschluss von Relationen-Eigenschaften
          __ret__:= property::simpex(ex)
        end_if
      elif type(ex) = "_in" then
        if testtype(op(ex, 2), Type::Property) then
          __ret__:= property::_is(op(ex))
        else
          case domtype(op(ex, 2))
            of solvelib::BasicSet do
              __ret__:= property::_is(op(ex, 1), solvelib::set2prop(op(ex, 2)));
              break
            of piecewise do
              return(simplify(piecewise::map(op(ex, 2), X -> is(op(ex, 1) in X))));
              break
            of Dom::Interval do
              __ret__:= property::_is(op(ex, 1), Dom::Interval::set2prop(op(ex, 2)));
              break
            of Dom::ImageSet do
              M:= Dom::ImageSet::expr2set(op(ex, 2), op(ex, 1));
              if type(M)="_in" then
                return(UNKNOWN)
              else
                return(property::_is(M))
              end_if
            otherwise
              return(UNKNOWN)
          end_case
          //error("cannot decide this fact, use 'contains' or 'solve'")
        end_if
      elif (__f_:= contains(["_less", "_leequal", "_equal", "_unequal"],
                            type(ex))) > 0 then
        // numerisch 
        if (M:= ({map(op(ex), domtype)} minus
            {DOM_INT, DOM_FLOAT, DOM_RAT})) = {} then
          return(bool(ex))
        //elif contains(M, DOM_COMPLEX) then
        //  if __f_ > 2 then
        //    return(bool(ex))
        //  else
// !!!!!!!!!!!!!!!!!!!!!!!!! COMPLEX !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            //return(FALSE) // DOM_COMPLEX nicht reell!
        //  end_if
        end_if;
        __f_:= map(map(ex, float), float);
        if ({map(op(__f_), domtype)} minus {DOM_INT, DOM_FLOAT, DOM_RAT}) = {} then
          return(bool(__f_))
        end_if;

        // Relationen nur in einer Richtung 
        if prop = null() then delete prop end_if;
        if contains({">", "<"}, prop) then
          if prop = "<" then
            __ret__:= property::_is(op(ex, 1),
                                    property::Rel(op(ex, 0),
                                                  op(ex, 2)))
          else // ">" 
            __ret__:= property::_is(op(ex, 2),
                                    property::Rel(-op(ex, 0),
                                                  op(ex, 1)))
          end_if
        elif op(ex, 1) = op(ex, 2) then
          if contains({hold(_equal), hold(_leequal)}, op(ex, 0)) then
            __ret__:= TRUE
          else __ret__:= FALSE
          end_if
        else

          __ret__:= property::isrel(ex) // Relationen

        end_if;
      // DOM_FUNC_ENV 
      elif domtype(__f_) = DOM_FUNC_ENV and
           (__f_:= slot(__f_, "is")) <> FAIL then
        // fprint(0, "slot(".expr2text(op(ex, 0)).", is)");
        __ret__:= __f_(op(ex), prop)
//       #( DOM_EXPR )#
//       elif type(__f_) = "abs" then
//         if property::_is(ex, Type::Complex) = TRUE then
//           //fprint(0, "abs", prop, " => ", Type::NonNegative);
//           __ret__:= property::implies(prop, Type::NonNegative)
//         end_if
      // DOM_EXPR
      else
        __ret__:= property::isfunc(ex, prop);
        if not(contains({TRUE, FALSE}, __ret__)) then
          // 
          __f_:= property::_getprop(ex); // zuerst ohne Konvertierung
          if minprop <> FAIL then
            if __f_ = ex then
              __f_:= minprop
            else
              __f_:= __f_ and minprop
            end_if
          end_if;
          __ret__:= property::implies(__f_, prop);
          if __ret__ = UNKNOWN then
            __ret__:= property::implies(property::convert_to(__f_, prop), prop)
          end_if
        end_if
      end_if
    else // not DOM_EXPR
      __f_:= property::Ex2Px(ex);
      if contains({"and", "or"}, type(__f_)) then
        __ret__:= property::lzeval(__f_, property::implies, prop)
      else
        __ret__:= property::implies(__f_, prop)
      end_if;
      if __ret__ = UNKNOWN then
        __ret__:= property::implies(property::_getprop(__f_, prop), prop);
      end_if
    end_if;
    // konstante Werte
    if __ret__ = UNKNOWN then
      __ret__:= __ret__ and CONST
    end_if;
    // remember
    //sysassign(property::RECLEVEL, property::RECLEVEL - 1);
    //userinfo(Text, 8, "<** _is: ", __ret__);
    __ret__
  end_proc:

// funktionale Eigenschaften 
property::isfunc:=
  proc(_func, prop)
    local ret, i;
  begin
    if op(_func) = hold(_in) then
      return(property::_is(op(_func, 1), op(_func, 2)))
    end_if;
    if nops(_func) <> 1 or domtype(op(_func)) <> DOM_IDENT then
      return(UNKNOWN)
    end_if;
    if (i:= contains([hold(Re), hold(Im)], op(_func, 0))) > 0 then
      if property::implies(prop, Type::Real) = TRUE then
        return(TRUE)
      end_if;
      if type((ret:= getprop(op(_func, 1)))) = "Complex" then
        property::implies(ret, property::Complex(op(subsop([FAIL, FAIL], i = prop))))
      end_if
    else
      UNKNOWN
    end_if
  end_proc:

// gibt BOOL zuruck, ob aus _exp prop folgt 
// _exp - P-Ausdruck von Eigenschaften, prop - Eigenschaft 
property::implies:=
  proc(_exp, prop = null())
    local __ret, __rule;
    //option remember;
  begin
    if prop = null() then
      return(UNKNOWN)
    end_if;
    
    //remember
    // Grundeigenschaften
    if property::sysisprop(_exp, prop) then
      return(TRUE)
    end_if;
    
    if property::Fail(args(), op(_exp), op(prop)) then
      return(UNKNOWN)
    end_if;

    if _exp = prop then return(TRUE) end_if;

    // remember: keine Endlosschleifen bei unauflosbaren Eigenschaften

    __ret:= UNKNOWN;
    if domtype(_exp) = DOM_EXPR then
      if type(_exp) = "_not" then
        __ret:= not(property::implies(op(_exp), prop))
      elif contains({"_and", "_or"}, type(_exp)) then
        __ret:= property::lzeval(_exp, property::implies, prop)
      else
        if property::OWNRULES then
          __rule:= property::Prule(_exp);
          __ret:= property::_getrule((op(__rule, 2))::dom, __rule);
          if __ret <> FAIL then
            return(property::implies(__ret, prop))
          end_if;
          __ret:= property::_getfunc((op(__rule, 2))::dom, __rule);
          if __ret <> FAIL then
            __ret:= property::implies(__ret, prop)
          end_if
        end_if;

        if domtype((__rule:= float(_exp))) <> DOM_EXPR then
          __ret:= property::implies(__rule, prop)
        end_if
      end_if
    else
      // ungleiches Domain 
      //fprint(0, "isprop1", type(_exp), type(prop));
      if type(_exp) <> type(prop) then
        if not(contains({TRUE, FALSE},
                        (__ret:= prop::dom::is(_exp, prop)))) then
          //fprint(0, "isprop2", __ret);
          if not(contains({TRUE, FALSE},
                          (__ret:= _exp::dom::is(_exp, prop)))) then
            //fprint(0, "isprop3", __ret);
            if (__rule:= property::_convert(hold(Sloppy), _exp, prop)) <> FAIL then
              //fprint(0, "isprop4", __ret, prop::dom);
              if (__ret:= prop::dom::is(__rule, prop)) = UNKNOWN then
                //fprint(0, "isprop5", __ret);
                if _exp::dom::prop = TRUE
                   and (__rule:= property::_convert(hold(Sloppy), prop, _exp)) <> FAIL then
                  __ret:= _exp::dom::is(_exp, __rule) and UNKNOWN; // sonst Informations-Verlust!!!
                  //fprint(0, "isprop6", __ret);
                end_if
              end_if
            end_if
          end_if
        end_if
      else // gleiches Domain 
        __ret:= _exp::dom::is(_exp, prop)
      end_if
    end_if;
    if property::Fail(__ret) then __ret:= UNKNOWN end_if;
    if __ret = UNKNOWN then
      if property::constant(_exp) = TRUE and property::constant(prop) = TRUE then
        __ret:= FALSE
      end_if
    end_if;
    __ret
  end_proc:

property::propend:=
  proc(ident, IN = {})
    local P;
  begin
    if indets((P:= property::_getprop(ident))) = {} then
      return(TRUE)
    elif indets(P) intersect IN <> {} then
      return(FALSE)
    else
      return(_and(map(op(indets(property::_getprop(ident))), property::propend, IN union {ident})))
    end_if
  end_proc:

property::_is:=
  prog::remember(property::_is, property::depends, hold(PreventRecursion), UNKNOWN):
property::implies:=
  prog::remember(property::implies, property::depends, hold(PreventRecursion), UNKNOWN):

