// (ident, prop, Op) verknupft die Eigenschaften von ident Op prop
property::assume:=
  proc(ident, prop, Op)
    option hold;
    local m, OPR, ARGS, IDENT;
  begin
    if testargs() then
      ARGS:= [context(args())];
      IDENT:= op(ARGS, 1);
      OPR:=
        proc(NR) // 
        begin
          if nops(ARGS) > NR - 1 then
            if contains({_and, _or, hold(_and), hold(_or)}, op(ARGS, NR)) then
              if nops(ARGS) > NR then
                hold(error)("too many arguments")
              end_if
            else
              hold(error)("wrong type of ".output::ordinal(NR)." argument (operator expected)")
            end_if
          end_if
        end_proc;

      if nops(ARGS) > 0 then
        if testtype(IDENT, Type::Property) then
          // assume(Type::Real)
          eval(OPR(2)) // check 2nd operand
        elif domtype(IDENT) = DOM_EXPR and
             misc::maprec(IDENT, {"NRange", "IV", "IVnat", "Prop",
                                  "Rel", "Complex", "Residue"} = TRUE) = TRUE then
          eval(OPR(2)) // check 3rd operand
        elif domtype(IDENT) = DOM_IDENT then
          if nops(ARGS) > 1 then
            if testtype(op(ARGS, 2), Type::Property) then
              eval(OPR(3)) // check 3rd operand
            elif domtype(op(ARGS, 2)) = DOM_EXPR and
                 misc::maprec(op(ARGS, 2), {"NRange", "IV", "IVnat", "Prop",
                                            "Rel", "Complex", "Residue"} = TRUE) = TRUE then
              eval(OPR(3)) // check 3rd operand
            else
              error("second argument must be a property")
            end_if
          else
            error("too few arguments")
          end_if
        elif testtype(IDENT, Type::Relation) then
          if contains({domtype(op(IDENT, 1)), domtype(op(IDENT, 2))}, DOM_IDENT) then
            // assume(x > 0)
          elif (m:= contains(map([op(IDENT)], testtype, Type::Relation), TRUE)) > 0
               and contains(map({op(op(IDENT, m))}, domtype), DOM_IDENT) then
            // 0 < x < 1
          elif {type(op(IDENT, 1)), type(op(IDENT, 2))} intersect {"Re", "Im"} <> {} then
            if domtype(op(op(IDENT, 1))) = DOM_IDENT
               or domtype(op(op(IDENT, 2))) = DOM_IDENT then
              // Re(x) > 0
            else
              error("argument of \"Re\" or \"Im\" must be an identifier")
            end_if
          else
            error("wrong type of first argument")
          end_if
        elif type(IDENT) = "_in" then
          if domtype(op(IDENT, 1)) = DOM_IDENT then
            if testtype(op(IDENT, 2), Type::Property) then
              eval(OPR(3)) // check 3rd operand
            else
              error("second operand must be a property")
            end_if
          else
            error("first operands must be an identifier")
          end_if
        elif domtype(IDENT) = DOM_SET or domtype(IDENT) = DOM_LIST then
          if map({op(IDENT)}, domtype) = {DOM_IDENT} then
            //
          else
            error("the "._if(domtype(IDENT) = DOM_SET, "set", "list").
                  " can only contain identifiers")
          end_if
        elif contains({"Re", "Im"}, type(IDENT)) then
          if domtype(op(IDENT)) = DOM_IDENT then
            // Re(x) > 0
          else
            error("argument of \"Re\" or \"Im\" must be an identifier")
          end_if
        else
          error("wrong type of first argument")
        end_if
      else
        error("wrong number of arguments")
      end_if
    end_if;

    if not contains({hold(_and), hold(_or)},
                    args(args(0) - (m:= (_if(args(args(0)) = hold(NoErrors), 1, 0)))))
       and (context(ident))::dom::prop = FAIL then
      property::unassume(indets(ident));
    end_if;
    
    property::_assume(bool(m = 0), context(args(1..(args(0) - m))))
  end_proc:

// 
property::_Assume:=
  proc(Err)
    local i, ARGS, m;
  begin
    m:= sign(contains([_and, _or, _not], args(args(0)))); // Opr
    ARGS:= [];
    for i from 2 to args(0) - m do
      if domtype(args(i)) = DOM_EXPR then // 1
        ARGS:= append(ARGS, [args(i)])
      elif domtype(args(i)) = DOM_IDENT or domtype(args(i)) then
      end_if;
    end_for;
    
    property::_assume()
    
  end_proc:

//
property::_assume:=
  proc(Err, ident, prop = null(), Op = null(), Opt = null())
    local idprops, ORIG;
  begin
    if contains({"_less", "_leequal", "_equal", "_unequal"}, // Relation
                type(ident)) then
      return(property::setrel(args()));
    end_if;
    if type(ident) = "_in" then
      return(property::_assume(op(ident), _if(args(0) > 1, args(1..args(0)), null())));
    end_if;
    if domtype(ident) = DOM_EXPR then
      Op:= property::setfunc(args());
      if Op = hold(Error) then
        if args(0) = 2
           or args(0) = 3 and contains({_and, _or, hold(_and), hold(_or)}, prop) then
          // Global
          return(property::_assume(Err, hold(Global), ident, prop))
        elif Opt = hold(Quiet) then
          return(FAIL)
        else
          error("only expressions of type 'Re' or 'Im' possible")
        end_if
      else
        return(Op)
      end_if
    elif domtype(ident) in {DOM_LIST, DOM_SET} then
      map(op(ident), assume, prop, Op, Opt);
      return(prop)
    end_if;
    if ident::dom::prop = TRUE then // globales assume
      return(property::_assume(Err, hold(Global), args(2..args(0))))
    end_if;

    //Global
    protected(hold(Global), hold(None));
    if args(0) < 4  then // standard: loschen
      properties(ident, FAIL);
    else // ausdr.: loschen
      if Op = hold(New) then
        properties(ident, FAIL);
      end_if
    end_if;
    idprops:= op(properties(ident), 2);
    if idprops = FAIL then // keine Eigenschaften
      properties(ident, [property::sysprop(prop), prop]);
      protected(hold(Global), hold(Error));
      return(prop)
    else // ... besitzt Eigenschaften
      // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      userinfo(Text, 1, "pre-assign property: ",
               ident = (_if(Op = _or, hold(_or), hold(_and)))(idprops, prop));
      ORIG:= properties(ident);
      properties(ident, [0, (_if(Op = _or, hold(_or), hold(_and)))(idprops, prop)]);
      if domtype(idprops) = DOM_EXPR then
        idprops:= map(idprops, Op, prop)
      else
        idprops:= eval(Op(idprops, prop))
      end_if;
      if TRUE then                 // Vereinfachung gewunscht 
        if domtype(idprops) = DOM_EXPR then
          idprops:= op(idprops, 0)(op({op(idprops)}))
        end_if
      end_if;
      if property::Fail(idprops) then
        if Err then
          //property::reset(0);
          properties(ident, ORIG);
          error("assumption impossible (".expr2text(idprops).")")
        end_if
      end_if;
      properties(ident, [property::sysprop(idprops), idprops])
    end_if;
    protected(hold(Global), hold(Error));
    return(idprops)
  end_proc:
  
// (rel, _Op) setzt neue Relation 
property::setrel:=
  proc(Err, _rel, _Op = id)
    local ret, REL;
  begin
    ret:= FAIL;
    if indets(op(_rel, 1)) minus Type::ConstantIdents <> {} then
      if type(op(_rel, 1)) <> DOM_IDENT
         and contains({"_less", "_leequal"}, type(op(_rel, 1))) then
        // Sonderfall: 'expr rel expr'  0 < x < 1
        property::_assume(Err, op(_rel, 1), _Op);
        REL:= property::Rel(op(_rel, 0), op(_rel, 2));
        ret:= property::_assume(Err, op(indets(op(_rel, 1)), 1), REL, _and, hold(Quiet))
      else
        if indets(op(_rel, 1)) intersect indets(op(_rel, 2)) <> {} then
          error("same identifiers on both sides not allowed")
        end_if;
        REL:= property::Rel(op(_rel, 0), op(_rel, 2));
//     if property::Rel::constant(REL) = TRUE then
//       error("illegal constant assumption (use assign)")
//     end_if;
        ret:= property::_assume(Err, op(_rel, 1), REL, _Op, hold(Quiet))
      end_if
    end_if;
    if indets(op(_rel, 2)) minus Type::ConstantIdents <> {} then
      if type(op(_rel, 2)) <> DOM_IDENT
         and contains({"_less", "_leequal"}, type(op(_rel, 2))) then
        // Sonderfall: 'expr rel expr'
        property::_assume(Err, op(_rel, 2), _Op);
        REL:= property::Rel(-op(_rel, 0), op(_rel, 1));
        ret:= property::_assume(Err, op(indets(op(_rel, 2)), 1), REL, _and, hold(Quiet))
      else
        if indets(op(_rel, 1)) intersect indets(op(_rel, 2)) <> {} then
          error("same identifiers on both sides not allowed")
        end_if;
        REL:= property::Rel(-op(_rel, 0), op(_rel, 1));
//     if property::Rel::constant(REL) = TRUE then
//       error("illegal constant assumption (use assign)")
//     end_if;
        REL:= property::_assume(Err, op(_rel, 2), REL, _Op, hold(Quiet))
      end_if
    end_if;
    if type(ret) = hold(Error) and type(REL) = hold(Error)
       or ret = FAIL and REL = FAIL then
      error("wrong type of argument (DOM_IDENT expected)")
    end_if;
    if ret = FAIL or ret = hold(Error) then
      REL
    else
      ret
    end_if
  end_proc:

property::_setrel:=
  proc(Rel)
  begin
    _or(_if(type(op(Rel, 1)) = DOM_IDENT, property::Rel(op(Rel, 0), op(Rel, 2)), null()),
        _if(type(op(Rel, 2)) = DOM_IDENT, property::Rel(-op(Rel, 0), op(Rel, 1)), null()))
  end_proc:

// (rel, _Op) setzt funktionale Eigenschaften 
property::setfunc:=
  proc(Err, _func, _prop, Op = null())
    local i;
  begin
    //property::reset(0):
    if (i:= contains([hold(Re), hold(Im)], op(_func, 0))) > 0 then
      if nops(_func) <> 1 or domtype(op(_func)) <> DOM_IDENT then
        error("wrong type of argument of '".expr2text(op(_func, 0))."' (DOM_IDENT expected)")
      end_if;
      property::_assume(Err, op(_func, 1),
                        property::Complex(op(subsop([Type::Real, Type::Real], i = _prop))),
                        Op)
    else
      hold(Error)//error("only expressions of type 'Re' or 'Im' possible")
    end_if
    //property::_assume(Err, op(_func, 1), property::Func(op(_func, 0), _prop), Op)
  end_proc:

assume:= property::assume:
