
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
/////
/////   A C H T U N G  ! ! !   A T T E N T I O N  ! ! !
/////
///////////////////////////////////////////////////////////////////////////////
/////
/////   Aenderung der Reihenfolge / Kodierung in property::SYSPROP
/////   verursacht fatale Fehler bei der automatischen Vereinfachung
/////   von Ausdruecken durch den MuPAD-Kern!!!
/////   Aenderungen muessen sofort in den Kern-Quelldateien
/////      MGS_simplify.h (Definements MGSC_SYS_PROP_....)
/////   nachgehalten werden.
/////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

// alle Grundeigenschaften 
property::SYSPROP:=
	[//alle benotigten Eigenschaften
         /* 0 */ Type::Complex                       /*( komplex       )*/,
         /* 1 */ Type::Real                          /*( reell         )*/,
         /* 2 */ Type::NonNegative                   /*( nicht-negativ )*/,
         /* 3 */ Type::Positive                      /*( positiv       )*/,
         /* 4 */ Type::Negative                      /*( negativ       )*/,
         /* 5 */ Type::Integer                       /*( ganzzahlig    )*/,
         /* 6 */ Type::Zero                          /*( = Null        )*/,
         /* 7 */ Type::NonZero                       /*( <> Null       )*/,
         /* 8 */ property::Rel(_equal, 1)            /*( = 1           )*///,
         /* 9 */ //Type::Even                          #( gerade        )#
         ]:

// erstellt aus einer Eigenschaft fur den Kern benotigte Eigenschaften [interne Darstellung] 
property::sysprop:=
	proc(prop)
          local sysprop, P, k;
          //option remember;
        begin
          if not(property::propend(prop)) then
            return(0)
          end_if;
          k:= 0;
          sysprop:= 0;
          for P in property::SYSPROP do
            if property::implies(prop, P) = TRUE then
              sysprop:= sysprop + 2^k
            end_if;
            k:= k + 1
          end_for;
          sysprop
        end_proc:

// ident/integer: -> System-Eigenschaften
property::getsysprop:=
        proc(ident)
          local P, i, RET;
        begin
          if domtype(ident) = DOM_IDENT then
            if properties(ident) = FAIL then
              return([])
            else
              P:= "0000000000" . int2text(op(properties(ident), 1), 2)
            end_if
          elif testtype(ident, Type::Property) then
            P:= "0000000000" . int2text(property::sysprop(ident), 2)
          elif domtype(ident) = DOM_INT then
            P:= "0000000000" . int2text(ident, 2)
          else
            return(FAIL)
          end_if;
          RET:= [];
          for i from 1 to nops(property::SYSPROP) do
            if substring(revert(P), i - 1, 1) = "1" then
              RET:= append(RET, op(property::SYSPROP, i))
            end_if
          end_for;
          RET
        end_proc:

property::syspropget:=
	proc(ident)
        begin
          if (ident:= op(properties(ident), 1)) <> FAIL then
            return(ident)
          else
            return(0)
          end_if
        end_proc:

// property, property
property::sysisprop:=
	proc(prop, sysprop)
          local P, Q;
        begin
          if (Q:= contains(property::SYSPROP, sysprop)) > 0 then
            if (P:= property::sysprop(prop)) <> FAIL then
              return(bool(substring(revert(int2text(P, 2)) . "0000000000", Q - 1, 1) = "1"))
            end_if
          end_if;
          FALSE
        end_proc:

// ident, property
property::sysidprop:=
	proc(ident:DOM_IDENT, sysprop)
          local P, Q;
        begin
          if (Q:= contains(property::SYSPROP, sysprop)) > 0 then
            if (P:= op(properties(ident), 1)) <> FAIL then
              return(bool(substring(revert(int2text(P, 2)) . "0000000000", Q - 1, 1) = "1"))
            end_if
          end_if;
          FALSE
        end_proc:

// Vorinitialisierung Grundeigenschaften
//proc()
//   local P;
// begin
//   for P in                                        // 876543210
//     [property::Rel(_equal, 1)                     = "110001111",
//      property::Rel(-_less, 0)                     = "010001111",
//      property::Rel(-_leequal, 0)                  = "000000111",
//      property::Rel(-_less, 1)                     = "010001111",
//      property::Rel(-_leequal, 1)                  = "010001111",
//      property::Rel(_less, 0)                      = "010010011",
//      property::Rel(_leequal, 0)                   = "000000011",
//      property::Rel(_less, 1)                      = "000000011",
//      property::Rel(_leequal, 1)                   = "000000011",
//      property::Rel(_less, -1)                     = "010010011",
//      property::Rel(_leequal, -1)                  = "010010011",
//      property::IV(0, 1)                           = "010001111",
//      property::IV([0], 1)                         = "000000111",
//      property::IV([0, 1])                         = "000000111",
//      property::IV(0, [1])                         = "010001111",
//      property::IV(-1, 1)                          = "000000011",
//      property::IV([-1, 1])                        = "000000011",
//      property::IV([-1], 1)                        = "000000011",
//      property::IV(-1, [1])                        = "000000011",
//      property::IV([-1], 0)                        = "010010011",
//      property::IV([-1], [0])                      = "000000011",
//      property::IV(-1, [0])                        = "000000011",
//      property::IV(-1, 0)                          = "010010011",
//      Type::Even                                   = "000100010",
//      Type::Odd                                    = "000100010",
//      Type::NonZero                                = "010000000",
//      Type::Zero                                   = "001100111",
//      Type::Prime                                  = "010101111",
//      Type::PosInt                                 = "010101111",
//      Type::NonNegInt                              = "000100111",
//      Type::NegInt                                 = "010110011",
//      Type::Integer                                = "000100011",        
//      Type::PosRat                                 = "010001111",
//      Type::NonNegRat                              = "000000111",      
//      Type::NegRat                                 = "010010011", 
//      Type::Rational                               = "000000011",       
//      Type::Fraction                               = "000000011",       
//      Type::Positive                               = "010001111",    
//      Type::NonNegative                            = "000000111",     
//      Type::Negative                               = "010010011",   
//      Type::Irrational                             = "000000011",       
//      Type::Real                                   = "000000011",
//      Type::IntImaginary                           = "000000001",        
//      Type::Imaginary                              = "000000001",        
//      Type::Complex                                    = "000000001",       
//      property::Complex(property::Rel(-_less, 0))      = "000000001",
//      property::Complex(property::Rel(-_leequal, 0))   = "000000001",
//      property::Complex(property::Rel(_unequal, 0))    = "000000000"] do
//     sysassign(property::sysprop(op(P, 1)), text2int(op(P, 2), 2))
//   end_for
// end_proc():
//         # 0 # Type::Complex                       #( komplex       )#,
//         # 1 # Type::Real                          #( reell         )#,
//         # 2 # Type::NonNegative                   #( nicht-negativ )#,
//         # 3 # Type::Positive                      #( positiv       )#,
//         # 4 # Type::Negative                      #( negativ       )#,
//         # 5 # Type::Integer                       #( ganzzahlig    )#,
//         # 6 # Type::Zero                          #( = Null        )#,
//         # 7 # Type::NonZero                       #( <> Null       )#,
//         # 8 # property::Rel(_equal, 1)            #( = 1           )#


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
/////
/////   A C H T U N G  ! ! !   A T T E N T I O N  ! ! !
/////
///////////////////////////////////////////////////////////////////////////////
/////
/////   Aenderung der Reihenfolge / Kodierung in property::SYSPROP
/////   verursacht fatale Fehler bei der automatischen Vereinfachung
/////   von Ausdruecken durch den MuPAD-Kern!!!
/////   Aenderungen muessen sofort in den Kern-Quelldateien
/////      MGS_simplify.h (Definements MGSC_SYS_PROP_....)
/////   nachgehalten werden.
/////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

