// $Date: 2000/05/24 14:22:14 $ $Author: jngerhar $ $Revision: 1.10 $ 

/*--
	Ei/Series -- the function attribut "series" for Ei
--*/

Ei:=slot(Ei,"series",proc(f,x,n,dir) // series(Ei(f),x=0,n) 
    local s,t,i,k,tt,a;
begin
   if f=x then // expansion of Ei(x) for x = 0 
     Series::Puiseux::create(1,0,n,[-ln(x)-EULER,(-1)^(i+1)/i/fact(i)$i=1..n-1],x)
   else
     t:=Series::series(f,x,n,dir);
     if domtype(t) = Series::Puiseux then
       k:=Series::Puiseux::ldegree(t);
       if k=FAIL then // t = O(..)
         error("order too small");
       end_if;
       if k>0 then // f goes to zero 
         t:=series((exp(-f)-1)/f*diff(f,x),x,n,
                   if dir = FAIL then null() else dir end_if);
         if not testtype(t,Type::Series(Taylor)) then
           userinfo(2,"unable to compute series expansion");
           return(FAIL)
         end_if;
         k:=series(ln(f),x,n+k,
                   if dir = FAIL then null() else dir end_if);
         if type(k) <> Series::Puiseux then
           userinfo(2,"unable to compute series expansion");
	   return(FAIL)
         end_if;
         return(Series::series(-EULER-expr(k)-int(expr(t),x),x,n+1,dir))
       elif k<0 then // f goes to +/-infinity 
         tt:=1;
         s:=Series::Puiseux::create(1,1,n+1,[1,(tt:=-tt*i)$i=1..n-1],x);
         s:=Series::Puiseux::_fconcat(s, 1/t);
         s:=Series::gseries::convert(extsubsop(s,5=x));
         return(Series::gseries::scalmult(s,1,exp(-f)))
       elif k = 0 then // expansion around a finite point <> 0
         a := lcoeff(t);
         if testtype(a, Type::Negative) = TRUE then
           // expansion on the branch cut
// In future versions, signIm should be expanded further if a direction
// is specified
           return((1 - signIm(f))*PI*I + Series::unknown(Ei(f),x,n,dir))
         end_if
       end_if;
       Series::unknown(Ei(f),x,n,dir)
     else
        userinfo(2, "unable to compute series expansion");
        FAIL
     end_if
  end_if
end_proc):

// end of file 
