// $Date: 2000/05/24 14:44:20 $ $Author: jngerhar $ $Revision: 1.6 $ 

/*--
	Si/Series -- the function attribut "series" for Si
--*/

Si:= slot(Si, "series", proc(e,x,n,dir)
   local l,k,f,g,sg,t,d;
begin

   if dir <> FAIL then // directional expansion
     l:=limit(e,x,if dir = Real then null() else dir end_if);
     if l=0 then // formula 5.2.14 
       f:=series(_plus((-1)^k*x^(2*k+1)/(2*k+1)/fact(2*k+1)
	    $ k=0..(n-2) div 2),x,n);
       if e=x then return(f) else return(f @ series(e,x,n,dir)) end_if
     elif l=infinity or l=-infinity then
       sg:=(if l=infinity then 1 else e:=-e; -1 end_if);
       // Si(-x)=-Si(x) 
       // 5.2.34 
// More efficient: do this directly via create !!!
       f:=series(_plus((-1)^k*fact(2*k)*x^(2*k+1)$k=0..(n-2) div 2),x,n);
       // 5.2.35 
       g:=series(_plus((-1)^k*fact(2*k+1)*x^(2*k+2)$k=0..(n-3) div 2),x,n);
       if e<>1/x then
         l:=series(1/e,x,n,dir);
         f:=f @ l;
         g:=g @ l
       end_if;
       // 5.2.8 
       return(sg * (PI/2 - f*cos(e) - g*sin(e)));
     end_if
   end_if;

   // recursively expand the argument
   t := Series::series(e, x, n, dir);

   if domtype(t) = Series::Puiseux then
     d := ldegree(t);
     if d=FAIL then // t = O(..)
	d:=Series::Puiseux::order(t);
        if d >= 0 then return(t)
        else
	  error("order too small");
          return(FAIL);
        end_if
     end_if;
     if d > 0 then
       // expansion around 0, better do this via create !!!
       f:=series(_plus((-1)^k*x^(2*k+1)/(2*k+1)/fact(2*k+1)
	  $ k=0..(n-2) div 2),x,n);
       if e=x then return(f) else return(f @ t) end_if
     elif d < 0 then
       return(FAIL)
     end_if
   end_if;

   Series::unknown(Si(e),x,n)

end_proc):

// end of file 
