arccot:= slot(arccot,"series",proc(f,x,n,dir)
   local s, i, l, t, d;
begin
   //The following yields too complicated results
   //return(series(I/2*(ln(1-I/f) - ln(1+I/f)), x,n));

   if dir <> FAIL then // directional expansion
     l:= limit(f, x, if dir = Real then null() else dir end_if);
     if has(l, hold(limit)) then
       return(FAIL)
     elif l = undefined then
       return(FAIL)
     elif iszero(l) then
       // warning: the leading term sign(x)*PI/2 is not correct.
       // Replace sign(x) by sgn(x)=sign(x) with sgn(0):= 1.
       // Further, this expansion is only valid along the real line!
       s:=(if n=0 then []
          elif n=1 then [sign(f)*PI/2]
          else s:=-1;
               [sign(f)*PI/2,s,(0,(s:=-s)/(2*i+1))$i=1..(n div 2)-1]
          end_if);
       s:=Series::Puiseux::create(1,0,n,s,x);
       if f=x
         then return(s)
         else return(Series::Puiseux::_fconcat(s,series(f,x,n,dir)))
       end_if
     elif l = infinity then
        return(series(arctan(1/f), x, n, dir))
     elif l = -infinity then
        return(series(arctan(1/f), x, n, dir))
     end_if
   end_if;

   // recursively expand the argument
   t := Series::series(f, x, n, dir);

   if domtype(t) = Series::Puiseux then
     d := ldegree(t);
     if d = FAIL then
       error("order too small")
     elif d > 0 then
       // expansion around 0 not defined in the undirected case
       return(FAIL)
     elif d < 0 then
       return(FAIL)
     end_if
   end_if;

   Series::unknown(arccot(f),x,n);

end_proc):

