
arcsin:= slot(arcsin, "series", proc(f,x,n,dir)
   local s,l,k,t,d;
begin

   if dir <> FAIL then // directional expansion
     l:=limit(f, x, if dir = Real then null() else dir end_if);
     if has(l, hold(limit)) then
       return(FAIL)
     elif iszero(l) then
       if n<2 
         then s:= []
         else s:= 1; 
              s:=[s,(0,(s:=s*(2*k-1)/2/k)/(2*k+1))$k=1..(n div 2)-1]
       end_if;
       s:=Series::Puiseux::create(1,1,n,s,x);
       if f=x
         then return(s)
         else return(Series::Puiseux::_fconcat(s,series(f,x,n,dir)))
       end_if
     elif iszero(l-1) then
       s:=1; l:=1; f:=1-f;
       for k from 1 to n-2 do
         l:=l*f*(2*k-1)/4/k;
         s:=s+l/(2*k+1)
       end_for;
       return(Series::series(PI/2-sqrt(2*f)*s,x,n,dir));
     elif iszero(l+1) then
        s:=1; l:=1; f:= 1+f;
        for k from 1 to n-2 do
           l:=l*f*(2*k-1)/4/k;
           s:=s+l/(2*k+1)
        end_for;
        return(Series::series(-PI/2+sqrt(2*f)*s,x,n,dir));
     elif has(l, infinity) then
        return(series(-I*ln(I*f+sqrt(1-f^2)), x, n, dir));
     end_if;
  end_if;

  // recursively expand the argument
  t := Series::series(f, x, n, dir);

  if domtype(t) = Series::Puiseux then
    d := ldegree(t);
    if d=FAIL then // t = O(..)
	d:=Series::Puiseux::order(t);
        if d > 0 then return(t)
        else
	  error("order too small");
          return(FAIL);
        end_if
    end_if;
    if d >= 0 then
      case coeff(t, x, 0)
      of 0 do
        if n<2 
          then s:= []
          else s:= 1; 
               s:=[s,(0,(s:=s*(2*k-1)/2/k)/(2*k+1))$k=1..(n div 2)-1]
        end_if;
        s:=Series::Puiseux::create(1,1,n,s,x);
        if f=x
          then return(s)
          else return(Series::Puiseux::_fconcat(s, t));
        end_if
      of 1 do
        s:=1; l:=1; f:=1-f;
        for k from 1 to n-2 do
          l:=l*f*(2*k-1)/4/k;
          s:=s+l/(2*k+1)
        end_for;
        return(Series::series(PI/2-sqrt(2*f)*s,x,n,dir));
      of -1 do
        s:=1; l:=1; f:= 1+f;
        for k from 1 to n-2 do
           l:=l*f*(2*k-1)/4/k;
           s:=s+l/(2*k+1)
        end_for;
        return(Series::series(-PI/2+sqrt(2*f)*s,x,n,dir));
      end_case
    else // ldegree(t) < 0
      return(FAIL)
    end_if
  end_if;

  Series::unknown(arcsin(f),x,n,dir);

end_proc):
