arctan:= slot(arctan, "series", proc(f,x,n,dir)
   local s,l,t,d;
begin

// //The following expansion gives too complicated results
// if nops(s) < 4 then
//    return(series(I/2*ln((1-I*f)-ln(1+I*f)), x, n));
// end_if:

   if dir <> FAIL then // directional expansion
     l:= limit(f,x,if dir = Real then null() else dir end_if):
     if has(l, hold(limit)) then
       return(FAIL)
     elif iszero(l) or (l=infinity) or (l=-infinity) then
       if n<2
         then s:= []
         else s:= 1;
              s:= [s,(0,(s:=-s)/(2*l+1))$l=1..(n div 2)-1]
       end_if;
       s:=Series::Puiseux::create(1,1,n,s,x);
       if f=x then
         return(s)
       elif iszero(l) then
           return(Series::Puiseux::_fconcat(s,series(f,x,n,dir)))
       elif l=infinity then
           // arctan(x)=PI/2-arctan(1/x)
           return( PI/2 - Series::Puiseux::_fconcat(s,series(1/f,x,n,dir)))
       elif l = -infinity then
           return(-PI/2 - Series::Puiseux::_fconcat(s,series(1/f,x,n,dir)))
       end_if
     end_if
   end_if;

   // recursively expand the argument
   t := Series::series(f, x, n, dir);

   if domtype(t) = Series::Puiseux then
     d := ldegree(t);
     if d=FAIL then // t = O(..)
	d:=Series::Puiseux::order(t);
        if d > 0 then return(t)
        else
	  error("order too small");
          return(FAIL);
        end_if
     end_if;
     if d > 0 then
       // expansion around 0
       if n<2
         then s:= []
         else s:= 1;
              s:= [s,(0,(s:=-s)/(2*l+1))$l=1..(n div 2)-1]
       end_if;
       s:=Series::Puiseux::create(1,1,n,s,x);
       if f=x then
         return(s)
       else
         return(Series::Puiseux::_fconcat(s, t))
       end_if
     elif d < 0  then
       return(FAIL);
     end_if
   end_if;

   Series::unknown(arctan(f),x,n);

end_proc):
