// $Date: 2000/06/26 12:51:18 $ $Author: jngerhar $ $Revision: 1.10 $ 

/*--
	cos/Series -- the function attribut "series" for cos
--*/

cos:=slot(cos,"series",proc(f,x,n,dir)
  local t,k,a;
begin
   if f=x then Series::Puiseux::create(1,0,n,Series::gen["cos"](n),x)
   else
      t:=Series::series(f,x,n,dir);
      if domtype(t)<>Series::Puiseux then return(FAIL) end_if;
      k:=ldegree(t);
      if k=FAIL then
         if extop(t,4)=[] and extop(t,3)>0 then // O(x^k) for k>0 
            1+t^2
         else 
	    error("order too small")
         end_if
      elif k>0 then 
	 Series::Puiseux::_fconcat(
            Series::Puiseux::create(1,0,n,Series::gen["cos"](n),x)
	 ,t)
      elif k=0 then
         a:=lcoeff(t);
         t:=f-a;
         cos(a)*cos::series(t,x,n,dir)-sin(a)*sin::series(t,x,n,dir)
      else 
	 userinfo(2, "unable to compute series expansion");
         FAIL
      end_if
   end_if
end_proc):

// ensure that domain Series is loaded
Series:

Series::gen["cos"]:=proc(n) local i,t;
begin
   t:=1; 
   [1,(0,(t:=-t/(2*i-1)/(2*i)))$i=1..(n-1) div 2]
end_proc:
Series::gen["cos"](0):=[]:

// end of file 
