/*--
        igamma/Series -- the function attribut "series" for igamma
--*/

igamma := slot(igamma,"series",proc(a,f,x,n,dir)
   local fa, l, k, /*P,*/ s0, s, t, tt, d;
begin

   fa:=float(a):
   if not(type(fa)=DOM_FLOAT or type(fa)=DOM_COMPLEX) or has(a,x) then
     return(FAIL);
   end_if;

// why is expansion w.r.t the first argument not possible?

   if dir <> FAIL then // directional expansion
      l:=limit(f,x,if dir = Real then null() else dir end_if);
      if iszero(l) then 
         // use expansion in 0: 
         // i.e. Abramowitz and Stegun 6.5.29
         // with 6.5.3. and 6.5.4.
         t:=x^a/a;
         s0:=t;
         s:=_plus(s0,(t:=-t*x/(a+k)/k*(a+k-1))$ k=1..trunc(n));
         //apply 6.5.3
         s:=gamma(a)-s;
// More efficient: use create !!!
         s:=series(s,x,n);
         if f = x then return(s) else return(s @ series(f,x,n,dir)) end_if:
         // warning asymptotic series expansion not possible
         // until overhaul of basic series data structure.
      //elif l=infinity then
         //// use asymptotic expansion of A and S eq. 6.5.32
         //// changed z into 1/x (z->infinity when x->0, Right)
         //t:=1:
         //P:=_plus(1,(t:=t*(a-k)*x)$ k=1..trunc(n)):
         //P:=series(P,x,n):
         //if f<>1/x then s:=series(1/f,x,n); P:=P @ s; end_if;
         //s:=(f^(a-1))*exp(-f)*P;
      end_if
   end_if;

   // recursively expand the argument
   tt := Series::series(f, x, n, dir);

   if domtype(tt) = Series::Puiseux then
     d := ldegree(tt);
     if d = FAIL then // tt = O(..)
       d := Series::Puiseux::order(tt);
       if d > 0 then
         return(gamma(a) + tt^a)
       else
         error("order too small")
       end_if
     elif d > 0 then // expansion around 0
         // use expansion in 0: 
         // i.e. Abramowitz and Stegun 6.5.29
         // with 6.5.3. and 6.5.4.
         t:=x^a/a;
         s0:=t;
         s:=_plus(s0,(t:=-t*x/(a+k)/k*(a+k-1))$ k=1..trunc(n));
         //apply 6.5.3
         s:=gamma(a)-s;
// More efficient: use create !!!
         s:=series(s,x,n);
         if f = x then return(s) else return(s @ tt) end_if:
     elif d < 0 then
       return(FAIL)
     end_if
   end_if;
 
   Series::unknown(igamma(a,f),x,n,dir)

end_proc):
