// $Date: 2000/06/26 12:51:20 $ $Author: jngerhar $ $Revision: 1.12 $ 

/*--
	ln/Series -- the function attribut "series" for ln
--*/

ln:=slot(ln,"series",proc(f,x,n,dir) local s,t,a,k;
begin
   s:=Series::Puiseux::create(1,1,n,Series::gen["ln"](n),x);
   if f=1+x then s
   else
      t:=Series::series(f,x,n,dir);
      if domtype(t)<>Series::Puiseux then return(FAIL) end_if;
      k:=Series::Puiseux::ldegree(t);
      a:=Series::Puiseux::lcoeff(t);
      if k = FAIL then
        error("order too small")
      elif k=0 then // expansion around the finite point a <> 0
         if a<>1 then t:=Series::Puiseux::scalmult(t,1/a) end_if;
         // better than t - 1 which does not work for floating-points
         if testtype(a, Type::Negative) then
           // expansion on the branch cut
// In future versions, signIm should be expanded further if a direction
// is specified
           signIm(f)*I*PI+ln(-a)+Series::Puiseux::_fconcat(s,Series::Puiseux::lmonomial(t,Rem)[2])
         else
// This may still be wrong if a contains x or a can be simplified to 0
// or a negative number!
           ln(a)+Series::Puiseux::_fconcat(s,Series::Puiseux::lmonomial(t,Rem)[2])
         end_if
      else // expansion around +-infinity
         t:=Series::Puiseux::lmonomial(t,Rem)[2];
         t:=Series::Puiseux::scalmult(t,1/a,-k); // t <- t/(a*x^k) 
         t:=Series::Puiseux::_fconcat(s,t);

         if is(x>0) = TRUE 
         then t+Series::Puiseux::create(1,0,Series::Puiseux::order(t),[ln(a)+k*ln(x)],x);
         else
             // Here, we wish to have
             //       series(ln(-x),x=0) = ln(-x) + O(..),
             // not   series(ln(-x),x=0) = I*PI + ln(x) + O(..).
             // because the second version is not correct for x<0!
             // Hence, only extract leading coefficient a, if a>0:
         
             if is(a>0) = TRUE 
             then t+Series::Puiseux::create(1,0,Series::Puiseux::order(t),[ln(a)+ln(x^k)],x);
             elif is(a<0) = TRUE
             then t+Series::Puiseux::create(1,0,Series::Puiseux::order(t),[ln(-a)+ln(-x^k)],x);
             else t+Series::Puiseux::create(1,0,Series::Puiseux::order(t),[ln(a*x^k)],x);
             end_if
         end_if
      end_if
   end_if
end_proc):

// ensure that domain Series is loaded
Series:

// expansion for ln(1+x) 
Series::gen["ln"]:=proc(n) local t,i;
begin
   t:=-1; [((t:=-t)/i$i=1..n-1)]
end_proc:

// end of file 
