/*--
	sin/Series -- the function attribut "series" for sin
--*/

sin:=slot(sin,"series",proc(f,x,n,dir)
   local t,k,a;
begin
   if f=x then Series::Puiseux::create(1,1,n,Series::gen["sin"](n),x)
   else
      t:=Series::series(f,x,n,dir);
      if domtype(t)<>Series::Puiseux then return(FAIL)
      end_if;
      k:=ldegree(t);
      if k=FAIL then // t = O(..)
	k:=Series::Puiseux::order(t);
        if k >= 0 then return(t)
        else
	  error("order too small");
          return(FAIL);
        end_if
      end_if;
      if k>0 then Series::Puiseux::_fconcat(
          Series::Puiseux::create(1,1,n,Series::gen["sin"](n),x),t)
      elif k=0 then
         a:=lcoeff(t);
         // sin(a+t)=sin(a)*cos(t)+cos(a)*sin(t) 
         t:=subs(expand(f-a),0.0=0);
         sin(a)*cos::series(t,x,n,dir)+cos(a)*sin::series(t,x,n,dir)
      else 
        userinfo(2, "unable to compute series expansion");
	FAIL
      end_if
   end_if
end_proc):

// ensure that domain Series is loaded
Series:

Series::gen["sin"]:=proc(n) local i,t;
begin
   t:=1;
   [1,(0,(t:=-t/(2*i)/(2*i+1)))$i=1..(n-2) div 2]
end_proc:
Series::gen["sin"](0):=[]:
Series::gen["sin"](1):=[]:

// end of file 
