// $Date: 2000/06/26 12:51:21 $ $Author: jngerhar $ $Revision: 1.8 $ 

/*--
	sinh/Series -- the function attribut "series" for sinh
--*/

sinh:=slot(sinh,"series",proc(f,x,n,dir)
   local t,k,a;
begin
   if f=x then Series::Puiseux::create(1,1,n,Series::gen["sinh"](n),x)
   else
      t:=Series::series(f,x,n,dir);
      k:=ldegree(t);
      if k=FAIL then // t = O(..)
	k:=Series::Puiseux::order(t);
        if k >= 0 then return(t)
        else
	  error("order too small");
          return(FAIL);
        end_if
      end_if;
      if k>0 then Series::Puiseux::_fconcat(
         Series::Puiseux::create(1,1,n,Series::gen["sinh"](n),x),t)
      elif k=0 then
         a:=lcoeff(t);
         t:=f-a;
         sinh(a)*cosh::series(t,x,n,dir)+cosh(a)*sinh::series(t,x,n,dir)
      else 
         userinfo(2,"unable to compute series expansion");
         FAIL
      end_if
   end_if
end_proc):

// ensure that domain Series is loaded
Series:

Series::gen["sinh"]:=proc(n) local i,t; // 0.9s pour n=100 
begin
   t:=1;
   [1,(0,(t:=t/(2*i)/(2*i+1)))$i=1..(n-2) div 2]
end_proc:
Series::gen["sinh"](0):=[]:
Series::gen["sinh"](1):=[]:

// end of file 
