
zeta:= slot(zeta,"series",proc(f,x,n,dir)
  local l, t, d;
begin

  if f = x + 1 then
    case n
    of 0 do
      return(Series::Puiseux::create(1,-1,-1,[],x,0));
    of 1 do
      return(Series::Puiseux::create(1,-1,0,[1],x,0));
    of 2 do
      return(Series::Puiseux::create(1,-1,1,[1,EULER],x,0));
    end_case;
    return(FAIL);
  end_if;    

  // recursively expand the argument
  t := Series::series(f, x, n, dir);

  if dir <> FAIL then // directional expansion
    l := limit(f,x,if dir = Real then null() else dir end_if);
    if l = undefined or has(l, infinity) then
      // expansion around infinity not yet implemented
      return(FAIL);
    end_if
  elif domtype(t) = Series::Puiseux then
    d := ldegree(t);
    if d = FAIL then // order too small
      l := FAIL;
    elif d >= 0 then
      l := coeff(t, x, 0)
    else // ldegree(t) < 0
      // expansion around infinity not yet implemented
      return(FAIL);
    end_if
  else
    l := FAIL
  end_if;

  if l = 1 then
    return(Series::Puiseux::create(1,-1,1,[1,EULER],x,1) @ t)
  end_if;

  Series::unknown(zeta(f),x,n,dir)

end_proc):
