/* $Date: 2000/10/25 15:59:59 $ $Author: stefanw $ $Revision: 1.9 $ */

// solvelib::getoptions

// return a table of options

// if a table is given as first argument, return this table
// if no argument is given, return the default options
// if some arguments are given, return these as options



solvelib::getoptions:=
proc()
local options,i;
  
begin
  if args(0)>=1 and type(args(1))=DOM_TABLE then
    return(args(1))
  end_if;
  
  options:=solvelib::defaultOptions;
   /* get options */
   /* only preliminary, until the final option concept is finished */
   for i from 1 to args(0) do
     case type(args(i))
       of DOM_IDENT do
         case args(i)
           of hold(Multiple) do
             options["Multiple"]:=TRUE;
             break
           of hold(PrincipalValue) do
             options["PrincipalValue"]:=TRUE;
             break
           of hold(IgnoreSpecialCases) do
             options["IgnoreSpecialCases"]:=TRUE;
             break
           otherwise
             error("Unknown option ".expr2text(args(i)))
         end_case;
         break
       of DOM_INT do
/* for compatibility reasons, "MaxDegree=" may
    be left out */
         options["MaxDegree"]:=args(i);
         break
       of "_equal" do
         case op(args(i),1)
           of hold(MaxDegree) do
             options["MaxDegree"]:=op(args(i),2);
             break
           of hold(BackSubstitution) do
             options["BackSubstitution"]:=op(args(i),2);
             break
           of hold(Domain) do
             options["Domain"]:=op(args(i),2);
             break
           otherwise
             error("Unknown option ".expr2text(args(i)))
         end_case;
         break
       otherwise
         error("Unknown option ".expr2text(args(i)))
     end_case
   end_for;

  userinfo(10, "Options used: ".expr2text(options));
   
  options

end_proc:


solvelib::defaultOptions:=
table(
   "MaxDegree"=2,
   "Multiple"=FALSE,
   "PrincipalValue"=FALSE,
   "BackSubstitution"=TRUE,
   "Domain"= hold(Expr),
   "IgnoreSpecialCases"= FALSE
):

solvelib::nonDefaultOptions:=
proc(t : DOM_TABLE)
  local s : DOM_LIST;
begin
  s:= select([op(t)], eq -> solvelib::defaultOptions[op(eq,1)]<>op(eq,2));
  op(map(s, eq -> text2expr(op(eq,1)) = op(eq,2) ))
end_proc:



