// $Date: 1999/12/15 18:31:29 $ $Author: stefanw $ $Revision: 1.2 $


// solvelib::ignoreSpecialCases

/* filters the input to a piecewise such
   that all equalities are considered FALSE unless they
   are provably TRUE */

solvelib::ignoreSpecialCases:=
proc()
  option hold;
  local argv, removeEquals, u;
  
begin
  removeEquals:=
  proc(cond)
  begin
    case type(cond)
      of "_equal" do
        if is(cond)=TRUE then
          TRUE
        else  
          FALSE
        end_if;
        break
      of "_unequal" do
        if is(cond)=FALSE then
          FALSE
        else
          TRUE
        end_if;
        break
      of "_or" do
      of "_and" do
        map(cond, removeEquals);
        break
      otherwise
        cond
    end_case;
  end_proc;

     // flatten first ? Not necessary if solver does not pass exprseqs 

  argv:=[];
  for u in [args()] do
    if type(u)<>DOM_LIST then
      error("Argument is not a list")
    end_if;
    removeEquals(context(u[1]));
    case %
      of TRUE do
        return(context(u[2]))
      of FALSE do
        break
      otherwise  
        argv:=append(argv, [%, context(u[2])])
    end_case
  end_for;
  piecewise(op(argv))
end_proc:
  
