/* */
/* $Date: 2000/11/20 14:48:24 $ $Author: stefanw $ $Revision: 1.4 $ */
/* */
/* zimmerma, 14/12/95 */

/*--
	solvelib::solve_isalgebraic

	returns FALSE if sys is not an algebraic system with respect 
	to unk, otherwise sys where all equalities a=b have been 
	replaced by a-b and all 0 equations have been deleted.

   Parameters:

   sys -  set or list of equations or arithmetical expressions
     u - set or list of identifiers

--*/

solvelib::solve_isalgebraic :=
proc(sys,unk)
  local eq, den;
begin
  den := 1;
  for eq in sys do
    den:= expand(den * denom(eq));
  end_for;
  if not testtype(den, Type::PolyExpr([op(unk)])) then
    return(FALSE)
  end_if;

  sys:= map(sys, numer);
  if has(map(sys, testtype,Type::PolyExpr([op(unk)])), FALSE) then
    return(FALSE)
  end_if;

    // zeroes of the denominator cannot be solutions
    // it would suffice to divide them out in one numerator
  map(sys,
      proc(eq)
        local g;
      begin
        while degree((g:=gcd(eq, den))) > 0 do
          eq:= divide(eq, g, Exact)
        end_while;
      eq
      end_proc
      )
end_proc:

/* end of file */

