/* $Date: 2000/11/17 16:40:47 $ $Author: stefanw $ $Revision: 1.22 $ */


/* solvelib::preImage(eq, x, S)

   determine the set of all C such that subs(eq, x=C) is an
   element of S

*/


solvelib::preImage:=
proc(eq, x, S)
local i, opt;

begin
  if args(0)<3 then
    error("Wrong number of arguments")
  end_if;

  opt:=solvelib::getoptions(args(4..args(0)));
  
  if S::dom::preImage<>FAIL then
    return(S::dom::preImage(args()))
  end_if;
  
  if S=solvelib::BaseSet then
    return(solvelib::solve_minus(solvelib::BaseSet, discont(eq, x, undefined),
                                 opt))
  end_if;
  if eq=x then
    return(S)
  end_if;
  case type(S)
    of DOM_SET do
      return(_union(solve(eq=op(S,i), x, opt) $i=1..nops(S)))
    of "_union" do  
    of "_intersect" do
    of "_minus" do  
      return(map(S, u-> solvelib::preImage(eq, x, u, opt)))
    of Dom::Interval do
      return(solve(eq in S, x, opt))
    of Dom::ImageSet do
      // S = { f(y); y \in A }
      // then eq(x) \in S iff eq(x)=f(y)
      if S::dom::nvars(S)=1 then 
        return(solvelib::Union(solve(eq=expr(S), x, opt),
                                       op(S::dom::variables(S), 1),
                                       op(S::dom::sets(S), 1)))
      else
        break
      end_if
    of solvelib::BasicSet do
      case S
        of solvelib::BasicSet(Dom::Complex) do
          return(S minus discont(eq, x, undefined))
        of solvelib::BasicSet(Dom::Real) do
            return(solve(Im(eq),x, opt))
        /* otherwise fall through ... */  
      end_case;
  end_case;
  
  i:=genident();
  solve(eq=i, x, opt);
  solvelib::Union(%, i, S)
end_proc:
    


