// $Date: 2000/10/31 15:08:39 $ $Author: stefanw $ $Revision: 1.11 $

/* solvelib::substituteBySet(a, x, S)

   given an object a that is not a set and contains the variable x,
   return the set of all objects that can be
   obtained by substituting some element of S for x

*/


solvelib::substituteBySet:=
proc(a, x, S)

begin
  if args(0)<>3 then
    error("Wrong number of arguments")
  end_if;
  
  if S::dom::substituteBySet <> FAIL then
    return(S::dom::substituteBySet(args()))
  end_if;

  case domtype(S)
    of DOM_INT do
    of DOM_RAT do
    of DOM_COMPLEX do
      return(a)
    of DOM_SET do
      return(map(S, proc(u)
                      local c;
                      begin
                      traperror((c:=subs(a, x=u)));
                      if %<>0 then
                        null()
                      else
                        c
                      end_if
                      end_proc))
    of DOM_EXPR do
      case type(S)
        of "solve" do
        of "RootOf" do
        of "_minus" do
          break
        otherwise
          return(eval(map(S, u-> solvelib::substituteBySet(a, x, u))))
      end_case;
      break
  end_case;

  if not has(a, x) then
     {a}
  else
     genident();
     Dom::ImageSet(subs(a, x=%), %, S)
  end_if
end_proc:


