arccsch :=
proc(x)
    option noDebug;
    // arccsch(x) = arcsinh(1/x) 
begin
  if args(0) = 0 then error("no arguments given")
  elif x::dom::arccsch <> FAIL then return(x::dom::arccsch(args()))
  elif args(0) <> 1 then error("1 argument expected")
  end_if;

  // handle sets
  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, arccsch))
  end_case;

  if not testtype(x,Type::Arithmetical) then
      error("argument must be of 'Type::Arithmetical'")
  elif iszero(x) then
      error("singularity")
  else
      arcsinh(1/x)
  end_if
end_proc:

arccsch:= funcenv(arccsch):
arccsch:= slot(arccsch, "print", "arccsch"):
arccsch:= slot(arccsch, "info", "arccsch -- the inverse hyperbolic cosecant"):
arccsch:= slot(arccsch, "type", "arccsch"):

arccsch:= slot(arccsch, "inverse", "csch"):

// end of file 
