arcsech := proc(x)
  option noDebug;
  // arcsech(x) = arccosh(1/x) 
begin
  if args(0) < 1 then error("no arguments given")
  elif x::dom::arcsech <> FAIL then return(x::dom::arcsech(args()))
  elif args(0) <> 1 then error("1 argument expected")
  end_if;

  // handle sets
  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, arcsech))
  end_case;
  
  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  elif iszero(x) then
    error("singularity")
  else
   arccosh(1/x)
  end_if
end_proc:

arcsech:= funcenv(arcsech):
arcsech:= slot(arcsech, "print", "arcsech"):
arcsech:= slot(arcsech, "info", "arcsech -- the inverse hyperbolic secant"):
arcsech:= slot(arcsech, "type", "arcsech"):

arcsech:= slot(arcsech, "inverse", "sech"):

// end of file 

