
ceil := proc(a)
  option noDebug;
  local r;
  save DIGITS;
begin
  if args(0) <> 1 then
    error("one argument expected")
  elif a::dom::ceil <> FAIL then
    return(a::dom::ceil(args()))
  end_if;

  case type(a)
    of DOM_INT do return(a);
    of DOM_RAT do return(specfunc::ceil(a));
    of DOM_SET do
    of "_union" do
      return(map(a, ceil))
  end_case;
  
  if not testtype(a,Type::Arithmetical) then
     error("argument must be of 'Type::Arithmetical'")
  end_if;

  // PARI's ceil is buggy. It may return 'Loss of precision'
  // if DIGITS is not high enough.
  // Otherwise it seems ok.

  case traperror((r:=specfunc::ceil(a)))
  of 0 do  // no error
     return(r);
  of 11 do // Error: Loss of precision (in ceil) 
     // This can happen only if a is a number, i.e.,
     // round(a) must produce an integer or a Gaussian integer
     DIGITS:= 3 + length(round(a));
     return( specfunc::ceil(a) )
//of 431 do // Error: Loss of precision (during evaluation of a)
//    what can we do ????
  otherwise
     lasterror()
  end_case;
end_proc:

ceil:= funcenv(ceil):
ceil:= slot(ceil, "float", specfunc::ceil):

ceil:= slot(ceil, "undefined", {}):
ceil:= slot(ceil, "realDiscont", Z_):

ceil::Content      := (Out, data) -> Out::Capply(Out::Cceil, Out(op(data))):

ceil:= slot(ceil,"series",
	loadproc(slot(ceil,"series"),pathname("SERIES"),"ceil")):
