csc :=
proc(x)
  option noDebug;
  // csc(x) = 1/sin(x) 
begin
  if args(0) = 0 then
    error("no arguments given")
  elif x::dom::csc <> FAIL then
    return(x::dom::csc(args()))
  elif args(0) <> 1 then
    error("1 argument expected")
  end_if;

  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, csc))
  end_case;
  
  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  end_if;

  x:= sin(x);
  if iszero(x) then
    error("singularity")
  else
    1/x
  end_if
end_proc:

csc := funcenv(csc):
csc := slot(csc, "type", "csc"):
csc := slot(csc, "print", "csc"):
csc := slot(csc, "info", "csc -- the cosecant"):

csc := slot(csc, "inverse", "arccsc"):

csc := slot(csc, "expand", proc() begin expand(1/sin(args(1))) end_proc  ):

csc:= slot( csc, "conjugate",
    loadproc(slot(csc,"conjugate"),pathname("STDLIB","CONJ"),"csc")
):

// end of file 
