csch :=
proc(x)
    option noDebug;
    // csch(x) = 1/sinh(x) 
begin
  if args(0) = 0 then
    error("no arguments given")
  elif x::dom::csch <> FAIL then
    return(x::dom::csch(args()))
  elif args(0) <> 1 then
    error("1 argument expected")
  end_if;

  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, csch))
  end_case;
  
  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  end_if;

  x:= sinh(x);
  if iszero(x) then
    error("singularity")
  else
    1/x
  end_if;
end_proc:

csch := funcenv(csch):
csch := slot(csch, "type", "csch"):
csch := slot(csch, "print", "csch"):
csch := slot(csch, "info", "csch -- the hyperbolic cosecant"):

csch := slot(csch, "inverse", "arccsch"):

csch := slot(csch, "expand", proc() begin expand(1/sinh(args(1))) end_proc  ):

csch:= slot( csch, "conjugate",
    loadproc(slot(csch,"conjugate"),pathname("STDLIB","CONJ"),"csch")
):

// end of file 
