
floor := proc(a)
  option noDebug;
  local r;
  save DIGITS;
begin
  if args(0) <> 1 then
    error("one argument expected")
  elif a::dom::floor <> FAIL then
    return(a::dom::floor(args()))
  end_if;

  case type(a)
    of DOM_INT do return(a);
    of DOM_RAT do return(specfunc::floor(a));
    of DOM_SET do
    of "_union" do
      return(map(a, floor))
  end_case;
  
  if not testtype(a,Type::Arithmetical) then
     error("argument must be of 'Type::Arithmetical'")
  end_if;

  // PARI's floor is buggy. It may return 'Loss of precision'
  // if DIGITS is not high enough.
  // Otherwise it seems ok.

  case traperror((r:=specfunc::floor(a)))
  of 0 do  // no error
       return(r);
  of 11 do // Error: Loss of precision (in floor)
     // This can happen only if a is a number, i.e.,
     // round(a) must produce an integer or a Gaussian integer
     DIGITS:= 3 + length(round(a));
     return(specfunc::floor(a));
//of 431 do // Error: Loss of precision (during evaluation of a)
//   what can we do ????
  otherwise
      lasterror() 
  end_case;
end_proc:

floor:= funcenv(floor):
floor:= slot(floor, "float", specfunc::floor):
floor:= slot(floor, "realDiscont", Z_):
floor:= slot(floor, "undefined", {}):

floor::Content      := (Out, data) -> Out::Capply(Out::Cfloor, Out(op(data))):

floor:= slot(floor,"series",
	loadproc(slot(floor,"series"),pathname("SERIES"),"floor")):
