
frac:= proc(a)
  option noDebug;
  local r;
  save DIGITS;
begin
  if args(0) <> 1 then
    error("one argument expected")
  elif a::dom::frac <> FAIL then
    return(a::dom::frac(args()))
  end_if;

  case type(a)
    of DOM_INT do return(0);
    // the PARI routine seems to work fine for rationals:
    of DOM_RAT do return(specfunc::frac(a));
    of DOM_SET do
    of "_union" do
      return(map(a, frac))
  end_case;
  
  if not testtype(a,Type::Arithmetical) then
     error("argument must be of 'Type::Arithmetical'")
  end_if;

  // Need a work-around, because PARI's frac is buggy:
  // 1) 'Error: Loss of precision' may occur
  // 2) the result may not be correct to all DIGITS digits
  // We need to boost DIGITS!

  r:= round(a); // use round to test whether a is a number
  case domtype(r)
    of DOM_INT do
       DIGITS:= DIGITS + length(r);
       break;
    of DOM_COMPLEX do
       DIGITS:= DIGITS + max(length(round(op(a,1))),
                             length(round(op(a,2))));
  end_case:

  // Now, let PARI do the job:
  return(specfunc::frac(a)):
end_proc:

frac:= funcenv(frac):
frac:= slot(frac, "float", specfunc::frac):

frac:= slot(frac,"series",
	loadproc(slot(frac,"series"),pathname("SERIES"),"frac")):
