sech := proc(x)
  option noDebug;
  // sech(x) = 1/cosh(x) 
begin
  if args(0) = 0 then error("no arguments given")
  elif x::dom::sech <> FAIL then return(x::dom::sech(args()))
  elif args(0) <> 1 then error("one argument expected")
  end_if;

  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, sech))
  end_case;

  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  end_if;

  x:= cosh(x);
  if iszero(x) then
    error("singularity")
  else
    1/x
  end_if
end_proc:

sech:= funcenv(sech):
sech:= slot(sech, "type", "sech"):
sech:= slot(sech, "print", "sech"):
sech:= slot(sech, "info", "sech -- the hyperbolic secant"):

sech:= slot(sech, "inverse", "arcsech"):

sech:= slot(sech, "expand", proc() begin expand(1/cosh(args(1))) end_proc  ):

sech:= slot(sech, "conjugate",
    loadproc(slot(sech,"conjugate"),pathname("STDLIB","CONJ"),"sech")
):

// end of file 
