// $Date: 2000/05/25 22:05:49 $  $Author: walter $   $Revision: 1.8 $ 

/*--
usage:
linReg(l) / linReg(s, c, ...)

linear regression,
returns least square estimators a and b of function f(x)=a+b*x

FIRST VERSION ... more features to come soon !
--*/
/*--
parameters:
l  list of rows with 2 elements each or sequence of 2 columns
s  stats::sample
c  sequence / list of data-column indices
   (optional if sample contains only 2 data-columns)
--*/

stats::linReg := proc()
  local l, n, x, y, xx, yy, z;
begin
  l:=stats::getdata(testargs(), "all_data", 2, args());
  if testargs() then
    if domtype(l) = DOM_STRING then error(l) end_if
  end_if;

  // calculation 
  if op(l, 1) = [] then
    return(FAIL); // division by zero 
  end_if;
  [x,y]:= [l];  // x = [x1,x2,..], y = [y1,y2,..]
  n:= nops(x); // = nops(y)
  xx:= _plus(op(x))/n; // mean of x values
  yy:= _plus(op(y))/n; // mean of y values
  x:= map(x, _subtract, xx); // x = [x1-xx,x2-xx,..]
  y:= map(y, _subtract, yy); // y = [x1-yy,x2-yy,..]
  z:= _plus(op(map(x, x->x^2))); // z = (x1-xx)^2 + (x2-xx)^2 + ...
  if iszero(z) then return(FAIL) end_if;
  return([_plus(x[i]*(yy*x[i]-xx*y[i]) $ i=1..n) / z ,
          _plus(x[i]*y[i] $ i=1..n) / z])
end_proc:


// end of file 
 
