// $Date: 2000/05/21 15:03:29 $  $Author: bij $   $Revision: 1.3 $ 

/*--
usage:
quadratic(l) / quadratic(s, c)

quadratic mean value (root-mean-square)
--*/
/*--
parameters:
l  list or sequence
s  stats::sample
c  data-column index (optional if sample contains only one data-column)
--*/

stats::quadratic := proc()
  local l;
begin
  l:=stats::getdata(testargs(), "all_data", 1, args());
  if testargs() then
    if domtype(l) = DOM_STRING then error(l) end_if
  end_if;

  // calculation 
  if l = [] then
    FAIL // division by zero 
  else
    sqrt(_plus(op(map(l, _power, 2)))/nops(l))
  end_if
end_proc:


// end of file 
 
