// $Date: 2000/05/21 15:03:30 $  $Author: bij $   $Revision: 1.6 $ 

/*--
usage:
stdev(l) / stdev(s, c) /
stdev(l, Sample) / stdev(s, c, Sample) 

standard deviation ( sqrt(1/n*(...)) or sqrt(1/(n-1)*(...)) 
                     if option Sample is selected           )
--*/
/*--
parameters:
l  list or sequence
s  stats::sample
c  data-column index (optional if sample contains only one data-column)
--*/

stats::stdev := proc()
  local l, x_, smple, nl;
begin
  if args(args(0)) = Sample then
    smple:=1;
    l:=stats::getdata(testargs(), "all_data", 1, args(1..(args(0)-1)))
  else
    smple:=0;
    l:=stats::getdata(testargs(), "all_data", 1, args())
  end_if;

  if testargs() then
    if domtype(l) = DOM_STRING then error(l) end_if
  end_if;

  // calculation 
  nl:=nops(l);
  if iszero(nl-smple) then
    FAIL // division by zero 
  else
    x_:=_plus(op(l))/nl;
    sqrt(_plus(op(map(map(l, _plus, -x_), _power, 2)))/(nl-smple))
  end_if
end_proc:


// end of file 
 
