// $Date: 2000/05/21 15:03:31 $  $Author: bij $   $Revision: 1.4 $ 

/*--
usage:
variance(x1,x2,..., <Sample>)
variance([x1,x2,..], <Sample>)
variance(sample, <colindex>, <Sample>)
--*/
/*--
parameters:
x1, x2, ... -- data (arithmetical expressions)
s           -- sample of type stats::sample
c           -- integer representing a column index of s
               (optional if sample contains only one data-column)
--*/

stats::variance := proc()
  local l, x_, smple, nl;
begin
  if args(args(0)) = Sample then
    smple:= 1;
    l:=stats::getdata(testargs(), "all_data", 1, args(1..(args(0)-1)))
  else
    smple:=0;
    l:=stats::getdata(testargs(), "all_data", 1, args())
  end_if;

  if testargs() then
    if domtype(l) = DOM_STRING then error(l) end_if
  end_if;

   // calculation 
   nl:= nops(l);
   if iszero(nl -smple) then
     FAIL // division by zero 
   else
     x_:=_plus(op(l))/nl;
     _plus(op(map(map(l, _plus, -x_), _power, 2)))/(nl -smple)
   end_if
end_proc:


// end of file 
 
