
/*--
	log/expand -- the function attribut "expand" for log

	log(b, x ^ n)  = n * log(b, x)          if x is real positive and n is real
                       = n                      Special case for x=b 
	log(b, x * y)  = log(b, x) + log(b, y)  if x or y are real positive
	log(b, -c * x) = log(b, c) + log(b, -x)
--*/

log := slot(log, "expand", proc(b, x)
// local n, t, y;
begin

  expand( ln(x)/ln(b) );

/* The line above replace the following code:
  y := normal(expand(x));

  case type(y)

    of DOM_RAT do return(log(b, op(y,1))-log(b, op(y,2)))

    of "_mult" do 
        // log(b, x*y)=log(b, x)+log(b, y) is only true
        // when x or y is real positive #
        n:=0; t:=1;
        for y in y do
            if is(y>=0)=TRUE then n:=n+log(b,y) else t:=t*y end_if
        end_for;
        return(n + log(b,t))

    of "_power" do
        n:=op(y,1); t:=op(y,2);
        if (is(n>=0)=TRUE or n=b) and is(t, Type::Real)=TRUE then
            return(expand(t * log(b,n)))
        end_if;
        break

  end_case;

  log(b, y)
*/

end_proc):

// end of file 
