// $Date: 2000/05/21 15:04:16 $ $Author: bij $ $Revision: 1.4 $ 

/*--
	psi/expand -- the function attribut "expand" for psi

	psi(x+i,n) = psi(x,n)+(-1)^n*n!*(1/x^(n+1)+1/(x+1)^(n+1)+...+
           1/(x+i-1)^(n+1))
--*/

psi:= slot( psi, "expand", proc(x,n) local i,j,t,rng,N;
begin
   if args(0)=1 then n:=0; N:=null() else N:=n end_if;
   if testtype(x, Type::Numeric)
   then if domtype(x) = DOM_COMPLEX then
           i:= floor(op(x,1));
           if i>=0
           then return(psi(x-i,N)+(-1)^n*fact(n)*_plus(1/(x-j)^(n+1) $ j=1..i))
           else return(psi(x-i,N)-(-1)^n*fact(n)*_plus(1/(x+j)^(n+1) $ j=0..(-i-1)))
           end_if;
        end_if;
        if domtype(x) = DOM_RAT then
           i:= floor(x);
           if i>=0
           then return(psi(x-i,N)+(-1)^n*fact(n)*_plus(1/(x-j)^(n+1) $ j=1..i))
           else return(psi(x-i,N)-(-1)^n*fact(n)*_plus(1/(x+j)^(n+1) $ j=0..(-i-1)))
           end_if;
        end_if;
        if domtype(x) = DOM_INT then
           if x>0 
           then return(psi(1,N) + (-1)^n*fact(n)*_plus(1/j^(n+1) $ j=1..x-1));
           else error("singularity")
           end_if;
        end_if;
   end_if;
   // arguments such as x = y + 5:
   i:=coeff(x,0);
   if type(i)=DOM_INT
   then x:=x-i;
        if i<0 then rng:=i..-1 else rng:=0..i-1 end_if;
        t:=_plus(1/(x+j)^(n+1) $ j=rng);
        return(hold(psi)(x,N)+sign(i)*(-1)^n*fact(n)*t)
   else return(hold(psi)(x,N))
   end_if
end_proc):

// end of file 
