// $Date: 2000/05/21 15:04:16 $ $Author: bij $ $Revision: 1.3 $ 

/*--
	sinh/expand -- the function attribut "expand" for sinh

 sinh(-x)     = -sin(x)                                                  
 sinh(x +- y) = sinh(x) * cosh(y) +- sinh(y) * cosh(x)                   
                n                                                        
               ---                                                       
               \   (   n  )                                              
 sinh(n * x) = /   ( 2*i+1) cosh(x)^(n-2*i-1)*sinh(x)^(2*i+1)*(-1)^(i+1) 
               ---                                                       
               i=0     
--*/

sinh := slot(sinh, "expand", proc(x)
  local n, t, y;
begin
  y := expand(x);

  case type(y)

    of "_plus" do

       n := op(y, 1); y := subsop(y, 1=null());
       return(expand(sinh(n)*cosh(y)+cosh(n)*sinh(y)));

    of "_mult" do

       n := op(y, nops(y)); t := type(n);
       if t = DOM_INT or t = DOM_RAT then
          if n < 0 then
             return(expand(-sinh(-y)));
          elif t = DOM_INT and n > 0 then
             y := y / n;
             return(expand(2*sinh((n-1)*y)*cosh(y)-sinh((n-2)*y)));
          end_if
       end_if

  end_case;

  sinh(y)

end_proc):

// end of file 
