// $Date: 2000/11/28 12:51:39 $ $Author: ccr $ $Revision: 1.28 $ 

/*--
	_power/simplify -- the function attribut "simplify" for _power
--*/

_power:=slot
(_power,"simplify",
 proc(e)
   name _power::simplify;
   local c,q,l,i,p,t,aa,k,ok,_a,_aa,b,br,br1;
 begin
   _a:= simplify(op(e,1)); b:= op(e,2);
   // This case must be treated before sign(b)=-1, because 
   // we want to simplify exp(x)^(-y) -> exp(x*(-y))       
   if testtype(_a, "exp") then
     // rewrite exp(x)^b = exp(xb) if -PI < Im(x) <= PI or b in Z
     if is(op(_a), Type::Real) = TRUE or
        (is(-PI < Im(op(_a))) = TRUE and is(Im(op(_a)) <= PI) = TRUE) or
        is(b, Type::Integer) = TRUE then
       return(simplify(exp(op(_a)*b)))
     end_if;
   end_if;

   // (NonNegative^Rational)^Rational
//    if type(_a) = "_power" and is(b, Type::Rational) = TRUE then
//      if is(op(_a, 1), Type::NonNegative) = TRUE then
//        return(simplify(op(_a, 1)^(op(_a, 2)*b)))
//      end_if
//    end_if;

 if sign(b)=-1 then
   return(simplify(_a^(-b))^(-1))
 end_if;
   // now b cannot be negative 
 
 // beginning of extension from Francois Maltey 
 if (br:=stdlib::radsimp_matchsqrt (e))<> FAIL
   and (br1 := stdlib::radsimp_match2sqrt (br)) <> FAIL
   // returns a b r 
   and is(br1[1] > 0) = TRUE
   and is(br1[2] > 0) = TRUE
   and is((br := br1[1]^2 - br1[2]^2 * br1[3]) >= 0) = TRUE
   // Delta here a^2 - b^2 r 
   and ((type ((br := sqrt (br))) = DOM_INT) or (type (br) = DOM_RAT))
   then
   return (sqrt ((br1[1] + br) / 2) + sqrt ((br1[1] - br) / 2)) ;
   // end of 1st case : sqrt x + sqrt y 
   // beginning of 2nd case : sqrt x - sqrt y 
 elif (br:=stdlib::radsimp_matchsqrt (e))<> FAIL
   and (br1 := stdlib::radsimp_match2sqrt (br)) <> FAIL // returns a b r 
   and is(br1[1] > 0) = TRUE
   and is(br1[2] < 0) = TRUE
   and is((br := br1[1]^2 - br1[2]^2 * br1[3]) >= 0) = TRUE
   // here a^2 - b^2 r 
   and ((type ((br := sqrt (br))) = DOM_INT) or (type (br) = DOM_RAT))
   then
   return (sqrt ((br1[1] + br) / 2) - sqrt ((br1[1] - br) / 2)) ;
   // end of 2nd case : sqrt x - sqrt y 
   // end of extension from Francois Maltey 
 end_if;
 
             
 if type(_a)="_mult" then
   if is(b,Type::Integer)=TRUE then
     return(map(map(_a,simplify),_power,b))
   elif type(b)=DOM_RAT then
     c := op(_a, nops(_a));
     if testtype(c, Type::Numeric) then
       if testtype(c, Type::Real) and c < 0 then
         t := trunc(b);
         if (t <> 0) then
           return(_a^t*simplify(_a^(b-t)))
         end_if
       end_if
     end_if;
   end_if;
   p:=1; aa:=1;
   for q in _a do
     if is(q>=0)=TRUE then
       _aa:=simplify(q^b);
       if _aa = hold(_power)(q,b) then
         aa := aa * q;
       else
         p:=p*_aa;
       end_if;
     elif is(q<0)=TRUE and _a<>-q then
       _aa := simplify((-q)^b);
       if _aa = hold(_power)(-q,b) then
         aa := aa * q;
       else
         p:=p*_aa; aa:=-aa;
       end_if
     else
       aa:=aa*q
     end_if;
   end_for;
   return(p*aa^b)
 elif type(_a)="_plus" then
   if type(b)=DOM_RAT then
     i:=trunc(b); b:=b-i;
     l:=expand(_a^i);
   else
     l:=1
   end_if;
      // result is l*_a^b 
      // try to simplify the fractional part 
   aa:=rationalize(_a,NIL,NIL,{"_power"});
   q:= Factored::convert_to(polylib::sqrfree(numer(aa[1])),DOM_LIST); 
   p:= Factored::convert_to(polylib::sqrfree(denom(aa[1])),DOM_LIST);
   ok:=bool(nops(q)<>3 or nops(p)<>1); // to avoid loops 
   if sign(b)=1 and ok then
     for i from nops(q) div 2 downto 1 do
       if q[2*i+1]<>1 then
         if is(q[2*i]^q[2*i+1]>=0)=TRUE then
           l:=l*simplify((q[2*i]^q[2*i+1])^b);
           delete q[2*i+1], q[2*i]; ok:=TRUE
         end_if
       end_if
     end_for;
   elif sign(b)=1 and nops(q)=3 and q[3]=2 then
         // (x^2)^b = x*(y*b) if sign(b)=1 and Re(x)>=0 
     subs(q[2],aa[2]);
     if is(%>=0)=TRUE then
       return(l*%^(2*b))
     elif is(%<=0)=TRUE then
       return(l*(-%)^(2*b))
     elif is(Re(%)>=0)=TRUE then
       return(l*%^(2*b))
     elif is(Re(%)<=0)=TRUE then
       return(l*(-%)^(2*b)) end_if
     end_if;
     q:=_mult(q[1],q[2*i]^q[2*i+1]$ i=1..nops(q) div 2);
     p:=_mult(p[1],p[2*i]^p[2*i+1]$ i=1..nops(p) div 2);
     q:=subs(q/p,aa[2]);
     _a:=q^b;
     if type(l)="_plus" then
       p:=map(l,_mult,_a)
     else
       p:=l*_a
     end_if;
     return(p)
   elif type(_a)=DOM_INT and type(b)=DOM_RAT then
     if _a < 0 then
       return( (-1)^b * simplify((-_a)^b) )
     end_if;
     q:=op(b,2); // denominator 
      // first tries to decompose the exponent 
     l:=stdlib::ifactor(q, UsePrimeTab); // otherwise it could take too long
     // invariant: result = _a^b 
     _a:=_a^op(b,1); b:=1/q;
     for i from 1 to nops(l) div 2 do
       p:=l[2*i]; k:=l[2*i+1];
       repeat
         // is _a^(1/p) an integer ? 
         aa:=round(_a^(1/p));
         if _a=aa^p then
           _a:=aa; b:=b*p; k:=k-1
         else
           break
         end_if;
       until k=0 end_repeat;
     end_for;
     // return(_a^b);
      /* now tries to factor _a: removed PZ 8.1.99 since it can lead to
        infinite loops as simplify(2^(1/2)*3^(1/2)) -> 6^(1/2) */
      /* if isprime(_a) then return(_a^b)
      else
         l:=stdlib::ifactor(_a);
         _a:=l[1]^b;
         for i from 1 to nops(l) div 2 do
            p:=l[2*i]; k:=l[2*i+1];
            _a:=_a*p^(k*b)
         end_for;
         return(_a)
       end_if; */

     // more conservative heuristic: do only extract factors
     // of the form n^q

     q:=denom(b);
     p:=numer(b);
     l:=stdlib::ifactor(_a, UsePrimeTab);
     // l[1] is known to be 1, since _a is positive
     // get all pairs l[2*i],l[2*i+1] according to whether
     // q >= l[2*i+1]

     br:=1;
     // loop invariant is _a^(p/q) * br
     for i from 2 to nops(l) step 2 do
       if l[i+1] >= q then
         // if l[i+1]= s*q +t, the power (l[i]^l[i+1])^(p/q) can be simplified
         // to l[i]^(ps) * l[i]^(pt/q)
         // divide _a by l[i]^s
         _a := _a / l[i]^ (q*(l[i+1] div q));
         br:= br* l[i] ^ (p*(l[i+1] div q))
       end_if
     end_for;
     return(_a^(p/q)*br)
   elif testtype(_a,hold(_power)(Type::AnyType,Type::Rational)) 
    and type(b)=DOM_RAT then // (x^r)^(j/k) 
      p:=op(_a,1)^(op(_a,2)*b);
      if is(p>=0)=TRUE then
        return(p)
      elif b=1/2 then
	if is(Re(_a)>0)=TRUE 
	   or is (Im(_a)<>0)=TRUE
	   or ( is(op(_a,2), Type::Even) = TRUE
		and is(Re(op(_a,1)^(op(_a,2)/2)) > 0) = TRUE )
	 then
           return(p)
         elif is(p,Type::Real)=TRUE then
             //return(abs(p))
           return(p*sign(p))
         end_if
      end_if
   elif b = 1/2 and _a<>op(e,1) // otherwise it will loop !!! 
   then
      return(simplify(sqrt(_a)))
   end_if;
   e
 end_proc
 ):

// end of file 
