// 
// $Date: 2000/09/18 15:16:03 $ $Author: tonner $ $Revision: 1.24 $ 

simplify := proc(e,f)
    local _t, s, _e, p, Try;
begin
    // is overloaded ? 
    if e::dom::simplify<>FAIL then 
	return(e::dom::simplify(args())) 
    end_if;

    case args(0)
    of 2 do 
	f:=slot(simplify,expr2text(f));
	if f <> FAIL then return( f(e) )
	else
            error("invalid second argument");
        end_if;
    of 1 do break;
    otherwise error("wrong no of args")
    end_case;

    case domtype(e)
    of DOM_INT     do
    of DOM_RAT     do
    of DOM_FLOAT   do
    of DOM_COMPLEX do return( e )
    of DOM_POLY	   do return( mapcoeffs(e,simplify) )
    of Series::Puiseux	   do return( map(e,simplify) )
    of DOM_LIST    do 
    of DOM_ARRAY   do
    of DOM_SET     do return( map(e,simplify) )
    of DOM_EXPR    do
	// try global simplifications first 
	Try:= TRUE;
	while Try  do
	    _e:= e;
            for _t in map(indets(e, RatExpr), type) do
                if (p:= slot(simplify, _t)) <> FAIL then
		    e:= p( e );
		    if e <> _e then break end_if
	        end_if
	    end_for;
	    if e = _e then
                Try:= FALSE 
	    end_if
        end_while;

	if testtype( e,Type::Numeric ) then return( e ) end_if;

        _t := eval(op(e,0));
        if domtype(_t) = DOM_FUNC_ENV and
           (s:= slot(_t,"simplify")) <> FAIL 
	then
           return( s(e) )
        end_if;
	e:=map(e,simplify);
    end_case;
    e
end_proc:

DOM_NIL::simplify:=proc() begin NIL end_proc :

simplify:=funcenv(simplify):

//---- trigonometric functions -----
simplify:= slot(simplify,"sin",
    loadproc(slot(simplify,"sin"),pathname("STDLIB","SIMPLIFY"),
        "SIMPLsin")
):
simplify:= slot(simplify,"cos",
    loadproc(slot(simplify,"cos"),pathname("STDLIB","SIMPLIFY"),
        "SIMPLcos")
):

//---- sqrt -----
simplify:=slot(simplify,"sqrt",radsimp):

//---- exp -----
simplify:=slot(simplify,"exp",
    loadproc(slot(simplify,"exp"),pathname("STDLIB","SIMPLIFY"),
        "SIMPLexp")
):

//---- logarithms -----
simplify:=slot(simplify,"ln",
    loadproc(slot(simplify,"ln"),pathname("STDLIB","SIMPLIFY"),
        "Sln")
):

simplify:=slot(simplify,"log",
    loadproc(slot(simplify,"log"),pathname("STDLIB","SIMPLIFY"),
        "Slog")
):

//---------------------------------
_power:= slot(_power,"simplify",
    loadproc(slot(_power,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "_power")
):

_mult:= slot(_mult,"simplify",
    loadproc(slot(_mult,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "_mult")
):

max:=slot(max,"simplify",
    loadproc(slot(max,"simplify"),pathname("STDLIB","SIMPLIFY"),"max")):

min:=slot(min,"simplify",
    loadproc(slot(min,"simplify"),pathname("STDLIB","SIMPLIFY"),"min")):

//stdlib::logic:= loadproc(stdlib::logic, pathname("STDLIB", "SIMPLIFY", "LOGIC"), simplify):

simplify:=slot(simplify,"logic",
loadproc(stdlib::logic::simplify,pathname("STDLIB","SIMPLIFY", "LOGIC"),"simplify")):

//stdlib::relation:= loadproc(stdlib::relation, pathname("STDLIB", "SIMPLIFY", "LOGIC"), simplify):

simplify:=slot(simplify,"relation",
loadproc(stdlib::relation::simplify,pathname("STDLIB","SIMPLIFY"),"relation")):


_plus:= slot(_plus,"simplify",
    loadproc(slot(_plus,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "_plus")
):

_fconcat:= slot(_fconcat, "simplify",
    loadproc(slot(_fconcat, "simplify"), pathname("STDLIB","SIMPLIFY"),
	"_fconcat")
):

int:= slot(int,"simplify",
    loadproc(slot(int,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "int")
):

sum:= slot(sum, "simplify",
            loadproc(slot(sum,"simplify"),pathname("STDLIB","SIMPLIFY"),
        "sum")
):

Re:= slot(Re, "simplify",
          proc(x)
            begin
              Re(expr(rectform(op(x,1))));
              if not hastype(%, {"Re", "Im"}) then
                simplify(%)
              else
                %
              end_if
          end_proc):

Im:= slot(Im, "simplify",
          proc(x)
          begin
            Im(expr(rectform(op(x,1))));
            if not hastype(%, {"Re", "Im"}) then
              simplify(%)
            else
              %
            end_if
          end_proc
          ):


simplify:=slot(simplify,"normal",normal):
simplify::print:= "simplify":

// end of file 

