// $Date: 2000/09/27 16:44:30 $ $Author: frankp $ $Revision: 1.4 $ #
/*
  frankp, 16.03.2000
 
        expr(x) -- converts x into an expression consisting only of basic types.

        x: Any
  
        The kernel function 'kernel' does not work recursively 
        on subexpressions of x, as one might expect. Hence, we
        moved this function to stdlib::expr and implemented a 
        library function 'expr' which does this job and therefore 
        guarantees, at least for basic types, that the result and 
        its operands are objects of basic types.
*/
expr:= proc(x)
    local tmp;
begin
    if args(0) <> 1 then error("expecting one argument") end_if;
    case domtype(x)
    of DOM_INT do
    of DOM_COMPLEX do
    of DOM_RAT do
    of DOM_POLYGON do
    of DOM_POINT do
    of DOM_FAIL do
    of DOM_NIL do
    of DOM_BOOL do
    of DOM_STRING do
    of DOM_FLOAT do
    of DOM_IDENT do
    of DOM_VAR do
    of DOM_NULL do
    of DOM_FUNC_ENV do
    of DOM_PROC_ENV do
    of DOM_EXEC do
    of DOM_DOMAIN do
    of DOM_PROC do
        return( x )
    of DOM_POLY do
        return( expr(stdlib::expr(x)) )
    of DOM_ARRAY do
    of DOM_TABLE do
    of DOM_LIST do
    of DOM_SET do 
        if nops(x) = 1 then 
            return(stdlib::expr(x))
        else
            return(map(x,expr))
        end_if
    of DOM_EXPR do
        return(map(x,expr))
    otherwise
        if (tmp:= x::dom::expr) <> FAIL then 
            return( tmp(x) ) 
        else
            return( FAIL )
        end_if;
    end_case; 
end_proc:

