// $Date: 2000/10/09 06:47:01 $ $Author: tonner $ $Revision: 1.6 $

/* _in(x,S)

   returns an expression xpr depending on x such that
   bool(subs(xpr, x=C)) is equivalent to x \in S

*/


_in:= funcenv(
proc(x, S)
  name _in;
begin
  if x::dom::_in <> FAIL then
    return(x::dom::_in(x,S))
  end_if;
  
  if S::dom::set2expr <> FAIL then
    return(S::dom::set2expr(S,x))
  end_if;

  case type(S)
    of DOM_SET do
      return(_or(x=i $i in S))
    of "solve" do
      if contains({"_equal", "_unequal", "_less", "_leequal"},
                  type(op(S,1))) then
        return(subs(op(S,1), op(S,2)=x))
      elif contains({DOM_LIST, DOM_SET}, type(op(S,1))) then
        break
      else
        return(subs(op(S,1),op(S,2)=x)=0)
      end_if
    of "RootOf" do
      return(subs(op(S,1)=0, op(S,2)=x))
    of "_union" do
      return(_or(_in(x, op(S,i)) $i=1..nops(S)))
    of "_intersect" do
      return(_and(_in(x, op(S,i)) $i=1..nops(S)))
    of "_minus" do
      return(_in(x, op(S,1)) and not
             _in(x, op(S,2)))
  end_case;

  procname(x, S)
end_proc,  builtin(1100, 6, " in ", "_in" )):

slot(_in, "type"):="_in":
slot(_in, "print"):="_in":
_in::Content := (Out, data) -> Out::Capply(Out::Cin, map(op(data), Out)):
