// $Date: 2000/05/21 15:03:44 $ $Author: bij $ $Revision: 1.6 $ 

// kg, 21/04/98 

/*++
operator -- define operator

operator(name, expr [, type [, prio ] ])
operator(name, Delete)

name - operator name (string)
expr - expression representing the operator
type - type of operator (Prefix, Postfix, Binary, Nary)
       default: Nary
prio - operator priority (400-2099)
       default: 1800
++*/

operator:= proc(nam, fc, typ, prio)
    local n, i, pc;
    option noDebug;
begin
    n:= args(0);
    if testargs() then
	if n <> 2 and n <> 4 then
	    error("wrong no of args")
	end_if;
	if domtype(nam) <> DOM_STRING or length(nam) > 32 then
	    error("illegal operator name")
	end_if;
	if n = 4 then
	    if typ <> hold(Prefix) and typ <> hold(Postfix) and
	       typ <> hold(Binary) and typ <> hold(Nary) then
		error("illegal operator type")
	    end_if;
	    if domtype(prio) <> DOM_INT or prio < 1 or prio >= 2000 then
		error("illegal operator priority")
	    end_if;
	end_if;
    end_if;

    pc:= _parser_config();
    if pc = null() then
	pc:= [table(), table(), table(), []]
    end_if;

    if n = 2 then
	if fc = hold(Delete) then
	    i:= contains(map(pc[4], op, 1), nam);
	    if i = 0 then
		error("operator does not exist")
	    end_if;
	    delete pc[4][i];
	    _parser_config(pc);
	    return(null());
	end_if;
	typ:= hold(Nary);
	prio:= 1300;
    end_if;

    i:= contains(map(pc[4], op, 1), nam);
    if i <> 0 then
	error("operator already exists")
    end_if;
    pc[4]:= append(pc[4], [nam,fc,typ,prio]);
    _parser_config(pc);
    null()
end_proc:

// end of file 
