// $Date: 2000/09/13 07:47:43 $ $Author: walter $ $Revision: 1.32 $

// rewrite the expression f to type typ 

rewrite :=
proc(f,typ)
begin
  
  if f::dom::rewrite <> FAIL then
    return(f::dom::rewrite( args() ))
  end_if;

  if args(0)<>2 then
    error("Wrong number of arguments")
  end_if;

  if domtype(typ)= DOM_FUNC_ENV and slot(typ, "rewrite")<>FAIL then
    return(slot(typ, "rewrite")(args()))
  end_if;
  
  case typ 
    of exp do
      eval(subs(f, [
                hold(sin)   = (x -> 1/(2*I)*(exp(x*I)-exp(-x*I))),
                hold(cos)   = (x -> 1/2*(exp(x*I)+exp(-x*I))),
                hold(tan)   = (x -> -I*(exp(x*I)^2-1)/(exp(x*I)^2+1)),
                hold(cot)   = (x -> I*(exp(x*I)^2+1)/(exp(x*I)^2-1)),
                hold(sinh)  = (x -> 1/2*(exp(x)-exp(-x))),
                hold(cosh)  = (x -> 1/2*(exp(x)+exp(-x))),
                hold(tanh)  = (x -> (exp(x)^2-1)/(exp(x)^2+1)),
                hold(coth)  = (x -> (exp(x)^2+1)/(exp(x)^2-1)),
                hold(arcsin)= (x -> -I*ln(I*x+sqrt(1-x^2))),
                hold(arccos)= (x -> -I*ln(x+I*sqrt(1-x^2))),
                //hold(arctan)=(x -> I*1/2*(ln(1-I*x)-ln(1+I*x))),
                hold(arctan)= proc(x,y)  // method from ln case
                              begin
                               if args(0)=1 then
                                 I/2*(ln(1-I*x)-ln(1+I*x))
                               else
                                 -I * ln((x+I*y)/(abs(x+I*y)))
                               end_if
                              end_proc,
                hold(arccot) = (x -> I/2*(ln(1-I/x)-ln(1+I/x))),
                hold(arcsinh)= (x -> ln(x+sqrt(x^2+1))),
                hold(arccosh)= (x -> ln(x+sqrt(x^2-1))),
                hold(arctanh)= (x -> 1/2*(ln(1+x)-ln(1-x))),
                hold(arccoth)= (x -> 1/2*(ln(1+1/x)-ln(1-1/x))),
                hold(arg)=((x,y) -> -I*ln( (x+I*y)/abs(x+I*y)))
               ]));
      break
    of tan do
      eval(subs(f, [
                hold(sin)  = (x ->  2*tan(x/2)     / (1+tan(x/2)^2) ),
                hold(cos)  = (x -> (1-tan(x/2)^2)  / (1+tan(x/2)^2) ),
                hold(cot)  = (x ->  1/tan(x) ),
             // hold(exp)  = (x -> (1-I*tan(I*x/2))^2
             //                                    / (1+tan(I*x/2)^2) ),
                hold(exp)  = (x -> (I+tan(I*x/2))  / (I-tan(I*x/2)) ),
                hold(sinh) = (x -> -I*2*tan(I*x/2) / (1+tan(I*x/2)^2) ),
                hold(cosh) = (x -> (1-tan(I*x/2)^2)/ (1+tan(I*x/2)^2) ),
                hold(tanh) = (x ->-I*tan(I*x) ),
                hold(coth) = (x -> I/tan(I*x) )
               ]));
      break
    of tanh do
      eval(subs(f, [
                hold(sin)  = (x ->-2*I*tanh(I*x/2) /(1-tanh(I*x/2)^2) ),
                hold(cos)  = (x ->(1+tanh(I*x/2)^2)/(1-tanh(I*x/2)^2) ),
                hold(tan)  = (x ->-I*tanh(I*x) ),
                hold(cot)  = (x -> I/tanh(I*x) ),
             // hold(exp)  = (x -> (1+tanh(x/2))^2 /(1-tanh(x/2)^2) ),
                hold(exp)  = (x -> (1+tanh(x/2))   /(1-tanh(x/2)  ) ),
                hold(sinh) = (x -> 2*tanh(x/2)     /(1-tanh(x/2)^2) ),
                hold(cosh) = (x -> (1+tanh(x/2)^2) /(1-tanh(x/2)^2) ),
                hold(coth) = (x ->  1/tanh(x))
               ]));
      break
    of cot do
      eval(subs(f, [
                hold(sin)  = (x ->   2*cot(x/2)   / (cot(x/2)^2+1) ),
                hold(cos)  = (x -> (cot(x/2)^2-1) / (cot(x/2)^2+1) ),
                hold(tan)  = (x -> 1/cot(x) ),
             // hold(exp)  = (x ->-(1+I*cot(I*x/2))^2/(1+cot(I*x/2)^2) ),
                hold(exp)  = (x -> (cot(I*x/2)-I)   / (cot(I*x/2)+I) ),
                hold(sinh) = (x -> -I*2*cot(I*x/2)  / (1+cot(I*x/2)^2) ),
                hold(cosh) = (x -> (cot(I*x/2)^2-1) / (1+cot(I*x/2)^2) ),
                hold(tanh) = (x ->-I/cot(I*x) ),
                hold(coth) = (x -> I*cot(I*x) )
               ]));
      break
    of coth do
      eval(subs(f, [
                hold(sin)  = (x -> -2*I*coth(I*x/2) /(coth(I*x/2)^2-1) ),
                hold(cos)  = (x -> (1+coth(I*x/2)^2)/(coth(I*x/2)^2-1) ),
                hold(tan)  = (x -> -I/coth(I*x) ),
                hold(cot)  = (x ->  I*coth(I*x) ),
             // hold(exp)  = (x -> (1+coth(x/2))^2 / (coth(x/2)^2-1) ),
                hold(exp)  = (x -> (1+coth(x/2))   / (coth(x/2)  -1) ),
                hold(sinh) = (x ->    2*coth(x/2)  / (coth(x/2)^2-1) ),
                hold(cosh) = (x -> (coth(x/2)^2+1) / (coth(x/2)^2-1) ),
                hold(tanh) = (x -> 1/coth(x) )
               ]));
      break
    of ln do
      eval(subs(f, [
                // formulae 4.4.26-4.4.31 in Abramowitz and Stegun 
                hold(arcsin)=(x ->  -I*ln(I*x+sqrt(1-x^2))),
                hold(arccos)=(x ->  -I*ln(x+I*sqrt(1-x^2))),
         //     hold(arctan)=(x ->   I/2*(ln(1-I*x)-ln(1+I*x))),
                hold(arctan)=proc(x,y)
                             begin
                               if args(0)=1 then
                                 I/2*(ln(1-I*x)-ln(1+I*x));
                               else
                                 -I * ln((x+I*y)/(abs(x+I*y)))
                               end_if
                             end_proc,
                hold(arccot)=(x ->  I/2*(ln(1-I/x) - ln(1+I/x))),
                // formulae 4.6.20-4.6.25 in Abramowitz and Stegun 
                hold(arcsinh)=(x -> ln(x+sqrt(x^2+1))),
                hold(arccosh)=(x -> ln(x+sqrt(x^2-1))),
                // both rewriting rules arctanh -> ln are valid
         //     hold(arctanh)=(x -> ln(sqrt(1+x))-ln(sqrt(1-x))),
                hold(arctanh)=(x -> 1/2*( ln(1+x)-ln(1-x))),
                // both rewriting rules arccoth -> ln are valid
         //     hold(arccoth)=(x -> ln(sqrt(1+1/x))-ln(sqrt(1-1/x))),
                hold(arccoth)=(x -> 1/2* (ln(1+1/x)-ln(1-1/x))),
         //     hold(arg)=((x,y) -> -I*ln( (x+I*y)/sqrt(x^2+y^2)))
                hold(arg)=((x,y) -> -I*ln( (x+I*y)/abs(x+I*y))),
                hold(log)=((b,x) -> ln(x)/ln(b))    
               ]));
      break
    of gamma do
      eval(subs(f, [
                hold(fact)= (x -> gamma(x+1)),
                hold(binomial) = ((n,k) -> gamma(n+1)/gamma(k+1)/gamma(n-k+1) )
               ]));
               break
    of fact do
      eval(subs(f, [
                hold(gamma)= (x -> fact(x-1)),
                hold(binomial) = ((n,k) -> fact(n)/fact(k)/fact(n-k) )
               ]));
               break
    of diff do
      misc::maprec(f,{"function"}=stdlib::Dtodiff); break
    of sign do
      misc::maprec(f,{"heaviside"}=
                   proc()
                   begin
                     (sign(op(args(1)))+1)/2
                   end_proc,
                   {"abs"}=
                   proc()
                   begin
                     sign(op(args(1)))*(op(args(1)))
                   end_proc);
      break
    of heaviside do
      misc::maprec(f,{"sign"}=
                   proc()
                   begin
                     2*heaviside(op(args(1)))-1
                   end_proc );
      break
    of piecewise do
      eval(subs(f, [
                hold(sign)=
                proc(x)
                begin
                  if type(x)=piecewise then
                    piecewise([map(x,_not@_leequal,0), 1],
                               [map(x,_less,0), -1],
                               [map(x, _equal, 0), 0],
                               [map(x, z-> not z in R_),
                                x/sqrt(Re(x)^2+Im(x)^2) ]
                               )
                  else
                    piecewise([x>0, 1],
                               [x<0, -1],
                               [x=0, 0],
                               [not x in R_, x/sqrt(Re(x)^2+Im(x)^2)]
                               )
                  end_if
                end_proc,
                hold(abs)=
                proc(x)
                begin
                  if type(x)=piecewise then
                    piecewise([map(x,_not@_less,0), x],
                               [map(x,_leequal,0), -x],
                               [map(x, z-> not z in R_),
                                sqrt(Re(x)^2+Im(x)^2) ]
                               )
                  else
                    piecewise([x>=0, x],
                               [x<=0, -x],
                               [not x in R_, sqrt(Re(x)^2+Im(x)^2)]
                               )
                  end_if;
                end_proc,
                hold(heaviside)=
                proc(x)
                  begin
                  if type(x)=piecewise then
                    piecewise([map(x,_not@_leequal,0), 1],
                              [map(x,_equal, 0), heaviside(0)],
                              [map(x,_less,0), -1]
                               )
                  else
                    piecewise([x>0, 1],
                              [x=0, heaviside(0)],
                              [x<0, -1]
                               )
                  end_if;
                end_proc
           ]));
      break
    of sincos do
      misc::maprec(f,
                   {"exp"}= proc() begin
                     cos(op(args(1),1)/I)+I*sin(op(args(1),1)/I)
                   end_proc,
                   {"tan"}= proc() begin
                     sin(op(args(1)))/cos(op(args(1)))
                   end_proc,
                   {"cot"}= proc() begin
                     cos(op(args(1)))/sin(op(args(1)))
                   end_proc,
                   {"sinh"}= proc() begin
                     -I*sin(I*op(args(1),1))
                   end_proc,
                   {"cosh"}= proc() begin
                     cos(I*op(args(1),1))
                   end_proc,
                   {"tanh"}= proc() begin
                     -I*sin(I*op(args(1),1))/cos(I*op(args(1),1))
                   end_proc,
                   {"coth"}= proc() begin
                     I*cos(I*op(args(1),1))/sin(I*op(args(1),1))
                   end_proc 
                  );
      break
    of sinhcosh do
      eval(subs(f, [
                hold(exp) =(x ->  cosh(x) + sinh(x) ), 
                hold(tanh)=(x ->    sinh(x)/cosh(x) ),
                hold(coth)=(x ->    cosh(x)/sinh(x) ),
                hold(sin) =(x ->  I*sinh(x/I) ),
                hold(cos) =(x ->    cosh(x/I) ),
                hold(tan) =(x ->  I*sinh(x/I)/cosh(x/I) ),
                hold(cot) =(x -> -I*cosh(x/I)/sinh(x/I) )
                   ]));
      break
    otherwise
      error("Unknown target type in rewrite")
  end_case
end_proc:

/* D(f)(x) -> diff(f(x),x)
  D(D(f))(x) -> diff(f(x),x,x)
  D([1],f)(x) -> diff(f(x),x)
  D([1,2],f)(x,y) -> diff(f(x,y),x,y)
  D(f)(x,y) -> diff(f(x,y),x)+diff(f(x,y),y) [total derivative]
*/
stdlib::Dtodiff:=
proc(x)
  local i;
begin
  if nops(x)=1 and type(op(x,1))=DOM_IDENT
    and nops(op(x,0))=1 then
    stdlib::Dtodiff2(op(x,0..1))
  elif map({op(x)},type)={DOM_IDENT} then
    if nops(op(x,0))=2 then
      op(x,[0,1]); // list of indices 
      diff(subsop(x,0=op(x,[0,2])),
           op(x,%[i])$ i=1..nops(%))
    elif nops(op(x,0))=1 and op(x,[0,0])=hold(D) then
      // D(f)(x,y,...) -> diff(f(x,y,...),x)+diff(...,y)+... 
      subsop(x,0=op(x,[0,1]));
      _plus(diff(%,op(x,i))$ i=1..nops(x))
    else
      x
    end_if
  else
    x
  end_if
end_proc :

stdlib::Dtodiff2:=
proc()
begin
  if type(args(1))="D" and nops(args(1))=1 then
	diff(stdlib::Dtodiff2(op(args(1),1),args(2)),args(2))
  else
    args(1)(args(2))
  end_if
end_proc :
