// $Date: 2000/04/10 16:59:28 $ $Author: frankp $ $Revision: 1.3 $

student::simpson:= proc(f,r,n=4)
    local x, a, b, h, F, i, Sum;
begin
    if testargs() then
        if args(0) < 2 or (not testtype(f,Type::Arithmetical) and domtype(f) <> DOM_PROC)
           or not testtype(r,Type::Equation(DOM_IDENT,Type::Arithmetical..Type::Arithmetical))
        then
            error("call: 'simpson(f(x), x=a...b, n)'")
        elif not testtype(n,Type::PosInt) or n mod 2 <> 0 then
            error("3rd argument: must have an even number of intervals")
        end_if
    end_if;

    x:= op(r,1);
    a := op(r,[2,1]);
    b := op(r,[2,2]);
    h := (b - a)/n;

    if domtype(f) <> DOM_PROC then
        if has(f,x) then
            F:= X -> eval(subs(f,x=X))
        else
            F:= X -> f
        end_if
    elif op(f,1) = x then
        F:= f
    else
        error("variables don't match")
    end_if;

    i:= genident("i");
    Sum:= proc(f,r) 
        local a,b;
    begin
        a:= op(r,[2,1]);
        b:= op(r,[2,2]);
        if testtype(a,Type::Real) and testtype(b,Type::Real) and a > b then 
            return( 0 )
        elif a = b then
            return( eval(subs(f,op(r,1)=a)) )
        else
            return(freeze(sum)(f,r))
        end_if
    end_proc:

    return(h/3*(
        F(a) + F(b) + 4*Sum(F(a + (2*i - 1)*h), i = 1 .. 1/2*n)
        + 2*Sum(F(a + 2*i*h), i = 1 .. 1/2*n - 1)
    ))
end_proc:

