/****** TESTFILE FOR THE CT-TESTSUITE ******/
// frankp

prog::testinit("CTTest"):
prog::testfunc(Any):

// I. Linear Algebra
// -----------------

// I.1
MS:= Dom::SquareMatrix( 30,Dom::Rational ):
prog::testfunc( MS::_invert ):
H:=MS( (i,j)->(1/(i+j-1)) ):
iH:= H^(-1):
prog::test( iH[30,30],53338390370510951379337308012614400 ):
print("total time I.1", time()):

//-----------------------------------

// I.2
prog::testfunc( linalg::eigenvalues ):
MExpr:= Dom::Matrix( Dom::ExpressionField(normal) ):
A:= MExpr( [[a,1,0],[1,1,1],[1,1,2]] ):
prog::test(
    traperror(linalg::eigenvalues( A )),0
):
print("total time I.2", time()):

//-----------------------------------


// II. Simplify Expressions
// ------------------------

// II.1
prog::testfunc( radsimp ):
prog::test(radsimp( sqrt( 9+4*sqrt(5) ) ), 5^(1/2)+2):
print("total time II.1", time()):

//-----------------------------------

// II.2
e:= (sin(2*x) - sin(x)*cos(x))/(cos(x)*(1+tan(x)^2)):
prog::testfunc( combine ):
prog::test(
    combine( normal(expand(e)), sincos ),sin(x)/4+sin(3*x)/4
):
print("total time II.2", time()):

//-----------------------------------

// II.3
prog::testfunc( simplify ):
prog::test(
    simplify( (exp(x) - 1)/(exp(x/2)+1),exp ),exp(x/2)-1
):
print("total time II.3", time()):

//-----------------------------------


// III. Solve Equations
// --------------------

prog::testfunc( solve ):

// III.1 
S:= solve( x^4 + a*x^2 + 1 = 0, x):
prog::test( has(S,sqrt(2)*(-a+(a^2-4)^(1/2))^(1/2)/2) ):
print("total time III.1", time()):

//-----------------------------------

// III.2
S:= solve( 2*sin(x) + 5*cos(x) = 3, x ):
prog::test( nops(S),2 ):
print("total time III.2", time()):

//-----------------------------------

// III.3
S:= solve( exp(2*x) + exp(x) - 1 = 0, x ):
prog::test(  nops(S),2 ):
print("total time III.3", time()):

//-----------------------------------

// III.4
equations := {x*y^2+2*c+x*z=1, x*y-x^2+2*z=0, x*y-z=0}:
T:= solve( {x*y^2+2*c+x*z=1, x*y-x^2+2*z=0, x*y-z=0}, {x,y,z} ):
assume(c <> 1/2):
S := simplify(T):
prog::test(( 
 {map(subs(op(equations), op(op(S,i))), 
      bool@((x) -> map(x, expand@simplify@radsimp@normal))) $ i = 1.. nops(S)}
), {TRUE}
):
// sollte fuer c = 1/2 auch was sinnvolles geben, hat aber 2*c-1 im Nenner!
// (jngerhar, 24.11.00)
delete equations, c, S, T:
print("total time III.4", time()):

//-----------------------------------


// IV. Series and Summations 
// --------------------------- 

// IV.1
prog::testfunc( series ):
S:= series( cosh(x)/sinh(x)-1/x,x,5 ):
prog::test( expr(S),x/3 ):
print("total time IV.1", time()):

//-----------------------------------

// IV.2
// Unable to do

// IV.3 
prog::testfunc( sum ):
assume(a > 0):
S:= normal(simplify(sum(1/(k^2+a^2), k=1..infinity))):
prog::test( S,a^(-1)*(psi(a*(- I) + 1)*I + psi(a*I + 1)*(- I))*1/2 ):
delete a:
print("total time IV.3", time()):

// V. Limit Computation and Differentation
// --------------------------------------- 

// V.1
prog::testfunc( limit ):
assume(b>0):
prog::test(
    limit( arcsinh((u+a)/b) - arcsinh((u-a)/b), u=infinity ),0
):
unassume(b):
print("total time V.1", time()):

//-----------------------------------

// V.2
prog::test(
    limit( exp(1/x^2)/(exp(1/x^2)+exp(1/x^4)), x=0),0
):
print("total time V.2", time()):

//-----------------------------------

// V.3
prog::testfunc( diff ):
S:= diff(
  (-1/5*x^2 + 1/5*x^2*tan(1/2*ln(x))^2 +
  4/5*x^2*tan(1/2*ln(x))) / (1 + tan(1/2*ln(x))^2)
,x):
prog::test( has(S,tan(ln(x)/2)) ):
print("total time V.3", time()):

//-----------------------------------

// V.4
// Unable to do


// VI. Integration
// ---------------

prog::testfunc( int ):

// VI.1 
S:= int( (2*x^4 + 1)/((x^5+x)*sqrt(x^4+1)), x):
prog::test( type(S),"int" ):
print("total time VI.1", time()):

//-----------------------------------

// VI.2
S:= int( exp(-x)*sin(x)*cos(x),x ):
prog::test( S,-cos(2*x)/5/exp(x) - sin(2*x)/10/exp(x) ):
print("total time VI.2", time()):

//-----------------------------------

// VI.3 
S:= int( x^3/(exp(x)+1), x=0..infinity ):
prog::test( S,7*PI^4/120 ):
print("total time VI.3", time()):

//-----------------------------------

// VI.4 
S:= int( ln(x)^2/sqrt(1-x^2), x=0..1 ):
prog::test( S,PI^3/24+PI*ln(2)^2/2 ):
print("total time VI.4", time()):

//-----------------------------------


// VII. Laplace and Fourier Transformation 
// --------------------------------------- 

// VII.1
prog::testfunc( transform::laplace ):
S:= transform::laplace( sin(t), t, s ):
prog::test( S,1/(s^2+1) ):
print("total time VII.1", time()):

//-----------------------------------

// VII.2
prog::testfunc( transform::invlaplace ):
prog::test( transform::invlaplace( S, s, t ),sin(t) ):
print("total time VII.2", time()):

//-----------------------------------

// VII.3
prog::testfunc( transform::laplace ):
S:= transform::laplace( heaviside(t-2) * sin(t), t, s ):
prog::test( expand(S-exp(-2*s)*(cos(2)/(s^2+1)+s*sin(2)/(s^2+1))), 0):
print("total time VII.3", time()):

//-----------------------------------

// VII.4
prog::testfunc( transform::invlaplace ):
S:= transform::invlaplace( S,s,t ):
prog::test( combine(S,sincos),heaviside(t-2) * sin(t) ):
print("total time VII.4", time()):

//-----------------------------------

// VII.5 
prog::testfunc( transform::fourier ):
S:= transform::fourier( exp(-t^2),t,x ):
prog::test( S,PI^(1/2)*exp(-x^2/4) ):
print("total time VII.5", time()):

//-----------------------------------

// VII.6
prog::testfunc( transform::invfourier ):
S:= transform::invfourier( exp(-t^2),t,x ):
prog::test( S,exp(-x^2/4)/2/PI^(1/2) ):
print("total time VII.6", time()):

//-----------------------------------


// VIII. Differential Equations
// ---------------------------- 
prog::testfunc( ode::solve ):

// VIII.1 
prog::test(
    (S:= solve( ode( x^2*diff(y(x),x)-x*y(x)=x*ln(x),y(x) ));
   {(Y := op(S, i); 
    bool(normal(x^2*diff(Y,x)-x*Y = x*ln(x)))) $ i = 1..nops(S)}),
   {TRUE}
):
print("total time VIII.1", time()):

//-----------------------------------

// VIII.2 
prog::test(
  (S:=solve( ode(diff(y(x),x) - y(x)^2 - 3*y(x) + 4 = 0, y(x)) );
   {(Y := op(S, i); bool(normal(diff(Y,x)-Y^2-3*Y+4 = 0))) $ i = 1..nops(S)}),
   {TRUE}
):
print("total time VIII.2", time()):

//-----------------------------------

// VIII.3 
prog::test(
  (S:=solve( ode( diff(y(x),x$2) - 4*y(x) = sin(x), y(x)) );
   {(Y := op(S, i); bool(normal(diff(Y,x$2)-4*Y = sin(x)))) $ i = 1..nops(S)}),
   {TRUE}
):
print("total time VIII.3", time()):

//-----------------------------------

// VIII.4 
prog::test(
    (S:= solve( ode(
        diff(y(x),x$2) - 2/x*diff(y(x),x) + 3/x^2*y(x) = 2*x - 1, y(x)
              ) );
     {(Y := op(S, i); 
       bool(map(normal(diff(Y,x$2)-2/x*diff(Y,x)+3/x^2*Y=2*x-1), expand))) 
       $ i = 1..nops(S)}),
     {TRUE}
):
prog::test( has(S,x^3) ):
prog::test( has(S,x^(3/2)) ):
prog::test( has(S,cos(ln(x)*3^(1/2)/2)) ):
prog::test( has(S,sin(ln(x)*3^(1/2)/2)) ):
print("total time VIII.4", time()):

//-----------------------------------
//--------------------------------------------------------------

/* Auskommentiert, da der Test derzeit nicht terminiert, und nach
   CTTestBug.tst verschoben (jngerhar, 24.11.00)
// VIII.5 
// alle 7 gef. Loesungen scheinen korrekt zu sein
// unklar, ob es mehr gibt !?
prog::test(nops(
    (S:= solve( ode( 8*diff(y(x),x$2) + 9*diff(y(x),x)^4 = 0, y(x) ) ))
),7):
// ist ja wohl kein Qualitaetskriterium:
// prog::test( has(S,solve) ):
print("total time VIII.5", time()):
*/

//-----------------------------------

// VIII.6

// ich liebe derart intelligente Tests!!!!
//prog::test( has((S:=
//    solve( ode(
//        4*diff(y(x),x$4) - 12*diff(y(x),x$3) +
//        11*diff(y(x),x$2) - 3*diff(y(x),x) = 4*cos(x), y(x)
//    ) )
//),18*sin(x)/65) ):
//prog::test( has(S,-14*cos(x)/65) ):
//prog::test( has(S,exp(x)) ):

prog::test( (S:=solve( ode(4*diff(y(x),x$4) - 12*diff(y(x),x$3) +
             11*diff(y(x),x$2) - 3*diff(y(x),x) = 4*cos(x), y(x)) );
            simplify(eval(subs(4*diff(y(x),x$4) - 12*diff(y(x),x$3) +
                               11*diff(y(x),x$2) - 3*diff(y(x),x)-4*cos(x),
                               y(x)=op(S))));)
            ,0 ):

print("total time VIII.6", time()):

//-----------------------------------

// VIII.7

// bei diesen Tests moechte ich am liebsten gleich zum mittag essen gehen
// und versuchen das was ich gesehen habe zu vergessen!!!!
//prog::test( nops(op(
//    (S:= solve( ode(
//        {diff(x(t),t) - x(t) + diff(y(t),t) + 2*y(t) = 1+exp(t),
//        diff(y(t),t) + 2*y(t) + diff(z(t),t) + z(t) = 2+exp(t),
//        diff(x(t),t) - x(t) + diff(z(t),t) + z(t) = 3+exp(t)},
//    {x(t), y(t), z(t)}) ))
//)),3 ):
//prog::test( has(S,exp(t)) ):

prog::test(
           (S:= solve( ode(
            {diff(x(t),t) - x(t) + diff(y(t),t) + 2*y(t) = 1+exp(t),
             diff(y(t),t) + 2*y(t) + diff(z(t),t) + z(t) = 2+exp(t),
             diff(x(t),t) - x(t) + diff(z(t),t) + z(t) = 3+exp(t)},
            {x(t), y(t), z(t)}) );
            S:=eval(subs({diff(x(t),t)-x(t) + diff(y(t),t) + 2*y(t) = 1+exp(t),
                          diff(y(t),t)+2*y(t) + diff(z(t),t) + z(t) = 2+exp(t),
                          diff(x(t),t)-x(t) + diff(z(t),t) + z(t) = 3+exp(t)},
                         op(S)));
            map(map(S,e->lhs(e)-rhs(e)),simplify))
           ,{0} ):

print("total time VIII.7", time()):

//-----------------------------------

// END OF TESTFILE
prog::testexit():
