// Testfile for calls which are necessary for correct and stable
// integration and solving ode's
//
// Author: Winfried Fakler
// Date:        23 September 1999
// Last Update: 22 November  2000

setuserinfo(prog::test,0):

// as a first version some calls are performed outside prog::test, since
// in that case I do not have a plan to do it with it.

prog::testinit("Fakler"):

// ------------------------------------------------------------
// 1. Simplify
// ------------------------------------------------------------
prog::testfunc(simplify ):
print("-------------testing simplify-------------"):

prog::test(simplify(cos(x+PI)),-cos(x), "Simplify 1"):
prog::test(simplify(ln(infinity)), infinity, "Simplify 2"):
prog::test(simplify(exp(infinity)), infinity, "Simplify 3"):

// ------------------------------------------------------------
// 2. Solvelib
// ------------------------------------------------------------
prog::testfunc(solve):
print("-------------testing solve-------------"):

//-------------------------------

// auskommentiert: man darf sich nie darauf verlassen,
// dass solve einen bestimmten typ liefert. Stefan
// ... man sollte sich auf solve gar nicht verlassen und stattdessen
// maple verwenden!!!! :-(((  WF
// ... aber was vernuenftiges & brauchbares sollte es doch liefern!!!!!!!!
// durch das auskommentieren willst Du vertuschen, dass solve fast keine
// heuristischen Methoden enthaelt. Doch gerade die sind fuer ode's
// wichtig!!
prog::test((
            s:=solve(z*(-1) + C1*exp(ln(v1)*(-2/3) +v1^(-3)*(-1/9)), v1);
            if type(s)="solve" or domtype(s)=DOM_SET or domtype(s)=piecewise
              then TRUE
            else FALSE
            end_if;
            ),TRUE, "SolveTest 1" ): 

//-------------------------------

prog::test((
            s:=solve(X*(-2) + X^2*(-1) + (-1),X, Multiple);
            [expand(s)];
            ), [-1,-1], "SolveTest 2 - Multiple"):

//-------------------------------

prog::test((
            assume(z,Type::Real);
            assume(a<>0);  // sonst ist das geforderte a^(-2) ja Unsinn. Stefan
                           // ehrlich? dann erzaehle mir mal wie denn ein
                           // Programm das eben diese Zwischenergebnisse hat
                           // so etwas sebstaendig annehmen soll?  WF 
            solve(b*z + Y^(1/2)*a, Y);
            ), {a^(-2)*b^2*z^2}, "SolveTest 3 - Properties-------------"):

//-------------------------------

prog::test((
            s:=solve(u^(-2)*(-1/2) = y*(-9/8) + C20,u);
            if type(s)="solve" or domtype(s)=DOM_SET or domtype(s)=piecewise
              then TRUE
            else FALSE
            end_if;
            ),TRUE, "SolveTest 4" ):

//-------------------------------

prog::test((
            s:=solve((C4*(-8)+y*9)^(3/2)*(-1/27)=C6+z, y);
            if type(s)="solve" or domtype(s)=DOM_SET or domtype(s)=piecewise
              then TRUE
            else FALSE
            end_if;
            ),TRUE, "SolveTest 5" ):

//-------------------------------

prog::test((
            s:=NIL;
            err:=traperror(
              (s:=solve(y*(y*9+C20*(-8))^(1/2)*1/3+C20*(y*9+C20*(-8))^(1/2)
                     *(-8/27)=z+C22,y);
              ),240);
            if err<>0 then error("solve an Zeitlimit gescheitert!!!") end_if;
            if type(s)="solve" or domtype(s)=DOM_SET or domtype(s)=piecewise
              then TRUE
            else FALSE
            end_if;
            ),TRUE, "SolveTest 6" ):

//-------------------------------

prog::test(( // maple returns:
             // 3/2 LambertW(2/3 exp(1/3 x - 1/3 C1 - 4/3)) - x + 2
            s:=solve(2*y + 3*ln(x + y - 2) = - C1 - x, y);
            if type(s)="solve" 
              then FALSE
            else TRUE
            end_if;
            ),TRUE, "SolveTest 7",Quiet ):

//-------------------------------

prog::test((
            s:=solve({(C11 + 2/5)^(-1/2) = 1},{C11});
            ),{[C11 = 3/5]}, "SolveTest 8" ):


//-------------------------------
// The following solve command does not seem to produce
// a result in finite time (?). I put it in comments for
// the remaining tests to go through. Walter

//prog::test(TRUE, FALSE, "check the following solve!", Quiet):

prog::test((
            s:=NIL;
            err:=traperror(
              (s:=solve(16*y^2*p17-16*y*p13+8*y^4*p13*p17-32*y^3*p13^2
                       -75*y^5*p13^3-8*p13*(16*y^2+16*y^4*p13+
                                          25*y^6*p13^2)^(1/2)
                       +4*y*p17*(16*y^2+16*y^4*p13+25*y^6*p13^2)^(1/2)
                       -15*y^2*p13^2*(16*y^2+16*y^4*p13+25*y^6*p13^2)^(1/2),y);
              ),240);
            if err<>0 then error("solve an Zeitlimit gescheitert!!!") end_if;
            if hastype(s,"RootOf") then TRUE else FALSE end_if;
            ),TRUE, "SolveTest 9" ):

//-------------------------------

prog::test((
            s:=NIL;
            err:=traperror(
              (s:=solve(1/3*y*(9*y - 8*C26)^(1/2) - 8/27*C26*(9*y 
                        - 8*C26)^(1/2) = z + C28, y, MaxDegree = 1);
              ),240);
            if err<>0 then error("solve an Zeitlimit gescheitert!!!") end_if;
            if s<>NIL and type(s)<>"solve" then TRUE else FALSE end_if;
            ),TRUE, "SolveTest 10" ):

//-------------------------------------------------------------
// 3.  discont
//-------------------------------------------------------------
prog::testfunc(discont):
print("-------------testing discont-------------"):

prog::test((
            r:=discont(_X_^(-2)*(_X_*(-1) + (-1/2)), _X_ = 1..infinity);
            if map(r, e->bool(1<=e and e<=infinity)) union {TRUE} = {TRUE}
              then TRUE
            else FALSE
            end_if;
            ),TRUE, "discont 1" ):

//-------------------------------

 prog::test((
             r:=discont(ln(sin(_X_)*(-2)+2)*(-1/2)+ln(sin(_X_)*2+2)*1/2,
                        _X_=0..PI*1/4);
             if domtype(r)=DOM_SET and
               map(r, e->is(0<=e) and is(e<=PI*1/4)) union {TRUE} = {TRUE}
               then TRUE
             else FALSE // discont ist entweder zu schlecht oder hat den
                        // range nicht beachtet
             end_if;
            ),TRUE, "discont 2" ):

//-------------------------------

// liefert einen bug 21.11.2000	    	    
//assume(x,Type::Interval([-1,1])):
//err:=traperror(discont(x*(2*sign(y-a-x^2)-2*a*sign(y-a-x^2))-
//                       2/3*x^3*sign(y-a-x^2),
//                       x=-1..1, Dom::Real)):
//if err<>0 then error("Error: in assume(x,Type::Interval([-1,1])): ".
//                     "discont(x*(2*sign(y-a-x^2)-2*a*sign(y-a-x^2))-".
//                     "2/3*x^3*sign(y-a-x^2),x=-1..1, Dom::Real)")
//end_if;
//delete x:
 
prog::test((
            assume(x,Type::Interval([-1,1]));
            r:=discont(x*(2*sign(y-a-x^2)-2*a*sign(y-a-x^2))-
                       2/3*x^3*sign(y-a-x^2),
                       x=-1..1, Dom::Real);
            delete x;
            if domtype(r)=DOM_SET or domtype(r)=piecewise then TRUE
            else FALSE
            end_if;
           ),TRUE, "discont 3  a test with properties" ):
           
//-------------------------------------------------------------
// 4.  transform
//-------------------------------------------------------------

prog::testfunc(transform):
print("-------------testing transform::laplace-------------"):

prog::test((
            r:=transform::laplace(x*diff(y(x),x)=0,x,s);
            if type(r)="_equal" then TRUE else FALSE end_if;
           ), TRUE, "Transform 1"):

//-------------------------------------------------------------
// 5.  limit
//-------------------------------------------------------------
// folgender Test ist zusaetzlich in STDLIB/TEST/limit.tst eingetragen
// (Walter 5.5.2000)
prog::testfunc(limit):
print("-------------testing limit-------------"):

prog::test(limit((exp(k)+exp(k)*ln(2)*(-2)+PI^2*exp(k)+
	          exp(k)*ln(2)^2)^(-1)*(cos(k*PI)*2^k*(-1)+
	          PI*sin(k*PI)*2^k+cos(k*PI)*2^k*ln(2)),k=infinity),
           0,
           "Limit 1"):

//-------------------------------------------------------------

prog::test(limit(-1/3*igamma(1/3,x)-x^(1/3)*exp(-x),x=infinity),
           0, // ????
           "Limit 2"):

prog::testexit():






