// Dirk Mueller, olorien, 30/10/96, v1.0 

alias( IntTrans = transform::IntTrans ):

_mult:=slot(_mult, "transform::laplace", 
proc(_fu, var1, var2) 
    local ana, ana_args, L, rat, nonrat, nonrat_types, m, i, j, k, match_set, match_list, 
         _g, test, trafo, _c, pos, L2, the_end, _n, this_op,
         Num, Den, _lin, Num_sp, Den_sp, Den_L, Den_code, Num_code,
         rat_code, nonrat_code, rat_pat, nonrat_pat, Den_nmb, Num_pat,
         _a, _b, _d, erg1, erg2;
begin

  Num:=numer(_fu); Den:=denom(_fu); 
    if type(Num)="_mult" then
      _lin:=select(Num, not has, var1);
      Num:=Num/_lin;
    elif not has(Num, var1) then
      _lin:=Num; Num:=1;
    else
      _lin:=1;
    end_if;

  Num_sp:=[IntTrans::mult_split(Num, var1)];
  Den_sp:=[IntTrans::mult_split(Den, var1)];

  if Num_sp[1]=1 and Den_sp[2]=1 then // NonRat / Rat 

    if Den<>1 then 
      Den_L:=IntTrans::anapol(Den, var1);
      if Den_L = FAIL then return(FAIL) end_if;
      Den_code:={op(Den_L[1])}; Den_nmb:=nops(Den_L[1]);
      Num_code:=IntTrans::nonrat_ana(Num, var1);
      if Num_code = FAIL then return(FAIL) end_if;
      Num_pat:=[Num_code[1], Num_code[2], Num_code[3]];

      case Den_code
      of {[1, 2]} do

        case Num_pat
        of ["_mult", ["exp"], [1]] do
          _a:=op(Num)/var1;
          if not has(_a, var1) then
            userinfo(10, "formula 62 from Heuser");
            return(  -_lin*(ln(-_a+var2))   );
          end_if;
          break;

        of ["_plus", ["cos", "RAT"], [1, 1]] do
          if Num_code[4][2]=1 then
            _a:=Num_code[4][1]/var1;
            if not has(_a, var1) then
              userinfo(10, "formula 5.31 from R&K");
              return( 1/2*ln(var2^2+_a^2)-ln(var2)  );
            end_if;
          end_if;
          break;

        end_case; // [Num_code] 
        break;
       
      end_case: // Den_code 
    else

      Num_code:=IntTrans::nonrat_ana(Num, var1);
      if Num_code = FAIL then return(FAIL) end_if;

      Num_pat:=[Num_code[1], Num_code[2], Num_code[3]];

      case Num_pat
      of ["_mult", ["Ei", "exp"], [1, 1]] do
        _c:=Num_code[4][1]/var1;

        if not has(_c, var1) then
          if testtype(Num_code[4][2], Type::RatExpr(var1)) then
            ana:=IntTrans::anapol(op(op(Num,2)),var1);
            if ana = FAIL then return(FAIL) end_if;
            case ana[1][1]
            of [1,3] do
              _a:=ana[2][1][2]; _b:=ana[2][1][1];
              userinfo(10, "formula from frankp");
              return( exp(_b)*ln((var2+_c-_a)/_c)/(var2-_a)  );
            end_case;
          end_if;
        end_if;
      end_case; // Num_code 
     
    end_if;

  elif Den=1 then
    rat_code:=IntTrans::anapol(Num_sp[1], var1);
    if rat_code = FAIL then return(FAIL) end_if;
    nonrat_code:=IntTrans::nonrat_ana(Num_sp[2], var1);
    if domtype(nonrat_code) <> DOM_LIST
       or nops(nonrat_code) < 3 then 
       return(FAIL)
    end_if;

    nonrat_pat:=[nonrat_code[1], nonrat_code[2], nonrat_code[3]];

    if nonrat_pat=["_mult", ["exp"], [1] ] then 
      this_op:=nonrat_code[4][1];
      if testtype(this_op, Type::RatExpr(var1) ) then
        _c:=-this_op*var1;
        if not has( _c, var1) then
          if rat_code[1][1][2]=2 then 
            _n:=rat_code[3][1][1];
            userinfo(10, "formula from frankp");
            return( 2*besselK(_n+1,2*sqrt(_c*var2))*(_c/var2)^(_n/2+1/2)  );
          end_if;
        end_if;
      end_if;
    end_if;
  end_if;

  ana:=[IntTrans::mult_split(_fu, var1)];

  rat:=ana[1]; nonrat:=ana[2]; 
  match_list:=["heaviside", "exp", "sinh", "cosh", "sin", "cos"];

  test:=IntTrans::anapol(rat, var1);
  if test = FAIL then return(FAIL) end_if;

  if test[1][1][2]=2 then

    //--------------------------------------------------------------
    // Walter, 27.11.00:
    // I assume that this is the case laplace(x^n*nonrat(x), x, s).
    // However, the matcher seems to be bugg. With
    // laplace(x^2*(x-1),x,s) we end up here with rat=x^2*(x-1)
    // and nonrat = 1. So, as a crude hack, I expand rat
    // and return the transform term by term:
    if type(expand(rat))="_plus" then
       rat:= expand(rat);
       return(
         _plus(transform::laplace(op(rat, k)*nonrat, var1, var2)
                $ k = 1..nops(rat)
              )
             );
    end_if;
    if type(rat) = "_mult" then // e.g., for rat = x*x^a
       return(FAIL)
    end_if;

    // now, I can assume rat = var1^(_n)
    //--------------------------------------------------------------

    _n:=test[3][1][1];
    if is(_n>0)=TRUE then
      trafo:=(transform::laplace)(nonrat, var1, var2);
      userinfo(10, "power modulation");
      if not hastype(trafo, "transform::laplace")
        then
          // if domtype(_n) = DOM_INT inserted (Walter, 27.11.00)
          // Before, transform::laplace(x^(3/2)*(x-1), x, s) arrived
          // here with _n = 3/2 and produced an error in k=1.._n
          // This is just a crude hack to prevent wrong results!
          // The symbolic answer transform::laplace(x^(3/2)*(x-1), x, s)
          // that we get now is not satisfactory!
          if domtype(_n) = DOM_INT then 
             return( (-1)^_n*diff(trafo, var2 $ k=1.._n) );
          end_if;
      end_if;
/*
    elif is(_n<0) then
      return(FAIL);
*/
    end_if;
  end_if;

  if type(nonrat)<>"_mult" then
    nonrat_types:=[type(nonrat)];
  else
    nonrat_types:=[map(op(nonrat), type)];
  end_if;

  m:=nops(nonrat_types);

  for i from 1 to nops(match_list) do
    pos:=0: 
    L2:=[ (pos:=contains(nonrat_types, match_list[i], pos+1)) 
                $ k=1..nops(nonrat_types),0  ];

    the_end:=contains(L2, 0);

    for j from 1 to the_end-1 do
     if type(nonrat)="_mult" then
       test:=op(op(nonrat, L2[j]));
     else
       test:=op(nonrat);
     end_if;

      if testtype(test, Type::RatExpr(var1)) then
        ana_args:=IntTrans::anapol(test, var1);
        if ana_args = FAIL then return(FAIL) end_if;
        _c:=ana_args[2][1][2];

        if m=1 then
          _g:=rat;
        else
          _g:=subsop(nonrat, L2[j]=1)*rat;
        end_if;

        if ana_args[1][1]=[1,2] then

          case nonrat_types[L2[j]] 
          of "exp" do
            userinfo(10, "exp-modulation");
            return((transform::laplace)(_g, var1, var2-_c));

          of "sin" do
            trafo:=(transform::laplace)(_g, var1, var2); 
            userinfo(10, "sin-modulation");
            return( 1/(2*I)*(subsex(trafo, var2=var2-I*_c)-
                             subsex(trafo, var2=var2+I*_c)));

          of "cos" do
             trafo:=(transform::laplace)(_g, var1, var2);
             userinfo(10, "cos-modulation");
             return( 1/2*(subsex(trafo, var2=var2-I*_c)+
                          subsex(trafo, var2=var2+I*_c)));

          of "sinh" do
            trafo:=(transform::laplace)(_g, var1, var2);
            userinfo(10, "sinh-modulation");
            return( 1/2*(subsex(trafo, var2=var2-_c)-
                         subsex(trafo, var2=var2+_c)));

          of "cosh" do
            trafo:=(transform::laplace)(_g, var1, var2); 
            userinfo(10, "cosh-modulation");
            return( 1/2*((transform::laplace)(_g, var1, var2-_c)+
                    (transform::laplace)(_g, var1, var2+_c))
                  );

          of "heaviside" do
            erg1:=is(_c>0);
            if erg1=FALSE then
              userinfo(10, "heaviside modulation, case 1");
              return(0)
            elif erg1=TRUE then
              userinfo(10, "heaviside modulation, case 2");
              return( (transform::laplace)(_g, var1, var2) )
            end_if;
            break;

          end_case;
        elif ana_args[1][1]=[1,3] then
          _d:=ana_args[2][1][1];
          case nonrat_types[L2[j]]
          of "heaviside" do
            erg1:=is(_c>0); erg2:=is(_d>0);
            if erg1=TRUE and erg2=TRUE then
              userinfo(10, "heaviside-modulation, case 3");
              return((transform::laplace)(_g, var1, var2));

            elif erg1=TRUE and erg2=FALSE then
              userinfo(10, "heaviside modulation, case 4");
              return(  exp(_d/_c*var2)*(transform::laplace)
                          (subs(_g,var1=var1-_d/_c), var1, var2));
            elif erg1=FALSE and erg2=TRUE then
              userinfo(10, "heaviside modulation, case 5");
              return(  int(exp(-var2*var1)*_g, var1=0..-_d/_c));
            elif erg1=FALSE and erg2=FALSE then
              userinfo(10, "heaviside modulation, case 6");
              return(0);
            end_if;
            break;
            userinfo(10, "heaviside-modulation");

            return((transform::laplace)(_g, var1, var2-_c));
          end_case;
        end_if;

      end_if;
    end_for;
  end_for;

 
  return(FAIL);

end_proc):

unalias( IntTrans ):

// end of file 
