// $Date: 2000/04/17 07:37:31 $  $Author: frankp $  $Revision: 1.10 $


/*

Arithmetical -- the type of all arithmetical expressions
without equations/inequations

*/

Type::Arithmetical:= new(Type, "Arithmetical",
    proc(t,x)
      option noDebug;
    begin
      if args(0) <> 2 then return(FALSE) end_if;

      case domtype(x)
      of DOM_EXPR do
           if contains({"_equal", "_less", "_leequal",
                    "_and", "_or", "_not", "_exprseq",
                    "_intersect", "_union", "_minus",
                    "_assign", "_range",
                    "_break", "_case", "_for", "_for_down",
                    "_for_in", "_if", "_next", "_repeat", "_unequal",
                    "_stmtseq", "_seqbegin", "_while"}, type(x)) 
		    then
                return(FALSE)
            end_if;
      of DOM_IDENT        do
      of DOM_INT          do
      of DOM_COMPLEX      do
      of DOM_FLOAT        do
      of DOM_RAT          do 
      of stdlib::Infinity do
      of undefined        do
      of rectform         do
      of O                do
      of Series::gseries  do
      of Series::Puiseux  do 
          return(TRUE)

      of piecewise        do
      of DOM_POLY         do                   
      of DOM_STRING       do
      of DOM_BOOL         do
      of DOM_POINT        do
      of DOM_POLYGON      do
      of DOM_NIL          do
      of DOM_NULL         do
      of DOM_FAIL         do
      of DOM_ARRAY        do
      of DOM_LIST         do
      of DOM_SET          do
      of DOM_TABLE        do
      of DOM_FUNC_ENV     do
      of DOM_EXEC         do
      of DOM_PROC         do
      of DOM_DOMAIN       do
          return(FALSE)
      otherwise
          if domtype(domtype(x)) = DOM_DOMAIN then
              // treat domain objects as arithmetical operands:
              return( TRUE )
	  else
	      return( FAIL )
	  end_if
      end_case
end_proc, FALSE, FALSE):

// end of file

