#ifndef __MCL_context_h__
#define __MCL_context_h__

MTR_DECL_LITERAL(MCLV_id_ClientObject)

/// Initialize client context module.
void MCL_init();

/// Reset context module on reset(). Must be called twice!
void MCL_reset(bool re_init);

/// Exit client context module.
void MCL_exit();

/** Create new client context given a namespace.
 * The namespace is created if it does not exist yet.
 * Returns the index of the new client context. */
long MCL_new_context(const char* namesp);

/// Delete client context given its index.
void MCL_delete_context(long ctx_id);

/// Makes a client context the actual one or de-activates it.
void MCL_activate_context(long ctx_id, bool activate);

/** Returns the main client object of a named client or the actual client. */
S_Pointer MCL_eval_client_object(S_Pointer, long, long, S_Pointer);

/** Calls an callback function of a client. */
S_Pointer MCL_eval_client_call(S_Pointer, long, long, S_Pointer);

#endif // __MCL_context_h__

