/* $Date: 2000/10/13 13:32:29 $  $Author: andi $  $Revision: 1.9 $ */

/**************************************************************************/
/* FILE   : MFO_open.h                                                    */
/* AUTHOR : Klaus Gottheil                                                */
/* CREATED: 30/11/92                                                      */
/* CHANGED: 15/06/94                                                      */
/**************************************************************************/

#ifndef __MFO_open__
#define __MFO_open__

#include "MCT_iostream.h"

/**************************************************************************/
/* Headerfile fuer die Routinen zum Oeffnen von Files                     */
/**************************************************************************/

#define MFOC_ERROR    0

#define MFOC_READ     1    /* Modus fuer File-Operationen */
#define MFOC_WRITE    2
#define MFOC_APPEND   3

#define MFOC_TEXT     1    /* File-Typen */
#define MFOC_BIN      2
#define MFOC_PLOT     4
#define MFOC_UNKNOWN  8
#define MFOC_CODE    16

/* Magic Number zur Erkennung von M-Code Bianaer-Dateien. */

#define MFOC_BIN_MAGIC_1 '\003'
#define MFOC_BIN_MAGIC_2 '\001'
#define MFOC_BIN_MAGIC_3 '\001'
#define MFOC_BIN_MAGIC_4 '\001'

/* Magic Number zur Erkennung von M-Code Plot-Dateien. */

#define MFOC_PLOT_MAGIC_1 '\003'
#define MFOC_PLOT_MAGIC_2 '\002'
#define MFOC_PLOT_MAGIC_3 '\002'
#define MFOC_PLOT_MAGIC_4 '\001'

/* Magic Number zur Erkennung von verschluesselten Text-Dateien. */

#define MFOC_CODE_MAGIC_1 '\003'
#define MFOC_CODE_MAGIC_2 '\003'
#define MFOC_CODE_MAGIC_3 '\001'
#define MFOC_CODE_MAGIC_4 '\001'


class MPAT_stream_parser;

/* Die mit fopen geoeffneten Files werden im ass. Speicher MFOV_OPEN_FILES
 * gespeichert. Die Werte der Eintraege in MFOV_OPEN_FILES sind S-Zeiger
 * vom Typ MMM_TMP, deren Mem-Teil aus einer Struktur vom Typ MFOT_finfo
 * besteht und die weiter einen S-Zeiger auf einen String mit dem vollen
 * Pfadnamen des Files enthalten. Die Indizes der Eintraege sind positive
 * ganze Zahlen (File-Deskriptoren). */

typedef struct _MFOT_finfo {
    MCLT_iostream fp;           /* File-Pointer */
    long mode;                  /* Modus: read/write/append */
    long type;                  /* Typ: Text,Binaer */
    MPAT_stream_parser* parser; /* Parser fuer finput bei Text-Files */
} MFOT_finfo;


void        MFO_create_file_name( char* buff, 
                                  const char* path, const char* file );

const char* MFO_get_file_name( const char* path );

void        MFO_compress_dir_name( char* buff, const char* file );

bool        MFO_file_exist ( const char *name );

void        MFO_get_dir_name( char* buff, const char* file );

bool        MFO_open_read( S_Pointer name, S_Pointer *path,
                           MFOT_finfo *info );

bool        MFO_open_write( S_Pointer name, S_Pointer *path,
                            MFOT_finfo *info, long overwrite_dialog );

#endif /* __MFO_open__ */

