/*
 * File:        MGR_command.h
 *
 * Inhalt:      Diese Datei enth"alt die Deklarationen der Funktionen, die aus
 *              den Grafikdaten einen Befehlsspointer machen und an das Grafik-
 *              tool schicken. Diese Routinen waren zuvor in MGR_sys_func.c
 *              definiert.
 *
 * Autor:       Gudrun Oevel, Thorsten Schulze
 *
 * Datum:       27.09.1994
 */

#ifndef __MGR_command__
#define __MGR_command__


/*
 * globale Funktionen
 */

/** Removes every CAT_PROC S\_Pointer from a MMM\_SCENE\_2D or MMM\_SCENE\_3D
    object. 
    @param sp_scene   A MMM\_SCENE\_2D or MMM\_SCENE\_3D object which will 
                      be modified by this routine.
*/
void MGR_delete_proc_from_scene( S_Pointer *sp_scene) ;

/** Removes every CAT_PROC S\_Pointer from a MMM\_OBJECT\_2D or MMM\_OBJECT\_3D
    object. 
    @param sp_object  A MMM\_OBJECT\_2D or MMM\_OBJECT\_3D object which will 
                      be modified by this routine.
*/
void MGR_delete_proc_from_object( S_Pointer *sp_object) ;

void    MGR_calc_sp_command
           (   S_Pointer    *sp_command,
               S_Pointer    sp_graphic
           );

/** Sends the graphic command 'sp_command'. This means handling the graphic 
    object which is inside the graphic command 'sp_command', this can be
    saving the graphic in a file or sending the graphic to another application.
    @param sp_command  A MMM\_GRAPHIC\_COMMAND object which will contains the 
                       graphic and some information concerning the handling
                       of the graphic. Have a look at the implementation of the 
                       MGR\_send\_sp\_command to get more informations about
                       this.
    @return            {\bf false}  If one tries to plot a graphic inside a
                                    a terminal version.
                       {\bf true}   otherwise
                       
*/
bool    MGR_send_sp_command( S_Pointer sp_command );

#endif /* __MGR_command__ */
