/*
 * File:        MGR_global.h
 *
 * Inhalt:      Diese Datei enth"alt die Definition aller globalen Variablen
 *              die im MuPAD-Kern auf Grafikseite ben"otigt werden. Diese
 *              Variablen waren zuvor in MGR_sys_func.c definiert.
 *
 * Autor:       Gudrun Oevel, Thorsten Schulze
 *
 * Datum:       27.09.1994
 */

#ifndef __MGR_global__
#define __MGR_global__


/*
 * globale Variablen, hier nur noch die Deklaration. Die
 * Definition steht in MGR_sys_func.c, T.S..
 */

extern S_Pointer MGRV_SP_DEFAULTS;
extern bool      MGRV_MACHINE_FLOAT;

MTR_DECL_LITERAL(MSTR_Var1)
MTR_DECL_LITERAL(MSTR_Var2)
MTR_DECL_LITERAL(MSTR_XMin)
MTR_DECL_LITERAL(MSTR_XMax)
MTR_DECL_LITERAL(MSTR_YMin)
MTR_DECL_LITERAL(MSTR_YMax)
MTR_DECL_LITERAL(MSTR_ZMin)
MTR_DECL_LITERAL(MSTR_ZMax)
MTR_DECL_LITERAL(MSTR_PlotDevice)
MTR_DECL_LITERAL(MSTR_Screen)
MTR_DECL_LITERAL(MSTR_Title)
MTR_DECL_LITERAL(MSTR_TitlePosition)
MTR_DECL_LITERAL(MSTR_Below)
MTR_DECL_LITERAL(MSTR_Above)
MTR_DECL_LITERAL(MSTR_Axes)
MTR_DECL_LITERAL(MSTR_NoAxes)
MTR_DECL_LITERAL(MSTR_NormalAxes)
MTR_DECL_LITERAL(MSTR_FramedAxes)
MTR_DECL_LITERAL(MSTR_Boxed)
MTR_DECL_LITERAL(MSTR_Ticks)
MTR_DECL_LITERAL(MSTR_Arrows)
MTR_DECL_LITERAL(MSTR_Labels)
MTR_DECL_LITERAL(MSTR_Labeling)
MTR_DECL_LITERAL(MSTR_AxesOrigin)
MTR_DECL_LITERAL(MSTR_Scaling)
MTR_DECL_LITERAL(MSTR_Constrained)
MTR_DECL_LITERAL(MSTR_UnConstrained)
MTR_DECL_LITERAL(MSTR_ViewingBox)
MTR_DECL_LITERAL(MSTR_Automatic)
MTR_DECL_LITERAL(MSTR_Routine)
MTR_DECL_LITERAL(MSTR_Color)
MTR_DECL_LITERAL(MSTR_Colormap)
MTR_DECL_LITERAL(MSTR_CameraPoint)
MTR_DECL_LITERAL(MSTR_FocalPoint)
MTR_DECL_LITERAL(MSTR_Lighting)
MTR_DECL_LITERAL(MSTR_Ambient)
MTR_DECL_LITERAL(MSTR_Mode)
MTR_DECL_LITERAL(MSTR_Mode2d)
MTR_DECL_LITERAL(MSTR_Mode3d)
MTR_DECL_LITERAL(MSTR_Curve)
MTR_DECL_LITERAL(MSTR_Contour)
MTR_DECL_LITERAL(MSTR_Surface)
MTR_DECL_LITERAL(MSTR_List)
MTR_DECL_LITERAL(MSTR_Grid)
MTR_DECL_LITERAL(MSTR_Smoothness)
MTR_DECL_LITERAL(MSTR_TitleOrientation)
MTR_DECL_LITERAL(MSTR_Style)
MTR_DECL_LITERAL(MSTR_Horizontal)
MTR_DECL_LITERAL(MSTR_Vertical)
MTR_DECL_LITERAL(MSTR_Points)
MTR_DECL_LITERAL(MSTR_Lines)
MTR_DECL_LITERAL(MSTR_LinesPoints)
MTR_DECL_LITERAL(MSTR_Impulses)
MTR_DECL_LITERAL(MSTR_Bottom)
MTR_DECL_LITERAL(MSTR_Attached)
MTR_DECL_LITERAL(MSTR_WireFrame)
MTR_DECL_LITERAL(MSTR_Mesh)
MTR_DECL_LITERAL(MSTR_ULine)
MTR_DECL_LITERAL(MSTR_VLine)
MTR_DECL_LITERAL(MSTR_HiddenLine)
MTR_DECL_LITERAL(MSTR_ColorPatches)
MTR_DECL_LITERAL(MSTR_Only)
MTR_DECL_LITERAL(MSTR_AndMesh)
MTR_DECL_LITERAL(MSTR_AndULine)
MTR_DECL_LITERAL(MSTR_AndVLine)
MTR_DECL_LITERAL(MSTR_DepthCueing)
MTR_DECL_LITERAL(MSTR_Flat)
MTR_DECL_LITERAL(MSTR_Height)
MTR_DECL_LITERAL(MSTR_Physical)
MTR_DECL_LITERAL(MSTR_Indexed)
MTR_DECL_LITERAL(MSTR_Rgb)
MTR_DECL_LITERAL(MSTR_QuickDraw)
MTR_DECL_LITERAL(MSTR_QualityDraw)
MTR_DECL_LITERAL(MSTR_Implicit)
MTR_DECL_LITERAL(MSTR_Dimension)
MTR_DECL_LITERAL(MSTR_PointWidth)
MTR_DECL_LITERAL(MSTR_PointStyle)
MTR_DECL_LITERAL(MSTR_LineWidth)
MTR_DECL_LITERAL(MSTR_LineStyle)
MTR_DECL_LITERAL(MSTR_FontFamily)
MTR_DECL_LITERAL(MSTR_FontStyle)
MTR_DECL_LITERAL(MSTR_FontSize)
MTR_DECL_LITERAL(MSTR_FilledSquares)
MTR_DECL_LITERAL(MSTR_Squares)
MTR_DECL_LITERAL(MSTR_FilledCircles)
MTR_DECL_LITERAL(MSTR_Circles)
MTR_DECL_LITERAL(MSTR_SolidLines)
MTR_DECL_LITERAL(MSTR_DashedLines)
MTR_DECL_LITERAL(MSTR_ForeGround)
MTR_DECL_LITERAL(MSTR_BackGround)
MTR_DECL_LITERAL(MSTR_Function)
MTR_DECL_LITERAL(MSTR_Closed)
MTR_DECL_LITERAL(MSTR_Filled)
MTR_DECL_LITERAL(MSTR_Ascii)
MTR_DECL_LITERAL(MSTR_Binary)
MTR_DECL_LITERAL(MSTR_Raster)
MTR_DECL_LITERAL(MSTR_Gif)
MTR_DECL_LITERAL(MSTR_Postscript)
MTR_DECL_LITERAL(MSTR_Lin)
MTR_DECL_LITERAL(MSTR_Log)
MTR_DECL_LITERAL(MSTR_AxesScaling)
MTR_DECL_LITERAL(MSTR_Shift)
MTR_DECL_LITERAL(MSTR_GridLines)

#ifndef NO_TICKS_EXTENSION

extern S_Pointer MGRC_MIN_ID[3];
extern S_Pointer MGRC_MAX_ID[3];

#endif


#endif /* __MGR_global__ */
