/*
 * File:         MGR_makro.h
 *
 * Inhalt:       Diese Datei enth"alt alle Makros, die vom MuPAD-Kern auf Seiten
 *               der Grafikberechnungen ben"otigt werden. Diese Makros wurden
 *               zuvor in MGR_sys_func.c definiert. Um die Makros besser von an-
 *               deren Funktionen unterscheiden zu k"onnen, beginnen sie nun mit
 *               der Buchstabenfolge 'MGRM'.
 *
 * Autor:        Gudrun Oevel, Thorsten Schulze
 *
 * Datum:        27.09.1994
 */

#ifndef __MGR_makro__
#define __MGR_makro__

#define MGRM_cat(s)             MMMZ(&s,CATEGORY)->cat

#define MGRM_set_error(s)       MEV_set_error(MEVC_PLOT_ERROR, "plot", (s))

#define MGRM_type_error(cat)                                               \
{ char error[255];                                                         \
  sprintf(error, "Plot function(s) must return real numbers.\n       Type of the returned value is %s", MEVV_CAT_NAMES[cat]); \
  MEV_set_error(MEVC_OWN_ERR_MESS, "", error);                             \
}

#define MGRM_log_error() \
        MEV_set_error(MEVC_OWN_ERR_MESS, "", "Plot function(s) must return real numbers\n        greater than zero in logarithmic plots")

#define MGRM_CHECK_ITEM(testnr) if ( testarray[testnr]==1 ) \
                                    MGRM_set_error("Twice specified"); \
				else \
                                    testarray[testnr]=1;

#define MGRM_MIN(A,B)           ( (A)<(B) ? (A):(B) )
#define MGRM_MAX(A,B)           ( (A)>(B) ? (A):(B) )

#ifndef NO_TICKS_EXTENSION

#define MGRM_cat2cstr(s) \
        MMMmvarr(MMMP(&(s),0), sizeof(STRSIZE), 0, char)

#endif

#endif /* __MGR_makro__ */

