#ifndef __MIO_collect_h__
#define __MIO_collect_h__


// the container will be resized blockwise with this block size
#define MIOC_BLOCK_SIZE  10


/** Collect outputs for blockwise prints.
 */
class MIOT_collect {
public:
  /// Create empty container
  MIOT_collect();

  /// Delete container
  ~MIOT_collect();

  /** Add a MuPAD object to the output container
   */
  bool add(S_Pointer s);

  /** Add a string to the output container
   */
  bool add(const char *str);

  /** Add a formatted c-string to the output container
   */
  int printf(const char *s Mva_arglist);

  /** Add a formatted c-string to the output container
   *  only for MUT_print_error to access the variable arg list of
   *  this function.
   */
  int printf1(const char *s, Mva_list arg1);

  /** Insert a newline in the output container
   */
  bool newline();

  /** Print the container
   */
#ifndef GRAPHIC
  bool print(S_Pointer outputType, bool newline=true);
#else
  bool print();
#endif

  /** clear the container for reuse
   */
  bool clear();

  /** insert in the list of global objects to save the buffer over
   *  the garbage collection
   */
  void insert_global();

protected:
  S_Pointer container_;
  long used_entries_;
  /** internal function for the add-methods
   */
  bool add_(S_Pointer s);


};


S_Pointer MIO_out_collect( S_Pointer s );  /* wird von MIO_out aufgerufen */

#ifndef GRAPHIC
/* Dieser enthaelt die jeweils letzte Fehlermeldung */
extern MIOT_collect *MIOV_LAST_ERROR_MESSAGE;
#endif

#endif  /* __MIO_collect_h__ */
