/******************************************************************************/
/* FILE   :  MKT_func.h                                                       */
/* AUTHOR :  Andreas Sorgatz                                                  */
/* CREATED:  18/07/95                                                         */
/* CHANGED:  27/09/99                                                         */
/* DESCRIP:  Teile des MAPI,  bindet auf Bedarf die Kern header files ein     */
/*           und enthaelt die EXTERN Deklarationen aller Kernobjekte, die     */
/*           innerhalb von Modulen als Teil des MAPI UNBEDINGT adressier-     */
/*           bar sein muessen.                                                */
/******************************************************************************/

#ifndef __MKT_func__
#define __MKT_func__

#ifndef MEXDSTANDARD
#  define MEXDSTANDARD                     /*** Aktivieren von MEX_extern.h ***/
#endif

/*** The following header files must not be included in a dynamic module ******/
/*** which does not use the resolver of the dynamic linker  but uses the ******/
/*** the restricted MAPI (symbol table 'MDMV_object_tab') instead.       ******/

#if defined ISMODULE && !defined MDMD_USE_DYNLINK
#  include "MMMstorage_lean.h"
#  include "MUP_constants.h"
#  include "MEV_evaluate_help.h"
#  include "MUP_env.h"
#  include "MEX_extern.h"
#  include "MDE_declare.h"
#  include "MUP_version.h"
#  include "MDM_kern.h"
#else

#ifdef DOS_FILENAMES
#  include "MEX_ext.h"
#  include "MEN_stri.h"
#  include "MDE_decl.h"
#  include "MKT_stre.h"
#  include "MKT_mssg.h"
#  include "MMMstora.h"
#  include "MLI_lite.h"
#  include "MUP_typ.h"
#  include "MUP_cons.h"
#  include "MUP_env.h"
#  include "MUP_ext.h"
#  include "MTA_tabl.h"
#  include "MEV_eval.h"
#  include "MAS_asso.h"
#  include "MCL_clie.h"
#  include "MPE_env.h"
#  include "MID_iden.h"
#  include "MSG_sign.h"
#  include "MCM_comp.h"
#  include "MCL_cont.h"
#  include "MDB_debu.h"
#  include "MPA_pars.h"
#  include "MTR_tree.h"
#  include "MSU_eval.h"
#  include "MAM_ass_.h"
#  include "MAR_arra.h"
#  include "MGS_simp.h"
#  include "MSR_stri.h"
#  include "MSE_set.h"
#  include "MGR_cons.h"
#  include "MGR_type.h"
#  include "MGR_makr.h"
#  include "MGR_glob.h"
#  include "MGR_exte.h"
#  include "MGR_colo.h"
#  include "MGR_file.h"
#  include "MGR_defa.h"
#  include "MGR_opti.h"
#  include "MGR_calc.h"
#  include "MGR_util.h"
#  include "MGR_chec.h"
#  include "MGR_comm.h"
#  include "MGR_init.h"
#  include "MGR_sys_.h"
#  include "MDF_diff.h"
#  include "MXP_expa.h"
#  include "MFO_open.h"
#  include "MFO_file.h"
#  include "MSY_sys_.h"
#  include "MSY_sysh.h"
#  include "MPL_para.h"
#  include "MTR_tree.h"
#  include "MSV_save.h"
#  include "MPO_poly.h"
#ifndef GRAPHIC
#  include "MPO_polh.h"
#endif /* GRAPHIC */
#  include "MUP_func.h"
#  include "MHI_hist.h"
#  include "MGH_mess.h"
#  include "MPR_prot.h"
#  include "MDM_kern.h"
#  include "MNS_name.h"
#  include "MIO_coll.h"
#  include "MIO_io.h"
#  include "MUT_debu.h"
#  include "MUT_util.h"
#  include "MUP_reso.h"
#  include "MBC_byte.h"
#  include "MVC_vec.h"
#ifndef GRAPHIC
#    include "MPM_ac.h"
#endif

#else /*** !DOS_FILENAMES ***/

#  include "MEX_extern.h"
#  include "MEN_string.h"
#  include "MDE_declare.h"
#  include "MKT_stream.h"
#  include "MKT_mssg.h"
#  include "MMMstorage_lean.h"
#  include "MLI_literals.h"
#  include "MUP_types.h"
#  include "MUP_constants.h"
#  include "MUP_env.h"
#  include "MUP_extern.h"
#  include "MCT_iostream.h"
#  include "MTA_table.h"
#  include "MEV_evaluate.h"
#  include "MAS_assoc.h"
#if !(defined GRAPHIC || defined MOTIF)
#  include "MCL_client.h"
#else
   class MCLT_client;
#endif
#  include "MPE_proc_env.h"
#  include "MID_ident.h"
#  include "MSG_signature.h"
#  include "MCM_compare.h"
#  include "MCL_context.h"
#  include "MDB_debug.h"
#  include "MPA_parser.h" 
#  include "MTR_tree.h"
#  include "MSU_eval_subs.h"
#  include "MAM_ass_mem.h"
#  include "MAR_array.h"
#  include "MGS_simplify.h"
#  include "MSR_string.h"
#  include "MSE_set.h"
#  include "MGR_constants.h"
#  include "MGR_types.h"
#  include "MGR_makro.h"
#  include "MGR_global.h"
#  include "MGR_extern.h"
#  include "MGR_color.h"
#  include "MGR_file.h"
#  include "MGR_defaults.h"
#  include "MGR_option_management.h"
#  include "MGR_calc.h"
#  include "MGR_util.h"
#  include "MGR_check.h"
#  include "MGR_command.h"
#  include "MGR_init.h"
#  include "MGR_sys_func.h"
#  include "MDF_diff.h"
#  include "MXP_expand.h"
#  include "MFO_open.h"
#  include "MFO_fileop.h"
#  include "MSY_sys_func.h"
#if !(defined GRAPHIC || defined MOTIF)
#  include "MSY_sys_func_help.h"
#endif
#  include "MPL_parallel.h"
#  include "MTR_tree.h"
#  include "MSV_save.h"
#  include "MPO_poly.h"
#if !(defined GRAPHIC || defined MOTIF)
#  include "MPO_poly_help.h"
#endif /* GRAPHIC */
#  include "MUP_funcs.h"
#  include "MHI_history.h"
#  include "MGH_message.h"
#  include "MLE_lineedit.h"
#  include "MDM_kern.h"
#  include "MNS_namespace.h"
#  include "MIO_collect.h"
/*#if !(defined GRAPHIC || defined MOTIF)*/
#  include "MIO_io.h"
/*#endif*/
#  include "MUT_debug.h"
#  include "MUT_utils.h"
#  include "MUP_resources.h"
#  include "MBC_bytecode.h"
#  include "MVC_vector.h"
#if !(defined GRAPHIC || defined MOTIF)
#    include "MPM_acmatch.h"
#endif
#endif /* DOS_FILENAMES */

#if defined MSDOS && !defined ISMODULE
#  include "MSW_int.h"
#endif /* MSDOS... */

#if defined MACINTOSH && !defined ISMODULE
#  include "MAC_interface.h"
#endif /* MACINTOSH... */

#endif /* ISMODULE... */


/******************************************************************************/
/*** Unterhalb dieser Grenze keine Aenderungen und Erweiterungen vornehmen! ***/
/*** Die folgenden Zeilen werden vom Programm 'mapi' genutzt um die Symbol- ***/
/*** tabelle sowie die Resolvermacros automatisch zu erstellen.   Das gege- ***/
/*** bene Format muss ZWINGEND eingehalten werden.                          ***/
/******************************************************************************/

typedef S_Pointer MTcell;

/*** Basic interface (for internal use only!!!) *******************************/

#define MFcat(s_)  (MMMZ(&(s_), CATEGORY)->cat )
#define MFspec(s_) (MMMZ(&(s_), CATEGORY)->spec)

/*** Macros which are by the module generator otherwise ***********************/

#ifndef ISMODULE 
#   define MD_MF_NAME(MD_name)  MFeval_ ## MD_name
#   define MD_MODSTR            ""
#endif

/******************************************************************************/
/*** START OF EXTERN Declaration of MAPI Objects ******************************/
/******************************************************************************/

#ifdef EXTERN
#  error "EXTERN is defined"
#  undef  EXTERN
#endif
#define   EXTERN  extern

/******************************************************************************/
//** Toolbox - Variables ******************************************************/
/******************************************************************************/

EXTERN long    MV_errnum;
EXTERN char   *MV_errstr;
EXTERN MTcell  MV_result;

/******************************************************************************/
/*** Toolbox - Routines *******************************************************/
/******************************************************************************/

//** Memory Management ********************************************************/

EXTERN const MTcell MMMNULL;

EXTERN char   *MFmmmstring ( MTcell s );

EXTERN short   MFdom     ( MTcell s );
EXTERN MTcell  MFcopy    ( MTcell  s );
EXTERN MTcell  MFchange  ( MTcell *s );
EXTERN void    MFfree    ( MTcell  s );
EXTERN long    MFnopsGet ( MTcell  s );
EXTERN void    MFnopsSet ( MTcell *s, long n );

EXTERN MTcell* MFopAdr   ( MTcell  s, long n );
EXTERN MTcell  MFopGet   ( MTcell  s, long n );
EXTERN MTcell  MFopSet   ( MTcell  s, long n, MTcell t );

EXTERN void    MFopFree  ( MTcell  s, long n );
EXTERN void    MFopSubs  ( MTcell *s, long n, MTcell t );
EXTERN long    MFsizeGet ( MTcell  s );
EXTERN long    MFsizeSet ( MTcell *s, long n );

EXTERN char*   MFmemoGet ( MTcell  s, long offset );
EXTERN char*   MFmemoSet ( MTcell  s, long offset );

EXTERN void    MFsig     ( MTcell  s );
EXTERN void*   MFcmalloc ( size_t  n );
EXTERN void    MFcfree   ( void   *p );

//** Boolean constants ********************************************************/

EXTERN MTcell       MFtrue();
EXTERN MTcell       MFfalse();
EXTERN MTcell       MFunknown();

//** Special arithmetic constants *********************************************/

EXTERN MTcell       MFi();
EXTERN MTcell       MFzero();
EXTERN MTcell       MFhalf();
EXTERN MTcell       MFone();
EXTERN MTcell       MFone_();
EXTERN MTcell       MFtwo();
EXTERN MTcell       MFtwo_();

//** Other special constants **************************************************/

EXTERN MTcell       MFfail();
EXTERN MTcell       MFnil();
EXTERN MTcell       MFnull();

//** Compare ******************************************************************/

EXTERN MTbool MFequal ( MTcell s, MTcell t );
EXTERN int    MFcmp   ( MTcell s, MTcell t );
EXTERN MTbool MFeq    ( MTcell s, MTcell t );
EXTERN MTbool MFneq   ( MTcell s, MTcell t );
EXTERN MTbool MFlt    ( MTcell s, MTcell t );
EXTERN MTbool MFle    ( MTcell s, MTcell t );
EXTERN MTbool MFgt    ( MTcell s, MTcell t );
EXTERN MTbool MFge    ( MTcell s, MTcell t );

//** Convert basic types (MTbools,numbers,strings,identifiers) ****************/

EXTERN double  MFcdouble    ( MTcell s );
EXTERN MTcell  MFmdouble    ( double v );

EXTERN char*   MFcstring    ( MTcell s, long option);
EXTERN MTcell  MFmstring    ( const char  *v );

EXTERN char*   MFcident     ( MTcell s, long option);
EXTERN MTcell  MFmident     ( char  *v );

EXTERN long    MFclong      ( MTcell s );
EXTERN MTcell  MFmlong      ( long   v );

EXTERN MTcell  MFratNum    ( MTcell s );
EXTERN MTcell  MFratDen    ( MTcell s );

EXTERN MTcell  MFcomplexRe ( MTcell s );
EXTERN MTcell  MFcomplexIm ( MTcell s );

//** Types and Typechecking ***************************************************/

/*** Identify any type of a number ********************************************/

/*** Identify MTbool constants ***********************************************/

/*** Identify special arithmetic constants ************************************/

/*** Identify character based data types **************************************/

/*** Identify expressions *****************************************************/

EXTERN MTbool MFisExpr1( MTcell s, long type );

//** Numbers ******************************************************************/

//** DOM_STRING/DOM_IDENT *****************************************************/

EXTERN long MFlenString ( MTcell s );
EXTERN long MFlenIdent  ( MTcell s );

//** DOM_EXPR *****************************************************************/

EXTERN MTcell MFnewExpr1( MTcell  s, long n );
EXTERN MTcell MFnewExpr2( long n, va_list args );

EXTERN MTcell MFnewExprSeq ( long    n  Mva_arglist );
EXTERN MTcell MFgetExpr    ( MTcell *s, long n );
EXTERN void   MFsetExpr    ( MTcell *s, long n, MTcell v );
EXTERN void   MFfreeExpr   ( MTcell *s, long n );
EXTERN void   MFsubsExpr   ( MTcell *s, long n, MTcell v );

EXTERN char*  MFexpr2text  ( MTcell s );
EXTERN MTcell MFtext2expr2 ( char *string, long ShowErrors );
EXTERN MTcell MF           ( char *string );

//** DOM_LIST *****************************************************************/

EXTERN MTcell MFnewList  ( long    n );
EXTERN MTcell MFgetList  ( MTcell *s, long n );
EXTERN void   MFsetList  ( MTcell *s, long n, MTcell v );
EXTERN void   MFfreeList ( MTcell *s, long n );
EXTERN void   MFsubsList ( MTcell *s, long n, MTcell v );

//** DOM_EXT ******************************************************************/

EXTERN MTcell MFnewExt  ( MTcell  dom, long n );
EXTERN MTcell MFgetExt  ( MTcell *s, long n );
EXTERN void   MFsetExt  ( MTcell *s, long n, MTcell v );
EXTERN void   MFfreeExt ( MTcell *s, long n );
EXTERN void   MFsubsExt ( MTcell *s, long n, MTcell v );
EXTERN MTcell MFdomExt  ( MTcell  s );

//** DOM_SET ******************************************************************/

EXTERN MTcell MFnewSet       (  );
EXTERN MTbool MFinSet        ( MTcell s, MTcell v );
EXTERN void   MFinsSet       ( MTcell s, MTcell v );
EXTERN MTcell MFunionSet     ( MTcell s, MTcell t );
EXTERN MTcell MFminusSet     ( MTcell s, MTcell t );
EXTERN MTcell MFintersectSet ( MTcell s, MTcell t );
EXTERN MTcell MFset2list     ( MTcell v );
EXTERN MTcell MFlist2set     ( MTcell v );
EXTERN MTcell MFdelSet       ( MTcell s, MTcell v );

//** DOM_TABLE ****************************************************************/

EXTERN MTcell MFnewTable   (  );
EXTERN void   MFdelTable2  ( MTcell *s, MTcell idx, long t );

EXTERN MTcell MFgetTable2  ( MTcell *s, MTcell idx, long t );
EXTERN MTbool MFinTable2   ( MTcell *s, MTcell idx, long t );
EXTERN void   MFinsTable2  ( MTcell *s, MTcell idx, MTcell v, long t );

EXTERN MTcell MFtable2list ( MTcell v );
EXTERN MTcell MFlist2table ( MTcell v );

//** DOM_DOMAIN ***************************************************************/

EXTERN void   MFdelDomain ( MTcell dom, MTcell idx );
EXTERN MTcell MFgetDomain ( MTcell dom, MTcell idx );
EXTERN void   MFinsDomain ( MTcell dom, MTcell idx, MTcell val );
EXTERN MTcell MFnewDomain1( MTcell key, MTbool *is_new );

//** DOM_POLY *****************************************************************/

EXTERN MTcell MFpoly2list2( MTcell s, MTcell *u, MTcell *f );
EXTERN MTcell MFlist2poly2( MTcell s, MTcell  u, MTcell  f );
EXTERN long   MFdegPoly   ( MTcell s );

//** DOM_ARRAY ****************************************************************/

EXTERN MTcell MFarray2list ( MTcell s );
EXTERN MTcell MFlist2array2( MTcell list, long a,long b,long c,long d );
EXTERN long   MFdimArray   ( MTcell a );
EXTERN void   MFrangeArray ( MTcell a, long dim, long *l, long *r );

//**  DOM_... *****************************************************************/

EXTERN MTcell MFnewDebug   ( unsigned long value );
EXTERN MTcell MFnewExec    ( long n );
EXTERN MTcell MFnewFuncEnv (  );
EXTERN MTcell MFnewPoint2  ( MTcell x, MTcell y, MTcell z, MTcell col );
EXTERN MTcell MFnewPolygon2( long n, MTcell *pv, MTcell color,
                             MTcell closed, MTcell filled );
EXTERN MTcell MFnewProc    (  );

//** Get/Set identifiers ******************************************************/

EXTERN MTcell MFgetVar( char* var );
EXTERN void   MFsetVar( char* var, MTcell val );
EXTERN void   MFdelVar( char* var );

//** Service functions and Creation of special objects ************************/

EXTERN MTcell MFdomtype ( MTcell s );
EXTERN MTcell MFtype ( MTcell s );
EXTERN MTbool MFtesttype ( MTcell s, MTcell t );

//** Arbitrary Precision Numbers **********************************************/

#ifndef GRAPHIC
#if defined ISMODULE && !defined MDMD_USE_DYNLINK
typedef long    *GEN;
#endif

EXTERN GEN    MFcpari     ( MTcell s );
EXTERN MTcell MFmpari     ( GEN    s );
EXTERN GEN    MFparii     ( long   x );
#endif

//** Arithmetic ***************************************************************/

EXTERN void   MFsubto ( MTcell*s, MTcell t);
EXTERN void   MFaddto ( MTcell*s, MTcell t);
EXTERN void   MFmultto( MTcell*s, MTcell t);
EXTERN void   MFdivto ( MTcell*s, MTcell t);
EXTERN void   MFinc   ( MTcell*s );
EXTERN void   MFdec   ( MTcell*s );
EXTERN MTcell MFadd   ( MTcell s, MTcell t);
EXTERN MTcell MFsub   ( MTcell s, MTcell t);
EXTERN MTcell MFmult  ( MTcell s, MTcell t);
EXTERN MTcell MFdiv   ( MTcell s, MTcell t);
EXTERN MTcell MFdivInt( MTcell s, MTcell t);
EXTERN MTcell MFpower ( MTcell s, MTcell t);
EXTERN MTcell MFmod   ( MTcell s, MTcell t);
EXTERN MTcell MFmods  ( MTcell s, MTcell t);
EXTERN MTcell MFbinom ( MTcell s, MTcell t);
EXTERN MTcell MFexp   ( MTcell s );
EXTERN MTcell MFgcd   ( MTcell s, MTcell t);
EXTERN MTcell MFlcm   ( MTcell s, MTcell t);
EXTERN MTcell MFln    ( MTcell s );
EXTERN MTcell MFsqrt  ( MTcell s );
EXTERN MTbool MFisNeg ( MTcell s );
EXTERN MTcell MFneg   ( MTcell s );
EXTERN MTcell MFrec   ( MTcell s );
EXTERN MTcell MFabs   ( MTcell s );

//** Boolean Operators ********************************************************/

EXTERN MTcell MFnot   ( MTcell s );

//** Input/Output *************************************************************/

#ifndef GRAPHIC
EXTERN void   MFputsRaw   ( char *str );
EXTERN void   MFprintfRaw ( char *format  Mva_arglist );
EXTERN int    MFprintf    ( char *format  Mva_arglist );
EXTERN void   MFputs      ( char *str );
EXTERN MTcell MFout       ( MTcell s );
#endif

//** Evaluation ***************************************************************/

EXTERN MTcell MFexec ( MTcell s );
EXTERN MTcell MFeval( MTcell s );
EXTERN MTcell MFread( char* name );
EXTERN MTcell MFtrap( MTcell s, long *error );

//** Calling kernel built-in and library functions ****************************/

EXTERN MTcell MFcall1 ( MTcell s, long n, va_list args );

//** Kernel-Management ********************************************************/

EXTERN void   MFterminate (  );
EXTERN void   MFglobal    ( MTcell *s );
EXTERN char*  MFuserOpt   (  );

//** Module-Management ********************************************************/

EXTERN MTbool MFdisplace(  );
EXTERN MTbool MFstatic2 ( CONST char *name, short mode );

//** Module-Management (internal) *********************************************/

EXTERN int    MFfuncInit ( MTcell  MV_args,      long   MV_prev_func,
                           long   *MV_eval_type, MTcell MV_exec,
                           MTcell *MVargs,       long   MV_opt );
EXTERN void   MFfuncRem  ( MTcell MVargs, MTcell result, MTcell MV_exec );
EXTERN void   MFerror    ( char   *text   );
EXTERN void   MFexit     ( MTcell  result );

/******************************************************************************/
//** Kernel - Additional Kernel Objects ***************************************/
/******************************************************************************/
#if defined ISMODULE && !defined MDMD_USE_DYNLINK && (defined MUPD_USE_STALINK || defined DO_NOT_USE_THIS)

//** Kernel - Module Management (internal) ************************************/

EXTERN MDM_list_t       *MDMV_list;
EXTERN long              MDMV_support;
EXTERN long              MDMV_unload_support;
EXTERN long              MDMV_age_max;
EXTERN long              MDMV_aging;

EXTERN long              MDM_reset      (  );
EXTERN long              MDM_kick_out   (  );
EXTERN void              MDM_aging      (  );
EXTERN void              MDM_aging_intr (  );

EXTERN MDM_jump_t        MDM_object     ( CONST unsigned long index,
                                          CONST char*         file,
                                          CONST unsigned long line );

EXTERN long              MDMV_pmod_num;
EXTERN MDM_pmod_t        MDMV_pmod[];             
EXTERN long              MDMV_object_tab_len;
EXTERN MDM_jump_t        MDMV_object_tab[];

EXTERN long              MDM_invalid_name ( CONST char *name );
EXTERN long              MDM_exist        ( CONST char *name );
EXTERN long              MDM_which        ( CONST char *name,
                                            CONST char *suffix,
                                                  char *fullname );

//** C/C++ Calling Kernel Environment *****************************************/

#ifdef USE_THIS_EXTERN_DECLARATIONS_ONLY_FOR_MDM_obj_and_MDM_mod
EXTERN int    mupadInit        ( char *libpath ) ;
EXTERN int    mupadInitArgv    ( int argc, char *argv[] ) ;

EXTERN int    mupadReset       ( ) ;
EXTERN void   mupadExit        ( ) ;

EXTERN char*  mupadEvalString  ( char *string, long *errnum ) ;
EXTERN void   mupadFreeString  ( char *string ) ;

EXTERN void   mupadEvalFile    ( char *string, long *errnum, FILE *file,
                                 int   pretty ) ;

EXTERN void   mupadGarbageCollection ( );

EXTERN void   mupadSetCallback ( void (*func)() ) ;
#endif

//** Kernel Environment *******************************************************/

EXTERN MUPT_env          MUPV_env; 

//** Kernel - Parser and Evaluator Management *********************************/

#if /*!*/ !(defined MSDOS || defined WIN32 || defined MACINTOSH)
EXTERN void              osStartraw   (  );
EXTERN void              osStopraw    (  );
EXTERN int               osGetch      (  );
#else /*!*/
EXTERN void*             DUMMY_SYMBOL;
EXTERN void*             DUMMY_SYMBOL;
EXTERN void*             DUMMY_SYMBOL;
#endif /*!*/

EXTERN jmp_buf           MEVV_error_label;
EXTERN long              MEVV_ERROR;
EXTERN short             MEVV_STATUS;
EXTERN long              MEV_set_error(long err_nr, char *err_str Mva_arglist);

#if /*!*/ !(defined MACINTOSH)
EXTERN void              MUP_catch_system_error(  );
#else /*!*/
EXTERN void*             DUMMY_SYMBOL;
#endif /*!*/

#endif /*** Additional Kernel Objects ***/

/******************************************************************************/
/*** END OF EXTERN Declaration of MAPI Objects ********************************/
/******************************************************************************/

#undef EXTERN

#include "MKT_mapi.h"                       /** Include kernel declarations ***/

#endif /*** __MKT_func__ ***/
