#ifndef __MKT_kernel_stream_h__
#define __MKT_kernel_stream_h__

/* MKT_kernel_stream.h -- streams based on MTstream but used internally in the kernel only.
 *
 * Saves us from exporting MCLT_bytestream etc. into MKT_stream.h.
 */

#include "MKT_stream.h"
#include "MCO_compat.h"

class MCLT_bytestream;

/** A MCLT_bytestream used as a MTstream
 */
class MToldbyteStream : public MTstream
{
public:
   /// The MCLT_bytestream
   MCLT_bytestream *stre ;

   /// Create stream given the MCLT_bytestream
   MToldbyteStream(MCLT_bytestream *str) ;

   /// Destroy stream.
   virtual ~MToldbyteStream();

   virtual Stat read(void* buff, size_t buff_len, size_t& bytes_read) ;
   virtual Stat write(const void* data, size_t num_bytes,
                      size_t& bytes_written);

   /// The following just appears because they must be part of a MTstream
   /// but a MLCT_bytestream knows nothing about this
   virtual Stat flush() ;
   virtual bool eom() const ;
   virtual Stat status() ;
protected:
   virtual Stat status(Stat) ;
} ;

#endif // !__MKT_kernel_stream_h__
