/* $Date: 1999/06/02 07:21:53 $  $Author: kg $  $Revision: 1.4 $ */
#ifndef __MLI_literals_h__
#define __MLI_literals_h__

// MLI_literals.h

/** Initialize all s-pointer literals.
 The global vars containing literals are assigned.
 */
void MLI_init();

/** Mark r/w literals and their children.

 @param mark true if marks are to be set, false if marks are to be cleared
 */
void MLI_mark_literals(bool mark=true);

#ifdef MMMD_STATISTICS

/// Returns number of r/w literal s-pointers.
int MLI_num_rw_literals();

/// Get r/w literal s-pointer with index #i#.
/// #i# must hold #0 <= i < MLI_num_rw_literals()#.
/// The pointer is {\em not} copied.
S_Pointer MLI_get_literal(int i);

#endif // MMMD_STATISTICS

#endif // ! __MLI_literals_h__
