/*
 * MSC_scan.h -- Scanner declarations
 */

/* Operator priorities, as used for precedence parsing
 * in op_expr non-terminal.
 * PLEASE NOTE: MPAC_MIN_PRIO and MPAC_MAX_PRIO must match
 * the priorities of expressions parsed by expr(.)!
 */

#define P_noop		0        /* no op, ie. no precedence */
#define P_or		100
#define P_and		200
#define P_not		300
#define P_seqgen	300
#define P_relation	400
#define P_range		500
#define P_union		600
#define P_set_minus	700
#define P_intersect	800
#define P_mod_div	900
#define P_plus_minus	1000
#define P_mult_divide	1100
#define P_power		1200
#define P_fact		1300
#define P_fconcat	1500
#define P_fnest		1600
#define P_concat	1700
#define P_apply_index	1800
#define P_prime		1900
#define P_slot   	2000
#define P_INFINITE	1000000

struct MSCT_keyword {
    char *name;
    MPAT_token_no no;
    int prio;
};

const struct MSCT_keyword* MSC_lookup_keywd(register const char *str,
					    register int len);

const char* MSC_get_keywd_name(MPAT_token_no no);

