/*
 * kg, 5.12.95
 *
 * MSW_oldcom_int.h -- Interface-Routinen des Kerns fuer Windows-Switches 'oldcom' und 'dde'
 */

#ifndef _MSW_OLDCOM_INT_H_
#define _MSW_OLDCOM_INT_H_

#ifdef DOS_FILENAMES
#include "MMMstora.h"
#include "MPR_prot.h"
#include "MCT_iost.h"
#else
#include "MMMstorage_lean.h"
#include "MPR_protocol.h"
#include "MCT_iostream.h"
#endif

/* MSW_get_cmd -- sorgt dafuer, dass das naechste Kommando vom Client
 * geliefert wird. (Hierin ist die 'main event loop' implementiert!) */
char* MSW_get_cmd(void);

/* MSW_get_dbg_cmd -- liefert aehnlich wie MSW_get_cmd naechstes Kommando
 * vom Client, nur dass als Eingabe ein Debug-Kommando erwartet wird. */
void MSW_get_dbg_cmd(void);

/* MSW_pr_puts -- Ausagbe einer typisierten Meldung, wird in
 * MPR_protocol.c verwendet, um MPR_putstring zu implementieren.
 * Die Typen der Meldungen sind in MPR_protocol.h definiert. */
void MSW_pr_puts(MPRTtype t, char *s);

/* MSW_puts -- untypisierte Ausagbe, wird bei Kommunikation mit
 * naiven DDE-Clients verwendet (CMD-Protokoll). */
void MSW_puts(char *s);

/* MSW_query_cmd -- interaktive Abfrage einer MuPAD-Eingabe nach 'input'.
 * p ist der Prompt, zurueckgeliefert werden muss ein Pointer auf einen
 * Buffer, der einen 0-terminierten C-String enthaelt. Der Buffer wird
 * vom Kern nicht weiter verwaltet. */
char *MSW_query_cmd(char *p);

/* MSW_query_text -- interaktive Abfrage einer Text-Eingabe nach 'textinput'.
 * Ansonsten wie MSW_query_cmd zu benutzen. */
char *MSW_query_text(char *p);

#endif /* ! _MSW_INT_H_ */

