/*  LAST EDIT: Wed Apr 12 12:47:48 1995 by Holger Naundorf (snoo)  */
/* $Date: 2000/04/17 12:12:38 $  $Author: tonner $  $Revision: 1.12 $ */

/******************************************************************************/
/* FILE:             MSY_sys_func.h                                           */
/* Autor:            Andreas Kemper                                           */
/* Erstellt:         24/06/91                                                 */
/* Letzte Aenderung: 15/09/93                                                 */
/*                                                                            */
/* Dieses File enthaelt die Deklarationen des Modules `MSY_sys_func'.         */
/******************************************************************************/

#ifndef __MSY_sys_func__
#define __MSY_sys_func__

/* Typen von Funktionen fuer MSY_indets *************************************/

#define MSYC_POLY_INDETS  1    /* polynomiale Ausdruecke */
#define MSYC_RAT_INDETS   2    /* rationale Ausdruecke */
#define MSYC_OPD_INDETS   3    /* Operanden */

// public operation modes for MSY_dump_idents
#define MSYC_WRITE_IDENTS     7
#define MSYC_WRITE_IDENTS_BIN 8

/// type of function which evaluates a CAT\_EXPR
typedef S_Pointer MSYT_eval_func( S_Pointer, long, long, S_Pointer );

/// type of function which prints a CAT\_EXPR
typedef S_Pointer MSYT_output_func( S_Pointer* s, S_Pointer, long, S_Pointer );

/// array of the MMM-strings of the names of all kernel functions
extern S_Pointer* MTRV_SYS_FUNC_LIST;

/* Zustand der Funktion 'testargs' ******************************************/

extern bool MSYV_TESTARGS;


/* Optionen der Funktion 'indets'  ******************************************/

MTR_DECL_LITERAL( MSYV_STR_PolyExpr )
MTR_DECL_LITERAL( MSYV_STR_RatExpr )

MTR_DECL_LITERAL( MSYV_sys_func_mmm_str_names )
MTR_DECL_LITERAL( MSYV_sys_func_envs )

/* Prototypen ***************************************************************/

void	  MSY_init	  (  );
void	  MSY_reset	  (  );
void	  MSY_exit	  (  );
S_Pointer MSY_dump_idents ( long mode, MCLT_iostream &fp );
bool      MSY_number_less ( S_Pointer e1,
		            S_Pointer e2,
		            void *arg );
void      MSY_sort        ( S_Pointer *list,
		            long lb,
		            long ub,
		            bool ascending,
		            bool (*less)(S_Pointer, S_Pointer, void *),
		            void *arg );

/**
 Get MuPAD name of kernel function given its id (as defined in MUP_constants.h)
 @param id id of kernel function
 */
const char* MSY_get_function_name ( long id );

#endif /*__MSY_sys_func__ */
