/* $Date: 2001/01/31 13:13:05 $  $Author: ccr $  $Revision: 1.55 $ */

/**************************************************************************/
/* FILE:             MUP_constants.h                                      */
/* Autor:            Andreas Kemper                                       */
/* Erstellt:         25/04/91                                             */
/* Letzte Aenderung: 03/03/97                                             */
/**************************************************************************/

#ifndef __MUP_constants__
#define __MUP_constants__


/**************************************************************************/
/* Dieses File enythaelt die Definition fuer alle Konstanten.             */
/**************************************************************************/

/* Jetzt geht's los .... */


#define NO_SYM_BIT             0x0

#define OPTIONS_CHECKED_BIT    0x8
#define NO_DEBUG_BIT           0x10
#define HOLD_BIT               0x20
#define REMEMBER_BIT           0x40
#define ARROW_BIT              0x80
#define ESCAPE_BIT             0x100

#define NO_LEXENV_BIT          0x4000

/* Oder-Maske aller Prozedur-Options-Bits */
#define OPTION_BITS_MASK       0x1F0

/* Oder-Maske aller fuer Vergleiche beruecksichtigten Bits */
#define COMPARE_BITS_MASK      0x1F8

#ifdef MSDOS
#  define SYS_SIGNAL SIGQUIT    /* Dummy, da MSDOS SIGUSR2 nicht kennt  */
#else
#  define SYS_SIGNAL SIGUSR2    /* Signal an mupad zur Ank"undigung     */
                                /* eines Systembefehls                  */
#endif


/************* Defintion der Datentypen der Speicherverwaltung ***********
 *
 * Bei MMM-Typen, von denen Signaturen berechnet werden, muss die zugehoerige
 * MMM_-Konstante kleiner als MUPC_MaxStorTypes sein.
 */

enum MMME_type {
    MMM_INT = 14,
    MMM_LIST = 15,
    MMM_EXT_LIST = 16,
    MMM_CATEGORY = 17,
    MMM_STRING = 18,
    MMM_ASS_MEM = 19,
    MMM_VECTOR = 20, // multi-purpose vector of s-pointers, generates r/o literal
    MMM_VALUE = 26,
    MMM_DOMAIN = 27,
    MMM_ARRAY = 28,
    MMM_STRING_HELP = 29, /*Hilfstyp, der vom MCode benutzt wird*/
    MMM_NAMESPACE = 30,
    MMM_BYTECODE = 31,
    MMM_VAR = 32,
    MMM_PROC_ENV = 33,
    MMM_ASSOC = 34,
    MMM_RW_LIT = 35, // multi-purpose type for internal use only, generates r/w literal
    MMM_RO_LIT = 36, // multi-purpose type for internal use only, generates r/o literal
    MMM_EXEC = 40,
    MMM_CODE = 41,
    MMM_PARI =  44,
    MMM_DIST_POLY = 45,
    MMM_GRAPHIC = 50,   // Die Grafikobjekte muessen alle im Block
    MMM_SCENE_3D = 51,  // hintereinander liegen, da im MCODE getestet
                        // wird ob ein MMM_Object in dem Bereich
    MMM_OBJECT_3D = 53, // zwischen MMM_GRAPHIC und MMM_POLYGON liegt.
                        // Wenn sich dies aendert muss die Routine
    MMM_DEFAULTS = 55,  // MTkernParser::writeCatGeneric_()
                        // angepasst werden.
    MMM_POINTLIST = 57,
    MMM_GRLIST = 58,
    MMM_POINT_3D = 59,
    MMM_LINE = 61,
    MMM_TRIANGLE = 62,
    MMM_RGB_COLOR = 63,
    MMM_PIXMAP = 64,
    MMM_GRAPHIC_COMMAND = 65, // Befehl, wird an das Grafiktool geschickt
    MMM_POLYGON = 66,
    MMM_TITLE_RECTS = 67, // Scene/Objekt-Titel in Vcam
    MMM_TMP = 102,
    MMM_HIDDEN = 103,
    MMM_CLTCTX = 104,
    MMM_OUT_COLLECT = 109,
    MMM_OUT_NODE = 110,
    MMM_OUT_TEXT = 111,
    MMM_OUT_FIELD = 112
};


/****************** Defintion der Kategorietypen *************************/
/*
 * ACHTUNG: Bei Erweiterungen/Aenderungen muss auch die Tabelle der
 *	zugehoerigen Namen (MEVV_CAT_NAMES) angepasst werden!
 */

enum MTRE_cat_type {
    CAT_APM = 1,
    CAT_FLOAT = 2,
    CAT_INT = 3,
    CAT_RAT = 4,
    CAT_COMPLEX = 6,
    CAT_STRING = 10,
    CAT_BOOL = 11,
    CAT_NULL = 13,
    CAT_NIL = 14,
    CAT_IDENT = 20,
    CAT_SET_FINITE = 21,
    CAT_STAT_LIST = 23,
    CAT_ARRAY = 24,
    CAT_TABLE = 25,
    CAT_EXPR = 26,
    CAT_FUNC_ENV = 27,
    CAT_VAR = 28,
    CAT_PROC_ENV = 29,
    CAT_EXEC = 31,
    CAT_DEBUG = 32,
    CAT_PROC = 33,
    CAT_POLY = 34,
    CAT_DOM = 35,
    CAT_EXT = 36,
    CAT_FAILED = 37,
    CAT_POLYGON = 38,
    CAT_POINT = 39,
    CAT_NAMESPACE = 41,
    CAT_BYTECODE = 42,
};

#define MUPC_MaxCatTypes 50

#define MUPC_real         5
#define MUPC_num          7
#define MUPC_copy        15
#define MUPC_simple	 20


/****************** Definition der '_' - Systemfunktionen ****************/
/*                                                                       */
/*                   ACHTUNG !  ACHTUNG !  ACHTUNG!                      */
/*     Diese muessen zur Zeit mit den Konstanten MEVC_* und MPAC_*       */
/*                        unbedingt uebereinstimmen.                     */
/*************************************************************************/

#define _EXPRSEQ          1
#define _OR               2
#define _AND_             3 /* _AND kollidiert mit AMIGA */
#define _SEQGEN           4
#define _LESS             5
#define _LEEQUAL          6
#define _EQUAL            7
#define _UNEQUAL          8
#define _RANGE            9
#define _MOD             10
#define _DIV             11
#define _UNION           12
#define _MINUS           13
#define _INTERSECT       14
#define _PLUS            15
#define _MULT            16
#define _POWER_          17  /* _POWER kollidiert mit math.h */
#define _CONCAT          18
#define _FCONCAT         19

#define _NEGATE          20
#define _INVERT          21
#define _DIVEX           22
#define _SUBTRACT        23

#define _ASSIGN          34
#define _IF              35
#define _CASE            36
#define _FOR             37
#define _FOR_PAR         38
#define _FOR_DOWN        39
#define _FOR_IN          40
#define _FOR_IN_PAR      41
#define _WHILE           42
#define _REPEAT          43
#define _NEXT            44
#define _BREAK           45
#define _QUIT            46
#define _PARBEGIN        47
#define _SEQBEGIN        48
#define _STMTSEQ         49
#define _SYSASSIGN       50
#define _DELETE          51
#define _SYSDELETE       52
#define _LAZY_AND        53
#define _LAZY_OR         54


/*************************************************************************/
/* Definition aller weiteren '_' - Systemfunktionen. Diese werden als    */
/* 'MMM_STRING's in die Tabelle MTRV_SYS_FUNC_LIST eingetragen. Die      */
/* Funktionsnamen stimmen i.A. mit dem Definement ueberein.              */
/*************************************************************************/


/* Andere Datentypen */

#define _PROCDEF         60
#define _FUNC_ENV        61
#define _BUILT_IN        62
#define _ARRAY           63
#define _TABLE           64

#define _NULL_           65   // _NULL is defined on PowerMac
#define _SPLIT		 66

/* I/O - Routinen */

#define _PRINT_          70   // _PRINT may be defined in ctype.h
#define _INPUT           71
#define _TEXTINPUT       72
#define _WRITE           73
#define _FILEREAD        74
#define _FCLOSE		 75
#define _FINPUT		 76
#define _FILEOPEN	 77    // _FOPEN may be defined in a std header
#define _FPRINT		 78
#define _FTEXTINPUT	 79


/* Objektmanipulation */

#define _TYPE_           80   // _TYPE is defiened in math.h for VC++ 4.2
#define _NOPS            82
#define _OP              83
#define _SUBS            84
#define _SUBSEX          85
#define _SUBSOP          86
#define _TESTTYPE        87
#define _MUP_VAL         88
#define _SLOT            89
#define _EXTNOPS         90
#define _EXTOP           91
#define _EXTSUBSOP       92
#define _MAP		 93
#define _SORT		 94
#define _CONTEXT_        95  /* _CONTEXT kollidiert mit Visual C++ 4.0 */
#define _ID		 96
#define _DOMTYPE         97
#define _ZIP		 98
#define _SELECT		 99


/* Systemzustand - Analyse */

#define _TIME_          100   /* _TIME kollidiert mit PowerMac */
#define _RTIME          101
#define _ASSIGN_CNT     102
#define _HISTORY        103
#define _LAST           105
#define _RESET          107
#define _BYTES          109
#define _ANAMES         111
#define _SYSTEM         112
#define _PROTOCOL       113
#define _SYSNAME	114
#define _TESTARGS	115
#define _PARSER_CALLBACK 116
#define _REGISTER       118
#define _GETPID         119


/* Konvertierungsfunktionen */

#define _FLOAT          120
#define _BOOL           121
#define _NEW_EXTELEMENT 122
#define _NEW_DOMAIN     123
#define _GEN_LIT        124
#define _NEW_BYTECODE   128
#define _SHARE          129

/* Textmanipulation */

#define _SUBSTRING      130
#define _TBL2TEXT       132
#define _TEXT2TBL       133
#define _TEXT2LIST      134
#define _STRMATCH       135
#define _TEXT2EXPR      136
#define _EXPR2TEXT      137

/* Graphik */

#define _PLOT           140
#define _POINT          141
#define _POLYGON        142


/* Pari - Funktionen */

#define _INT2TEXT       144
#define _TEXT2INT       145
#define _SININT         146
#define _COSINT         147
#define _LAMBERTV       148
#define _LAMBERTW       149
#define _ABSS           150
#define _ACOS           151
#define _ASIN           152
#define _ASINH          153
#define _ATAN           154
#define _ATANH          155
#define _COS            156
#define _COSH           157
#define _EXP            158
#define _LN             159
#define _SIN            160
#define _SINH           161
#define _SQRT           162
#define _TAN            163
#define _TANH           164
#define _ACOSH		165
#define _ZETA		166
#define _GAMMA		167
#define _PSI		168
#define _ERFC           169
#define _CEIL           170
#define _FLOOR          171
#define _FRAC           172
#define _ISPRIME        173
#define _NEXTPRIME      174
#define _FACT           175
#define _ROUND          176
#define _TRUNC          177
#define _IGCD           178
#define _ILCM           179
#define _SIGN           180
#define _FRANDOM        181
#define _IFACTOR        182
#define _ITHPRIME       183
#define _PHI            184
#define _PRIMEDIVISORS  185
#define _NUMDIVISORS    186
#define _IGCDEX         187
#define _MODP		188
#define _MODS		189
#define _MUP_MAX	190
#define _MUP_MIN	191
#define _POWERMOD	192
#define _EINT		193
#define _IGAMMA		194
#define _ISQRT		195
#define _LLLINT         196

/* Verschiedenes */

#define _LASTERROR      197
#define _ASSIGN_ELEMS   198
#define _INDEX_VAL      199
#define _ARGS_          200   /* _ARGS kollidiert mit gcc 2.2.3 */
#define _RETURN         201
#define _TRAPERROR      202
#define _ERROR          203
#define _EVAL           204
#define _APPEND         205
#define _DIFF           206
#define _EXPAND         207
#define _INDEX          208
#define _HOLD           209
#define _HELP           210
#define _LEVEL          211
#define _NOT            212
#define _CONTAINS       213
#define _GPROF		214
#define _VOLATIL        215
#define _UNVOLATIL      216
#define _INDETS		217
#define _GENIDENT       219
#define _PROPERTIES     220
#define _HAS		221
#define _PREF		222
#define _ENCODE         223
#define _WARNING        224

/* Polynom-Operationen */

#define _POLY		230
#define _EXPR		231
#define _DEGREE		232
#define _DEGREEVEC	233
#define _LTERM		234
#define _LCOEFF		235
#define _TCOEFF		236
#define _COEFF		237
#define _MAPCOEFFS	238
#define _DIVIDE		239
#define _PDIVIDE	240
#define _ICONTENT	241
#define _MULTCOEFFS	242
#define _NORM		243
#define _EVALP		244
#define _ISZERO		245
#define _GENPOLY	246
#define _NTHTERM	247
#define _NTHCOEFF	248
#define _NTERMS		249
#define _LMONOMIAL	250
#define _NTHMONOMIAL	251
#define _DPOLY		252
#define _LDEGREE	253
#define _POLY2LIST      254
#define _FLOAT_MULT     255
#define _FLOAT_PLUS     256
#define _FLOAT_POWER    257

/* Dynamische Module */

#define _LOADMODUL      260
#define _UNLOADMODUL    261
#define _EXTERNAL       262

/* Verschiedenes II */

#define _USERINFO	263
#define _USERINFO_LEVEL 264
#define _SYSORDER	265
#define _LENGTH         266
#define _NOCOMPROD	267
#define _MUP_PROTECTED	268
#define _PARSER_CONFIG  269

/* Operator-Funktionen */

#define _OP_PLUSMULT    270
#define _OP_POWER       271
#define _OP_FCONCAT     272
#define _OP_FCONCATPOWER 273

#define _DOMAINFUNCCALL 275
#define _OUTPUT_FORMAT  276
#define _OUTPUT_TYPE    277


/* Debugger-Funktionen */

#define _DEBUG_         281	/* _DEBUG kollidiert mit Visual C++ 4.0 */
#define _GCOV           282


/* Konstruktoren, Clients */

#define _ACT_PROC_ENV	 286
#define _EVAL_ENTRY 	 287
#define _CLIENT_OBJECT   288
#define _CLIENT_CALL     289


#ifndef NO_ACMATCH
#   define _ACM_BUILD		295
#   define _ACM_SOLUTION	296
#   define _ACM_RELEASE 	297
#   define _AC_MATCH    	298
#endif

/* Funktionen zum Rechnen mit Floats und gerichteten Rundungen */

#define _RD_ROUND       310
#define _RD_INT2FLOAT   311
#define _RD_ABS         312
#define _RD_NEG         313
#define _RD_ADD         314
#define _RD_SUB         315
#define _RD_MUL         316
#define _RD_DIV         317
#define _RD_FLOAT2TEXT  318
#define _RD_TEXT2FLOAT  319
#define _RD_ISFINITE    320
#define _RD_GETSIGN     321

/* Achtung die Laenge dieser Liste ist durch 'MSYC_sys_func_list_len' */
/* in der Datei 'MSY_sys_func_init.cpp' beschraenkt.                  */


/********************* Konstanten ****************************************/

#define SET_HASH_SIZE      47
#define TABLE_HASH_SIZE    47
#define ARRAY_HASH_SIZE    47
#define IDENT_HASH_SIZE    47

#define HASHNUM            47   /* Konstante zum Hashen                 */
#define NUM_OF_STACKS       4   /* Anzahl der Stacks fuer jede Variable */

#define MUPC_MaxStorTypes  120   /* Maximale Anzahl der verschiedenen    */
                                 /* Speichertypen (MMM)                  */



/*********** Rechnerabhaengige Konstanten *******************************/

#define MAX_INT        2147483647
#define MIN_INT        2147483648

/************************************************************************/

#ifndef TRUE
#define TRUE		1
#endif

#ifndef FALSE
#define FALSE		0
#endif

/************************************************************************/

/* Modi fuer fopen() */

#ifdef MACINTOSH

#  define MUPC_READ_BIN		"rb"
#  define MUPC_READ_TEXT	"r"
#  define MUPC_WRITE_BIN	"wb"
#  define MUPC_WRITE_TEXT	"w"
#  define MUPC_APPEND_BIN	"ab"
#  define MUPC_APPEND_TEXT	"a"
#  define MUPC_READ_WRITE_BIN	"rb+"
#  define MUPC_READ_WRITE_TEXT	"r+"

#else
#ifdef MSDOS

#  define MUPC_READ_BIN		"rb"
#  define MUPC_READ_TEXT	"rt"
#  define MUPC_WRITE_BIN	"wb"
#  define MUPC_WRITE_TEXT	"wt"
#  define MUPC_APPEND_BIN	"ab"
#  define MUPC_APPEND_TEXT	"at"
#  define MUPC_READ_WRITE_BIN	"rb+"
#  define MUPC_READ_WRITE_TEXT	"rt+"

#else

#  define MUPC_READ_BIN		"r"
#  define MUPC_READ_TEXT	"r"
#  define MUPC_WRITE_BIN	"w"
#  define MUPC_WRITE_TEXT	"w"
#  define MUPC_APPEND_BIN	"a"
#  define MUPC_APPEND_TEXT	"a"
#  define MUPC_READ_WRITE_BIN	"r+"
#  define MUPC_READ_WRITE_TEXT	"r+"

#endif /* MSDOS */
#endif /* MACINTOSH */

/**************************  GLOBAL MACROS  *****************************/

#ifdef OLD_OUTPUT_TYPES
#define MUP_flush_stdout()  MIO_write('\0')
#else
#define MUP_flush_stdout()
#endif

#if   (defined MACINTOSH)
#  define MUP_exit(c)   { MAC_CloseFrontend(); ExitToShell(); }
#  define MUP_fatal(x)	{ MAC_fatal(x); }
#elif (defined MSDOS)
#  define MUP_exit(n)   { MSW_exit(n); }
#  define MUP_fatal(s)  { MSW_fatal(s); }
#else //       UNIX
#  define MUP_exit(c)   { exit(c); }
#  define MUP_fatal(t)  { fprintf(stderr,"\n%s\n", (t)); fflush(stderr); exit(1); }
#endif

/*********** Default - Werte veraenderbarer MuPAD - Systemvariablen *****/

#define MEVC_LEVEL_DEFAULT        	100
#define MEVC_MAXLEVEL_DEFAULT     	100
#define MEVC_MAXDEPTH_DEFAULT           500
#define MEVC_TEXTWIDTH_DEFAULT		 75

#define MEVC_DQ_DEFAULT			"\"" /* Darf nicht ver"andert werden */

/****************** Konstanten des Evaluierers **************************/

#define MEVC_LEVEL_INF		2147483647	/* 2^31 - 1 */
#define MEVC_NO_SUBS		2147483648	/* 2^31     */

#if defined MSDOS && !defined __GNUC__
/* Dummy-Vereinbarungen */
#define kill(a,b)               0
#define getpid()                0
#define getppid()               0
#endif

#define MUPC_constants_CAT_BOOL_FALSE   3  /* FALSE < UNKNOWN < TRUE ! */
#define MUPC_constants_CAT_BOOL_UNKNOWN 4
#define MUPC_constants_CAT_BOOL_TRUE    5

#if (defined MSDOS) || (defined WIN32)
#	define MUPC_PATH_SEPARATOR '\\'	    /* Trennung von Directory-Namen */
#	define MUPC_CMD_MARK '/'	    /* Markierung von Kommandozeilen-Optionen */
#  ifdef __GNUC__
#	define MUPC_MAX_PATH 512	    /* max. Pfadlaenge von Filenamen */
#  else
#	define MUPC_MAX_PATH _MAX_PATH	    /* max. Pfadlaenge von Filenamen */
#  endif
#elif (defined MACINTOSH)
#	define MUPC_PATH_SEPARATOR ':'
#else
#	define MUPC_PATH_SEPARATOR '/'
#	define MUPC_CMD_MARK '-'
#	define MUPC_MAX_PATH 512
#endif

#endif /* __MUP_constants__ */
