/* $Date: 2000/09/29 08:23:06 $  $Author: kg $  $Revision: 1.32 $ */

/**************************************************************************/
/* FILE:             MUT_utils.h                                          */
/* Autor:            Andreas Kemper, Oliver Kluge                         */
/* Erstellt:         25.04.1991                                           */
/* Letzte Aenderung: 14.09.1999                                           */
/**************************************************************************/

#ifndef __MUT_utils__
#define __MUT_utils__

#ifdef DOS_FILENAMES
#  include "MID_iden.h"
#  include "MIO_coll.h"
#  include "MCL_clie.h"
#else
#  include "MID_ident.h"
#  include "MIO_collect.h"
#  include "MCL_client.h"
#endif

#ifdef MSDOS
#  define MUTC_PARI_STACK_SIZE     (top-bot)
#  define MUTC_PARI_RESERVED_SIZE  (top-bot)
#else
#  define MUTC_PARI_STACK_SIZE     (avma-GLOBAL_READ(MCAV_avglob))
#  define MUTC_PARI_RESERVED_SIZE  MUPV_env.pariStackSize
#endif

#define MUTC_USED_MEM     ((long)(MUTC_PARI_STACK_SIZE) + MMMused_memory())
#define MUTC_RESERVED_MEM ((long)(MUTC_PARI_STACK_SIZE) + MMMreserved_memory())

/**************************************************************************/
/* Aus Kompatibilit"atsgr"unden (z.B. Macintosh) werden die Pfade mit NULL*/
/* und nicht mit "." initialisiert. NULL entspricht in den Routinen       */
/* MSY_write() und MSY_eval_read() aber gerade ".", also dem aktuellen	  */
/* Verzeichnis.								  */
/**************************************************************************/

#if (defined MSDOS)
#  define MUTC_SYS_INIT_FILENAME        "sysinit.mu"
#  define MUTC_USER_INIT_FILENAME       "userinit.mu"
#  define MUTC_HELP_INDEX_FILENAME      "mhelp.idx"
#  define MUTC_HELP_INDEX_FILENAME_TTY  "mhelp.idx"

#  define MUTC_MOD_INIT_PATH_DEFAULT    "\\modules"
#  define MUTC_LIB_INIT_PATH_DEFAULT    "\\lib"
#  define MUTC_USER_INIT_PATH_DEFAULT   NULL
#  define MUTC_HELP_INIT_PATH_DEFAULT   "."
#  define MUTC_HELP_INDEX_PATH_DEFAULT  NULL

#elif (defined MACINTOSH)
#  define MUTC_SYS_INIT_FILENAME        ":MuPAD Sysinit"
#  define MUTC_USER_INIT_FILENAME       ":MuPAD Init"
#  define MUTC_HELP_INDEX_FILENAME      "MuPAD Helpindex"
#  define MUTC_MOD_INIT_PATH_DEFAULT    ":Modules:"
#  define MUTC_LIB_INIT_PATH_DEFAULT    ":lib"
#  define MUTC_USER_INIT_PATH_DEFAULT   NULL
#  define MUTC_HELP_INIT_PATH_DEFAULT   ":doc"
#  define MUTC_HELP_INDEX_PATH_DEFAULT  ":Manuals:"

#else /* UNIX */
#  define MUTC_MMM_INIT_FILENAME        ".MMMinit"
#  define MUTC_SYS_INIT_FILENAME        "sysinit.mu"
#  define MUTC_USER_INIT_FILENAME       "userinit.mu"
#  define MUTC_HELP_INDEX_FILENAME      ".mupadhelpindex"
#  define MUTC_HELP_INDEX_FILENAME_TTY  ".mupadhelpindextty"
#  define MUTC_MOD_INIT_PATH_DEFAULT    "modules"
#  define MUTC_LIB_INIT_PATH_DEFAULT     "lib"
#  define MUTC_USER_INIT_PATH_DEFAULT    (char *) getenv("HOME")
#  define MUTC_HELP_INIT_PATH_DEFAULT   "doc\\ascii"
#  define MUTC_HELP_INDEX_PATH_DEFAULT  "help"
#endif


/************************** globale Variablen *****************************/

extern char *MUTV_READ_FILENAME;	/* Name der gerade mit 'read'
					 * gelesenen Files */

extern bool MUTV_NO_PRINT_ERROR;	/* TRUE, falls im Fehlerfall keine
					 * Meldung ausgegeben werden soll */


/**************************************************************************/
/* Dieses File enthaelt die Deklaration aller Hilfsprozeduren.            */
/**************************************************************************/

int          MUT_system           ( char *cmd );

S_Pointer    MUT_unique_string    ( S_Pointer s) ;
S_Pointer    MUT_new_cat_ident    ( S_Pointer s );
bool	     MUT_ident_has_name   ( S_Pointer s, S_Pointer string );
bool         MUT_is_ident         ( char *s );
int	     MUT_similcmp         ( char *, char * );
void	     MUT_tolower          ( char *, char * );

int          MUT_set_alarm        ( long sec, void (*ifunc)() );
void         MUT_reset_alarm      (  );

void         MUT_print_resources  (  );
void         MUT_trace_statistics (  );
S_Pointer    MUT_get_message      ( long );
S_Pointer    MUT_get_procname     (  );
void	     MUT_print_error      (long , const char *, Mva_list );
void         MUT_errorhandling    (bool interactive);

long 	     MUT_clock            (  );
long 	     MUT_clock_sec        (  );
#if ( defined SOLARIS || defined SOLARIS_i86 )
void         MUT_debugger         (  );
#endif
long	     MUT_str_cmp          ( S_Pointer m_string, char *c_string );

long         MUT_is_exprseq       ( S_Pointer s );
S_Pointer    MUT_read_exprseq     ( S_Pointer  exprseq, S_Pointer args );
S_Pointer    MUT_replace_exprseq  ( S_Pointer *exprseq, S_Pointer args, S_Pointer value, long* error, short force = MIDC_option_standard|MIDC_option_delete );

inline void  MUT_write_exprseq    ( S_Pointer *exprseq, S_Pointer args, S_Pointer value, long* error, short force = MIDC_option_standard|MIDC_option_delete )
{
    S_Pointer elem;
    elem = MUT_replace_exprseq(exprseq, args, value, error, force);
    MMMfree(elem);
}

S_Pointer    MUT_replace_list     ( S_Pointer *list, S_Pointer args, S_Pointer value, long offset, long* error, short force = MIDC_option_standard|MIDC_option_delete );

inline void  MUT_write_list       ( S_Pointer *list, S_Pointer args, S_Pointer value, long offset, long* error, short force = MIDC_option_standard|MIDC_option_delete )
{
    S_Pointer elem;
    elem = MUT_replace_list(list, args, value, offset, error, force);
    MMMfree(elem);
}

void MUT_first_init       ( );
void MUT_init             ( );
void MUT_exit             ( );
void MUT_reset            ( );
void MUT_read_init_file   ( bool sysinit, bool in_eval );

#if !(defined GRAPHIC || defined MOTIF)
void MUT_complete( MCLT_client* , char * );
#endif

#endif /* __MUT_utils__ */
