#ifndef __llparser_h__
#define __llparser_h__
/*
 * llparser.h
 */

class LLParser {
public:
    static void do_parse(LLParser* lp);

    virtual ~LLParser() { }
    virtual int lexer() = 0;
    virtual void message(int) = 0;
    virtual void parse();

    unsigned int *tcnt;
    unsigned int *scnt;
    int symb;
    int csymb;
    int level;

    void read();
    int skip();
    int next(int);
    void error(int);
    void newlevel(unsigned int *);
    void oldlevel(unsigned int *);
#ifndef LL_FASTER
    void scan(int);
#endif
};
#endif
