/*****************************************************************************/
/* pari-malloc.h                                                             */
/* pari object memory allocation header version 1.2                          */
/* Copyright (C) 1997 by Manfred Radimersky, Bad Pyrmont, Germany            */
/* Email: maradim@uni-paderborn.de                                           */
/*****************************************************************************/
/* This header makes pari-arithmetic.c allocate memory simply via malloc.    */
/* If you want to use some memory manager instead, you have to change the    */
/* macros parimalloc and parifree with respect to your memory manager.       */
/*****************************************************************************/

/* include standard headers */
#ifndef MACINTOSH
#include <malloc.h>
#endif

/* memory allocation defines */
#define parimalloc(arg) (long*) malloc(arg << LB_WORD_BYTES)
#define parifree(arg) free(arg)
